#include <stdio.h>

#include <iostream>
#include <iomanip>
#include <conio.h>
#include <vector>
#include <fstream>
#include <sstream>
#include "dll_app.h"



/*#include <boost/program_options.hpp>
namespace po = boost::program_options;
#include <boost/program_options/value_semantic.hpp>*/
#include <cstdlib>



#define PT2_DLL_APP_VER 0.3
#define GREEN					0x0A
#define RED						0x0c
#define BLACK					0x00
#define YELLOW					(FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_GREEN)
using namespace std;

HMODULE gLoadLib;


pfMchpEnableLogging libMchpEnableLogging;
pfMchpUsbGetVersion libMchpUsbGetVersion;
pfMchpSetPath libMchpSetPath;

void print_to_console(BOOL bsilent,char *chConsole, unsigned char byColor)
{
	HANDLE hstdin  = GetStdHandle( STD_INPUT_HANDLE  );
	HANDLE hstdout = GetStdHandle( STD_OUTPUT_HANDLE );
	// Remember how things were when we started
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	WORD   index   = 0;


	if (byColor != 0xff)
	{
		GetConsoleScreenBufferInfo( hstdout, &csbi );
		SetConsoleTextAttribute( hstdout, byColor );
	}

	if(!bsilent)
		cout << chConsole << endl;

	if (byColor != 0xff)
	{
		SetConsoleTextAttribute( hstdout, csbi.wAttributes );
	}
}

//Main Function
void main( int ac, char* av[])
{
		CHAR sztext[2048];
		UINT hubindex = 0 ;
		BOOL bVsmInstall = FALSE;
		UINT32 dwError = Error_Success;
		INT iRestartDelay = 10000;
		BOOL	bSilent=FALSE;

		if( ac <= 1)
		{
			cout <<  "Invalid Arguments";
			exit(1);
		}
		
		if ((0 == strcmp(av[1],"--help")) || (0 == strcmp(av[1],"/?")))
		{
			cout <<left<< setw(20)<<"/help or /?"<<left<< setw(20)<<"Prints help message\n\n"
			<<left<< setw(20)<<""<<left<< setw(10)<<"Sample.exe <DeviceType> \n"
			<<left<< setw(20)<<""<<left<< setw(10)<<"DeviceType:	USB or LAN or PCIE\n"
			<<left<< setw(20)<<""<<left<< setw(10)<<"USAGE: Sample.exe USB \n";
			exit(1);
		}

		//Load library
		gLoadLib = LoadLibrary ("MPLABConnect.dll");
		if (gLoadLib != NULL) 
		{ 
		   printf("Loadlib library Loaded\n");
		}
		else 
		{
			printf ("Press any key to exit....\n");
			_getch ();
			exit (1);
		}
		libMchpUsbGetVersion		= (pfMchpUsbGetVersion) GetProcAddress ( gLoadLib ,"MchpUsbGetVersion");
		libMchpEnableLogging		= (pfMchpEnableLogging) GetProcAddress ( gLoadLib ,"MchpEnableLogging");
		libMchpSetPath				= (pfMchpSetPath) GetProcAddress ( gLoadLib ,"MchpSetPath");

		HMODULE LoadLib;
		TCHAR basepath[MAX_PATH] = { 0 };
		std::string tempfile = "";
		std::string filepath = "";
		GetCurrentDirectory(MAX_PATH, basepath);
		tempfile = basepath;
		filepath = basepath;
		char chToPrint[256] = {0};


		#ifdef x64
			filepath = filepath + "\\APILib\\64-bit\\MPLABConnect.dll";
			LoadLib = LoadLibrary(filepath.c_str());
		#else
			filepath = filepath + "\\APILib\\32-bit\\MPLABConnect.dll";
			LoadLib = LoadLibrary(filepath.c_str());
		#endif

		if (LoadLib != NULL)
		{
			print_to_console(bSilent, "Loadlib library Loaded\n", GREEN);
		}
		else
		{
			sprintf(chToPrint,"Failed to Load DLL : %s\n",filepath.c_str());
			print_to_console(bSilent,chToPrint,RED);
			_getch ();
			exit (1);
		}
	
		libMchpEnableLogging(LOG_DETAILED_DESCRIPTION);

		if (FALSE == libMchpUsbGetVersion(sztext))
		{
			printf ("\nPress any key to exit....");
			_getch ();
			exit (1);
		}
		cout << sztext << endl;

		////Set Ini file path
		//if(libMchpSetPath("F:\MPLABConnect"))
		//{
		//	printf("File exists");
		//}
		//else
		//{
		//	printf("File does not exists. Tool will check MPLABConnect.ini file in current directory");
		//}

		//TO RUN USB SAMPLE APPLICATION
		if(0 == strcmp(av[1],"LAN"))
		{
			//TO RUN LAN SAMPLE APPLICATION
			MchpLanSampleApp();
		}
		else if(0 == strcmp(av[1],"PCIE"))
		{
			//TO RUN PCIE SAMPLE APPLICATION
			MchpPcieSampleApp();
		}
		else
		{
			printf ("\nDevice type not supported \n");
			printf ("\nPress any key to exit....");
			_getch ();
			exit (1);
		}
}

