#pragma once

#include "..\..\APIHeader\MPLABConnect.h"


/*******************************************************************************************************************/
/*												Common															  */
/*****************************************************************************************************************/
typedef void  (*pfMchpEnableLogging) (INT);
typedef BOOL (*pfMchpUsbGetVersion) (PCHAR );
typedef BOOL  (*pfMchpSetPath) (PCHAR);

/***********************************************************************************************************************/
/*														LAN															  */
/*********************************************************************************************************************/
//Open/Close
typedef INT (*pfMchpLanGetDevices) (PCHAR);
typedef HANDLE (*pfMchpLanOpen) (UINT32);
typedef HANDLE (*pfMchpLanOpenID) (UINT16,UINT16,UINT8*);
typedef void (*pfMchpLanClose) (HANDLE);
typedef void (*pfMchpLanCloseAllHandles)();


//Program
typedef BOOL (*pfMchpLanProgramFile)(HANDLE,UINT,PCHAR,PCHAR);
typedef BOOL (*pfMchpLanProgramFileWithSerial)(HANDLE,UINT,PCHAR,PCHAR,PCHAR);

//ReadMem
typedef BOOL (*pfMchpLanReadMemory)(HANDLE,UINT,UINT8*,UINT16,UINT);

//Read/write 
typedef BOOL (*pfMchpLanRegisterRead)(HANDLE,UINT32, UINT32, UINT32*);
typedef BOOL (*pfMchpLanRegisterWrite)(HANDLE,UINT32, UINT32, UINT32*);
typedef BOOL (*pfMchpLanPhyRegisterRead)(HANDLE,UINT32, UINT32, UINT16*);
typedef BOOL (*pfMchpLanPhyRegisterWrite)(HANDLE,UINT32, UINT32, UINT16*);

//Verify
typedef BOOL (*pfMchpLanVerifyParameters)(HANDLE,PCHAR,PCHAR);

//Miscellaneous
typedef BOOL (*pfMchpLanGetDriverVersion)(void*);
typedef BOOL (*pfMchpLanGetAdapterBits)(void*);
typedef BOOL (*pfMchpLanGetAdapterKey)(HANDLE,void*);
typedef BOOL (*pfMchpLanGetAdapterPort)(HANDLE,void*);
typedef BOOL (*pfMchpLanGetAdapterPDO)(HANDLE, void*);
typedef BOOL (*pfMchpLanReadTxRxStat)(HANDLE, void*);
typedef BOOL (*pfMchpLanReadUsbPhyStat)(HANDLE, void*);
typedef BOOL (*pfMchpLanEepromConfigureCommand)(HANDLE, UINT32);
typedef BOOL (*pfMchpLanReadEepromByte)(HANDLE,UINT16, UINT8*);
typedef BOOL (*pfMchpLanWriteEepromByte)(HANDLE, UINT16, UINT8*);
typedef BOOL (*pfMchpLanEraseEeprom)(HANDLE);
typedef BOOL (*pfMchpLanGetEepromSize)(HANDLE, INT*);
typedef BOOL (*pfMchpLanOtpConfigureCommand)(HANDLE, UINT32); 
typedef UINT32 (*pfMchpLanGetLastErr)(HANDLE);

/***********************************************************************************************************************/
/*														PCIE															  */
/*********************************************************************************************************************/
//Open/Close
typedef INT (*pfMchpPcieGetDevices) (PCHAR);
typedef HANDLE (*pfMchpPcieOpen) (UINT32);
typedef HANDLE (*pfMchpPcieOpenID) (UINT16,UINT16,UINT8*);
typedef void (*pfMchpPcieClose) (HANDLE);
typedef void (*pfMchpPcieCloseAllHandles)();


//Program
typedef BOOL (*pfMchpPcieProgramFile)(HANDLE,UINT,PCHAR,PCHAR);

//ReadMem
typedef BOOL (*pfMchpPcieReadMemory)(HANDLE,UINT,UINT8*,UINT16,UINT);

//Read/write 
typedef BOOL (*pfMchpPcieRegisterRead)(HANDLE,UINT32, UINT32, UINT32*);
typedef BOOL (*pfMchpPcieRegisterWrite)(HANDLE,UINT32, UINT32, UINT32*);
typedef BOOL (*pfMchpPciePhyRegisterRead)(HANDLE,UINT32, UINT32, UINT16*);
typedef BOOL (*pfMchpPciePhyRegisterWrite)(HANDLE,UINT32, UINT32, UINT16*);
typedef BOOL (*pfMchpPcieRegisterReadPci)(HANDLE,UINT16, UINT16, UINT32*);
typedef BOOL (*pfMchpPcieRegisterWritePci)(HANDLE,UINT16, UINT16, UINT32*);

//Verify
typedef BOOL (*pfMchpPcieVerifyParameters)(HANDLE,PCHAR,PCHAR);

//Miscellaneous
typedef BOOL (*pfMchpPcieGetDriverVersion)(void*);
typedef BOOL (*pfMchpPcieGetAdapterBits)(void*);
typedef BOOL (*pfMchpPcieGetAdapterKey)(HANDLE,void*);
typedef BOOL (*pfMchpPcieGetAdapterPort)(HANDLE,void*);
typedef BOOL (*pfMchpPcieGetAdapterPDO)(HANDLE, void*);
typedef BOOL (*pfMchpPcieReadTxRxStat)(HANDLE, void*);
typedef BOOL (*pfMchpPcieEepromConfigureCommand)(HANDLE, UINT32);
typedef BOOL (*pfMchpPcieReadEepromByte)(HANDLE,UINT16, UINT8*);
typedef BOOL (*pfMchpPcieWriteEepromByte)(HANDLE, UINT16, UINT8*);
typedef BOOL (*pfMchpPcieEraseEeprom)(HANDLE);
typedef BOOL (*pfMchpPcieGetEepromSize)(HANDLE, INT*);
typedef BOOL (*pfMchpPcieOtpConfigureCommand)(HANDLE, UINT32); 
typedef BOOL (*pfMchpPcieSetLinkMode)(HANDLE, PCHAR);
typedef BOOL (*pfMchpPcieSetLinkState)(HANDLE, PCHAR);
typedef BOOL (*pfMchpPciePing)(HANDLE, PCHAR, BOOL);
typedef UINT32 (*pfMchpPcieGetLastErr)(HANDLE);

//To Run Sample application for PCIE 
void MchpPcieSampleApp();

//To Run Sample application for LAN 
void MchpLanSampleApp();


