#include <stdio.h>
#include "stdafx.h"

#include <iostream>
#include <iomanip>
#include <conio.h>
#include <vector>
#include <fstream>
#include <sstream>
#include <cstdlib>
#include <string>

// MPLABConnect DLL header file
#include "..\..\APIHeader\MPLABConnect.h"

using namespace std;

#define GREEN					0x0A
#define RED						0x0c
#define BLACK					0x00
#define YELLOW					(FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_GREEN)

//Common
typedef BOOL (*pfMchpUsbGetVersion) (PCHAR );
typedef void (*pfMchpEnableLogging) (INT);
typedef BOOL  (*pfMchpSetPath) (PCHAR);

//Open/Close
typedef INT(*pfMchpUsbGetAllHubs) (PCHAR);
typedef HANDLE(*pfMchpUsbOpen) (CONST UINT);
typedef HANDLE(*pfMchpUsbOpenID) (UINT16, UINT16);
typedef HANDLE(*pfMchpUsbHCEOpen) (UINT16, UINT16);
typedef BOOL(*pfMchpUsbClose) (HANDLE);

//Get last error
typedef UINT32(*pfMchpUsbGetLastErr) (HANDLE);

//FlexConnect
typedef BOOL(*pfMchpUsbFlexConnect) (HANDLE, UINT16);
typedef BOOL(*pfMchpUsbWriteFlexConfigArea)(HANDLE, UINT8*, INT, BOOL);

//Role switch
typedef BOOL(*pfMchpUsbRoleSwitch) (HANDLE, UINT8, BOOL, UINT8);
typedef BOOL (*pfMchpUsbSetRoleSwitch) (HANDLE, UINT16);

//Common
pfMchpEnableLogging libMchpEnableLogging;
pfMchpUsbGetVersion libMchpUsbGetVersion;
pfMchpSetPath libMchpSetPath;


//Open/Close
pfMchpUsbGetAllHubs libMchpUsbGetAllHubs;
pfMchpUsbOpen libMchpUsbOpen;
pfMchpUsbOpenID libMchpUsbOpenID;
pfMchpUsbHCEOpen libMchpUsbHCEOpen;
pfMchpUsbClose libMchpUsbClose;
pfMchpUsbGetLastErr libMchpUsbGetLastErr;

//Flexconnect
pfMchpUsbFlexConnect libMchpUsbFlexConnect;
pfMchpUsbWriteFlexConfigArea libMchpUsbWriteFlexConfigArea;

//RoleSwitch
pfMchpUsbRoleSwitch libMchpUsbRoleSwitch;
pfMchpUsbSetRoleSwitch libMchpUsbSetRoleSwitch;

CHAR sztext[2048];

void print_to_console(BOOL bsilent, char *chConsole, unsigned char byColor)
{
	HANDLE hstdin = GetStdHandle(STD_INPUT_HANDLE);
	HANDLE hstdout = GetStdHandle(STD_OUTPUT_HANDLE);
	// Remember how things were when we started
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	WORD   index = 0;


	if (byColor != 0xff)
	{
		GetConsoleScreenBufferInfo(hstdout, &csbi);
		SetConsoleTextAttribute(hstdout, byColor);
	}

	if (!bsilent)
		cout << chConsole << endl;

	if (byColor != 0xff)
	{
		SetConsoleTextAttribute(hstdout, csbi.wAttributes);
	}
}

int main(int argc, char* argv[])
{
	try
	{
		UINT16 wVID = 0x0424, wPID = 0x4002, wHCEVID = 0x0424, wHCEPID = 0x7040;
		BOOL bHubIDPresent = FALSE;
		BOOL bHubOpenIDPresent = FALSE;
		BOOL bHCEOpenPresent = FALSE;
		BYTE hubid = 0;
		BOOL bSilent = FALSE;
		int ArgPos = 0;
		UINT hub_count = 0;
		HANDLE hDevice = INVALID_HANDLE_VALUE;
		DWORD dwError = 0;
		char chToPrint[256] = { 0 };
		HMODULE LoadLib;
		CHAR sztext[2048];

		BOOL Flex = FALSE;
		BOOL FlexWrite = FALSE;
		BOOL RoleSwitch = FALSE;
		BOOL RoleSwitchwValue = FALSE;
		UINT16 Config = 0;
		string FlexConfigFile = "";
		int ConfigDataLen = 0;
		BOOL SetFlexReg = FALSE;
		UINT8 Timeout = 0;
		BOOL Turn_ON_Role_Switch = FALSE;
		UINT8 Port = 0;
		HANDLE hconfigfile;
		BYTE byConfigData[1024 * 8];
		DWORD dwBufOTPSize;
		
		if ((argc <= 1) || (0 == strcmp(argv[1],"--help")) || (0 == strcmp(argv[1], "/?")))
		{
			cout << left << setw(20) << "--help" << left << setw(20) << "Prints help message\n\n"
			<< left << setw(20) << "*********************************/flex***********************************\n"
			<< left << setw(20) << "/flex" << left << setw(10) << "Flex Connect \n"
			<< left << setw(20) << "Format" << left << setw(10) << "/flex <Config> ((/id <idValue>) | (/OpenId OpenIdValue) \n"
			<< left << setw(20) << "" << left << setw(10) <<"| (/HCEOpen <HCEOpenId))\n\n"
			<< left << setw(20) << "Arguments" << left << setw(10) << "Config: wValue field of the Flexconnect SETUP Command.\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/flex 0x0011 /id 0 \n\n"

			<< left << setw(20) << "******************************/roleswitch********************************\n"
			<< left << setw(20) << "/roleswitch" << left << setw(10) << "RoleSwitch \n"
			<< left << setw(20) << "Format1" << left << setw(10) <<  "/roleswitch ((<Timeout> <Turn_ON_Role_Switch> <Port>))\n"
			<< left << setw(20) << "" << left << setw(10) <<" ((/id <idValue>) | (/OpenId OpenIdValue) \n"
			<< left << setw(20) << "" << left << setw(10) <<"| (/HCEOpen <HCEOpenId))\n\n"
			<< left << setw(20) << "Arguments" << left << setw(10) << "Timeout	: ENUM_TIMEOUT \n\n"

			<< left << setw(20) << "" << left << setw(10) << "Turn_ON_Role_Switch	: \n"
			<< left << setw(20) << "" << left << setw(10) << "1 - PORT into role switched state\n"
			<< left << setw(20) << "" << left << setw(10) << "0 - PORT out of role switched state\n\n"

			<< left << setw(20) << "" << left << setw(10) << "Port: Downstream port number that needs to switch role\n"
			<< left << setw(20) << "Example1" << left << setw(10) << "/roleswitch 0 1 1 /id 0 \n\n"

			<< left << setw(20) << "Format2" << left << setw(10) <<"/roleswitch -wvalue <Config> ((/id <idValue>) | \n"
			<< left << setw(20) << "" << left << setw(10) <<" (/OpenId OpenIdValue) | (/HCEOpen <HCEOpenId))\n\n"
			<< left << setw(20) << "" << left << setw(10) << "Config : wValue field of the RoleSwitch SETUP Command\n"
			<< left << setw(20) << "Example2" << left << setw(10) << "/roleswitch -wvalue 0x0011 /id 0 \n\n"

			<< left << setw(20) << "******************************/flexcfgwrite******************************\n"
			<< left << setw(20) << "/flexcfgwrite" << left << setw(20) << "Write to Flex Configuration Area  \n"
			<< left << setw(20) << "Format" << left << setw(10) << "/flexcfgwrite <FileName> <ConfigDataLen> <SetFlexReg>\n"
			<< left << setw(20) << "" << left << setw(10) <<"((/id <idValue>) | (/OpenId OpenIdValue) |\n"
			<< left << setw(20) << "" << left << setw(10) <<"(/HCEOpen <HCEOpenId))\n\n"
			<< left << setw(20) << "Arguments" << left << setw(10) << "Config : wValue field of the Flexconnect SETUP Command.\n"
			<< left << setw(20) << "" << left << setw(10) << "FileName: File containing config data\n"
			<< left << setw(20) << "" << left << setw(10) << "ConfigDataLen : Configuraion Buffer Length\n"

			<< left << setw(20) << "" << left << setw(10) << "SetFlexReg	: Flex Config Flag \n"
			<< left << setw(20) << "" << left << setw(10) << "0 - Do not boot for Flex config area\n"
			<< left << setw(20) << "" << left << setw(10) << "1 - Boot form Flex config area\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/flexxfgwrite flexcfg.cfg 18 1 /id 0 \n\n"

			<< left << setw(20) << "***********************Device Open Methods*******************************\n"
			<< left << setw(20) << "/id" << left << setw(20) << "idValue: Index of the hub connected to\n"
			<< left << setw(20) << "" << left << setw(10) <<"the system - MchpUsbGetAllHubs\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/id 0 \n \n"
			<< left << setw(20) << "/OpenId" << left << setw(10) << "OpenIdValue: VID of the Hub <space> PID\n"
			<< left << setw(20) << "" << left << setw(10) <<"of the Hub\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/OpenId 0x0424 0x4002\n\n"
			<< left << setw(20) << "/HCEOpen" << left << setw(10) << "HCEOpenId	: VID of the HCE device \n"
			<< left << setw(20) << "" << left << setw(10) <<"<space> PID of the HCE device\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/HCEOpen 0x0424 0x7040\n\n"
			<< left << setw(20) << "Note" << left << setw(20) << "Position of Arguments should be \n"
			<< left << setw(20) << "" << left << setw(10) << "same as Format mentioned in help.\n";

			return 0;
		}
		else
		{
			if ((0 == strcmp(argv[1],"/flex")) || (0 == strcmp(argv[1],"/roleswitch")) || (0 == strcmp(argv[1],"/flexcfgwrite")))
			{
				for (int i = 1; i < argc; i++)
				{
					if (argv[i] != NULL)
					{
						if (0 == strcmp(argv[i], "/flex"))
						{
							if (argv[i + 1] != NULL)
							{
								Config = (WORD)strtol(argv[++i], 0, 16);  //If current arg is "/flex", the next arg should be Config
								Flex = TRUE;
								continue;
							}
							else
							{
								print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
								return -1;
							}
						}
						else if (0 == strcmp(argv[i], "/flexcfgwrite"))
						{
							//If current arg is "/flexwrite", it should be followed by FlexConfigFile, ConfigDataLen, SetFlexReg
							if ((argv[i + 1] != NULL) && (argv[i + 2] != NULL) && (argv[i + 3] != NULL))
							{
								FlexConfigFile = argv[++i];
								ConfigDataLen = atoi(argv[++i]);
								SetFlexReg = atoi(argv[++i]);
								FlexWrite = TRUE;
								continue;
							}
							else
							{
								print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
								return -1;
							}
						}
						else if (0 == strcmp(argv[i], "/roleswitch"))
						{
							if (argv[i + 1] == NULL)
							{
								print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
								return -1;
							}
							if (0 == strcmp(argv[i + 1], "-wvalue"))
							{
								if (argv[i + 2] != NULL)
								{
									Config = (WORD)strtol(argv[++i], 0, 16);
									RoleSwitch = TRUE;
									RoleSwitchwValue = TRUE;
									continue;
								}
								else
								{
									print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
									return -1;
								}

							}
							else
							{
								//If current arg is "/roleswitch", it should be followed by Timeout, Turn_ON_Role_Switch, Port
								if ((argv[i + 1] != NULL) && (argv[i + 2] != NULL) && (argv[i + 3] != NULL))
								{
									Timeout = atoi(argv[++i]);
									Turn_ON_Role_Switch = atoi(argv[++i]);
									Port = atoi(argv[++i]);
									RoleSwitch = TRUE;
									continue;
								}
								else
								{
									print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
									return -1;
								}
							}
						}
						if (argv[i] != NULL)
						{
							if (0 == strcmp(argv[i], "/id")) //Device Open Using MchpUsbOpen
							{
								if (argv[i + 1] != NULL)
								{
									hubid = atoi(argv[++i]);
									bHubIDPresent = TRUE;
									continue;
								}
								else
								{
									print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
									return -1;
								}

							}
							else if (0 == strcmp(argv[i], "/OpenId")) //Device Open Using MchpUsbOpenID
							{
								if ((argv[i + 1] != NULL) && (argv[i + 2] != NULL))
								{
									wVID = (WORD)strtol(argv[++i], 0, 16);
									wPID = (WORD)strtol(argv[++i], 0, 16);
									bHubOpenIDPresent = TRUE;
									continue;
								}
								else
								{
									print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
									return -1;
								}
							}
							else if (0 == strcmp(argv[i], "/HCEOpen")) //Device Open Using MchpUsbHCEOpen
							{
								if ((argv[i + 1] != NULL) && (argv[i + 2] != NULL))
								{
									wHCEVID = (WORD)strtol(argv[++i], 0, 16);
									wHCEPID = (WORD)strtol(argv[++i], 0, 16);
									bHCEOpenPresent = TRUE;
									continue;
								}
								else
								{
									print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
									return -1;
								}
							}
						}
					}
				}
			}
		}
		TCHAR basepath[MAX_PATH] = {0};
		std::string tempfile = "";
		std::string filepath = "";
		GetCurrentDirectory(MAX_PATH,  basepath);
		tempfile = basepath;
		filepath = basepath;


		#ifdef x64
			filepath = filepath + "\\APILib\\64-bit\\MPLABConnect.dll";
			LoadLib = LoadLibrary(filepath.c_str());
		#else
			filepath = filepath + "\\APILib\\32-bit\\MPLABConnect.dll";
			LoadLib = LoadLibrary(filepath.c_str());
		#endif

		if (LoadLib != NULL)
		{
			print_to_console(bSilent, "Loadlib library Loaded\n", GREEN);
		}
		else
		{
			sprintf(chToPrint,"Failed to Load DLL : %s\n",filepath.c_str());
			print_to_console(bSilent,chToPrint,RED);
			return -1;
		}
		//Common
		libMchpEnableLogging    = (pfMchpEnableLogging) GetProcAddress ( LoadLib ,"MchpEnableLogging");
		libMchpSetPath    = (pfMchpSetPath) GetProcAddress ( LoadLib ,"MchpSetPath");
		libMchpUsbGetVersion    = (pfMchpUsbGetVersion) GetProcAddress ( LoadLib, "MchpUsbGetVersion");

		//Open/close
		libMchpUsbGetAllHubs = (pfMchpUsbGetAllHubs)GetProcAddress(LoadLib, "MchpUsbGetAllHubs");
		libMchpUsbOpen = (pfMchpUsbOpen)GetProcAddress(LoadLib, "MchpUsbOpen");
		libMchpUsbOpenID = (pfMchpUsbOpenID)GetProcAddress(LoadLib, "MchpUsbOpenID");
		libMchpUsbHCEOpen = (pfMchpUsbHCEOpen)GetProcAddress(LoadLib, "MchpUsbHCEOpen");
		libMchpUsbClose = (pfMchpUsbClose)GetProcAddress(LoadLib, "MchpUsbClose");

		libMchpUsbFlexConnect = (pfMchpUsbFlexConnect)GetProcAddress(LoadLib, "MchpUsbFlexConnect");
		libMchpUsbWriteFlexConfigArea   = (pfMchpUsbWriteFlexConfigArea) GetProcAddress ( LoadLib ,"MchpUsbWriteFlexConfigArea");
		libMchpUsbRoleSwitch	=	(pfMchpUsbRoleSwitch) GetProcAddress ( LoadLib ,"MchpUsbRoleSwitch");
		libMchpUsbSetRoleSwitch	=	(pfMchpUsbSetRoleSwitch) GetProcAddress ( LoadLib ,"MchpUsbSetRoleSwitch");

		libMchpUsbGetLastErr	= (pfMchpUsbGetLastErr) GetProcAddress ( LoadLib ,"MchpUsbGetLastErr");

		//Enable logging
		libMchpEnableLogging(LOG_DETAILED_DESCRIPTION);

		//Get Version
		if (FALSE == libMchpUsbGetVersion(sztext))
		{
			print_to_console(bSilent,"Failed to get Version number", RED);
			return -1;
		}
		else
		{
			sprintf(chToPrint,"Version : %s\n",sztext);
			print_to_console(bSilent,chToPrint,0xFF);
		}
		
		//Set Ini file path
		tempfile = tempfile + "\\APILib\\";
		if(FALSE == libMchpSetPath((PCHAR)tempfile.c_str()))
		{
			sprintf(chToPrint,"File Does not exists : %s\n",tempfile.c_str());
			print_to_console(bSilent,chToPrint,0xFF);
		}

		//Device Open Using MchpUsbOpen
		if (bHubIDPresent)
		{
			hub_count = libMchpUsbGetAllHubs(sztext); //GET all HUBs
			if (hub_count == 0)
			{
				print_to_console(bSilent, "Zero hubs found", RED);
				return -1;
			}
			else
			{
				print_to_console(FALSE,sztext,0xFF);
			}
			hDevice = libMchpUsbOpen(hubid);
			if (hDevice == INVALID_HANDLE_VALUE)
			{
				print_to_console(bSilent, "FAIL: MchpUsbOpen", RED);
				return -1;
			}
			else
			{
				print_to_console(bSilent, "SUCCESS: MchpUsbOpen", GREEN);
			}
		}
		else if (bHubOpenIDPresent) //Device Open Using MchpUsbOpenID
		{
			hDevice = libMchpUsbOpenID(wVID, wPID); //valid handle test
			if (INVALID_HANDLE_VALUE == hDevice)
			{
				print_to_console(bSilent, "FAIL: MchpUsbOpenID", RED);
				return -1;
			}
			else
			{
				print_to_console(bSilent, "SUCCESS: MchpUsbOpenID", GREEN);
			}
		}
		else if (bHCEOpenPresent) //Device Open Using MchpUsbHCEOpen
		{
			hDevice = libMchpUsbHCEOpen(wHCEVID, wHCEPID); //valid handle test
			if (INVALID_HANDLE_VALUE == hDevice)
			{
				print_to_console(bSilent, "FAIL: MchpUsbHCEOpen", RED);
				return -1;
			}
			else
			{
				print_to_console(bSilent, "SUCCESS: MchpUsbHCEOpen", GREEN);
			}
		}
		else
		{
			print_to_console(bSilent,"Please provide valid method to Open the Device",RED);
			return -1;
		}


		if (TRUE == FlexWrite) //MchpUsbWriteFlexConfigArea Function
		{
			hconfigfile = CreateFile(FlexConfigFile.c_str(), GENERIC_READ, FILE_SHARE_READ,
				NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
			if (INVALID_HANDLE_VALUE == hconfigfile)
			{
				print_to_console(bSilent, "FAIL. File doesnot exists", RED);
			}
			if (FALSE == ReadFile(hconfigfile, &byConfigData[0], (1024 * 8), (LPDWORD)&dwBufOTPSize, NULL))
			{
				CloseHandle(hconfigfile);
			}
			CloseHandle(hconfigfile);

			if (FALSE == libMchpUsbWriteFlexConfigArea(hDevice, &byConfigData[0], ConfigDataLen, SetFlexReg))
			{
				dwError = libMchpUsbGetLastErr(hDevice);

				memset(chToPrint, 0x00, sizeof(chToPrint));
				sprintf(chToPrint, "FAIL: MchpUsbWriteFlexConfigArea.\n Error: %04xn", dwError);
				print_to_console(bSilent, chToPrint, RED);
				goto Device_Close;
			}
			else
			{
				print_to_console(bSilent, "SUCCESS: MchpUsbWriteFlexConfigArea", GREEN);
			}
		}
		if (TRUE == Flex) //MchpUsbFlexConnect Function
		{
			if (FALSE == libMchpUsbFlexConnect(hDevice, Config))
			{
				dwError = libMchpUsbGetLastErr(hDevice);
				memset(chToPrint, 0x00, sizeof(chToPrint));
				sprintf(chToPrint, "FAIL: MchpUsbFlexConnect.\n Error: %04xn", dwError);
				print_to_console(bSilent, chToPrint, RED);
				goto Device_Close;
			}
			else
			{
				print_to_console(bSilent, "SUCCESS: MchpUsbFlexConnect", GREEN);
			}
		}
		if (TRUE == RoleSwitch) //MchpUsbRoleSwitch Function
		{
			if(TRUE == RoleSwitchwValue)
			{
				if(FALSE == libMchpUsbSetRoleSwitch(hDevice, Config))
				{
					dwError = libMchpUsbGetLastErr(hDevice);
					memset(chToPrint, 0x00, sizeof(chToPrint));
					sprintf(chToPrint, "FAIL: MchpUsbSetRoleSwitch.\n Error: %04xn", dwError);
					print_to_console(bSilent, chToPrint, RED);
					goto Device_Close;
				}
				else
				{
					print_to_console(bSilent, "SUCCESS: MchpUsbRoleSwitch", GREEN);
				}
			}
			else
			{
				if (FALSE == libMchpUsbRoleSwitch(hDevice, Timeout, Turn_ON_Role_Switch, Port))
				{
					dwError = libMchpUsbGetLastErr(hDevice);

					memset(chToPrint, 0x00, sizeof(chToPrint));
					sprintf(chToPrint, "FAIL: MchpUsbRoleSwitch.\n Error: %04xn", dwError);
					print_to_console(bSilent, chToPrint, RED);
					goto Device_Close;
				}
				else
				{
					print_to_console(bSilent, "SUCCESS: MchpUsbRoleSwitch", GREEN);
				}
			}

		}
		
	Device_Close:
		if (FALSE == libMchpUsbClose(hDevice))
		{
			dwError = libMchpUsbGetLastErr(hDevice);
			memset(chToPrint, 0x00, sizeof(chToPrint));
			sprintf(chToPrint, "\n FAIL: MchpUsbClose.Error: %04x", dwError);
			print_to_console(bSilent, chToPrint, RED);
		}
		else
		{
			print_to_console(bSilent, "Success: MchpUsbClose", BLACK);
		}
	}
	//Try catch implementation 
	catch (...)
	{
		cout << "Oops... There is a problem with previous command\n" << endl;
		cout << "See log for more details in the application directory\n" << endl;
		return -1;
	}
	return -1;
}

