// USB_Miscellaneous.cpp : Defines the entry point for the console application.
//
#include <stdio.h>
#include "stdafx.h"

#include <iostream>
#include <iomanip>
#include <conio.h>
#include <vector>
#include <fstream>
#include <sstream>
#include <cstdlib>
#include <string>

// MPLABConnect DLL header file
#include "..\..\APIHeader\MPLABConnect.h"

using namespace std;

#define GREEN					0x0A
#define RED						0x0c
#define BLACK					0x00
#define YELLOW					(FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_GREEN)

//Common
typedef BOOL (*pfMchpUsbGetVersion) (PCHAR );
typedef void (*pfMchpEnableLogging) (INT);
typedef BOOL  (*pfMchpSetPath) (PCHAR);

//Open/Close
typedef INT(*pfMchpUsbGetAllHubs) (PCHAR);
typedef HANDLE(*pfMchpUsbOpen) (CONST UINT);
typedef HANDLE(*pfMchpUsbOpenID) (UINT16, UINT16);
typedef HANDLE(*pfMchpUsbHCEOpen) (UINT16, UINT16);
typedef BOOL(*pfMchpUsbClose) (HANDLE);

//Get last error
typedef UINT32(*pfMchpUsbGetLastErr) (HANDLE);


typedef BOOL(*pfMchpVerifyWidgetValues) (HANDLE, PCHAR, PCHAR);
typedef BOOL(*pfMchpUsbDeviceReset) (HANDLE);
typedef BOOL(*pfMchpUsbHCETransfer) (HANDLE, UINT8, UINT8*, UINT8, UINT16, UINT16, UINT16);
typedef BOOL(*pfMchpVerifyWidgetValues) (HANDLE, PCHAR, PCHAR);
typedef BOOL(*pfMchpUsbVSMTransfer)(CONST UINT, UINT8, UINT8*, UINT8, UINT16, UINT16, UINT16);
typedef BOOL(*pfMchpUsbSetDCPMode) (HANDLE, UINT16);
typedef BOOL (*pfMchpDynamicPortMapping) (HANDLE,UINT8*,UINT8*, PCHAR);

//Common
pfMchpEnableLogging libMchpEnableLogging;
pfMchpUsbGetVersion libMchpUsbGetVersion;
pfMchpSetPath libMchpSetPath;

//Open/Close
pfMchpUsbGetAllHubs libMchpUsbGetAllHubs;
pfMchpUsbOpen libMchpUsbOpen;
pfMchpUsbOpenID libMchpUsbOpenID;
pfMchpUsbHCEOpen libMchpUsbHCEOpen;
pfMchpUsbClose libMchpUsbClose;

pfMchpVerifyWidgetValues libMchpVerifyWidgetValues;
pfMchpUsbDeviceReset libMchpUsbDeviceReset;
pfMchpUsbHCETransfer libMchpUsbHCETransfer;
pfMchpUsbVSMTransfer libMchpUsbVSMTransfer;
pfMchpUsbSetDCPMode libMchpUsbSetDCPMode;
pfMchpDynamicPortMapping libMchpDynamicPortMapping;

pfMchpUsbGetLastErr libMchpUsbGetLastErr;

void print_to_console(BOOL bsilent, char *chConsole, unsigned char byColor)
{
	HANDLE hstdin = GetStdHandle(STD_INPUT_HANDLE);
	HANDLE hstdout = GetStdHandle(STD_OUTPUT_HANDLE);
	// Remember how things were when we started
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	WORD   index = 0;


	if (byColor != 0xff)
	{
		GetConsoleScreenBufferInfo(hstdout, &csbi);
		SetConsoleTextAttribute(hstdout, byColor);
	}

	if (!bsilent)
		cout << chConsole << endl;

	if (byColor != 0xff)
	{
		SetConsoleTextAttribute(hstdout, csbi.wAttributes);
	}
}

int main( int argc, char* argv[])
{
	try
	{
		UINT16 wVID = 0x0424, wPID = 0x4002, wHCEVID = 0x0424, wHCEPID = 0x7040;
		BOOL bHubIDPresent = FALSE;
		BOOL bHubOpenIDPresent = FALSE;
		BOOL bHCEOpenPresent = FALSE;
		BYTE hubid = 0;
		BOOL bSilent = FALSE;
		int ArgPos = 0;
		UINT hub_count = 0;
		HANDLE hDevice = INVALID_HANDLE_VALUE;
		DWORD dwError = 0;
		char chToPrint[512] = { 0 };
		HMODULE LoadLib;
		CHAR sztext[2048];

		BOOL VERIFY_WIDGETS = FALSE;
		UINT8 bmRequestType;
		UINT8 byBufferData[512];
		UINT8 bRequest;
		UINT16 wValue;
		UINT16 wIndex;
		UINT16 wLength;
		UINT16 Config =0;
		BOOL VSM_TRANSFER = FALSE;
		BOOL DEV_RESET = FALSE;
		BOOL HCE_TRANSFER = FALSE;
		BOOL HCE_Operation = TRUE;
		BOOL VSM_Operation = FALSE;
		BOOL SET_DCP_MODE = FALSE;
		BOOL DYNAMICPORTMAP = FALSE;
		char widget_buffer_names[4098];
		char widget_buffer_values[4098];
		BYTE Usb3PortMapping[7] = {0};
		BYTE Usb2PortMapping[7] = {0};
		string verifyParams[50];
		char chText [256];
		
		if ((argc <= 1) || (0 == strcmp(argv[1], "--help")) || (0 == strcmp(argv[1], "/?")))
		{
			cout << left << setw(20) << "--help" << left << setw(20) << "Prints help message\n\n"
			<< left << setw(20) << "*******************************/verify***********************************\n"
			<<left<< setw(20)<<"/verify"<<left<< setw(10)<<"Verify widgets\n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/verify <no.of.widgets> <widgetname> ((/id <idValue>)|\n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"(/OpenId OpenIdValue) | (/HCEOpen <HCEOpenId))\n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/verify 2 vid pid /id 0 \n\n"
			
			<< left << setw(20) << "*******************************/devreset*********************************\n"
			<<left<< setw(20)<<"/devReset"<<left<< setw(10)<<"Device Reset\n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/devreset ((/id <idValue>) | \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"(/OpenId OpenIdValue) | (/HCEOpen <HCEOpenId))\n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/devreset /id 0 \n\n"

			<< left << setw(20) << "*******************************/hcetransfer******************************\n"
			<<left<< setw(20)<<"/hcetransfer"<<left<< setw(10)<<"HCE Transfer\n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/hcetransfer <operation> <RequestType> \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"<bRequest> <wValue> <wIndex> <wLength> ((/id <idValue>)\n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"| (/OpenId OpenIdValue) | (/HCEOpen <HCEOpenId))\n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/hcetransfer -r 0xc0 0x04 0x3004 0xBF80 2 /id 0 \n\n"

			<< left << setw(20) << "*******************************/vsmtransfer******************************\n"
			<<left<< setw(20)<<"/vsmtransfer"<<left<< setw(10)<<"VSM Transfer\n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/vsmtransfer <operation> <RequestType> \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"<bRequest> <wValue> <wIndex> <wLength> ((/id <idValue>) \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"| (/OpenId OpenIdValue) | (/HCEOpen <HCEOpenId))\n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/vsmtransfer -r 0xc0 0x01 0x3004 0xBF80 2 /id 0 \n\n"

			<< left << setw(20) << "*****************************/dynamicportmap*****************************\n"
			<<left<< setw(20)<<"/dynamicportmap"<<left<< setw(10)<<"Dynamic Port Mapping\n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/dynamicportmap -usb2portmap <len> \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"<USB2PortMapping> -usb3portmap <len> <USB3PortMapping> ((/id \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<" <idValue>) | (/OpenId OpenIdValue) | (/HCEOpen <HCEOpenId))\n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/dynamicportmap -usb2 7 1 2 3 4 5 6 7 \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"-usb3 7 1 0 2 0 0 0 0 /id 0\n\n"
			<<left<< setw(20)<<"Note"<< left<<setw(10)<<"USB2 and USB3 port remap values length should be always 7\n\n"

			<< left << setw(20) << "*****************************/setdcp*****************************\n"
			<<left<< setw(20)<<"/setdcp"<<left<< setw(10)<<"Set DCP mode\n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/setdcp <config> ((/id <idValue>) \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"| (/OpenId OpenIdValue) | (/HCEOpen <HCEOpenId))\n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/setdcp 0x0003 /id 0\n\n"
			<<left<< setw(20)<<"Note"<< left<<setw(10)<<"Battery charging should be enabled before setting DCP for a particular port\n\n"
			

			<< left << setw(20) << "***********************Device Open Methods*******************************\n"
			<< left << setw(20) << "/id" << left << setw(20) << "idValue: Index of the hub connected to\n"
			<< left << setw(20) << "" << left << setw(10) <<"the system - MchpUsbGetAllHubs\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/id 0 \n \n"
			<< left << setw(20) << "/OpenId" << left << setw(10) << "OpenIdValue: VID of the Hub <space> PID\n"
			<< left << setw(20) << "" << left << setw(10) <<"of the Hub\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/OpenId 0x0424 0x4002\n\n"
			<< left << setw(20) << "/HCEOpen" << left << setw(10) << "HCEOpenId	: VID of the HCE device \n"
			<< left << setw(20) << "" << left << setw(10) <<"<space> PID of the HCE device\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/HCEOpen 0x0424 0x7040\n\n"
			<< left << setw(20) << "Note" << left << setw(20) << "Position of Arguments should be \n"
			<< left << setw(20) << "" << left << setw(10) << "same as Format mentioned in help.\n";

			return 0;
		}
		else
		{
			if (0 == strcmp(argv[1],"/verify"))
			{
				VERIFY_WIDGETS = TRUE;
				int len = 0;
				if (argv[2] != NULL)
				{
					len = atoi(argv[2]);
				}
				else
				{
					print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
					return -1;
				}

				memset(widget_buffer_names, 0x00, sizeof(widget_buffer_names));
				for(int j=0; j<len;j++)
				{
					if ((argv[3 + j] != NULL) && (strcmp(argv[3 + j], "/id") != 0))
					{
						verifyParams[j] = argv[3 + j];
						strcat(widget_buffer_names, verifyParams[j].c_str());
						strcat(widget_buffer_names, ",");
					}
					else
					{
						print_to_console(bSilent, "Widget Count does not match with Length\n", RED);
						return -1;
					}
				}
				ArgPos = 3 + len;	
				if (argv[ArgPos] == NULL)
				{
					print_to_console(bSilent, "Please provide valid method to Open the Device", RED);
					return -1;
				}
			}
			else if (0 == strcmp(argv[1],"/devreset"))
			{
				DEV_RESET = TRUE;
				ArgPos = 2;
				if (argv[ArgPos] == NULL)
				{
					print_to_console(bSilent, "Please provide valid method to Open the Device", RED);
					return -1;
				}
			}
			else if (0 == strcmp(argv[1], "/hcetransfer"))
			{
				HCE_TRANSFER = TRUE;	
				if ((argv[2] != NULL) && (argv[3] != NULL) && (argv[4] != NULL) && (argv[5] != NULL)
					&& (argv[6] != NULL) && (argv[7] != NULL))
				{
					if (0 == strcmp(argv[2], "-w"))
					{
						HCE_Operation = TRUE;
					}
					else if(0 == strcmp(argv[2], "-r"))
					{
						HCE_Operation = FALSE;
					}
					else
					{
						print_to_console(bSilent, "Please provide valid operation to be performed", RED);
						return -1;
					}
					bmRequestType = (BYTE)strtol(argv[3], 0, 16);
					bRequest = (BYTE)strtol(argv[4], 0, 16);
					wValue = (WORD)strtol(argv[5], 0, 16);
					wIndex = (WORD)strtol(argv[6], 0, 16);
					wLength = (WORD)strtol(argv[7], 0, 16);
				}
				else
				{
					print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
					return -1;
				}
				ArgPos = 8;
				if(HCE_Operation == TRUE)
				{
					for (int j=0; j< wLength; j++)
					{
						if ((argv[8 + j] != NULL) && (strcmp(argv[8 + j], "/id") != 0))
						{
							byBufferData[j] = (BYTE)strtol(argv[8 + j], 0, 16);
						}
						else
						{
							print_to_console(bSilent, "Data does not match with Length\n", RED);
							return -1;
						}
					}
					ArgPos = 8 + wLength;
				}	
				if (argv[ArgPos] == NULL)
				{
					print_to_console(bSilent, "Please provide valid method to Open the Device", RED);
					return -1;
				}
			}
			else if (0 == strcmp(argv[1],"/vsmtransfer"))
			{
				VSM_TRANSFER = TRUE;
				if ((argv[2] != NULL) && (argv[3] != NULL) && (argv[4] != NULL) && (argv[5] != NULL)
					&& (argv[6] != NULL) && (argv[7] != NULL))
				{
					if (0 == strcmp(argv[2], "-w"))
					{
						VSM_Operation = TRUE;
					}
					else
					{
						VSM_Operation = FALSE;
					}
					bmRequestType = (BYTE)strtol(argv[3], 0, 16);
					bRequest = (BYTE)strtol(argv[4], 0, 16);
					wValue = (WORD)strtol(argv[5], 0, 16);
					wIndex = (WORD)strtol(argv[6], 0, 16);
					wLength = (WORD)strtol(argv[7], 0, 16);
				}
				else
				{
					print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
					return -1;
				}
				ArgPos = 8;
				if(VSM_Operation == TRUE)
				{
					for (int j=0; j< wLength; j++)
					{
						if ((argv[8 + j] != NULL) && (strcmp(argv[8 + j], "/id") != 0))
						{
							byBufferData[j] = (BYTE)strtol(argv[8 + j], 0, 16);
						}
						else
						{
							print_to_console(bSilent, "Data does not match with Length\n", RED);
							return -1;
						}
					}
					ArgPos = 8 + wLength;
				}
				if (argv[ArgPos] == NULL)
				{
					print_to_console(bSilent, "Please provide valid method to Open the Device", RED);
					return -1;
				}
			}
			else if (0 == strcmp(argv[1],"/setdcp"))
			{
				if ((argv[2] != NULL) && (argv[3] != NULL))
				{
					Config = atoi(argv[2]);
					SET_DCP_MODE = TRUE;
					ArgPos = 3;
				}
				else
				{
					print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
					return -1;
				}
			}
			else if(0 == strcmp(argv[1],"/dynamicportmap"))
			{
				DYNAMICPORTMAP = TRUE;
				if (argv[2] != NULL)
				{
					if (0 == strcmp(argv[2], "-usb2")) //usb2 port mapping values
					{
						BYTE Size = (BYTE)strtol(argv[3], 0, 16);
						for (int l = 0; l < Size; l++)
						{
							if(argv[4 + l] != NULL)
							{
								Usb2PortMapping[l] = (BYTE)strtol(argv[4 + l], 0, 16);
							}
							else
							{
								print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
								return -1;
							}
						}
						ArgPos = 4 + Size;
					}
				}
				else
				{
					print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
					return -1;
				}
				if (argv[ArgPos] != NULL)
				{
					if (0 == strcmp(argv[ArgPos], "-usb3")) //usb3 port mapping values
					{
						BYTE Size = (BYTE)strtol(argv[++ArgPos], 0, 16);

						for (int l = 0; l < Size; l++)
						{
							Usb3PortMapping[l] = (BYTE)strtol(argv[++ArgPos], 0, 16);
						}
						ArgPos++;
					}
				}
			}
			if (argv[ArgPos] == NULL)
			{
				print_to_console(bSilent, "Please provide valid method to Open the Device", RED);
				return -1;
			}
			if(0 == strcmp(argv[ArgPos],"/id")) //Device Open Using MchpUsbOpen
			{
				if (argv[ArgPos + 1] != NULL)
				{
					hubid = atoi(argv[ArgPos + 1]);
					bHubIDPresent = TRUE;
				}
				else
				{
					print_to_console(bSilent, "Please enter valid Hub id", RED);
					return -1;
				}
			}
			else if(0 == strcmp(argv[ArgPos],"/OpenId")) //Device Open Using MchpUsbOpenID
			{
				if ((argv[ArgPos + 1] != NULL) && (argv[ArgPos + 2] != NULL))
				{
					wVID = (WORD)strtol(argv[ArgPos + 1], 0, 16);
					wPID = (WORD)strtol(argv[ArgPos + 2], 0, 16);
					bHubOpenIDPresent = TRUE;
				}
				else
				{
					print_to_console(bSilent, "Please enter valid Hub VID and Hub PID", RED);
					return -1;
				}
			}
			else if(0 == strcmp(argv[ArgPos],"/HCEOpen")) //Device Open Using MchpUsbHCEOpen
			{
				if ((argv[ArgPos + 1] != NULL) && (argv[ArgPos + 2] != NULL))
				{
					wHCEVID = (WORD)strtol(argv[ArgPos + 1], 0, 16);
					wHCEPID = (WORD)strtol(argv[ArgPos + 2], 0, 16);
					bHCEOpenPresent = TRUE;
				}
				else
				{
					print_to_console(bSilent, "Please enter valid HFC VID and HFC PID", RED);
					return -1;
				}
			}
		}
		TCHAR basepath[MAX_PATH] = { 0 };
		std::string tempfile = "";
		std::string filepath = "";
		GetCurrentDirectory(MAX_PATH, basepath);
		tempfile = basepath;
		filepath = basepath;


		#ifdef x64
			filepath = filepath + "\\APILib\\64-bit\\MPLABConnect.dll";
			LoadLib = LoadLibrary(filepath.c_str());
		#else
			filepath = filepath + "\\APILib\\32-bit\\MPLABConnect.dll";
			LoadLib = LoadLibrary(filepath.c_str());
		#endif

		if (LoadLib != NULL)
		{
			print_to_console(bSilent, "Loadlib library Loaded\n", GREEN);
		}
		else
		{
			sprintf(chToPrint,"Failed to Load DLL : %s\n",filepath.c_str());
			print_to_console(bSilent,chToPrint,RED);
			return -1;
		}

		//Common
		libMchpEnableLogging    = (pfMchpEnableLogging) GetProcAddress ( LoadLib ,"MchpEnableLogging");
		libMchpSetPath    = (pfMchpSetPath) GetProcAddress ( LoadLib ,"MchpSetPath");
		libMchpUsbGetVersion    = (pfMchpUsbGetVersion) GetProcAddress ( LoadLib, "MchpUsbGetVersion");

		//Open/close
		libMchpUsbGetAllHubs = (pfMchpUsbGetAllHubs)GetProcAddress(LoadLib, "MchpUsbGetAllHubs");
		libMchpUsbOpen = (pfMchpUsbOpen)GetProcAddress(LoadLib, "MchpUsbOpen");
		libMchpUsbOpenID = (pfMchpUsbOpenID)GetProcAddress(LoadLib, "MchpUsbOpenID");
		libMchpUsbHCEOpen = (pfMchpUsbHCEOpen)GetProcAddress(LoadLib, "MchpUsbHCEOpen");
		libMchpUsbClose = (pfMchpUsbClose)GetProcAddress(LoadLib, "MchpUsbClose");

		libMchpUsbGetLastErr	= (pfMchpUsbGetLastErr) GetProcAddress ( LoadLib ,"MchpUsbGetLastErr");
		libMchpVerifyWidgetValues	= (pfMchpVerifyWidgetValues)  GetProcAddress ( LoadLib ,"MchpVerifyWidgetValues");
		libMchpUsbDeviceReset = (pfMchpUsbDeviceReset) GetProcAddress ( LoadLib ,"MchpUsbDeviceReset");
		libMchpUsbHCETransfer = (pfMchpUsbHCETransfer) GetProcAddress ( LoadLib ,"MchpUsbHCETransfer");
		libMchpUsbVSMTransfer = (pfMchpUsbVSMTransfer) GetProcAddress ( LoadLib ,"MchpUsbVSMTransfer");
		libMchpUsbSetDCPMode   =(pfMchpUsbSetDCPMode) GetProcAddress ( LoadLib ,"MchpUsbSetDCPMode");
		libMchpDynamicPortMapping   = (pfMchpDynamicPortMapping)  GetProcAddress ( LoadLib ,"MchpDynamicPortMapping");

		libMchpUsbGetLastErr	= (pfMchpUsbGetLastErr) GetProcAddress ( LoadLib ,"MchpUsbGetLastErr");

		//Enable logging
		libMchpEnableLogging(LOG_DETAILED_DESCRIPTION);

		//Get Version
		if (FALSE == libMchpUsbGetVersion(sztext))
		{
			print_to_console(bSilent,"Failed to get Version number", RED);
			return -1;
		}
		else
		{
			sprintf(chToPrint,"Version : %s\n",sztext);
			print_to_console(bSilent,chToPrint,0xFF);
		}
		
		//Set Ini file path
		tempfile = tempfile + "\\APILib\\";
		if(FALSE == libMchpSetPath((PCHAR)tempfile.c_str()))
		{
			sprintf(chToPrint,"File Does not exists : %s\n",tempfile.c_str());
			print_to_console(bSilent,chToPrint,0xFF);
		}

		//Device Open Using MchpUsbOpen
		if (bHubIDPresent)
		{
			hub_count = libMchpUsbGetAllHubs(sztext); //GET all HUBs
			if (hub_count == 0)
			{
				print_to_console(bSilent, "Zero hubs found", RED);
				return -1;
			}
			else
			{
				print_to_console(FALSE,sztext,0xFF);
			}
			hDevice = libMchpUsbOpen(hubid);
			if (hDevice == INVALID_HANDLE_VALUE)
			{
				print_to_console(bSilent, "FAIL: MchpUsbOpen", RED);
				return -1;
			}
			else
			{
				print_to_console(bSilent, "SUCCESS: MchpUsbOpen", GREEN);
			}
		}
		else if (bHubOpenIDPresent) //Device Open Using MchpUsbOpenID
		{
			hDevice = libMchpUsbOpenID(wVID, wPID); //valid handle test
			if (INVALID_HANDLE_VALUE == hDevice)
			{
				print_to_console(bSilent, "FAIL: MchpUsbOpenID", RED);
				return -1;
			}
			else
			{
				print_to_console(bSilent, "SUCCESS: MchpUsbOpenID", GREEN);
			}
		}
		else if (bHCEOpenPresent) //Device Open Using MchpUsbHCEOpen
		{
			hDevice = libMchpUsbHCEOpen(wHCEVID, wHCEPID); //valid handle test
			if (INVALID_HANDLE_VALUE == hDevice)
			{
				print_to_console(bSilent, "FAIL: MchpUsbHCEOpen", RED);
				return -1;
			}
			else
			{
				print_to_console(bSilent, "SUCCESS: MchpUsbHCEOpen", GREEN);
			}
		}
		else
		{
			print_to_console(bSilent,"Please provide valid method to Open the Device",RED);
			return -1;
		}
		if (TRUE == VERIFY_WIDGETS)
		{
			if (FALSE == libMchpVerifyWidgetValues(hDevice, widget_buffer_names, widget_buffer_values))
			{
				dwError = libMchpUsbGetLastErr(hDevice);
				sprintf(chToPrint, "FAIL : MchpVerifyWidgetValues.Error:%x", dwError);
				print_to_console(bSilent, chToPrint, RED);
				goto Device_Close;
			}
			else
			{
				print_to_console(bSilent, "Success:MchpVerifyWidgetValues ", GREEN);
			}

			//Parse the comma sepearted value from DLL API
			string ParseValue(widget_buffer_values);

			//Small Parser code
			size_t pos = 0, position;
			std::string token;
			int j = 0;
			memset(sztext, 0x00, sizeof(sztext));
			while ((pos = ParseValue.find(",")) != std::string::npos)
			{
				position = ParseValue.find(",");
				token = ParseValue.substr(0, position);

				sprintf(chText, "WidgetName : %s , Value : %s \n", verifyParams[j++].c_str(), token.c_str());
				strcat(sztext, chText);
				ParseValue.erase(0, position + 1);
			}
			print_to_console(FALSE, sztext, YELLOW);
		}
		if (TRUE == DEV_RESET)
		{
			if (FALSE == libMchpUsbDeviceReset(hDevice))
			{
				dwError = libMchpUsbGetLastErr(hDevice);
				memset(chToPrint, 0x00, sizeof(chToPrint));
				sprintf(chToPrint, "FAIL: MchpUsbDeviceReset.Error: %x", dwError);
				print_to_console(bSilent, chToPrint, RED);
				goto Device_Close;
			}
			else
			{
				print_to_console(bSilent, "SUCCESS: MchpUsbDeviceReset", GREEN);
			}
		}
		if (TRUE == HCE_TRANSFER)
		{
			if (FALSE == libMchpUsbHCETransfer(hDevice, bmRequestType, byBufferData, bRequest, wValue, wIndex, wLength)) //invalid requesttype
			{
				dwError = libMchpUsbGetLastErr(hDevice);
				memset(chToPrint, 0x00, sizeof(chToPrint));
				sprintf(chToPrint, "FAIL: MchpUsbHCETransfer.Error: %04x", dwError);
				print_to_console(bSilent, chToPrint, RED);
				goto Device_Close;
			}
			else
			{
				print_to_console(bSilent, "SUCCESS: MchpUsbHCETransfer", GREEN);
				if (HCE_Operation == FALSE) //Read
				{
					memset(sztext, 0x00, sizeof(sztext));
					for (int i = 0; i< wLength; i++)
					{
						sprintf(chToPrint, "0x%02x ", byBufferData[i]);
						strcat(sztext, chToPrint);
					}
					print_to_console(bSilent, sztext, YELLOW);

				}
			}
		}
		if (TRUE == VSM_TRANSFER)
		{
			if (FALSE == libMchpUsbVSMTransfer((BYTE)hDevice, bmRequestType, byBufferData, bRequest, wValue, wIndex, wLength)) //invalid requesttype
			{
				dwError = libMchpUsbGetLastErr(hDevice);
				memset(chToPrint, 0x00, sizeof(chToPrint));
				sprintf(chToPrint, "FAIL: MchpUsbVSMTransfer.Error: %04x", dwError);
				print_to_console(bSilent, chToPrint, RED);
				goto Device_Close;
			}
			else
			{
				print_to_console(bSilent, "SUCCESS: MchpUsbVSMTransfer", GREEN);
				if (VSM_Operation == FALSE) //Read
				{
					memset(sztext, 0x00, sizeof(sztext));
					for (int i = 0; i< wLength; i++)
					{
						sprintf(chToPrint, "0x%02x ", byBufferData[i]);
						strcat(sztext, chToPrint);
					}
					print_to_console(bSilent, sztext, YELLOW);

				}
			}
		}
		if (TRUE == SET_DCP_MODE)
		{
			if (FALSE == libMchpUsbSetDCPMode(hDevice, Config))
			{
				dwError = libMchpUsbGetLastErr(hDevice);
				memset(chToPrint, 0x00, sizeof(chToPrint));
				sprintf(chToPrint, "FAIL: MchpUsbSetDCPMode.Error: %x", dwError);
				print_to_console(bSilent, chToPrint, RED);
				goto Device_Close;
			}
			else
			{
				print_to_console(bSilent, "SUCCESS: MchpUsbSetDCPMode", GREEN);
			}
		}
		if(TRUE == DYNAMICPORTMAP)
		{
			char XDATAValues[4098];
			if(FALSE == libMchpDynamicPortMapping(hDevice,Usb2PortMapping,Usb3PortMapping, XDATAValues))
			{
				dwError = libMchpUsbGetLastErr(hDevice);
				memset(chToPrint,0x00,sizeof(chToPrint));
				sprintf(chToPrint,"FAIL: MchpDynamicPortMapping.Error: %x",dwError);
				print_to_console(bSilent,chToPrint,RED); 
			}
			else
			{
				sprintf(chToPrint,"XDATAValues: %s",XDATAValues);
				print_to_console(bSilent,chToPrint,YELLOW); 
				print_to_console(bSilent,"SUCCESS: MchpDynamicPortMapping",GREEN);
			}
		}
	Device_Close:
		if (FALSE == libMchpUsbClose(hDevice))
		{
			dwError = libMchpUsbGetLastErr(hDevice);
			memset(chToPrint, 0x00, sizeof(chToPrint));
			sprintf(chToPrint, "\n FAIL: MchpUsbClose.Error: %04x", dwError);
			print_to_console(bSilent, chToPrint, RED);
		}
		else
		{
			print_to_console(bSilent, "Success: MchpUsbClose", BLACK);
		}

	}
	catch (...)
	{
		cout << "Oops... There is a problem with previous command\n" << endl;
		cout << "See log for more details in the application directory\n" << endl;
		return -1;
	}
	return -1;
}

