#include <stdio.h>
#include "stdafx.h"

#include <iostream>
#include <iomanip>
#include <conio.h>
#include <vector>
#include <fstream>
#include <sstream>
#include <cstdlib>
#include <string>

// MPLABConnect DLL header file
#include "..\..\APIHeader\MPLABConnect.h"

using namespace std;

#define GREEN					0x0A
#define RED						0x0c
#define BLACK					0x00
#define YELLOW					(FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_GREEN)


//Common
typedef BOOL (*pfMchpUsbGetVersion) (PCHAR );
typedef void (*pfMchpEnableLogging) (INT);
typedef BOOL  (*pfMchpSetPath) (PCHAR);

//Open/Close
typedef INT (*pfMchpUsbGetAllHubs) (PCHAR);
typedef HANDLE (*pfMchpUsbOpen) (CONST UINT);
typedef HANDLE (*pfMchpUsbOpenID) (UINT16,UINT16);
typedef HANDLE  (*pfMchpUsbHCEOpen) (UINT16,UINT16);
typedef BOOL (*pfMchpUsbClose) (HANDLE);

//OTP Bridging
typedef BOOL (*pfMchpUsbOtpRead) ( HANDLE , UINT, UINT , UINT8*);
typedef BOOL  (*pfMchpUsbOtpWrite) ( HANDLE , UINT, UINT8*);

typedef UINT32  (*pfMchpUsbGetLastErr) (HANDLE);

//Dev Reset
typedef BOOL(*pfMchpUsbDeviceReset) (HANDLE);


//Common
pfMchpEnableLogging libMchpEnableLogging;
pfMchpUsbGetVersion libMchpUsbGetVersion;
pfMchpSetPath libMchpSetPath;

//Open/Close
pfMchpUsbGetAllHubs libMchpUsbGetAllHubs;
pfMchpUsbOpen libMchpUsbOpen;
pfMchpUsbOpenID libMchpUsbOpenID;
pfMchpUsbHCEOpen libMchpUsbHCEOpen;
pfMchpUsbClose libMchpUsbClose;

//OTP Bridging
pfMchpUsbOtpRead libMchpUsbOtpRead;
pfMchpUsbOtpWrite libMchpUsbOtpWrite;

pfMchpUsbGetLastErr libMchpUsbGetLastErr;
pfMchpUsbDeviceReset libMchpUsbDeviceReset;

void print_to_console(BOOL bsilent,char *chConsole, unsigned char byColor)
{
	HANDLE hstdin  = GetStdHandle( STD_INPUT_HANDLE  );
	HANDLE hstdout = GetStdHandle( STD_OUTPUT_HANDLE );
	// Remember how things were when we started
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	WORD   index   = 0;


	if (byColor != 0xff)
	{
		GetConsoleScreenBufferInfo( hstdout, &csbi );
		SetConsoleTextAttribute( hstdout, byColor );
	}

	if(!bsilent)
		cout << chConsole << endl;

	if (byColor != 0xff)
	{
		SetConsoleTextAttribute( hstdout, csbi.wAttributes );
	}
}
//Main Function
int main( int argc, char* argv[])
{
	try
	{
		UINT16 wVID =0x0424, wPID = 0x4002, wHCEVID = 0x0424, wHCEPID= 0x7040;
		BOOL bHubIDPresent = FALSE;
		BOOL bHubOpenIDPresent = FALSE;
		BOOL bHCEOpenPresent = FALSE;
		BYTE hubid =0;
		BOOL	bSilent=FALSE;
		int ArgPos = 0;
		UINT hub_count =0;
		HANDLE hDevice =  INVALID_HANDLE_VALUE;
		DWORD dwError = 0;
		char chToPrint[256] = {0};
		HMODULE LoadLib;
		CHAR sztext[2048];

		BOOL OTPOperation = FALSE, bReset = FALSE;
		WORD wOTPSize =0,wOTPStartAddr=0;
		string configfile;
		HANDLE hconfigfile;
		BYTE byConfigData[1024 * 8];
		DWORD dwBufOTPSize=0;

		if ((argc <= 1) || (0 == strcmp(argv[1],"--help")) || (0 == strcmp(argv[1], "/?")))
		{
			cout <<left<< setw(20)<<"--help"<<left<< setw(20)<<"Prints help message\n\n"
			<<left<< setw(20)<<"/otp"<<left<< setw(10)<<"OTP Bridging \n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/otp <operation> <StartAddr> <Length> \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"((/id <idValue>) | (/OpenId OpenIdValue) | \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"(/HCEOpen <HCEOpenId))\n\n"
			<<left<< setw(20)<<"Arguments"<< left<<setw(10)<<"<operation>: -w - WRITE, -r - READ\n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"startaddr	: Valid Start address\n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"Length (hex)		: Bytes to read/write\n\n"

			<<left<< setw(20)<<"Note"<< left<<setw(10)<<"MchpUsbOtpWrite will only update content to OTP/Pseudo OTP\n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"area. To view the changes reset in required. \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"Use /devreset to reset.\n\n"

			<<left<< setw(20)<<"Example1"<< left<<setw(10)<<"OTP Read : /otp -r 0x00 0x200 /id 0\n"
			<<left<< setw(20)<<"Example2"<< left<<setw(10)<<"OTP Write : /otp -w 0x00 0x200 myconfig.cfg /devreset /id 0\n\n"

			<< left << setw(20) << "***********************Device Open Methods*******************************\n"
			<< left << setw(20) << "/id" << left << setw(20) << "idValue: Index of the hub connected to\n"
			<< left << setw(20) << "" << left << setw(10) <<"the system - MchpUsbGetAllHubs\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/id 0 \n \n"
			<< left << setw(20) << "/OpenId" << left << setw(10) << "OpenIdValue: VID of the Hub <space> PID\n"
			<< left << setw(20) << "" << left << setw(10) <<"of the Hub\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/OpenId 0x0424 0x4002\n\n"
			<< left << setw(20) << "/HCEOpen" << left << setw(10) << "HCEOpenId	: VID of the HCE device \n"
			<< left << setw(20) << "" << left << setw(10) <<"<space> PID of the HCE device\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/HCEOpen 0x0424 0x7040\n\n"
			<< left << setw(20) << "Note" << left << setw(20) << "Position of Arguments should be \n"
			<< left << setw(20) << "" << left << setw(10) << "same as Format mentioned in help.\n";

			return 0;
		}
		if(0 == strcmp(argv[1], "/otp"))
		{
			if (argc < 6)
			{
				print_to_console(bSilent, "Invalid Format. Please refer --help for more details", RED);
				return -1;
			}
			if ((argv[2] !=  NULL) && (argv[3] != NULL) && (argv[4] != NULL))
			{
				if (0 == strcmp(argv[2], "-w"))
				{
					OTPOperation = TRUE;
				}
				else if (0 == strcmp(argv[2], "-r"))
				{
					OTPOperation = FALSE;
				}
				else
				{
					print_to_console(bSilent, "Please enter Valid Operation to Perform. -w : Write and -r : Read", RED);
					return -1;
				}
				wOTPStartAddr = (WORD)stol(argv[3], 0, 16);
				wOTPSize = (WORD)stol(argv[4], 0, 16);
				ArgPos = 5;
			}
			
			if(TRUE == OTPOperation)
			{
				if (argv[5] != NULL)
				{
					configfile = argv[5];
					hconfigfile = CreateFile(configfile.c_str(), GENERIC_READ, FILE_SHARE_READ,
						NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
					if (INVALID_HANDLE_VALUE == hconfigfile)
					{
						print_to_console(bSilent, "FAIL. File doesnot exists", RED);
						CloseHandle(hconfigfile);
						return -1;
					}
					if (FALSE == ReadFile(hconfigfile, &byConfigData[0], (1024 * 8), (LPDWORD)&dwBufOTPSize, NULL))
					{
						CloseHandle(hconfigfile);
					}
					CloseHandle(hconfigfile);
				}
				ArgPos = 6;
			}
			if((0 == strcmp(argv[ArgPos],"/devreset")) && (OTPOperation == TRUE))
			{
				bReset = TRUE;
				ArgPos = 7;
			}
			if (argv[ArgPos] != NULL)
			{
				if (0 == strcmp(argv[ArgPos], "/id")) //Device Open Using MchpUsbOpen
				{
					if (argv[ArgPos + 1] != NULL)
					{
						hubid = atoi(argv[ArgPos + 1]);
						bHubIDPresent = TRUE;
					}
					else
					{
						print_to_console(bSilent, "Please provide Hub ID", RED);
						return -1;
					}
				}
				else if (0 == strcmp(argv[ArgPos], "/OpenId")) //Device Open Using MchpUsbOpenID
				{
					if ((argv[ArgPos + 1] != NULL) && (argv[ArgPos + 2] != NULL))
					{
						wVID = (WORD)strtol(argv[ArgPos + 1], 0, 16);
						wPID = (WORD)strtol(argv[ArgPos + 2], 0, 16);
						bHubOpenIDPresent = TRUE;
					}
					else
					{
						print_to_console(bSilent, "Please provide Hub VID and Hub PID", RED);
						return -1;
					}
				}
				else if (0 == strcmp(argv[ArgPos], "/HCEOpen")) //Device Open Using MchpUsbHCEOpen
				{
					if ((argv[ArgPos + 1] != NULL) && (argv[ArgPos + 2] != NULL))
					{
						wHCEVID = (WORD)strtol(argv[ArgPos + 1], 0, 16);
						wHCEPID = (WORD)strtol(argv[ArgPos + 2], 0, 16);
						bHCEOpenPresent = TRUE;
					}
					else
					{
						print_to_console(bSilent, "Please provide HFC VID and HFC PID", RED);
						return -1;
					}
				}
				else
				{
					print_to_console(bSilent, "Please enter Valid method to Open the Device", RED);
					return -1;
				}
			}
		}
		else
		{
			print_to_console(bSilent,"Invalid Parameters. Could not proceed. Refer ReadMe.txt file or --help for additional Info",RED);
			return -1;
		}

		TCHAR basepath[MAX_PATH] = { 0 };
		std::string tempfile = "";
		std::string filepath = "";
		GetCurrentDirectory(MAX_PATH, basepath);
		tempfile = basepath;
		filepath = basepath;


		#ifdef x64
			filepath = filepath + "\\APILib\\64-bit\\MPLABConnect.dll";
			LoadLib = LoadLibrary(filepath.c_str());
		#else
			filepath = filepath + "\\APILib\\32-bit\\MPLABConnect.dll";
			LoadLib = LoadLibrary(filepath.c_str());
		#endif

		if (LoadLib != NULL)
		{
			print_to_console(bSilent, "Loadlib library Loaded\n", GREEN);
		}
		else
		{
			sprintf(chToPrint,"Failed to Load DLL : %s\n",filepath.c_str());
			print_to_console(bSilent,chToPrint,RED);
			return -1;
		}

		//Common
		libMchpEnableLogging    = (pfMchpEnableLogging) GetProcAddress ( LoadLib ,"MchpEnableLogging");
		libMchpSetPath    = (pfMchpSetPath) GetProcAddress ( LoadLib ,"MchpSetPath");
		libMchpUsbGetVersion    = (pfMchpUsbGetVersion) GetProcAddress ( LoadLib, "MchpUsbGetVersion");

		//Open/close
		libMchpUsbGetAllHubs		= (pfMchpUsbGetAllHubs) GetProcAddress ( LoadLib ,"MchpUsbGetAllHubs");
		libMchpUsbOpen				= (pfMchpUsbOpen) GetProcAddress ( LoadLib ,"MchpUsbOpen");
		libMchpUsbOpenID				= (pfMchpUsbOpenID) GetProcAddress ( LoadLib ,"MchpUsbOpenID");
		libMchpUsbHCEOpen = (pfMchpUsbHCEOpen) GetProcAddress ( LoadLib ,"MchpUsbHCEOpen");
		libMchpUsbClose			= (pfMchpUsbClose) GetProcAddress ( LoadLib ,"MchpUsbClose");

		//OTP Bridging
		libMchpUsbOtpWrite	= (pfMchpUsbOtpWrite) GetProcAddress ( LoadLib ,"MchpUsbOtpWrite");
		libMchpUsbOtpRead	=(pfMchpUsbOtpRead) GetProcAddress ( LoadLib ,"MchpUsbOtpRead");

		libMchpUsbGetLastErr	= (pfMchpUsbGetLastErr) GetProcAddress ( LoadLib ,"MchpUsbGetLastErr");
		libMchpUsbDeviceReset   = (pfMchpUsbDeviceReset) GetProcAddress ( LoadLib ,"MchpUsbDeviceReset");

		//Enable logging
		libMchpEnableLogging(LOG_DETAILED_DESCRIPTION);

		//Get Version
		if (FALSE == libMchpUsbGetVersion(sztext))
		{
			print_to_console(bSilent,"Failed to get Version number", RED);
			return -1;
		}
		else
		{
			sprintf(chToPrint,"Version : %s\n",sztext);
			print_to_console(bSilent,chToPrint,0xFF);
		}
		
		//Set Ini file path
		tempfile = tempfile + "\\APILib\\";
		if(FALSE == libMchpSetPath((PCHAR)tempfile.c_str()))
		{
			sprintf(chToPrint,"File Does not exists : %s\n",tempfile.c_str());
			print_to_console(bSilent,chToPrint,0xFF);
		}

		//Device Open Using MchpUsbOpen
		if(bHubIDPresent)
		{
			hub_count = libMchpUsbGetAllHubs(sztext); //GET all HUBs
			if (hub_count == 0)
			{
				print_to_console(bSilent,"Zero hubs found", RED);
				return -1;
			}
			else
			{
				print_to_console(FALSE,sztext,0xFF);
			}
			hDevice = libMchpUsbOpen(hubid); 
			if(hDevice == INVALID_HANDLE_VALUE)
			{
				print_to_console(bSilent,"FAIL: MchpUsbOpen",RED);
				return -1;
			}
			else
			{
				print_to_console(bSilent,"SUCCESS: MchpUsbOpen",GREEN);
			}
		}
		else if(bHubOpenIDPresent) //Device Open Using MchpUsbOpenID
		{
			hDevice = libMchpUsbOpenID(wVID, wPID); //valid handle test
			if(INVALID_HANDLE_VALUE == hDevice) 
			{
				print_to_console(bSilent,"FAIL: MchpUsbOpenID",RED);
				return -1;
			}
			else
			{
				print_to_console(bSilent,"SUCCESS: MchpUsbOpenID",GREEN);
			}
		}
		else if(bHCEOpenPresent) //Device Open Using MchpUsbHCEOpen
		{
			hDevice = libMchpUsbHCEOpen(wHCEVID, wHCEPID); //valid handle test
			if(INVALID_HANDLE_VALUE == hDevice) 
			{
				print_to_console(bSilent,"FAIL: MchpUsbHCEOpen",RED);
				return -1;
			}
			else
			{
				print_to_console(bSilent,"SUCCESS: MchpUsbHCEOpen",GREEN);
			}
		}
		else
		{
			print_to_console(bSilent,"Please provide valid method to Open the Device",RED);
			return -1;
		}

		if(OTPOperation)
		{
			if (FALSE == libMchpUsbOtpWrite(hDevice, wOTPSize, &byConfigData[0]))
			{
				dwError = libMchpUsbGetLastErr(hDevice);
				sprintf(chToPrint,"FAIL : MchpUsbOtpWrite.Error:%x",dwError);
				print_to_console(bSilent,chToPrint,RED);
				goto Device_Close;
			}
			else
			{
				print_to_console(FALSE,"SUCCESS: MchpUsbOtpWrite",GREEN);
			}
			if(TRUE == bReset)
			{
				//Reset is required for programmed configuration to take effect. MchpUsbOtpWrite only updates 
				//configuration to OTP/Pseudo OTP. Enable this code to reset
				if (FALSE == libMchpUsbDeviceReset(hDevice))
				{
					dwError = libMchpUsbGetLastErr(hDevice);
					memset(chToPrint, 0x00, sizeof(chToPrint));
					sprintf(chToPrint, "FAIL: MchpUsbDeviceReset.Error: %x", dwError);
					print_to_console(bSilent, chToPrint, RED);
					goto Device_Close;
				}
				else
				{
					print_to_console(bSilent, "SUCCESS: MchpUsbDeviceReset", GREEN);
				}
			}
			else
			{
				print_to_console(bSilent, "Reset the hub to reflect the changes", 0xFF);
			}

		}
		else
		{
			UINT8 OTPReadBytes[1024 *8];
			if (FALSE == libMchpUsbOtpRead(hDevice,wOTPStartAddr, wOTPSize, OTPReadBytes))
			{
				dwError = libMchpUsbGetLastErr(hDevice);
				sprintf(chToPrint,"FAIL : MchpUsbOtpRead.Error:%x",dwError);
				print_to_console(bSilent,chToPrint,RED);
				goto Device_Close;
			}
			else
			{
				SYSTEMTIME systime;
				GetLocalTime(&systime);
				tempfile = "\0";
				char sztempFileName[MAX_PATH];
				strcat(basepath,"\\");
				sprintf(sztempFileName,"Read_OTP_%02d_%02d_%04d_%02d_%02d_%02d.dump",systime.wMonth,systime.wDay,systime.wYear,systime.wHour,systime.wMinute,systime.wSecond);
				tempfile.append(string(basepath));
				tempfile.append(sztempFileName);
				strcpy(basepath, tempfile.c_str());

				FILE	*fOTPRead;
				fopen_s(&fOTPRead, basepath, "wb");
				fseek(fOTPRead, wOTPStartAddr, SEEK_SET);
				fwrite(OTPReadBytes,1,wOTPSize,fOTPRead);
				fclose(fOTPRead);

				sprintf(chToPrint,"Read content is available in: %s\n",basepath);
				print_to_console(bSilent,chToPrint,0xFF);

				print_to_console(FALSE,"SUCCESS: MchpUsbOtpRead",GREEN);
			}
		}

	Device_Close:
		if (FALSE == libMchpUsbClose(hDevice))
		{
			dwError = libMchpUsbGetLastErr(hDevice);
			memset(chToPrint,0x00,sizeof(chToPrint));
			sprintf(chToPrint,"\n FAIL: MchpUsbClose.Error: %04x",dwError);
			print_to_console(bSilent,chToPrint,RED);
		}
		else
		{
			print_to_console(bSilent,"Success: MchpUsbClose",BLACK);
		}
	}
	//Try catch implementation 
	catch(...)
	{
		cout << "Oops... There is a problem with previous command\n"<<endl;
		cout << "See log for more details in the application directory\n"<<endl;
		return -1;
	}

	return -1;
}
