#include <stdio.h>
#include "stdafx.h"

#include <iostream>
#include <iomanip>
#include <conio.h>
#include <vector>
#include <fstream>
#include <sstream>
#include <cstdlib>
#include <string>

// MPLABConnect DLL header file
#include "..\..\APIHeader\MPLABConnect.h"

using namespace std;

#define GREEN					0x0A
#define RED						0x0c
#define BLACK					0x00
#define YELLOW					(FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_GREEN)


//Common
typedef BOOL (*pfMchpUsbGetVersion) (PCHAR );
typedef void (*pfMchpEnableLogging) (INT);
typedef BOOL  (*pfMchpSetPath) (PCHAR);


//Open/Close
typedef INT (*pfMchpUsbGetAllHubs) (PCHAR);
typedef HANDLE (*pfMchpUsbOpen) (CONST UINT);
typedef HANDLE (*pfMchpUsbOpenID) (UINT16,UINT16);
typedef HANDLE  (*pfMchpUsbHCEOpen) (UINT16,UINT16);
typedef BOOL (*pfMchpUsbClose) (HANDLE);

//Programming APIs
typedef BOOL (*pfMchpProgramFile) (HANDLE,PCHAR);
typedef BOOL (*pfMchpProgramSPIFile) (HANDLE,PCHAR,BOOL);
typedef BOOL (*pfMchpProgramFileWithSerial) (HANDLE,PCHAR,PCHAR);
typedef BOOL (*pfMchpUsbProgramFileWithUsb3Serial) (HANDLE,PCHAR, PCHAR,PCHAR);
typedef BOOL (*pfMchpProgramSPIFirmwareWithConfig) (HANDLE,BOOL,PCHAR,PCHAR); 
typedef BOOL(*pfMchpProgramSpiFwCfgFileWithSerial) (HANDLE, BOOL, PCHAR, PCHAR, PCHAR);
typedef BOOL(*pfMchpProgramSPIFirmwareWithConfigBuffer)(HANDLE, BOOL, UINT8*,UINT32, UINT8*, UINT32);
typedef BOOL (*pfMchpEnableAutoReprogram)(HANDLE,BOOL);
typedef BOOL(*pfMchpProgramFileWithMultipleSerial)(HANDLE,PCHAR,PCHAR,PCHAR);
typedef BOOL(*pfMchpProgramFileWithSerialMAC)(HANDLE,PCHAR,PCHAR,PCHAR,PCHAR,PCHAR,BOOL);
typedef BOOL(*pfMchpProgramSPIFirmwareWithConfigSerialMAC)(HANDLE,BOOL,PCHAR,PCHAR,PCHAR,PCHAR,PCHAR,PCHAR,BOOL);
typedef BOOL(*pfMchpProgramSpiFwCfgFileWithMultipleSerial)(HANDLE,BOOL,PCHAR,PCHAR,PCHAR,PCHAR);

typedef UINT32  (*pfMchpUsbGetLastErr) (HANDLE);

//Common
pfMchpEnableLogging libMchpEnableLogging;
pfMchpUsbGetVersion libMchpUsbGetVersion;
pfMchpSetPath libMchpSetPath;

//Open/Close
pfMchpUsbGetAllHubs libMchpUsbGetAllHubs;
pfMchpUsbOpen libMchpUsbOpen;
pfMchpUsbOpenID libMchpUsbOpenID;
pfMchpUsbHCEOpen libMchpUsbHCEOpen;
pfMchpUsbClose libMchpUsbClose;

//Programming APIs
pfMchpProgramFile libMchpProgramFile;
pfMchpProgramSPIFile libMchpProgramSPIFile;
pfMchpProgramFileWithSerial libMchpProgramFileWithSerial;
pfMchpUsbProgramFileWithUsb3Serial libMchpUsbProgramFileWithUsb3Serial;
pfMchpProgramSPIFirmwareWithConfig libMchpProgramSPIFirmwareWithConfig;
pfMchpProgramSpiFwCfgFileWithSerial libMchpProgramSpiFwCfgFileWithSerial;
pfMchpProgramSPIFirmwareWithConfigBuffer libMchpProgramSPIFirmwareWithConfigBuffer;
pfMchpEnableAutoReprogram libMchpEnableAutoReprogram;
pfMchpProgramFileWithMultipleSerial libMchpProgramFileWithMultipleSerial;
pfMchpProgramFileWithSerialMAC libMchpProgramFileWithSerialMAC;
pfMchpProgramSPIFirmwareWithConfigSerialMAC libMchpProgramSPIFirmwareWithConfigSerialMAC;
pfMchpProgramSpiFwCfgFileWithMultipleSerial libMchpProgramSpiFwCfgFileWithMultipleSerial;

pfMchpUsbGetLastErr libMchpUsbGetLastErr;

void print_to_console(BOOL bsilent,char *chConsole, unsigned char byColor)
{
	HANDLE hstdin  = GetStdHandle( STD_INPUT_HANDLE  );
	HANDLE hstdout = GetStdHandle( STD_OUTPUT_HANDLE );
	// Remember how things were when we started
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	WORD   index   = 0;


	if (byColor != 0xff)
	{
		GetConsoleScreenBufferInfo( hstdout, &csbi );
		SetConsoleTextAttribute( hstdout, byColor );
	}

	if(!bsilent)
		cout << chConsole << endl;

	if (byColor != 0xff)
	{
		SetConsoleTextAttribute( hstdout, csbi.wAttributes );
	}
}
//Main Function
int main( int argc, char* argv[])
{
	try
	{
		UINT16 wVID =0x0424, wPID = 0x4002, wHCEVID = 0x0424, wHCEPID= 0x7040;
		BOOL bHubIDPresent = FALSE;
		BOOL bHubOpenIDPresent = FALSE;
		BOOL bHCEOpenPresent = FALSE;
		BYTE hubid =0;
		BOOL	bSilent=FALSE;
		int ArgPos = 0;
		UINT hub_count =0;
		HANDLE hDevice =  INVALID_HANDLE_VALUE;
		DWORD dwError = 0;
		char chToPrint[256] = {0};
		HMODULE LoadLib;
		CHAR sztext[2048];
		
		BOOL PROGRAMCFG = FALSE;
		BOOL PROGRAMSPI = FALSE;
		BOOL BUFFER = FALSE;
		BOOL bERASE = FALSE;
		BOOL PROGRAMSERIAL = FALSE;
		BOOL bUSB3SERIAL = FALSE;
		BOOL PROGRAMMAC = FALSE;
		BOOL PROGRAMDIFFSERIAL = FALSE;
		string configfile, spifile, filename;;
		HANDLE hconfigfile,hspifile;
		DWORD dwActualSize =0;
		BYTE byConfigData[1024 * 8], bySPIData[1024 *264];
		string serial, serial1,serial2,macaddr1, macaddr2;
		DWORD dwBufOTPSize, dwBufSPISize =0;


		if ((argc <= 1) || (0 == strcmp(argv[1], "--help")) || (0 == strcmp(argv[1], "/?")))
		{
			cout <<left<< setw(20)<<"--help"<<left<< setw(20)<<"Prints help message\n\n"
			<< left << setw(20) << "***************************************/p*******************************\n"
			<<left<< setw(20)<<"/p"<<left<< setw(10)<<"Program configuration \n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/p <myconfig.cfg> <Device Open Method. \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"/id, /OpenId, /HCEOpen>\n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/p bConfig.cfg /id 0\n\n"

			<< left << setw(20) << "*******************************/pspi************************************\n"
			<<left<< setw(20)<<"/pspi"<<left<< setw(10)<<"Program SPI Firmware \n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/pspi <spifw.bin> /e <Device Open Method. \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"/id, /OpenId, /HCEOpen> \n\n"
			<<left<< setw(20)<<"Arguments"<< left<<setw(10)<<"<spifw.bin> - Valid SPI Firmware file\n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"/e - Erase Pseudo OTP area \n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/pspi SPI_FW.bin /e /id 0\n\n"

			<< left << setw(20) << "***********************/p+/pser*****************************************\n"
			<<left<< setw(20)<<"/p+/pser"<<left<< setw(10)<<"Program cfg +serial \n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/p <myconfig.cfg> /pser <serial> <Device Open \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"Method. /id, /OpenId, /HCEOpen>\n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/p bConfig.cfg /pser 1234 /id 0\n\n"

			<< left << setw(20) << "***********************/p+/pser1+/pser2+-usb3****************************\n"
			<<left<< setw(20)<<"/p+/pser1+/pser2+-usb3"<<left<< setw(10)<<"Program cfg + usb3serial \n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/p <myconfig.cfg> /pser1 <serial> /pser2 <usb3serial>\n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"-usb3 <Device Open Method. /id, /OpenId, /HCEOpen>\n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/p bConfig.cfg /pser1 1234 /pser2 5678 -usb3 /id 0\n\n"

			<< left << setw(20) << "****************************/pspi + /p***********************************\n"
			<<left<< setw(20)<<"/pspi+/p"<<left<< setw(10)<<"Program cfg +spi \n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/pspi <spifw.bin> /e /p <myconfig.cfg> /n\n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"<Device Open Method. /id, /OpenId, /HCEOpen>\n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/pspi SPI_FW.bin /e /p bConfig.cfg /id 0\n\n"

			<< left << setw(20) << "****************************/pspi + /p + /pser***************************\n"
			<<left<< setw(20)<<"/pspi+/p+/pser"<<left<< setw(10)<<"Program spi+ cfg +serial \n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/pspi <spifw.bin> /e /p <myconfig.cfg> /pser \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"<serial> <Device Open Method. /id, /OpenId, /HCEOpen>\n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/pspi SPI_FW.bin /e /p bConfig.cfg /pser 1234 /id 0\n\n"

			<< left << setw(20) << "****************************/pspi + /p + /buf***************************\n"
			<<left<< setw(20)<<"/pspi+/p+/buf"<<left<< setw(10)<<"Program spi+ cfg using buffer\n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/pspi <spifw.bin> /e /p <myconfig.cfg> /buf <Device Open \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"Method. /id, /OpenId, /HCEOpen>\n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/pspi SPI_FW.bin /p bConfig.cfg /buf /id 0 \n\n"

			<< left << setw(20) << "*******************************/p + /pser1 + /pser2*************************\n"
			<<left<< setw(20)<<"/p+/pser1+ /pser2"<<left<< setw(10)<<"Program cfg and different serial\n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/p <myconfig.cfg> /pser1 <serial1> \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"/pser2 <serial2> <Device Open Method. \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"/id, /OpenId, /HCEOpen> \n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/p bConfig.cfg /pser1 1234 /pser2 3456 /id 0\n\n"

			<< left << setw(20) << "*********************************/p + /pser + /pmac****************************\n"
			<<left<< setw(20)<<"/p+/pser+/pmac"<<left<< setw(10)<<"Program cfg + serial + mac\n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/p <myconfig.cfg> /pser <serial> /pmac1 <macaddr1>   \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"/pmac2 <macaddr2> <Device Open Method. /id, /OpenId, /HCEOpen>\n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/p bConfig.cfg /pser 1234 /pmac1 01:02:03:04:05:06 \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"/pmac2 01:02:03:04:05:06 /id 0\n\n"

			<< left << setw(20) << "*************************/pspi +/p + /pser + /pmac****************************\n"
			<<left<< setw(20)<<"/pspi+/p+/pser+/pmac"<<left<< setw(10)<<"Program SPI + cfg + serial + mac\n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/pspi <spi.bin> /e /p <myconfig.cfg> /pser <serial> /pmac1 \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"<macaddr1> /pmac2 <macaddr2> Device Open Method. /id, \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"/OpenId, /HCEOpen>\n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/pspi SPI_FW.bin /e /p bConfig.cfg /pser 1234 /pmac1\n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"01:02:03:04:05:06 /pmac2 01:02:03:04:05:06 /id 0\n\n"

			<< left << setw(20) << "***********************/pspi + /p + /pser1 + /pser2****************************\n"
			<<left<< setw(20)<<"/pspi+/p+/pser1+/pser2"<<left<< setw(10)<<"Program SPI + cfg + different serial \n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/pspi <spifile.bin> /e /p <myconfig.cfg> /pser1 \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"<serial1> /pser2 <serial2> <Device Open Method. /id, \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"/OpenId, /HCEOpen>\n\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"/pspi SPI_Fw.bin /e /p bConfig.cfg /pser1 1234 \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"/pser2 3456 /id 0\n\n"

			<< left << setw(20) << "***********************Device Open Methods*******************************\n"
			<< left << setw(20) << "/id" << left << setw(20) << "idValue: Index of the hub connected to\n"
			<< left << setw(20) << "" << left << setw(10) <<"the system - MchpUsbGetAllHubs\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/id 0 \n \n"
			<< left << setw(20) << "/OpenId" << left << setw(10) << "OpenIdValue: VID of the Hub <space> PID\n"
			<< left << setw(20) << "" << left << setw(10) <<"of the Hub\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/OpenId 0x0424 0x4002\n\n"
			<< left << setw(20) << "/HCEOpen" << left << setw(10) << "HCEOpenId	: VID of the HCE device \n"
			<< left << setw(20) << "" << left << setw(10) <<"<space> PID of the HCE device\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/HCEOpen 0x0424 0x7040\n\n"
			<< left << setw(20) << "Note" << left << setw(20) << "Position of Arguments should be \n"
			<< left << setw(20) << "" << left << setw(10) << "same as Format mentioned in help.\n";

			return 0;
		}
		else
		{
			for (int i = 1; i <= argc; i++)
			{
				if(argv[i] != NULL)
				{
					if (0 == strcmp(argv[i],"/id")) //Device Open Using MchpUsbOpen
					{
						if (argv[i + 1] != NULL)
						{
							hubid = atoi(argv[++i]);
							bHubIDPresent = TRUE;
							continue;
						}
						else
						{
							print_to_console(bSilent, "Please enter Valid Hub ID", RED);
							return -1;
						}
						
					}
					else if (0 == strcmp(argv[i],"/OpenId")) //Device Open Using MchpUsbOpenID
					{
						if ((argv[i + 1] != NULL) && (argv[i + 2] != NULL))
						{
							wVID = (WORD)strtol(argv[++i], 0, 16);
							wPID = (WORD)strtol(argv[++i], 0, 16);
							bHubOpenIDPresent = TRUE;
							continue;
						}
						else
						{
							print_to_console(bSilent, "Please enter Valid Hub VID and Hub PID", RED);
							return -1;
						}
					}
					else if (0 == strcmp(argv[i],"/HCEOpen")) //Device Open Using MchpUsbHCEOpen
					{
						if ((argv[i + 1] != NULL) && (argv[i + 2] != NULL))
						{
							wHCEVID = (WORD)strtol(argv[++i], 0, 16);
							wHCEPID = (WORD)strtol(argv[++i], 0, 16);
							bHCEOpenPresent = TRUE;
							continue;
						}
						else
						{
							print_to_console(bSilent, "Please enter Valid HFC VID and HFC PID", RED);
							return -1;
						}
					}
					if(0 == strcmp(argv[i],"/p"))
					{
						if (argv[i + 1] != NULL)
						{
							PROGRAMCFG = TRUE;
							configfile = argv[++i];
							continue;
						}
						else
						{
							print_to_console(bSilent, "Please enter Valid Configuration File", RED);
							return -1;
						}
					}
					if(0 == strcmp(argv[i],"/pspi"))
					{
						if (argv[i + 1] != NULL)
						{
							PROGRAMSPI = TRUE;
							spifile = argv[++i];
							continue;
						}
						else
						{
							print_to_console(bSilent, "Please enter Valid SPI Firmware File", RED);
							return -1;
						}
					}
					if(0 == strcmp(argv[i],"/buf"))
					{
						BUFFER = TRUE;
						hconfigfile = CreateFile (configfile.c_str(), GENERIC_READ, FILE_SHARE_READ,
						NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
						if (INVALID_HANDLE_VALUE == hconfigfile)
						{
							print_to_console(bSilent,"FAIL. File doesnot exists",RED);
						}
						if (FALSE == ReadFile (hconfigfile, &byConfigData[0], (1024 * 8) ,(LPDWORD)&dwBufOTPSize, NULL))
						{
							CloseHandle (hconfigfile);
						}
						CloseHandle (hconfigfile);

						hspifile = CreateFile (spifile.c_str(), GENERIC_READ, FILE_SHARE_READ,
						NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
						if (INVALID_HANDLE_VALUE == hspifile)
						{
							print_to_console(bSilent,"FAIL. File doesnot exists",RED);
						}
						if (FALSE == ReadFile (hspifile, &bySPIData[0], (1024 * 264) ,(LPDWORD)&dwBufSPISize, NULL))
						{
							CloseHandle (hspifile);
						}
						CloseHandle (hspifile);
					}
					if(0 == strcmp(argv[i],"/e"))
					{
						bERASE = TRUE;
						continue;
					}
					if(0 == strcmp(argv[i],"/pser"))
					{
						if (argv[i + 1] != NULL)
						{
							PROGRAMSERIAL = TRUE;
							PROGRAMDIFFSERIAL = FALSE;
							serial = argv[++i];
							continue;
						}
						else
						{
							print_to_console(bSilent, "Please enter Valid Serial Number", RED);
							return -1;
						}
					}
					if(0 == strcmp(argv[i],"/pser1"))
					{
						if (argv[i + 1] != NULL)
						{
							PROGRAMSERIAL = TRUE;
							PROGRAMDIFFSERIAL = TRUE;
							serial1 = argv[++i];
							continue;
						}
						else
						{
							print_to_console(bSilent, "Please enter Valid Serial Number", RED);
							return -1;
						}
					}
					if(0 == strcmp(argv[i],"/pser2"))
					{
						if (argv[i + 1] != NULL)
						{
							PROGRAMSERIAL = TRUE;
							PROGRAMDIFFSERIAL = TRUE;
							serial2 = argv[++i];
							continue;
						}
						else
						{
							print_to_console(bSilent, "Please enter Valid Serial Number", RED);
							return -1;
						}
					}
					if(0 == strcmp(argv[i],"/pmac1"))
					{
						if (argv[i + 1] != NULL)
						{
							PROGRAMMAC = TRUE;
							macaddr1 = argv[++i];
							continue;
						}
						else
						{
							print_to_console(bSilent, "Please enter Valid MAC Address", RED);
							return -1;
						}
					}
					if(0 == strcmp(argv[i],"/pmac2"))
					{
						if (argv[i + 1] != NULL)
						{
							PROGRAMMAC = TRUE;
							macaddr2 = argv[++i];
							continue;
						}
						else
						{
							print_to_console(bSilent, "Please enter Valid MAC Address", RED);
							return -1;
						}
					}
					if(0 == strcmp(argv[i], "-usb3"))
					{
						bUSB3SERIAL = TRUE;
						continue;
					}
				}
			}
		}
		TCHAR basepath[MAX_PATH] = { 0 };
		std::string tempfile = "";
		std::string filepath = "";
		GetCurrentDirectory(MAX_PATH, basepath);
		tempfile = basepath;
		filepath = basepath;


		#ifdef x64
			filepath = filepath + "\\APILib\\64-bit\\MPLABConnect.dll";
			LoadLib = LoadLibrary(filepath.c_str());
		#else
			filepath = filepath + "\\APILib\\32-bit\\MPLABConnect.dll";
			LoadLib = LoadLibrary(filepath.c_str());
		#endif

		if (LoadLib != NULL)
		{
			print_to_console(bSilent, "Loadlib library Loaded\n", GREEN);
		}
		else
		{
			sprintf(chToPrint,"Failed to Load DLL : %s\n",filepath.c_str());
			print_to_console(bSilent,chToPrint,RED);
			return -1;
		}

		//Common
		libMchpEnableLogging    = (pfMchpEnableLogging) GetProcAddress ( LoadLib ,"MchpEnableLogging");
		libMchpSetPath    = (pfMchpSetPath) GetProcAddress ( LoadLib ,"MchpSetPath");
		libMchpUsbGetVersion    = (pfMchpUsbGetVersion) GetProcAddress ( LoadLib, "MchpUsbGetVersion");

		//Open/close
		libMchpUsbGetAllHubs		= (pfMchpUsbGetAllHubs) GetProcAddress ( LoadLib ,"MchpUsbGetAllHubs");
		libMchpUsbOpen				= (pfMchpUsbOpen) GetProcAddress ( LoadLib ,"MchpUsbOpen");
		libMchpUsbOpenID			= (pfMchpUsbOpenID) GetProcAddress ( LoadLib ,"MchpUsbOpenID");
		libMchpUsbHCEOpen			= (pfMchpUsbHCEOpen) GetProcAddress ( LoadLib ,"MchpUsbHCEOpen");
		libMchpUsbClose				= (pfMchpUsbClose) GetProcAddress ( LoadLib ,"MchpUsbClose");

		//Programming
		libMchpProgramFile		= (pfMchpProgramFile)  GetProcAddress ( LoadLib ,"MchpProgramFile");
		libMchpProgramSPIFile	= (pfMchpProgramSPIFile)  GetProcAddress ( LoadLib ,"MchpProgramSPIFile");
		libMchpProgramFileWithSerial		= (pfMchpProgramFileWithSerial)  GetProcAddress ( LoadLib ,"MchpProgramFileWithSerial");
		libMchpUsbProgramFileWithUsb3Serial = (pfMchpUsbProgramFileWithUsb3Serial) GetProcAddress ( LoadLib ,"MchpUsbProgramFileWithUsb3Serial");
		libMchpProgramSPIFirmwareWithConfig = (pfMchpProgramSPIFirmwareWithConfig) GetProcAddress (LoadLib ,"MchpProgramSPIFirmwareWithConfig");
		libMchpProgramSpiFwCfgFileWithSerial = (pfMchpProgramSpiFwCfgFileWithSerial)GetProcAddress(LoadLib, "MchpProgramSpiFwCfgFileWithSerial");
		libMchpProgramSPIFirmwareWithConfigBuffer = (pfMchpProgramSPIFirmwareWithConfigBuffer) GetProcAddress (LoadLib,"MchpProgramSPIFirmwareWithConfigBuffer");
		libMchpEnableAutoReprogram=(pfMchpEnableAutoReprogram) GetProcAddress (LoadLib, "MchpEnableAutoReprogram");
		libMchpProgramFileWithMultipleSerial = (pfMchpProgramFileWithMultipleSerial)GetProcAddress(LoadLib,"MchpProgramFileWithMultipleSerial");
		libMchpProgramFileWithSerialMAC = (pfMchpProgramFileWithSerialMAC)GetProcAddress(LoadLib,"MchpProgramFileWithSerialMAC");
		libMchpProgramSPIFirmwareWithConfigSerialMAC = (pfMchpProgramSPIFirmwareWithConfigSerialMAC)GetProcAddress(LoadLib,"MchpProgramSPIFirmwareWithConfigSerialMAC");
		libMchpProgramSpiFwCfgFileWithMultipleSerial = (pfMchpProgramSpiFwCfgFileWithMultipleSerial)GetProcAddress(LoadLib,"MchpProgramSpiFwCfgFileWithMultipleSerial");

		libMchpUsbGetLastErr		= (pfMchpUsbGetLastErr) GetProcAddress ( LoadLib ,"MchpUsbGetLastErr");

		//Enable logging
		libMchpEnableLogging(LOG_DETAILED_DESCRIPTION);

		//Get Version
		if (FALSE == libMchpUsbGetVersion(sztext))
		{
			print_to_console(bSilent,"Failed to get Version number", RED);
			return -1;
		}
		else
		{
			sprintf(chToPrint,"Version : %s\n",sztext);
			print_to_console(bSilent,chToPrint,0xFF);
		}
		
		//Set Ini file path
		tempfile = tempfile + "\\APILib\\";
		if(FALSE == libMchpSetPath((PCHAR)tempfile.c_str()))
		{
			sprintf(chToPrint,"File Does not exists : %s\n",tempfile.c_str());
			print_to_console(bSilent,chToPrint,0xFF);
		}

		//Device Open Using MchpUsbOpen
		if(bHubIDPresent)
		{
			hub_count = libMchpUsbGetAllHubs(sztext); //GET all HUBs
			if (hub_count == 0)
			{
				print_to_console(bSilent,"Zero hubs found", RED);
				return -1;
			}
			else
			{
				print_to_console(FALSE,sztext,0xFF);
			}
			hDevice = libMchpUsbOpen(hubid); 
			if(hDevice == INVALID_HANDLE_VALUE)
			{
				print_to_console(bSilent,"FAIL: MchpUsbOpen",RED);
				return -1;
			}
			else
			{
				print_to_console(bSilent,"SUCCESS: MchpUsbOpen",GREEN);
			}
		}
		else if(bHubOpenIDPresent) //Device Open Using MchpUsbOpenID
		{
			hDevice = libMchpUsbOpenID(wVID, wPID); //valid handle test
			if(INVALID_HANDLE_VALUE == hDevice) 
			{
				print_to_console(bSilent,"FAIL: MchpUsbOpenID",RED);
				return -1;
			}
			else
			{
				print_to_console(bSilent,"SUCCESS: MchpUsbOpenID",GREEN);
			}
		}
		else if(bHCEOpenPresent) //Device Open Using MchpUsbHCEOpen
		{
			hDevice = libMchpUsbHCEOpen(wHCEVID, wHCEPID); //valid handle test
			if(INVALID_HANDLE_VALUE == hDevice) 
			{
				print_to_console(bSilent,"FAIL: MchpUsbHCEOpen",RED);
				return -1;
			}
			else
			{
				print_to_console(bSilent,"SUCCESS: MchpUsbHCEOpen",GREEN);
			}
		}
		else
		{
			print_to_console(bSilent,"Please provide valid method to Open the Device",RED);
			return -1;
		}
		if((TRUE == PROGRAMSPI) && (FALSE==PROGRAMCFG))
		{
			if (FALSE == libMchpProgramSPIFile(hDevice, (PCHAR)spifile.c_str(), bERASE))   //2
			{
				dwError = libMchpUsbGetLastErr(hDevice);
				sprintf(chToPrint,"FAIL : MchpProgramSPIFile.Error:%x",dwError);
				print_to_console(bSilent,chToPrint,RED);
			}
			else
			{
				print_to_console(bSilent,"SUCCESS: MchpProgramSPIFile",GREEN);
			}
			goto Device_Close;
		}
	if((TRUE == PROGRAMSPI) && (TRUE==PROGRAMCFG))
	{
		if(BUFFER)
		{
			if (FALSE == libMchpProgramSPIFirmwareWithConfigBuffer(hDevice, bERASE, bySPIData, dwBufSPISize, byConfigData, dwBufOTPSize))
			{
				dwError = libMchpUsbGetLastErr(hDevice);
				sprintf(chToPrint,"FAIL : MchpProgramSPIFirmwareWithConfigBuffer.Error:%x",dwError);
				print_to_console(bSilent,chToPrint,RED);
			}
			else
			{
				print_to_console(bSilent,"SUCCESS: MchpProgramSPIFirmwareWithConfigBuffer",GREEN);
			}
			goto Device_Close;
		}
		if(FALSE == PROGRAMSERIAL)
		{
			if (FALSE == libMchpProgramSPIFirmwareWithConfig(hDevice, bERASE, (PCHAR)spifile.c_str(), (PCHAR)configfile.c_str())) //5
			{
				dwError = libMchpUsbGetLastErr(hDevice);
				sprintf(chToPrint,"FAIL : MchpProgramSPIFirmwareWithConfig.Error:%x",dwError);
				print_to_console(bSilent,chToPrint,RED);
				
			}
			else
			{
				print_to_console(bSilent,"SUCCESS:  MchpProgramSPIFirmwareWithConfig",GREEN);
			}
			goto Device_Close;;
		}
		else
		{
			if(FALSE == PROGRAMMAC)
			{
				if(FALSE == PROGRAMDIFFSERIAL)
				{
					//6
					if (FALSE == libMchpProgramSpiFwCfgFileWithSerial(hDevice, bERASE,(PCHAR)spifile.c_str(), (PCHAR)configfile.c_str(), (PCHAR)serial.c_str())) //3
					{
						dwError = libMchpUsbGetLastErr(hDevice);
						sprintf(chToPrint,"FAIL : MchpProgramSpiFwCfgFileWithSerial.Error:%x",dwError);
						print_to_console(bSilent,chToPrint,RED);
					}
					else
					{
						print_to_console(bSilent,"SUCCESS:  MchpProgramSpiFwCfgFileWithSerial",GREEN);
					}
					goto Device_Close;
				}
				else
				{
					//12
					if (FALSE == libMchpProgramSpiFwCfgFileWithMultipleSerial(hDevice,bERASE,(PCHAR)spifile.c_str(),(PCHAR)configfile.c_str(), (PCHAR)serial1.c_str(), (PCHAR)serial2.c_str()))
					{
						dwError = libMchpUsbGetLastErr(hDevice);
						sprintf(chToPrint,"FAIL : MchpProgramSpiFwCfgFileWithMultipleSerial.Error:%x",dwError);
						print_to_console(bSilent,chToPrint,RED);
					}
					else
					{
						print_to_console(bSilent,"SUCCESS:  MchpProgramSpiFwCfgFileWithMultipleSerial",GREEN);
					}
					goto Device_Close;
				}
			}
			else
			{
				if(FALSE == PROGRAMDIFFSERIAL)
				{
					serial1 = serial;
					serial2 = serial;
				}
				//11
				if (FALSE == libMchpProgramSPIFirmwareWithConfigSerialMAC(hDevice,bERASE,(PCHAR)spifile.c_str(),(PCHAR)configfile.c_str(),(PCHAR)serial1.c_str(), (PCHAR)serial2.c_str(),\
					(PCHAR)macaddr1.c_str(),(PCHAR)macaddr2.c_str(),TRUE))
				{
					dwError = libMchpUsbGetLastErr(hDevice);
					sprintf(chToPrint,"FAIL : MchpProgramSPIFirmwareWithConfigSerialMAC.Error:%x",dwError);
					print_to_console(bSilent,chToPrint,RED);
				}
				else
				{
					print_to_console(bSilent,"SUCCESS:  MchpProgramSPIFirmwareWithConfigSerialMAC",GREEN);
				}
				goto Device_Close;
			}
		}
	}
	if(TRUE == PROGRAMCFG)
	{
		if(FALSE == PROGRAMSERIAL)
		{
			if (FALSE == libMchpProgramFile(hDevice, (PCHAR)configfile.c_str())) //1
			{
				dwError = libMchpUsbGetLastErr(hDevice);
				sprintf(chToPrint,"FAIL : MchpProgramFile.Error:%x",dwError);
				print_to_console(bSilent,chToPrint,RED);
			}
			else
			{
				print_to_console(bSilent,"SUCCESS:  MchpProgramFile",GREEN);
			}
			goto Device_Close;
		}
		else if(TRUE == PROGRAMSERIAL)
		{
			if(bUSB3SERIAL == TRUE)
			{
				//4
				if (FALSE == libMchpUsbProgramFileWithUsb3Serial(hDevice, (PCHAR)configfile.c_str(), (PCHAR)serial1.c_str(), (PCHAR)serial2.c_str()))
				{
					dwError = libMchpUsbGetLastErr(hDevice);
					sprintf(chToPrint,"FAIL : MchpUsbProgramFileWithUsb3Serial.Error:%x",dwError);
					print_to_console(bSilent,chToPrint,RED);
				}
				else
				{
					print_to_console(bSilent,"Success:MchpUsbProgramFileWithUsb3Serial",GREEN);
				}
				goto Device_Close;
			}
			else
			{
				if((FALSE==PROGRAMDIFFSERIAL) && (FALSE ==PROGRAMMAC))
				{
					if (FALSE == libMchpProgramFileWithSerial(hDevice, (PCHAR)configfile.c_str(), (PCHAR)serial.c_str())) //3
					{
						dwError = libMchpUsbGetLastErr(hDevice);
						sprintf(chToPrint,"FAIL : MchpProgramWithSerial.Error:%x",dwError);
						print_to_console(bSilent,chToPrint,RED);
					}
					else
					{
						print_to_console(bSilent,"Success:MchpProgramFileWithSerial ",GREEN);
					}
					goto Device_Close;
				}
				else
				{
					if(TRUE == PROGRAMMAC)
					{
						if(FALSE==PROGRAMDIFFSERIAL)
						{
							serial1 = serial;
							serial2 = serial;
						}
						//10
						if (FALSE == libMchpProgramFileWithSerialMAC(hDevice,(PCHAR)configfile.c_str(),(PCHAR)serial1.c_str(),(PCHAR)serial2.c_str(),(PCHAR)macaddr1.c_str(),(PCHAR)macaddr2.c_str(),TRUE))
						{
							dwError = libMchpUsbGetLastErr(hDevice);
							sprintf(chToPrint,"FAIL : MchpProgramFileWithSerialMAC.Error:%x",dwError);
							print_to_console(bSilent,chToPrint,RED);
						}
						else
						{
							print_to_console(bSilent,"Success:MchpProgramFileWithSerialMAC ",GREEN);
						}
						goto Device_Close;
					}
					else
					{
						if (FALSE == libMchpProgramFileWithMultipleSerial(hDevice,(PCHAR)configfile.c_str(),(PCHAR)serial1.c_str(),(PCHAR)serial2.c_str())) //9
						{
							dwError = libMchpUsbGetLastErr(hDevice);
							sprintf(chToPrint,"FAIL : MchpProgramFileWithMultipleSerial.Error:%x",dwError);
							print_to_console(bSilent,chToPrint,RED);
						}
						else
						{
							print_to_console(bSilent,"Success:MchpProgramFileWithMultipleSerial ",GREEN);
						}
						goto Device_Close;
					}
				}
			}
		}
	}

	Device_Close:
		if (FALSE == libMchpUsbClose(hDevice))
		{
			dwError = libMchpUsbGetLastErr(hDevice);
			memset(chToPrint,0x00,sizeof(chToPrint));
			sprintf(chToPrint,"\n FAIL: MchpUsbClose.Error: %04x",dwError);
			print_to_console(bSilent,chToPrint,RED);
		}
		else
		{
			print_to_console(bSilent,"Success: MchpUsbClose",BLACK);
		}
	}
	//Try catch implementation 
	catch(...)
	{
		cout << "Oops... There is a problem with previous command\n"<<endl;
		cout << "See log for more details in the application directory\n"<<endl;
		return -1;
	}

	return -1;
}
