#include <stdio.h>
#include "stdafx.h"

#include <iostream>
#include <iomanip>
#include <conio.h>
#include <vector>
#include <fstream>
#include <sstream>
#include <cstdlib>
#include <string>

// MPLABConnect DLL header file
#include "..\..\APIHeader\MPLABConnect.h"

using namespace std;

#define GREEN					0x0A
#define RED						0x0c
#define BLACK					0x00
#define YELLOW					(FOREGROUND_INTENSITY | FOREGROUND_RED | FOREGROUND_GREEN)


//Common
typedef BOOL (*pfMchpUsbGetVersion) (PCHAR );
typedef void (*pfMchpEnableLogging) (INT);
typedef BOOL  (*pfMchpSetPath) (PCHAR);

//Open/Close
typedef INT (*pfMchpUsbGetAllHubs) (PCHAR);
typedef HANDLE (*pfMchpUsbOpen) (CONST UINT);
typedef HANDLE (*pfMchpUsbOpenID) (UINT16,UINT16);
typedef HANDLE  (*pfMchpUsbHCEOpen) (UINT16,UINT16);
typedef BOOL (*pfMchpUsbClose) (HANDLE);

//SPI Bridging
typedef BOOL (*pfMchpUsbSpiSetConfig) (HANDLE, INT);
typedef BOOL (*pfMchpUsbSpiFlashRead)(HANDLE,UINT32 ,UINT8*, UINT32 );
typedef BOOL (*pfMchpUsbSpiFlashWrite)(HANDLE,UINT32 ,UINT8*, UINT32 );
typedef BOOL (*pfMchpUsbSpiTransfer)(HANDLE,INT,UINT8*, UINT16,UINT32);
typedef BOOL (*pfMchpUsbSpiSelectDuplex)(HANDLE, UINT8);

typedef UINT32  (*pfMchpUsbGetLastErr) (HANDLE);

//Common
pfMchpEnableLogging libMchpEnableLogging;
pfMchpUsbGetVersion libMchpUsbGetVersion;
pfMchpSetPath libMchpSetPath;

//Open/Close
pfMchpUsbGetAllHubs libMchpUsbGetAllHubs;
pfMchpUsbOpen libMchpUsbOpen;
pfMchpUsbOpenID libMchpUsbOpenID;
pfMchpUsbHCEOpen libMchpUsbHCEOpen;
pfMchpUsbClose libMchpUsbClose;

//SPI Bridging
pfMchpUsbSpiSetConfig libMchpUsbSpiSetConfig;
pfMchpUsbSpiFlashWrite libMchpUsbSpiFlashWrite;
pfMchpUsbSpiFlashRead libMchpUsbSpiFlashRead;
pfMchpUsbSpiTransfer libMchpUsbSpiTransfer;
pfMchpUsbSpiSelectDuplex libMchpUsbSpiSelectDuplex;

pfMchpUsbGetLastErr libMchpUsbGetLastErr;

void print_to_console(BOOL bsilent,char *chConsole, unsigned char byColor)
{
	HANDLE hstdin  = GetStdHandle( STD_INPUT_HANDLE  );
	HANDLE hstdout = GetStdHandle( STD_OUTPUT_HANDLE );
	// Remember how things were when we started
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	WORD   index   = 0;


	if (byColor != 0xff)
	{
		GetConsoleScreenBufferInfo( hstdout, &csbi );
		SetConsoleTextAttribute( hstdout, byColor );
	}

	if(!bsilent)
		cout << chConsole << endl;

	if (byColor != 0xff)
	{
		SetConsoleTextAttribute( hstdout, csbi.wAttributes );
	}
}
//Main Function
int main( int argc, char* argv[])
{
	try
	{
		UINT16 wVID =0x0424, wPID = 0x4002, wHCEVID = 0x0424, wHCEPID= 0x7040;
		BOOL bHubIDPresent = FALSE;
		BOOL bHubOpenIDPresent = FALSE;
		BOOL bHCEOpenPresent = FALSE;
		BYTE hubid =0;
		BOOL	bSilent=FALSE;
		int ArgPos = 0;
		UINT hub_count =0;
		HANDLE hDevice =  INVALID_HANDLE_VALUE;
		DWORD dwError = 0;
		char chToPrint[256] = {0};
		HMODULE LoadLib;
		CHAR sztext[2048];

		BOOL SPIOperation = FALSE, SPITRANSFER = FALSE;
		DWORD dwSPIStartAddr =0;
		DWORD dwSPISize =0;
		string spifile;
		HANDLE hspifile;
		BYTE bySPIData[1024 *264];
		DWORD dwBufSPISize =0;
		BYTE bySPITransfer[512];
		BYTE bySPITransRead[512];
		WORD wDataLength =0;
		DWORD dwTotalLength = 0;

		if ((argc <= 1) || (0 == strcmp(argv[1], "--help")) || (0 == strcmp(argv[1], "/?")))
		{
			cout <<left<< setw(20)<<"--help"<<left<< setw(20)<<"Prints help message\n\n"
			<< left << setw(20) << "*********************************/spi***********************************\n"
			<<left<< setw(20)<<"/spi"<<left<< setw(10)<<"SPI Bridging \n"
			<<left<< setw(20)<<"Format"<< left<<setw(10)<<"/spi <operation> <StartAddr> <Length> \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"((/id <idValue>) | (/OpenId OpenIdValue) | \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"(/HCEOpen <HCEOpenId))\n"
			<<left<< setw(20)<<"Arguments"<< left<<setw(10)<<"<operation>	: -w - WRITE, -r - READ\n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"startaddr	: Valid Start address\n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"Length(hex) : Bytes to read/write\n\n"

			<<left<< setw(20)<<"Example1"<< left<<setw(10)<<"SPI Read: /spi -r 0x00 512 /id 0\n"
			<<left<< setw(20)<<"Example2"<< left<<setw(10)<<"SPI Write: /spi -w 0x00 512 myspi.bin /id 0\n\n"

			<< left << setw(20) << "********************************/spi*transfer*****************************\n"
			<<left<< setw(20)<<"/spitransfer"<<left<< setw(10)<<"SPI Transfer \n"
			<<left<< setw(20)<<""<< left<<setw(20)<<"/spitransfer <operation> <DataLength> \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"<TotalLength> <Data if operaton is -w> ((/id <idValue>) \n"
			<<left<< setw(20)<<""<< left<<setw(10)<<"| (/OpenId OpenIdValue) | (/HCEOpen <HCEOpenId))\n"
			<<left<< setw(20)<<"Example"<< left<<setw(10)<<"SPI Transfer(Write): /spitransfer -w 1 4 0x9F /id 0\n\n"

			<< left << setw(20) << "***********************Device Open Methods*******************************\n"
			<< left << setw(20) << "/id" << left << setw(20) << "idValue: Index of the hub connected to\n"
			<< left << setw(20) << "" << left << setw(10) <<"the system - MchpUsbGetAllHubs\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/id 0 \n \n"
			<< left << setw(20) << "/OpenId" << left << setw(10) << "OpenIdValue: VID of the Hub <space> PID\n"
			<< left << setw(20) << "" << left << setw(10) <<"of the Hub\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/OpenId 0x0424 0x4002\n\n"
			<< left << setw(20) << "/HCEOpen" << left << setw(10) << "HCEOpenId	: VID of the HCE device \n"
			<< left << setw(20) << "" << left << setw(10) <<"<space> PID of the HCE device\n"
			<< left << setw(20) << "Example" << left << setw(10) << "/HCEOpen 0x0424 0x7040\n\n"
			<< left << setw(20) << "Note" << left << setw(20) << "Position of Arguments should be \n"
			<< left << setw(20) << "" << left << setw(10) << "same as Format mentioned in help.\n";

			return 0;
		}
		if(0 == strcmp(argv[1],"/spi"))
		{
			if ((argv[2] != NULL) && (argv[3] != NULL) && (argv[4] != NULL))
			{
				if (0 == strcmp(argv[2], "-w"))
				{
					SPIOperation = TRUE;
				}
				else if (0 == strcmp(argv[2], "-r"))
				{
					SPIOperation = FALSE;
				}
				else
				{
					print_to_console(bSilent, "Please enter Valid Operation to Perform. -w : Write and -r : Read", RED);
					return -1;
				}

				dwSPIStartAddr = (DWORD)stoul(argv[3], 0, 32);
				dwSPISize = (DWORD)stoul(argv[4], 0, 16);
				ArgPos = 5;
			}
			else
			{
				print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
				return -1;
			}
			if(SPIOperation)
			{
				if (argv[5] != NULL)
				{
					spifile = argv[5];
					hspifile = CreateFile(spifile.c_str(), GENERIC_READ, FILE_SHARE_READ,
						NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
					if (INVALID_HANDLE_VALUE == hspifile)
					{
						print_to_console(bSilent, "FAIL. File doesnot exists", RED);
					}
					if (FALSE == ReadFile(hspifile, &bySPIData[0], (1024 * 264), (LPDWORD)&dwBufSPISize, NULL))
					{
						CloseHandle(hspifile);
					}
					CloseHandle(hspifile);
					ArgPos = 6;
				}
				else
				{
					print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
					return -1;
				}
			}
		}
		else if(0 == strcmp(argv[1],"/spitransfer"))
		{
			SPITRANSFER = TRUE;
			if ((argv[2] != NULL) && (argv[3] != NULL) && (argv[4] != NULL))
			{
				if (0 == strcmp(argv[2], "-w"))
				{
					SPIOperation = TRUE;
				}
				else if (0 == strcmp(argv[2], "-r"))
				{
					SPIOperation = FALSE;
				}
				else
				{
					print_to_console(bSilent, "Please enter Valid Operation to Perform. -w : Write and -r : Read", RED);
					return -1;
				}

				wDataLength = (WORD)stol(argv[3], 0, 16);
				dwTotalLength = (DWORD)stoul(argv[4], 0, 32);
				ArgPos = 5;
			}
			else
			{
				print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
				return -1;
			}
			if(SPIOperation)
			{
				for (int i=0; i<wDataLength; i++)
				{
					if (argv[5 + i] != NULL)
					{
						bySPITransfer[i] = (BYTE)strtol(argv[5 + i], 0, 16);
					}
					else
					{
						print_to_console(bSilent, "Data does not match with Length", RED);
						return -1;
					}
				}
				ArgPos = 5 + wDataLength;
			}
		}
		else 
		{
			print_to_console(bSilent,"Invalid Parameters. Could not proceed. Refer ReadMe.txt file or --help for additional Info",RED);
			return -1;
		}
		if (argv[ArgPos] != NULL)
		{
			if (0 == strcmp(argv[ArgPos], "/id")) //Device Open Using MchpUsbOpen
			{
				if (argv[ArgPos + 1] != NULL)
				{
					hubid = atoi(argv[ArgPos + 1]);
					bHubIDPresent = TRUE;
				}
				else
				{
					print_to_console(bSilent, "Please enter valid Hub id", RED);
					return -1;
				}
			}
			else if (0 == strcmp(argv[ArgPos], "/OpenId")) //Device Open Using MchpUsbOpenID
			{
				if ((argv[ArgPos + 1] != NULL) && (argv[ArgPos + 2] != NULL))
				{
					wVID = (WORD)strtol(argv[ArgPos + 1], 0, 16);
					wPID = (WORD)strtol(argv[ArgPos + 2], 0, 16);
					bHubOpenIDPresent = TRUE;
				}
				else
				{
					print_to_console(bSilent, "Please enter valid Hub VID and Hub PID", RED);
					return -1;
				}
			}
			else if (0 == strcmp(argv[ArgPos], "/HCEOpen")) //Device Open Using MchpUsbHCEOpen
			{
				if ((argv[ArgPos + 1] != NULL) && (argv[ArgPos + 2] != NULL))
				{
					wHCEVID = (WORD)strtol(argv[ArgPos + 1], 0, 16);
					wHCEPID = (WORD)strtol(argv[ArgPos + 2], 0, 16);
					bHCEOpenPresent = TRUE;
				}
				else
				{
					print_to_console(bSilent, "Please enter valid HFC VID and Hub PID", RED);
					return -1;
				}
			}
		}
		else
		{
			print_to_console(bSilent, "Please enter valid arguments. Refer ReadMe.txt or --help for more details", RED);
			return -1;
		}

		TCHAR basepath[MAX_PATH] = { 0 };
		std::string tempfile = "";
		std::string filepath = "";
		GetCurrentDirectory(MAX_PATH, basepath);
		tempfile = basepath;
		filepath = basepath;


		#ifdef x64
			filepath = filepath + "\\APILib\\64-bit\\MPLABConnect.dll";
			LoadLib = LoadLibrary(filepath.c_str());
		#else
			filepath = filepath + "\\APILib\\32-bit\\MPLABConnect.dll";
			LoadLib = LoadLibrary(filepath.c_str());
		#endif

		if (LoadLib != NULL)
		{
			print_to_console(bSilent, "Loadlib library Loaded\n", GREEN);
		}
		else
		{
			sprintf(chToPrint,"Failed to Load DLL : %s\n",filepath.c_str());
			print_to_console(bSilent,chToPrint,RED);
			return -1;
		}

		//Common
		libMchpEnableLogging    = (pfMchpEnableLogging) GetProcAddress ( LoadLib ,"MchpEnableLogging");
		libMchpSetPath    = (pfMchpSetPath) GetProcAddress ( LoadLib ,"MchpSetPath");
		libMchpUsbGetVersion    = (pfMchpUsbGetVersion) GetProcAddress ( LoadLib, "MchpUsbGetVersion");

		//Open/close
		libMchpUsbGetAllHubs		= (pfMchpUsbGetAllHubs) GetProcAddress ( LoadLib ,"MchpUsbGetAllHubs");
		libMchpUsbOpen				= (pfMchpUsbOpen) GetProcAddress ( LoadLib ,"MchpUsbOpen");
		libMchpUsbOpenID				= (pfMchpUsbOpenID) GetProcAddress ( LoadLib ,"MchpUsbOpenID");
		libMchpUsbHCEOpen = (pfMchpUsbHCEOpen) GetProcAddress ( LoadLib ,"MchpUsbHCEOpen");
		libMchpUsbClose			= (pfMchpUsbClose) GetProcAddress ( LoadLib ,"MchpUsbClose");

		//SPI Bridging
		libMchpUsbSpiSetConfig = (pfMchpUsbSpiSetConfig)  GetProcAddress ( LoadLib ,"MchpUsbSpiSetConfig");
		libMchpUsbSpiSelectDuplex = (pfMchpUsbSpiSelectDuplex) GetProcAddress (LoadLib, "MchpUsbSpiSelectDuplex");
		libMchpUsbSpiFlashWrite	=(pfMchpUsbSpiFlashWrite) GetProcAddress ( LoadLib ,"MchpUsbSpiFlashWrite");
		libMchpUsbSpiFlashRead =(pfMchpUsbSpiFlashRead) GetProcAddress ( LoadLib ,"MchpUsbSpiFlashRead");
		libMchpUsbSpiTransfer = (pfMchpUsbSpiTransfer) GetProcAddress ( LoadLib ,"MchpUsbSpiTransfer");

		libMchpUsbGetLastErr	= (pfMchpUsbGetLastErr) GetProcAddress ( LoadLib ,"MchpUsbGetLastErr");

		//Enable logging
		libMchpEnableLogging(LOG_DETAILED_DESCRIPTION);

		//Get Version
		if (FALSE == libMchpUsbGetVersion(sztext))
		{
			print_to_console(bSilent,"Failed to get Version number", RED);
			return -1;
		}
		else
		{
			sprintf(chToPrint,"Version : %s\n",sztext);
			print_to_console(bSilent,chToPrint,0xFF);
		}
		
		//Set Ini file path
		tempfile = tempfile + "\\APILib\\";
		if(FALSE == libMchpSetPath((PCHAR)tempfile.c_str()))
		{
			sprintf(chToPrint,"File Does not exists : %s\n",tempfile.c_str());
			print_to_console(bSilent,chToPrint,0xFF);
		}

		//Device Open Using MchpUsbOpen
		if(bHubIDPresent)
		{
			hub_count = libMchpUsbGetAllHubs(sztext); //GET all HUBs
			if (hub_count == 0)
			{
				print_to_console(bSilent,"Zero hubs found", RED);
				return -1;
			}
			else
			{
				print_to_console(FALSE,sztext,0xFF);
			}
			hDevice = libMchpUsbOpen(hubid); 
			if(hDevice == INVALID_HANDLE_VALUE)
			{
				print_to_console(bSilent,"FAIL: MchpUsbOpen",RED);
				return -1;
			}
			else
			{
				print_to_console(bSilent,"SUCCESS: MchpUsbOpen",GREEN);
			}
		}
		else if(bHubOpenIDPresent) //Device Open Using MchpUsbOpenID
		{
			hDevice = libMchpUsbOpenID(wVID, wPID); //valid handle test
			if(INVALID_HANDLE_VALUE == hDevice) 
			{
				print_to_console(bSilent,"FAIL: MchpUsbOpenID",RED);
				return -1;
			}
			else
			{
				print_to_console(bSilent,"SUCCESS: MchpUsbOpenID",GREEN);
			}
		}
		else if(bHCEOpenPresent) //Device Open Using MchpUsbHCEOpen
		{
			hDevice = libMchpUsbHCEOpen(wHCEVID, wHCEPID); //valid handle test
			if(INVALID_HANDLE_VALUE == hDevice) 
			{
				print_to_console(bSilent,"FAIL: MchpUsbHCEOpen",RED);
				return -1;
			}
			else
			{
				print_to_console(bSilent,"SUCCESS: MchpUsbHCEOpen",GREEN);
			}
		}
		else
		{
			print_to_console(bSilent,"Please provide valid method to Open the Device",RED);
			return -1;
		}

		if (FALSE == libMchpUsbSpiSetConfig(hDevice, TRUE))
		{
			dwError = libMchpUsbGetLastErr(hDevice);
			sprintf(chToPrint,"FAIL : MchpUsbSpiSetConfig.Error:%x",dwError);
			print_to_console(bSilent,chToPrint,RED);
			goto Device_Close;
		}
		if(SPITRANSFER == FALSE)
		{
			if(SPIOperation)
			{
				if (FALSE == libMchpUsbSpiFlashWrite(hDevice, dwSPIStartAddr, &bySPIData[0], dwSPISize))
				{
					dwError = libMchpUsbGetLastErr(hDevice);
					sprintf(chToPrint,"FAIL : MchpUsbSpiFlashWrite.Error:%x",dwError);
					print_to_console(bSilent,chToPrint,RED);
					goto Device_Close;
				}
				else
				{
					sprintf(chToPrint,"SUCCESS : MchpUsbSpiFlashWrite");
					print_to_console(bSilent,chToPrint,GREEN);
				}
			}
			else
			{
				UINT8 SPIReadBytes[1024 * 264];
				if (FALSE  == libMchpUsbSpiFlashRead(hDevice,dwSPIStartAddr,&SPIReadBytes[0],dwSPISize))
				{
					dwError = libMchpUsbGetLastErr(hDevice);
					sprintf(chToPrint,"FAIL : MchpUsbSpiFlashRead.Error:%x",dwError);
					print_to_console(bSilent,chToPrint,RED);
					goto Device_Close;
				}
				else
				{
					SYSTEMTIME systime;
					GetLocalTime(&systime);
					tempfile = "\0";
					char sztempFileName[MAX_PATH];
					strcat(basepath,"\\");
					sprintf(sztempFileName,"Read_SPI_%02d_%02d_%04d_%02d_%02d_%02d.dump",systime.wMonth,systime.wDay,systime.wYear,systime.wHour,systime.wMinute,systime.wSecond);
					tempfile.append(string(basepath));
					tempfile.append(sztempFileName);
					strcpy(basepath, tempfile.c_str());

					FILE	*fSPIRead;
					fopen_s(&fSPIRead, basepath, "wb");
					fseek(fSPIRead, dwSPIStartAddr, SEEK_SET);
					fwrite(SPIReadBytes,1,dwSPISize,fSPIRead);
					fclose(fSPIRead);
					sprintf(chToPrint,"Read content is available in: %s\n",basepath);
					print_to_console(bSilent,chToPrint,0xFF);
					sprintf(chToPrint,"SUCCESS : MchpUsbSpiFlashRead.");
					print_to_console(bSilent,chToPrint,GREEN);
				}
			}
		}
		else
		{
			if(TRUE == SPIOperation)
			{
				if (FALSE == libMchpUsbSpiTransfer(hDevice, 0, &bySPITransfer[0], wDataLength, dwTotalLength)) //write
				{
					dwError = libMchpUsbGetLastErr(hDevice);
					sprintf(chToPrint,"FAIL : nMchpUsbSpiTransfer.Error:%x",dwError);
					print_to_console(bSilent,chToPrint,RED);
					goto Device_Close;
				}
				if (FALSE == libMchpUsbSpiTransfer(hDevice, 1, &bySPITransRead[0], NULL, dwTotalLength))
				{
					dwError = libMchpUsbGetLastErr(hDevice);
					sprintf(chToPrint,"FAIL : MchpUsbSpiTransfer.Error:%x",dwError);
					print_to_console(bSilent,chToPrint,RED);
					goto Device_Close;
				}
				else
				{
					sprintf(chToPrint,"SUCCESS: MchpUsbSpiTransfer.");
					print_to_console(bSilent,chToPrint,GREEN);
					memset(sztext,0x00,sizeof(sztext));
					for ( DWORD i = 0; i < dwTotalLength; i++)
					{
						sprintf(chToPrint,"0x%02x ",bySPITransRead[i]);
						strcat(sztext,chToPrint);
					}
					print_to_console(FALSE,sztext,YELLOW);
				}
			}
			else
			{
				if (FALSE == libMchpUsbSpiTransfer(hDevice, 1, &bySPITransRead[0], NULL, dwTotalLength))
				{
					dwError = libMchpUsbGetLastErr(hDevice);
					sprintf(chToPrint,"FAIL : MchpUsbSpiTransfer.Error:%x",dwError);
					print_to_console(bSilent,chToPrint,RED);
					goto Device_Close;
				}
				else
				{
					sprintf(chToPrint,"SUCCESS: MchpUsbSpiTransfer.");
					print_to_console(bSilent,chToPrint,GREEN);
					memset(sztext,0x00,sizeof(sztext));
					for ( DWORD i = 0; i < dwTotalLength; i++)
					{
						sprintf(chToPrint,"0x%02x ",bySPITransRead[i]);
						strcat(sztext,chToPrint);
					}
					print_to_console(FALSE,sztext,YELLOW);
				}
			}
		}
		if (FALSE == libMchpUsbSpiSetConfig(hDevice, FALSE))
		{
			dwError = libMchpUsbGetLastErr(hDevice);
			sprintf(chToPrint,"FAIL : MchpUsbSpiSetConfig.Error:%x",dwError);
			print_to_console(bSilent,chToPrint,RED);
			goto Device_Close;
		}
	

	Device_Close:
		if (FALSE == libMchpUsbClose(hDevice))
		{
			dwError = libMchpUsbGetLastErr(hDevice);
			memset(chToPrint,0x00,sizeof(chToPrint));
			sprintf(chToPrint,"\n FAIL: MchpUsbClose.Error: %04x",dwError);
			print_to_console(bSilent,chToPrint,RED);
		}
		else
		{
			print_to_console(bSilent,"Success: MchpUsbClose",BLACK);
		}
	}
	//Try catch implementation 
	catch(...)
	{
		cout << "Oops... There is a problem with previous command\n"<<endl;
		cout << "See log for more details in the application directory\n"<<endl;
		return -1;
	}

	return -1;
}