/*! jQuery v1.10.2 | (c) 2005, 2013 jQuery Foundation, Inc. | jquery.org/license
*/
//Variables to know which page has been selected: USB2.0 or USB3.1 Gen1
//var Product = getProduct();
//var ConfigType = getConfigType();
var LAN_ID = "";
var lansFound = false;
var RegString = "";
var stringnullvalue = "NULL STRING - NOT PROGRAMMED YET";
// values returned if a value is 1 from the backend
var checkbox_checked_value = "1";
var checkbox_unchecked_value = "0";

var enableApplyButton = false;
var CurrentLANProgrammed = "";
var disableWhenEEPROMLess = false;

var count = 0;
//Widget IDs of String fields in the GUI
var GwidgetlistString = [
	"macaddr"
];

//Widget IDs of Hex fields in the GUI
var GwidgetValuelistHex = [
	"subsystemvid",
	"subsystemid"
];

//Widget IDs of Checkbox fields in the GUI
var GwidgetCheckbox = [
	"LED0Enable",
	"LED1Enable",
	"LED2Enable",
	"LED3Enable"
];

var GwidgetlistDropDown1 = [
	"LED0Function",
	"LED1Function",
	"LED2Function",
	"LED3Function",
	"auxcurrent",
	"pmeSupport",
	"L0Latency",
	"L1Latency",
	"OBFFSupport"
];

var DropDownLEDListFunction = [
	"Link/Activity",
	"Link1000/Activity",
	"Link100/Activity",
	"Link10/Activity",
	"Link100/1000/Activity",
	"Link10/1000/Activity",
	"Link10/100/Activity",
	"Reserved",
	"Duplex/Collision",
	"Collision",
	"Activity",
	"Reserved",
	"Auto-Negotiation Fault",
	"Serial Mode",
	"Force LED Off",
	"Force LED On"
];

var auxcurrentFunction = [
	"0 mA",
	"55 mA",
	"100 mA",
	"160 mA",
	"220 mA",
    "270 mA",
	"320 mA",
	"375 mA"
];

var pmeFunction1 = [
    "D0",
	"D3 Hot",
	"D3 Cold"
];

var L0LatencyFunction = [
    "1 us",
	"2 us",
	"3 us",
	"4 us",
	"5 us",
	"6 us",
	"7 us"
];

var L1LatencyFunction = [
   "1 us",
	"2 us",
	"4 us",
	"8 us",
	"16 us",
	"32 us",
	"64 us"	
];

var OBFFSupportFunction = [
   "Not Supported",
	"Supported using message Signaling only",
	"Supported using WAKE# Signaling only",
	"Supported using WAKE# and message signaling"
];
//Widget IDs of Radio fields in the GUI
var GwidgetlistRadio = [
	"LED0CombineEnable",
	"LED1CombineEnable",
	"LED2CombineEnable",
	"LED3CombineEnable",
	"LED0",
	"LED1",
	"LED2",
	"LED3",
	"LED0Polarity",
	"LED1Polarity",
	"LED2Polarity",
	"LED3Polarity",
	"LEDActivity",
	"LEDRate",
	"LEDPulsing",
	"ClkPowerEnable",
	"LTRSupport",
	"ASPMControl",
	"L1PMSubstates",
	"PciPmL1",
	"PciPmL2",
	"ASPML2",
	"ASPML1",
	"macEEETxClkStopEnable",
	"macSpeedDetect",
	"macConfiguration",
	"macDuplexDetection",
	"macDuplexMode",
	"macDuplexPolarity",
	"macRgmiiTxDelayEnable",
	"macRgmiiRxEnable",
	"macClk125Enable",
	"macRefClk25Enable",
	"macEEEEnable"
];

//Mapping Hex widgets to the meaningful elaborations to print while in error
var Mapping = {
	"macaddr": "MAC Address",
	"subsystemvid": "Subsystem Vendor ID",
	"subsystemid": "Subsystem ID",
	"auxcurrent":"Aux Current",
	"pmeSupport":"PME Support",
	"ClkPowerEnable":"Clock Power Management",
	"ASPMControl":"ASPM Control",
	"L0Latency":"L0 Latency",
	"L1Latency":"L1 Latency",
	"LTRSupport":"LTR Support",
	"OBFFSupport":"OBFF Support",
	"L1PMSubstates":"L1 PM Subststes",
	"PciPmL1":"PCI-PM L1.1 Support",
	"PciPmL2":"PCI-PM L2 Support",
	"ASPML1":"ASPM L1.1 Support",
	"ASPML2":"ASPM L1.2 Support",
	"LED0Function": "LED 0 Function",
	"LED1Function": "LED 1 Function",
	"LED2Function": "LED 2 Function",
	"LED3Function": "LED 3 Function",
	"LED0Enable": "LED 0 Enable",
	"LED1Enable": "LED 1 Enable",
	"LED2Enable": "LED 2 Enable",
	"LED3Enable": "LED 3 Enable",
	"LED0CombineEnable":"LED Combination Enable",
	"LED1CombineEnable":"LED Combination Enable",
	"LED2CombineEnable":"LED Combination Enable",
	"LED3CombineEnable":"LED Combination Enable",
	"LED0": "LED Pulse Stretch Enable",
	"LED1": "LED Pulse Stretch Enable",
	"LED2": "LED Pulse Stretch Enable",
	"LED3": "LED Pulse Stretch Enable",
	"LEDRate":"LED Rate",
	"LEDPulsing":"LED Pulse",
	"LED0Polarity":"LED Polarity",
	"LED1Polarity":"LED Polarity",
	"LED2Polarity":"LED Polarity",
	"LED3Polarity":"LED Polarity",
	"LEDActivity":"LED Activity",
	"macSpeedDetect":"Automatic Speed Detection",
	"macConfiguration":"MAC Configuration",
	"macDuplexMode":"Duplex Mode",
	"macDuplexDetection":"Duplex Mode Detection",
	"macDuplexPolarity":"Duplex Polarity",
	"macEEEEnable":"Energy Efficient Ethernet Enable",
	"MacEEETxClkStopEnable":"Energy Efficient Ethernet TX Clock Stop Enable",
	"MacRgmiiTxDelayEnable":"RGMII TXC Enable",
	"macRgmiiRxEnable":"RGMII RXC Enable",
	"macClk125Enable":"Generate CLK 125 MHZ Enable",
	"macRefClk25Enable":"Reference CLK 25 MHZ Out Enable",
	"userInitentry":"User Initialization Table"
};

(function ($) {
    get_LAN_list = function () {
		//Close All LAN instances
		closeAll_pcie_devices();
		set_changed_fields_border_default();

        // Populate the List of LANs		
		clearLANWidgetMap();
		setConfigMode(false, "NULL");
		var i = 0;
		update_status_message("Fetching the PCIE list...");
		var data = "";
		data = getPCIEList();
		$("#dropDownUL").empty();

		if (data) {
			enable_fields();
			$("#Apply").attr('disabled', false);
			$("#Preview").attr('disabled', false);
			$("#Factory").attr('disabled', false);
			$("#eepromErase").attr('disabled', false);
			enableApplyButton = true;
			var lan_list = data.split("###");
			
			
			for (var k = (lan_list.length - 1); k >= 0; k--) {
				if (lan_list[k]) {
					update_status_message(lan_list[k]);
					$("#dropDownUL").append("<li> <a tabindex=\"-1\" href=\"javascript:void(0)\" align=\"left\">" + lan_list[k] + "</a> </li>");
				}
			}
			
			$("#selectedLANinput").val(lan_list[(lan_list.length - 2)]);
					$('.selectLAN1')
					.find('[data-bind="SelectLAN74XX"]').text(lan_list[(lan_list.length - 2)])
					.children('.dropdown-toggle').dropdown('toggle');
					
			
			var btnValue = $("#selectedLANinput").val();
			var colonIndex = btnValue.indexOf(":");
			LAN_ID = "" + btnValue.charAt(colonIndex + 1);
			lansFound = true;
			
		} else {
			var errorCode = getMchpLANLastError("0");
			
			if (errorCode == 24576) {
				alert(errorMap[Dec2Hex(errorCode)] + " Please open the application as Administrator.");
				update_status_message(errorMap[Dec2Hex(errorCode)] + " Please open the application as Administrator.");
			} else {
				if(errorCode == -1){ 
					window.alert("No LAN74XX Ethernet Bridging Device found");
					update_status_message("No LAN74XX Ethernet Bridging Device found");
				} else {
					window.alert(errorMap[Dec2Hex(errorCode)] + "No LAN74XX Ethernet Bridging Device found");
					update_status_message(errorMap[Dec2Hex(errorCode)] + "No LAN74XX Ethernet Bridging Device found");
				}
				
			}
			reset_fields();
			$("#Apply").attr('disabled', true);
			$("#Preview").attr('disabled', true);
			$("#Factory").attr('disabled', true);
			$("#eepromErase").attr('disabled', true);
			enableApplyButton = false;
			disable_fields();
			lansFound = false;
		}
    };
})(jQuery);

(function ($) {
    update_status_message = function (mesg) {
        var currentdate = new Date(); 
        currentdate+''; 
        var datetime = currentdate.toLocaleString();
        $("#DSStatusMessage").append( datetime +":"+ mesg + "\n");
        $("#DSStatusMessage").animate({
            scrollTop:$("#DSStatusMessage")[0].scrollHeight - $("#DSStatusMessage").height()
            },400,function(){
          })
        };
})(jQuery);


(function ($) {
    get_LAN_list_set_LAN_index_zero = function () {
		
		get_LAN_list();
		
		if (lansFound) {
			set_selected_lan_get_widgets();
		}
	};
})(jQuery);

var lanMemory;
(function ($) {
    set_selected_lan_get_widgets = function () {
		var skuName = get_sku(LAN_ID);
		
		if ((skuName == "LAN7430")) 
		{
			$("#duplexPolarity").attr('disabled', true);
			$("#LedTab").show();
			$("#showfor7431").hide();
		} else if((skuName == "LAN7431")){
			//$("#NotForLAN7400").show();
			$("#duplexPolarity").attr('disabled', false);
			$("#LedTab").hide();
			$("#showfor7431").show();
		}
		
		if (skuName == "") {
			skuName = "not identified";
		}

		update_status_message("The skuName for the LAN74XX Ethernet Briding Device of Index: " + LAN_ID + " is " + skuName + ".");

		if (skuName) {
			//enable_fields();
			$("#AIPNInput").val(skuName);
			
			if ((skuName === "NOT MICROCHIP") || (skuName === "NOT IMPLEMENTED"))
			{
				alert("LAN74XX is not a Microchip LAN.Please select a Microchip LAN");
				update_status_message("LAN74XX is not a Microchip LAN.Please select a Microchip LAN");

			} else {
				update_status_message ("The selected LAN part number is " + skuName);

				// LAN Memory Information
				lanMemory = get_lan_memory(LAN_ID);
				
				var otpConfLoc;
				var otpMem;
				if ((lanMemory == "EEPROM") || (lanMemory == "")){
					$("#OTPConfigLoadSection").hide();
					$("#EepromConfigLoadSection").show();
					enable_fields();
					var nameofcontrol = "input[name=eepromConfigGroup][value=1]";
					$(nameofcontrol).prop("checked", true);
				} else if(lanMemory == "EEPROM_MAC")
				{
					lanMemory = "EEPROM"
					$("#OTPConfigLoadSection").hide();
					$("#EepromConfigLoadSection").show();
					disable_fields();
					$("#MAC_Section").attr('disabled', false);
					$("#MemDump_Section").attr('disabled', false);
					$("#LU_Section").attr('disabled', false);
					var nameofcontrol = "input[name=eepromConfigGroup][value=0]";
					$(nameofcontrol).prop("checked", true);
					
				} else {
					$("#EepromConfigLoadSection").hide();
					$("#OTPConfigLoadSection").show();
					enable_fields();
					otpMem = lanMemory.split("_");
					lanMemory = otpMem[0];
					otpConfLoc = otpMem[1];
					$("#Factory").attr('disabled', true);
					$("#eepromErase").attr('disabled', true);
				}
				
				if (lanMemory != "") {
					
					var nameofcontrol = "input[name=ConfigLocationGroup][value=" + lanMemory + "]";
					$(nameofcontrol).prop("checked", true);
					
					if (lanMemory == "OTP") {
						$("#OTPConfigProgrammed").val(otpConfLoc);
					}
				} else {
					var errorCode = getMchpLANLastError(LAN_ID);
					if (errorCode == 24579) {
						alert(errorMap[Dec2Hex(errorCode)]);
						update_status_message(errorMap[Dec2Hex(errorCode)]);
						disableWhenEEPROMLess = true;
					} else if(errorCode == 24580){
						window.alert(errorMap[Dec2Hex(errorCode)]);
						update_status_message(errorMap[Dec2Hex(errorCode)]);
					} else if(errorCode == 24581){
						window.alert(errorMap[Dec2Hex(errorCode)]);
						update_status_message(errorMap[Dec2Hex(errorCode)]);
						disableWhenEEPROMLess = true;
					} else if(errorCode == 24582){
						window.alert(errorMap[Dec2Hex(errorCode)]);
						update_status_message(errorMap[Dec2Hex(errorCode)]);
						disableWhenEEPROMLess = true;
					} else if(errorCode == 24583){
						window.alert(errorMap[Dec2Hex(errorCode)]);
						update_status_message(errorMap[Dec2Hex(errorCode)]);
						disableWhenEEPROMLess = true;
					}
					
					if(disableWhenEEPROMLess) {
						reset_fields();
						$("#Apply").attr('disabled', true);
						$("#Preview").attr('disabled', true);
						$("#Factory").attr('disabled', true);
						$("#eepromErase").attr('disabled', true);
						//$('#myprogress').hide();
						enableApplyButton = false;
						disable_fields();
						lansFound = false;
						return;
					}
				}
			}
		}

		//Updating String widgets
		$.each(GwidgetlistString, function( index, value ) {
			var widgetid = "#" + value;
			var widgetValue = getLANWidgetValue(LAN_ID, value);
			
			if(widgetValue === "") {
				$(widgetid).val(stringnullvalue);
			} else {
				$(widgetid).val(widgetValue);
			}
		});
		

		// Updating GwidgetlistHex
		$.each(GwidgetValuelistHex, function( index, value ) {
			var widgetid = "#" + value;
			var widgetValue = getLANWidgetValue(LAN_ID, value);
			var decvalue = parseInt(widgetValue,10);
			var hexstring = decvalue.toString(16);
			$(widgetid).val(hexstring);
			
		});

		// Updating GwidgetlistDropDown1
		$.each(GwidgetlistDropDown1, function( index, value ) {
			var widgetValue = getLANWidgetValue(LAN_ID, value);
			var decval = parseInt(widgetValue,10);
			var nameofcontrol = "." + value;
			var nameofcontrol1 = "[data-bind=\"" + value + "label\"]";
			var selText = "None";

			if ((value == "LED0Function") || (value == "LED1Function") ||
			(value == "LED2Function") || (value == "LED3Function"))
			{
				$.each(DropDownLEDListFunction, function( index, valuelist ) {
					if ( index == decval)
					{
						selText = valuelist;
					}
				});
			}
			
			if (value == "auxcurrent")
			{
				$.each(auxcurrentFunction, function( index, valuelist ) {
					if ( index == decval)
					{
						selText = valuelist;
					}
				});
			}
			
			if (value == "pmeSupport")
			{
				$.each(pmeFunction1, function( index, valuelist ) {
					if(decval == 1)
					{
						selText = "D0";
					}
					if(decval == 8)
					{
						selText = "D3 Hot";
					}
					if(decval == 16)
					{
						selText = "D3 Cold";
					}
				});
			}
			
			if (value == "L0Latency")
			{
				$.each(L0LatencyFunction, function( index, valuelist ) {
					if ( index == decval)
					{
						selText = valuelist;
					}
				});
			}
			
			if (value == "L1Latency")
			{
				$.each(L1LatencyFunction, function( index, valuelist ) {
					if ( index == decval)
					{
						selText = valuelist;
					}
				});
			}
			
			if (value == "OBFFSupport")
			{
				$.each(OBFFSupportFunction, function( index, valuelist ) {
					if ( index == decval)
					{
						selText = valuelist;
					}
				});
			}
			
			// Update fields based on obtained value
			$(nameofcontrol)
		   .find(nameofcontrol1).text(selText)
			.children('.dropdown-toggle').dropdown('toggle');
		});
		
		// Updating GwidgetCheckbox
		$.each(GwidgetlistRadio, function( index, value ) {
			var groupname = value +"Group";
			var widgetValue = getLANWidgetValue(LAN_ID, value);
			if(value == "L1PMSubstates")
			{
				if((widgetValue = getLANWidgetValue(LAN_ID, "L1PMSubstates")) == 0)
				{
					$("#hideL1xbits").attr('disabled', true);
				}
				else
				{
					$("#hideL1xbits").attr('disabled', false);
				}
			}
			
			if(value == "macSpeedDetect")
			{
				if((widgetValue = getLANWidgetValue(LAN_ID, "macSpeedDetect")) == 1)
				{
					$("#macConfig").attr('disabled', true);
				}
				else
				{
					$("#macConfig").attr('disabled', false);
				}
			}
			
			if(value == "macDuplexDetection")
			{
				if((widgetValue = getLANWidgetValue(LAN_ID, "macDuplexDetection")) == 1)
				{
					$("#duplexMode").attr('disabled', true);
					$("#duplexPolarity").attr('disabled', true);
				}
				else
				{
					$("#duplexMode").attr('disabled', true);
					$("#duplexPolarity").attr('disabled', false);
				}
			}
			if(value == "macConfiguration") 
			{
				if(widgetValue == 2) {
					widgetValue = 2;
				}
			}
			var nameofcontrol = "input[name=" + groupname + "][value=" + widgetValue + "]";
			$(nameofcontrol).prop("checked", true);
			set_changed_fields_border_default();
		});
		
		// Updating GwidgetlistCheckbox
		$.each(GwidgetCheckbox, function( index, value ) {
			var widgetid = "#" + value;
			var widgetValue = getLANWidgetValue(LAN_ID, value);
			
			if ( widgetValue == checkbox_checked_value )
			{
				$(widgetid).prop('checked',true);     
				// If there are corresponding fieldsets - enable them 
				$(widgetid).trigger("change"); 
			}
			else {
				$(widgetid).prop('checked',false);
				// If there are corresponding fieldsets - disable them 
				$(widgetid).trigger("change"); 
			}
			set_changed_fields_border_default();
		});
		
		//Handling User Initialization table
		var user_enableVal = getLANWidgetValue(LAN_ID, "userInitentry");
		//var user_enableVal = "START_OFFSET+26+F0+1C+78+56+34+12+START_OFFSET+27+F8+1C+72+56+34+12+";
		var offset;
		var configOffset;
		var addressOffset;
		var address;
		var valueOffset1;
		var valueOffset2;
		var valueOffset3;
		var valueOffset4;
		var inc = 0;

		for (var index = 0; index < user_enableVal.length; index++)
		{
			var splituser_enableVal = user_enableVal.split('+');
			if(splituser_enableVal[index] == "START_OFFSET")
			{
				$('#RemoveTableSection').show();
				userIncrement++;
				count++;
				$('#linkuser').show();
				var objTo = document.getElementById('dynamicUsertable')
				var divtest = document.createElement("div");
				divtest.innerHTML = '<div id = "check"><div id = "che'+inc+'"><div class="container"> <div class="row"><div class="col-sm-3"> <p class="text-muted">Register Address Space</p> <div class="form-group"> <div class="col-sm-4" id="userConfig'+inc+'Group" onchange="updateFCWValue()"> <input type="radio" name="userConfig'+inc+'Group" id="userConfig'+inc+1+'" value="0" /><label for="userConfig'+inc+1+'" >CSR</label>  </br> <input type="radio" name="userConfig'+inc+'Group" id="userConfig'+inc+'" value="1" /><label for="userConfig'+inc+'" >PCIe</label> </div></div></div> <div class="col-sm-3"> <p class="text-muted">CSR/PCIecfg Register Address(Hex)</p> <div class="form-group"> <div class="col-sm-6" align = "center"> </br> <input id="userAddress" maxlength = "4" type="text" class="form-control" placeholder="Address"> </div></div></div> <div class="col-sm-6"><p class="text-muted">CSR/PCIecfg Register Value(Hex)</p> <div class="form-group"><div class="col-sm-3"><input id="byteEnable1" type="checkbox" ><label> Byte3(MSB)</label><input maxlength = "2" id="userValue1" type="text" class="form-control" placeholder="Value" onchange = "value1Change()"></div><div class="col-sm-3"><input id="byteEnable2" type="checkbox" ><label>Byte 2</label><input id="userValue2" maxlength = "2" type="text" class="form-control" placeholder="Value" onchange = "value2Change()"></div><div class="col-sm-3"><input id="byteEnable3" type="checkbox" ><label>Byte 1</label><input id="userValue3" maxlength = "2" type="text" class="form-control" placeholder="Value" onchange = "value3Change()"></div><div class="col-sm-3"><input id="byteEnable4" type="checkbox" ><label>Byte 0(LSB)</label><input id="userValue4" maxlength = "2" type="text" class="form-control" placeholder="Value" onchange = "value4Change()"></div></div><label for="singleClose" data-toggle="tooltip" title="Click to Remove Entry" data-container="body"><span class="popupClose" id = "singleClose" onClick = "$(this).parent().parent().parent().parent().remove();remEntry()" onchange = "changeSave()" oncut="changeClose()"></span></label></div></div></div></div></div>';
				objTo.appendChild(divtest);
				
				offset = splituser_enableVal[index+1];
				addressOffset = splituser_enableVal[index+3];
				configOffset = splituser_enableVal[index+2];
				var splitconfigOffset = configOffset.split("");
				
				if((splitconfigOffset[1] & 8) == 8)
				{
					var controlName = "div#che"+inc+" input[name=userConfig"+inc+"Group][value=1]";
					$(controlName).prop("checked", true);
				}
				else 
				{
					var controlName = "div#che"+inc+" input[name=userConfig"+inc+"Group][value=0]";
					$(controlName).prop("checked", true);
				}
				splitconfigOffset[1] = splitconfigOffset[1] & 7;
				splitconfigOffset = splitconfigOffset[1]+addressOffset;
				splitconfigOffset= parseInt(splitconfigOffset,16);
				address = splitconfigOffset << 2;
				address = address.toString(16);
				$('div#che'+inc+' input[id="userAddress"]').val(address);
				
				if(((parseInt(configOffset,16)) & 128) == 128)
				{
					valueOffset1 = splituser_enableVal[index+4];
					$("div#che"+inc+" input[id=byteEnable1]").prop('checked',true);   
				} else {
					valueOffset1 = 00;
					$("div#che"+inc+" input[id=byteEnable1]").prop('checked',false);  
				}
				
				if(((parseInt(configOffset,16)) & 64) == 64)
				{
					valueOffset2 = splituser_enableVal[index+5];
					$("div#che"+inc+" input[id=byteEnable2]").prop('checked',true);  
				} else {
					valueOffset2 = 00;
					$("div#che"+inc+" input[id=byteEnable2]").prop('checked',false); 
				}
				
				if(((parseInt(configOffset,16)) & 32) == 32)
				{
					valueOffset3 = splituser_enableVal[index+6];
					$("div#che"+inc+" input[id=byteEnable3]").prop('checked',true);    
				} else {
					valueOffset3 = 00;
					$("div#che"+inc+" input[id=byteEnable3]").prop('checked',false);
				}
				
				if(((parseInt(configOffset,16)) & 16) == 16)
				{
					valueOffset4 = splituser_enableVal[index+7];
					$("div#che"+inc+" input[id=byteEnable4]").prop('checked',true);    
				} else {
					valueOffset4 = 00;
					$("div#che"+inc+" input[id=byteEnable4]").prop('checked',false);   
				}
				$('div#che'+inc+' input[id="userValue1"]').val(valueOffset1);
				$('div#che'+inc+' input[id="userValue2"]').val(valueOffset2);
				$('div#che'+inc+' input[id="userValue3"]').val(valueOffset3);
				$('div#che'+inc+' input[id="userValue4"]').val(valueOffset4);
				inc++;
			}
		}
	};
})(jQuery);

(function ($) {
    set_changed_widget_list = function () {
		
		
		//Array to save the widgets and their values which were changed.
		var deltaobj = [];
		
		//List of widgets to display on the alert
		var widgetsToDisplay = [];
		var modifiedWidgets = [];
		
		//flag for alert message
		var errorFlag = false;
		
		var totalStringLength = 0;
		
		//TO DO: String length constraint check and coding
		//String Descriptors
		var StringList = [];
		
		$.each(GwidgetlistString, function( index1, value1 ) {
			var widgetid = "#" + value1;
			var oldval = getLANWidgetValue(LAN_ID, value1);
			if((typeof oldval== 'undefined') || (oldval =="undefined"))
			{
				errorFlag = true;
				return;
			}
			var newval = $(widgetid).val();
			if (value1 == "macaddr") {
				//Ignore as this is not part of the string descriptor
				
				//Validate the new MAC address entered
				var isMACok = ValidateMac(newval);
	
				if (!isMACok) {
					//update_status_message("Please enter a valid MAC address.");
					//alert("Please enter a valid MAC address.");
					errorFlag = true;
					return;
				}
			} else {
				if (newval == stringnullvalue) {
					newval = "";
				}
				StringList.push(value1, newval);
			}
			var that = $( widgetid ), parent = that.closest('fieldset');
			var checkdisabled = $(parent).prop( "disabled" );
			if ((newval === stringnullvalue) || (newval === oldval))
			{
				// do nothing no change detected.
			}
			else if (checkdisabled)
			{
				// Change detected but field is disabled - So do nothing
			}
			else {
				if (jQuery.isEmptyObject(newval)) {
					newval = "";
				}

				if ((value1 == "macaddr") && isMACok) {
					deltaobj.push(value1, newval);
					modifiedWidgets.push(value1);
				}
				if (value1 == "macaddr") {
					//MAC address is not a string descriptor. So it is not considered for length calculation.
				} else {
					totalStringLength = totalStringLength + newval.length;
				}
			}
		}); //End of $.each(GwidgetlistString, function( index1, value1 )*/
		
		if (lanMemory == "EEPROM") {
			var eepromSize = GetEepromSize(LAN_ID);
			
			if (eepromSize == 256) {
				if (totalStringLength > 29) {
					alert("Current EEPROM size is 256 and the total length of all the string descriptos should not exceed 29 characters.");
					update_status_message("Current EEPROM size is 256 and the total length of all the string descriptos should not exceed 29 characters.");
					errorFlag = true;
					return;
				}
			} else if (eepromSize == 512) {
				if (totalStringLength > 157) {
					alert("Current EEPROM size is 512 and the total length of all the string descriptos should not exceed 157 characters.");
					update_status_message("Current EEPROM size is 512 and the total length of all the string descriptos should not exceed 157 characters.");
					errorFlag = true;
					return;
				}
			} else {
				//Do nothing
			}
		} else {
			//Do nothing
		}
		
		var K;
		var V;
		var F = 0;
		
		//Hex Descriptors
		$.each(GwidgetValuelistHex, function( index1, value1 ) {
			var widgetid = "#" + value1;
			var oldval;
			var newval;
			var isOk;
			
			oldval = parseInt(getLANWidgetValue(LAN_ID, value1), 10);
			newval = parseInt($(widgetid).val(), 16);
			isOk = /^[0-9A-Fa-f]{1,4}$/i.test($(widgetid).val());
			
			if (!isOk) {
				update_status_message("The value entered for \"" + Mapping[value1] + "\" must be a hexadecimal value.");
				alert("The value entered for \"" + Mapping[value1] + "\" must be a hexadecimal value.");
				errorFlag = true;
			}
			
			if (!isOk) {
				// Do nothing. The value entered does not meet the expected pattern.
			} else {
				
				if ((oldval === newval) || isNaN(newval)) {
						//Do nothing
				} else {
					
					var that = $( widgetid ), parent = that.closest('fieldset');
					var checkdisabled = $(parent).prop( "disabled" );
					if (checkdisabled)
					{
						// Change detected but field is disabled - So do nothing
					}
					else {
						decvalue = parseInt(newval,10);
						// convert number to string and then string to hex
						valueToSet = "0x" + (decvalue.toString(16));
						deltaobj.push(value1,valueToSet);
						modifiedWidgets.push(value1);
						
					}
				}
			}
		});
		
		$.each(GwidgetlistDropDown1, function(index2, value1) {
			
			var nameofcontrol = "." + value1;
			var nameofcontrol1 = "[data-bind=\"" + value1 + "label\"]";
			var selText = $(nameofcontrol).find(nameofcontrol1).text();
			var newindexofdropdownlist;
			var that = $( nameofcontrol ), parent = that.closest('fieldset');
			var checkdisabled = $(parent).prop( "disabled" );

			if ((value1 == "LED0Function") || (value1 == "LED1Function") ||
			(value1 == "LED2Function") || (value1 == "LED3Function"))
			{
				$.each(DropDownLEDListFunction, function(index, valuelist) {
					if ( selText === valuelist)
					{
						newindexofdropdownlist = index;
					}
				});
			}
			
			if (value1 == "auxcurrent")
			{
				$.each(auxcurrentFunction, function( index, valuelist ) {
					if ( selText === valuelist)
					{
						newindexofdropdownlist = index;
					}
				});
				
			}
			
			if (value1 == "pmeSupport")
			{
				$.each(pmeFunction1, function( index, valuelist ) {
					if ( selText === valuelist)
					{
						if(selText == "D0")
						{
							newindexofdropdownlist = 1;
						}
						if(selText == "D3 Hot")
						{
							newindexofdropdownlist = 8;
						}
						if(selText == "D3 Cold")
						{
							newindexofdropdownlist = 16;
						}
					}
				});
			}
			
			if (value1 == "L0Latency")
			{
				$.each(L0LatencyFunction, function( index, valuelist ) {
					if ( selText === valuelist)
					{
						newindexofdropdownlist = index;
					}
				});
			}
			
			if (value1 == "L1Latency")
			{
				$.each(L1LatencyFunction, function( index, valuelist ) {
					if ( selText === valuelist)
					{
						newindexofdropdownlist = index;
					}
				});
			}
			
			if (value1 == "OBFFSupport")
			{
				$.each(OBFFSupportFunction, function( index, valuelist ) {
					if ( selText === valuelist)
					{
						newindexofdropdownlist = index;
					}
				});
			}
			
			var oldval = getLANWidgetValue(LAN_ID, value1);

			if (newindexofdropdownlist || newindexofdropdownlist == 0) {
				if ((newindexofdropdownlist == oldval))
				{
					// no change
				} else if (checkdisabled) {
					// Change detected but field is disabled - So do nothing
				} else {
					var dummyNewindexofdropdownlist = newindexofdropdownlist.toString(16);
					deltaobj.push(value1, dummyNewindexofdropdownlist);
					modifiedWidgets.push(value1);
				}
			}
		});
		
		///Radio buttons
		$.each(GwidgetlistRadio, function(index2, value1) {
			var widgetgroupname = '#' + value1 +"Group";
			var oldval = getLANWidgetValue(LAN_ID, value1);
			var newval = $(widgetgroupname).find(':checked').val();
			var that = $( widgetgroupname ), parent = that.closest('fieldset');
			var checkdisabled = $(parent).prop( "disabled" );
			if ((oldval === newval) || jQuery.isEmptyObject(newval))
			{
				// do nothing
			}
			else if (checkdisabled)
			{
				// Change detected but field is disabled - So do nothing
			}
			else
			{
				if(value1 == "macDuplexDetection")
				{
					if(newval == 1)
					{
						deltaobj.push("macDuplexMode", "0");
						modifiedWidgets.push("macDuplexMode");
						deltaobj.push("macDuplexPolarity", "0");
						modifiedWidgets.push("macDuplexPolarity");
					}
				}
				deltaobj.push(value1, newval);
				modifiedWidgets.push(value1);
			}
		});

		//Checkbox
		$.each(GwidgetCheckbox, function( index2, value1 ) {
			var widgetid = "#" + value1;
			var oldval = getLANWidgetValue(LAN_ID, value1);
			var newval = checkbox_unchecked_value;
			var that = $( widgetid ), parent = that.closest('fieldset');
			var checkdisabled = $(parent).prop( "disabled" );
			if($(widgetid).is(':checked'))
			{
				newval = checkbox_checked_value;
			}
			
			// Enabled - check the previous value and determine delta                              
			if (oldval == newval) {
				// do nothing - no change in value
			} else if (checkdisabled) {
				// Change detected but field is disabled - So do nothing
			} else {
				deltaobj.push(value1, newval);
				modifiedWidgets.push(value1);
			}
		});
		
	//Handling User Initialization table
	var user_enableVal = getLANWidgetValue(LAN_ID, "userInitentry");
	//var user_enableVal = "START_OFFSET+26+F0+1C+78+56+34+12+START_OFFSET+27+F8+1C+72+56+34+12+";
	var offset;
	var configOffset;
	var addressOffset;
	var address;
	var valueOffset1;
	var valueOffset2;
	var valueOffset3;
	var valueOffset4;
	var changeValue = false;
	var firstconfigOffset;
	var incn = 0;
	
	for (var index = 0; index < user_enableVal.length; index++)
	{
		var splituser_enableVal = user_enableVal.split('+');
		if(splituser_enableVal[index] == "START_OFFSET")
		{
			if(index == 0)
			{
				offset = splituser_enableVal[index+1];
			} else 
			{
				offset = parseInt(offset,16);
				offset = offset + parseInt(6);
				offset = offset.toString(16);
			}
			addressOffset = splituser_enableVal[index+3];
			configOffset = splituser_enableVal[index+2];
			var splitconfigOffset = configOffset.split("");
			
			
			if((splitconfigOffset[1] & 8) == 8)
			{
				if( $("div#che"+incn+" input[name=userConfig"+incn+"Group][value=0]").is(':checked')) {
						changeValue = true;
						firstconfigOffset = configOffset & 0xF7;
				} else {
					firstconfigOffset = configOffset;
				}
			} else {
					
				if($("div#che"+incn+" input[name=userConfig"+incn+"Group][value=1]").is(':checked')) {
					changeValue = true;
					firstconfigOffset = configOffset | 0x08;
				} else {
					firstconfigOffset = configOffset;
				}
			}
			
			
			splitconfigOffset[1] = splitconfigOffset[1] & 7;
			splitconfigOffset = splitconfigOffset[1]+addressOffset;
			splitconfigOffset= parseInt(splitconfigOffset,16);
			address = splitconfigOffset << 2;
			address = address.toString(16);
			
			if(address != $('div#che'+incn+' input[id="userAddress"]').val()) {
				changeValue = true;
				address = $('div#che'+incn+' input[id="userAddress"]').val();
				address = parseInt(address,16);
				address = address >>> 2;
				address = address & 0xFF;
			} else {
				address = addressOffset;
			}
			
			if((address & 0x0) == 0x0) {
				firstconfigOffset = firstconfigOffset | 0x0;
			} 
			else if((address & 0x1c00) == 0x1c00) {
				firstconfigOffset = firstconfigOffset | 0x07;
			} else if((address & 0x0400) == 0x0400) {
				firstconfigOffset = firstconfigOffset | 0x01;
			}  else if((address & 0x0800) == 0x0800) {
				firstconfigOffset = firstconfigOffset | 0x02;
			}  else if((address & 0x0c00) == 0x0c00) {
				firstconfigOffset = firstconfigOffset | 0x03;
			}  else if((address & 0x1000) == 0x1000) {
				firstconfigOffset = firstconfigOffset | 0x04;
			}  else if((address & 0x1400) == 0x1400) {
				firstconfigOffset = firstconfigOffset | 0x05;
			}  else if((address & 0x1800) == 0x1800) {
				firstconfigOffset = firstconfigOffset | 0x06;
			} 
			
			if(((parseInt(configOffset,16)) & 128) == 128)
			{
				valueOffset1 = splituser_enableVal[index+4];
				firstconfigOffset = firstconfigOffset | 0x80;
			} else {
				firstconfigOffset &= 0x7f;
				valueOffset1 = 00;
			}
			if(((parseInt(configOffset,16)) & 64) == 64)
			{
				valueOffset2 = splituser_enableVal[index+5];
				firstconfigOffset = firstconfigOffset | 0x40;
			} else {
				valueOffset2 = 00;
				firstconfigOffset &= 0xBF;
			}
			if(((parseInt(configOffset,16)) & 64) == 64)
			{
				valueOffset3 = splituser_enableVal[index+6];
				firstconfigOffset = firstconfigOffset | 0x20;
			} else {
				valueOffset3 = 00;
				firstconfigOffset &= 0xDF;
			}
			if(((parseInt(configOffset,16)) & 16) == 16)
			{
				valueOffset4 = splituser_enableVal[index+7];
				firstconfigOffset = firstconfigOffset | 0x10;
			} else {
				valueOffset4 = 00;
				firstconfigOffset &= 0xEF;
			}
			
			if(valueOffset1 != ($('div#che'+incn+' input[id="userValue1"]').val())) {
				changeValue = true;
				valueOffset1 = $('div#che'+incn+' input[id="userValue1"]').val();
			}
			if(valueOffset2 != ($('div#che'+incn+' input[id="userValue2"]').val())) {
				changeValue = true;
				valueOffset2 = $('div#che'+incn+' input[id="userValue2"]').val();
			}
			if(valueOffset3 != ($('div#che'+incn+' input[id="userValue3"]').val())) {
				changeValue = true;
				valueOffset3 = $('div#che'+incn+' input[id="userValue3"]').val();
			}
			if(valueOffset4 != ($('div#che'+incn+' input[id="userValue4"]').val())) {
				changeValue = true;
				valueOffset4 = $('div#che'+incn+' input[id="userValue4"]').val();
			}
			firstconfigOffset = firstconfigOffset.toString(16);
			address = address.toString(16);
			
			if(changeValue) {
				if(entryRemove || tableRemove)
				{
					RegString = "START_OFFSET"+"+"+(offset)+"+"+"00"+"+"+"00"+"+"+"00"+"+"+"00"+"+"+"00"+"+"+"00";
					removeflag--;
					if(removeflag == 0)
					{
						entryRemove = false;
					}
				} else {
				RegString = "START_OFFSET"+"+"+(offset)+"+"+firstconfigOffset+"+"+address+"+"+valueOffset1+"+"+valueOffset2+"+"+valueOffset3+"+"+valueOffset4;
				}
				deltaobj.push("userInitentry", RegString);
				modifiedWidgets.push("userInitentry");
				changeValue = false;
				
			}
			incn++;
		}
	}
	
		if(htcount != 0) {
			count++;

			var valueOffset1;
			var valueOffset2;
			var valueOffset3;
			var valueOffset4;
			var byteEnable1;
			var byteEnable2;
			var byteEnable3;
			var byteEnable4;
			var userConfig;
			
			for (count; count <= userIncrement ; count++) {
				
				if((typeof offset== 'undefined') || (offset =="undefined")) {
					offset = 26;
				} else {
					offset = parseInt(offset,16);
					offset = offset + parseInt(6);
					offset = offset.toString(16);
				}
				if($("div#che"+count+" input[name=userConfig"+count+"Group][value=1]").is(':checked'))
				{
					userConfig = "1";
				} else 
				{
					userConfig = "0";
				}
				var address = $('div#che'+count+' input[id="userAddress"]').val();
				
				if($("div#che"+count+" input[id=byteEnable1]").is(':checked')) {
					valueOffset1 = $('div#che'+count+' input[id="userValue1"]').val();
					byteEnable1 = "1";
				} else {
					valueOffset1 = 00;
					byteEnable1 = "0";
				}
				
				if($("div#che"+count+" input[id=byteEnable2]").is(':checked')) {
					valueOffset2 = $('div#che'+count+' input[id="userValue2"]').val();
					byteEnable2 = "1";
				} else {
					valueOffset2 = 00;
					byteEnable2 = "0";
				}
				
				if($("div#che"+count+" input[id=byteEnable3]").is(':checked')) {
					valueOffset3 = $('div#che'+count+' input[id="userValue3"]').val();
					byteEnable3 = "1";
				} else {
					valueOffset3 = 00;
					byteEnable3 = "0";
				}
				
				if($("div#che"+count+" input[id=byteEnable4]").is(':checked')) {
					valueOffset4 = $('div#che'+count+' input[id="userValue4"]').val();
					byteEnable4  = "1";
				} else {
					valueOffset4 = 00;
					byteEnable4 = "0";
				}
				
				address = parseInt(address,16);
				var newconfig = 000;
				if((address & 0x1c00) == 0x1c00) {
					newconfig = 111;
				} else if((address & 0x0400) == 0x0400) {
					newconfig = 001;
				}  else if((address & 0x0800) == 0x0800) {
					newconfig = 010;
				}  else if((address & 0x0c00) == 0x0c00) {
					newconfig = 011;
				}  else if((address & 0x1000) == 0x1000) {
					newconfig = 100;
				}  else if((address & 0x1400) == 0x1400) {
					newconfig = 101;
				}  else if((address & 0x1800) == 0x1800) {
					newconfig = 110;
				}  
			
				userConfig = byteEnable1+byteEnable2+byteEnable3+byteEnable4+userConfig+newconfig;
				userConfig = parseInt(userConfig,2).toString(10);;
				if(newconfig == 0) {
					userConfig = userConfig << 2;
				}
				userConfig = userConfig & 255;
				userConfig = userConfig.toString(16);
				address = address >> 2;
				address = address & 255;
				address = address.toString(16);
				if(entryRemove || tableRemove)
				{
					if(entryRemove) {
						offset = "00";
					}
					RegString = "START_OFFSET"+"+"+offset+"+"+"00"+"+"+"00"+"+"+"00"+"+"+"00"+"+"+"00"+"+"+"00";
					entryRemove = false;
				} else {
				RegString = "START_OFFSET"+"+"+(offset)+"+"+userConfig+"+"+address+"+"+valueOffset1+"+"+valueOffset2+"+"+valueOffset3+"+"+valueOffset4;
				}
				deltaobj.push("userInitentry", RegString);
				modifiedWidgets.push("userInitentry");
			}
		}
	
	//End of Special Checkbox widgets
		var stringToSet = "";
		var wKey;
		var wVal;
		var flag = 0;
		
		if (deltaobj.length != 0) {
			for (var i = 0; i < deltaobj.length; i = (i + 2)) {
				wKey = deltaobj[i];
				wVal = deltaobj[i+1];
				if ((typeof wKey === 'undefined') || (typeof wVal === 'undefined')) {
					// Do nothing
				} else {
					if (stringToSet == "") {
						stringToSet = wKey + ",,," + wVal;
					} else {
						stringToSet = stringToSet + ";;;" + wKey + ",,," + wVal;
					}
					flag++;
				}
			}
		}
		
		var memType = $("#ConfigLocationGroup").find(':checked').val();
		var memConfig = $("#eepromConfigGroup").find(':checked').val();
		
		if((memType == "EEPROM") && (typeof memConfig == 'undefined')) {
			alert("Please choose the appropriate EEPROM Configuration from the Device Management Tab.");
			update_status_message("Please choose the appropriate EEPROM Configuration from the Device Management Tab.");
			return;
		}
		var userSelection;
		
		if((memType == "EEPROM") && (memConfig == "0"))
		{
			userSelection = "3";
		} else if((memType == "EEPROM") && (memConfig == "1")){
			userSelection = "1";
		} else {
			userSelection = "2";
		}
		if (showPreview) {
			showPreview = false;
			if (flag != 0) {
				var memresult = User_Lan_Memory_Selection(LAN_ID, userSelection);
				var result = previewLANWidgetValue(LAN_ID, stringToSet);
				count = count -htcount-1;
				$('#previewChangesField').show();
			} else {
				alert("No Changes detected. Cannot show preview.");
			}
		} else {
			if (flag == 0 && errorFlag == false)
			{
				window.setTimeout(function() {
				  $('#myprogress .progress-bar').css('width', 100+'%').attr('aria-valuenow', 100);
				}, 500); 
				alert("Device configuration will not be changed ; No changes detected");
				update_status_message("Device configuration will not be changed ; No changes detected");
			} else {
				if(errorFlag == false)
				{
					var displayChange = "";
					
					for (var i = 0; i < modifiedWidgets.length; i++) {
						if(i%4 == 0)
						{
							if (displayChange) {
								displayChange = "\n" + Mapping[modifiedWidgets[i]] + ", " + displayChange;
								
							} else {
								displayChange = Mapping[modifiedWidgets[i]];
								
							}
						} else {
							if (displayChange) {
								displayChange = Mapping[modifiedWidgets[i]] + ", " + displayChange;
								
							}
						}
					}
					
					$('#myprogress').show();
					$('#myprogress .progress-bar').css('width', 5+'%').attr('aria-valuenow', 5);
					
					if($("input[id=userAddress]").val() == "") {
						alert("Provide CSR/PCIe Register address to proceed.");
						return;
					}
			
					if($("div#che"+count+" input[id=byteEnable1]").is(':checked')) {
					if($("input[id=userValue1]").val() == "") {
						alert("Provide CSR/PCIe Register values to proceed.");
						return;
						}
					}
					
					if($("div#che"+count+" input[id=byteEnable2]").is(':checked')) {
					if($("input[id=userValue2]").val() == "") {
						alert("Provide CSR/PCIe Register values to proceed.");
						return;
						}
					}
				
					if($("div#che"+count+" input[id=byteEnable3]").is(':checked')) {
					if($("input[id=userValue3]").val() == "") {
						alert("Provide CSR/PCIe Register values to proceed.");
						return;
						}
					}
					
					if($("div#che"+count+" input[id=byteEnable4]").is(':checked')) {
					if($("input[id=userValue4]").val() == "") {
						alert("Provide CSR/PCIe Register values to proceed.");
						return;
						}
					}
			
					if($("input[id=userAddress]").val() != "") {
						if($("input[id=userValue4]").val() == "") {
							if($("input[id=userValue3]").val() == "") {
								if($("input[id=userValue2]").val() == "") {
									if($("input[id=userValue1]").val() == "") {
										alert("Provide CSR/PCIe Register values to proceed.");
									}
								}
							}
						}
					}
					var option = confirm("The following device settings will be changed ; Previously created JSON and Configuration files will be removed ; Do you want to continue?\n" + displayChange);
					
					if (option) {
						
						
						//$('#myprogress').show();				
						$('#myprogress .progress-bar').css('width', 20+'%').attr('aria-valuenow', 20);
						
						
						update_status_message("JSON and cfg files will be overwritten; and PCIE device will be programmed with the following.\n " + displayChange);
						update_status_message("Programming in progress...Please wait");
						// call the service
						
						//Disable apply and preview buttons before making a java call
						
						$("#Preview").attr('disabled', true);
						$("#Apply").attr('disabled', true);
						$("#Factory").attr('disabled', true);
						$("#eepromErase").attr('disabled', true);
						
						var memresult = User_Lan_Memory_Selection(LAN_ID, userSelection);
						
						$('#myprogress .progress-bar').css('width', 40+'%').attr('aria-valuenow', 40);
						
						var result = setLANWidgetValue(LAN_ID, stringToSet);
						
						$('#myprogress .progress-bar').css('width', 50+'%').attr('aria-valuenow', 50);
						
						if (result && memresult) {
							update_status_message("LAN is successfully programmed");
						
							count = count -htcount-1;
							$('#myprogress .progress-bar').css('width', 70+'%').attr('aria-valuenow', 70);		
							
							// Change border back to default color from red
							set_changed_fields_border_default();

							update_status_message("Waiting for device reset to finish.....");

							CurrentLANProgrammed = $("#selectedLANinput").val();
							var colonIndex = CurrentLANProgrammed.indexOf(":");
							LAN_ID = "" + CurrentLANProgrammed.charAt(colonIndex + 1);

							$('#myprogress .progress-bar').css('width', 100+'%').attr('aria-valuenow', 100);		
							
							setTimeout(function() {
								// Do something after 5 seconds
								update_status_message("Refreshing LAN List....");
								// refresh hub list and set selected device
								window.setTimeout(function() {
									$('.panel-collapse').each(function () {
										if ($(this).hasClass('in')) {
											$(this).collapse('toggle');
										}
									});
									//alert(LAN_ID);
									close_lan_device(LAN_ID);
									refreshLAN();
									var div;
									while (div = document.getElementById('check')) {
										div.parentNode.removeChild(div);
									}
									$('#RemoveTableSection').hide();
									reset_fields();
									get_LAN_list_set_LAN_index_zero();
									//$("#myprogress").hide();
								},200);
								//$("body").css("cursor", "default");
								window.setTimeout(function(){
								  //your code to be executed after 1 seconds
								  $('#myprogress .progress-bar').css('width', 0+'%').attr('aria-valuenow', 0);
								  $('#myprogress').hide();
								}, 500);
							}, 5000);
						}
						else {
							count = count -htcount-1;
							errorCode = getMchpLANLastError(LAN_ID);
							alert("Programming Failed." + errorMap[Dec2Hex(errorCode)]);
							update_status_message("Programming Failed."+ errorMap[Dec2Hex(errorCode)]);
							if(errorCode == 28674)
							{
								alert("Application requires admin privilege to reflect the changes in the system.Please reboot the system to reflect the changes.");
							}
							window.setTimeout(function() {
								$('#myprogress .progress-bar').css('width', 0+'%').attr('aria-valuenow', 0);
								$("#myprogress").hide();
							},500);
						}
					} else {
						update_status_message("Programming of the device was terminated by the user.");
						count = count -htcount-1;
						window.setTimeout(function() {
							$('#myprogress .progress-bar').css('width', 0+'%').attr('aria-valuenow', 0);
							$("#myprogress").hide();
						},500);
					}
				}
			}
		}
		
		//Required clean up action
		errorFlag = false;
		RegString = false;
		// Enable apply and preview buttons after programming is done
		$("#Preview").removeAttr('disabled', false);
		$("#Apply").removeAttr('disabled', false);
		//$("#myprogress").hide();
	
	};
})(jQuery);

(function ($) {
    set_dropdown_selected_option = function () {
        
        // Ordering is important - dont change code
        // Click of any field in  any drop down menu
        $(document).on('click', '.dropdown li a', function (event) {
            // this code is for making the current selection appear with caret
            var $target = $(event.currentTarget);

            $target.closest('.btn-group')
            .find('[data-bind]').text($target.text())
            .end()
            .children('.dropdown-toggle').dropdown('toggle');
            var selop = $(this).text();
            console.log("Selected Option - All dropdowns:" + selop);
        });

        // Click of Any hub in Select HUB drop down menu
        $(document).on('click', '.dropdown-selectLAN li a', function (event) {
			var selop = $(this).text();
			$("#selectedLANinput").val(selop);
			var btnValue = $("#selectedLANinput").val();
			var colonIndex = btnValue.indexOf(":");
			var currentLANSelected = btnValue.charAt(colonIndex + 1);

			if (currentLANSelected == LAN_ID) {
				setTimeout(function() {
					//Do nothing as the same hub is selected.
					get_LAN_list_set_LAN_index_zero();
				}, 200);
			} else {
				setTimeout(function() {
					close_lan_device(LAN_ID);
					refreshLAN();
					LAN_ID = "" + currentHubSelected;
					set_selected_lan_get_widgets();
				}, 200);
			}
			return false;
        });
	};
})(jQuery);

function ValidateMac(currMac) {
	var MacValue = currMac.split(":");
	
	var maclength = MacValue.length;
	
	if(maclength < 6 || maclength > 6)
	{
		alert("The Given MAC Address is not valid.Mac Address should be for Example = 00:80:0F:10:20:01");
		return false;
	}
	MacValue[0] = parseInt(MacValue[0],16);
	if((MacValue[0] & 0x01) === 0x01)
	{
		alert("MAC Address should not be a Multicast or Broadcast address.");
		return false;
	}
	
	var regex = /^([0-9a-fA-F]{2}[:-]){5}([0-9A-F]{2})$/;
  
	var isMacOKAddr = regex.test(currMac);
	
	if(!isMacOKAddr)
	{
		alert("The Given MAC Address is not a valid Mac Address.");
		return false;
	}

	return true;
}
