/*! jQuery v1.10.2 | (c) 2005, 2013 jQuery Foundation, Inc. | jquery.org/license
*/

var errorMap = {
	"0x0000": "Operation Success.",
	"0x0001": "Unable to connect to the device.",
	"0x0002": "Argument passed to the API is invalid.",
	"0x0003": "Device handle passed to the API is not valid.",
	"0x0004": "API of the winusb library failed.",
	"0x0005": "System reboot is required.",
	"0x0006": "Error in installing VSM filter driver.",
	"0x0007": "Operation success but System reboot is required.",
	"0x0008": "Size of the bin file is invalid.",
	"0x0009": "Error while reading cfg/bin file.",
	"0x0010": "Code is running from SPI.",
	"0x0011": "Error in installing winusb driver.",
	"0x0012": "Invalid arguments.",
	"0x0013": "VSM Filter is not available as the class filter",
	"0x0014": "Application does not have admin rights",
	"0x0015": "VSM command failed as the device is in sleep state. Disable Power management of the device.",
	"0x0016": "Simultaneous programming of configuration and SPI not allowed for the device.",
	"0x0017": "Device memory reached maximum size.",
	"0x0018": "OTP content programmed does not match with given configuration file.",

	"0x1000": "Could not load the binary file.",
	"0x1001": "Reading from SPI flash failed.",
	"0x1002": "Selected file size is greater than currect OTP/EEPROM free available space.",
	"0x1003": "SPI pass through write command failed.",
	"0x1004": "SPI pass through Enter command failed.",
	"0x1005": "SPI flash could not be detected or not present.",
	"0x1006": "SPI Cancel Download.",
	"0x1007": "SPI flash programming failed.",
	"0x1008": "SPI pass through Exit command failed.",
	"0x1009": "SPI pass through read command failed.",
	"0x100a": "Unsupported SPI flash  detected.",
	"0x100b": "SPI flash read back and compare failed with programmed binary.",
	"0x100c": "Open Erase signature bin file failed.",
	"0x100d": "Read Erase signature bin file failed.",
	"0x100e": "SRAM programming failed.",
	"0x100f": "SPI_ERASE_4KBSECTOR command failed. Applicable for USB5734 only.",
	"0x1010": "Chip Erase command failed.",
	"0x1011": "Could not load the Json file.",
	"0x1012": "Could not load the INI file.",
	"0x1013": "Flex Reg Field was not programmed.",
	"0x1014": "SPI Firmware programming is not supported for the device.",


	// Error Code for I2C config
	"0x2000": "Cannot enable I2C Pass through interface.",
	"0x2001": "Cannot disable I2C Pass through interface.",
	"0x2002": "I2C Transfer failed.",
	"0x2003": "Error_I2C_Max_Size_Error.",

	// Error Code for SMBus config
	/*"0x3000": "SMBus port open error.",*/
	"0x3001": "Bitrate error.",
	"0x3002": "Data length error.",
	"0x3003": "SMBus write access failed.",
	"0x3004": "SMBus read access failed.",
	"0x3005": "SMBus close error.",

	"0x3000": "Maximum configuration block is already programmed.",

	"0x4000": "Communication at the specified baud rate will be error prone.",
	"0x4001": "Could not set USB2534 UART registers.",
	"0x4002": "Transmit failed. No data was sent.",
	"0x4003": "Transmit failed after transmitting some data.",
	"0x4004": "Receive failed due to buffer overrun, reduce baud rate.",
	"0x4005": "Receive failed due to unexpected Rx FIFO status.",
	"0x4006": "Receive failed since worker thread creation failed.",
	"0x4007": "UART Rx is pending due to asynchronous mode.",
	"0x4008": "UART receive aborted as per user request.",
	"0x4009": "UART Receive command failed by the firmware.",
	"0x400a": "Receive failed without receiving any data.",
	"0x400b": "UART receive timed out.",

	"0x5000": "Error_GPIO_Invalid_PinNumber",
	"0x6000": "Error_LAN78XX_Access_Denied",
	"0x6001": "Error_LAN78XX_Adapter_Busy",
	"0x6002": "Error_LAN78XX_Fail",
	"0x6003": "EEPROM is not available.OTP of the device is blank and can be used for programming.\n To program \n 1. Generate configuration file in \"Offline Page\".\n 2. Use generated configuration file in program page for programming.",
	"0x6004": "EEPROM is not available. OTP can be used for programming once.",
	"0x6005": "EEPROM is not available and there is no free space in OTP.Programming of this device cannot be done through MPLAB Connect.",
	"0x6006": "There is no space in the OTP but EEPROM is available for programming.\n To program \n 1. Generate configuration file in \"Offline Page\".\n 2. Use generated configuration file in program page for programming.",
	"0x6007": "Both EEPROM and OTP are blank and can be used for programming.\n To program \n 1. Generate configuration file in \"Offline Page\".\n 2. Use generated configuration file in program page for programming.",
	"0x6008": "OTP has invalid signature but EEPROM is available for programming.\n To program \n 1. Generate configuration file in \"Offline Page\".\n 2. Use generated configuration file in program page for programming.",
	"0x6009": "EEPROM is not available and OTP has invalid signature.",
	"0x600a": "EEPROM is not available.",
	"0x600b": "The highest priority goes to EEPROM since EEPROM present/Valid signature in the EEPROM.",
	"0x7000": "Ping Operation Failed.",
	"0x7002": "Application does not have enough access rights to reflect changes in the device.Changes will be reflected only after reboot.",
	"0xffff": "Unknown error occurred."
}

function Dec2Hex(decimal) {
	var hexString = decimal.toString(16);
	var length = hexString.length;
	if (length == 1) {
		hexString = "0x000" + hexString;
	} else if (length == 2) {
		hexString = "0x00" + hexString;
	} else {
		hexString = "0x" + hexString;
	}
	return hexString;
}

var KeyfromINI = readKeyfromINI();
var flagforINIread = false;
var cancelFlag = false;

if(KeyfromINI == 1) {
	flagforINIread = true;
} else {
	flagforINIread = false;
}

var debugOn = false;

(function ($) {
		debugAlert = function (mesg) {
		if(debugOn) {
			alert(mesg);
		}
            
    };
})(jQuery);
