/*! jQuery v1.10.2 | (c) 2005, 2013 jQuery Foundation, Inc. | jquery.org/license
*/

var Productfun = getFlextype();
var hubCount;
var hub_list;
var incval = 0;

var checkbox_checked_value = "1";
var checkbox_unchecked_value = "0";

var stringnullvalue = "NULL STRING - NOT PROGRAMMED YET";
//var gb_primaryCFlag = true;
var gb_HUB_ID = "0";
var gb_enableFlex = false;
var gb_enableport = false;
var gb_disableFlex = false;
var gb_hubsFound = false;
var gb_enable_swapupstreamdpdm = false;
var gb_skuType;


//flags for INI file programming
var gb_iniFile ="";
var gb_iniFile_fullPath ="";

		
// Widget list of hex fields in the GUI
//Should be same as html id attribute

var GwidgetlistHex = [
"vid",
"pid",
"did",
"usbvcd",
"languageid",
"secondary_vid",
"secondary_pid",
"secondary_did",
"secondary_usbvcd",
"secondary_languageid",
"hce_vid",
"hce_pid",
"hce_did",
"hce_languageid",
"hce1_vid",
"hce1_pid",
"hce1_did",
"hce1_languageid",
"hce2_vid",
"hce2_pid",
"hce2_did",
"hce2_languageid"
];


// Widget list of string fields in the GUI
//Should be same as html id attribute

var GwidgetlistString = [
"manufacturer", 
"secondary_manufacturer", 
"product",
"secondary_product",
"serial",
"secondary_serial",
"hce_manufacturer",
"hce_product",
"hce_serial",
"hce1_manufacturer",
"hce1_product",
"hce1_eapproduct",
"hce1_eapinterface",
"hce1_string5",
"hce2_manufacturer",
"hce2_product",
"hce2_eapproduct",
"hce2_eapinterface",
"hce2_string5",
"usb2uuid",
"secondary_usb2uuid",
"hce1_macaddr",
"hce2_macaddr",
];

// Widget list of decimal fields in the GUI
//Should be same as html id attribute

var GwidgetlistInt = [
"maxpowerself",
"hubcmaxpowerself",
"maxpowerbus",
"hubcmaxpowerbus",
"power_ontime"
];

// Widgets list of checkboxes in GUI
//Should be same as html id attribute

var GwidgetlistCheckbox = [
"flexconnect",
"hsdisable",
"hceenable",
"cdcenable",
"lpmenable",
"swapupstreamdpdm",
"swapport1dpdm",
"swapport2dpdm",
"swapport3dpdm",
"swapport4dpdm",
"swapport5dpdm",
"swapsecondaryportdpdm",
"enableport1",
"enableport2",
"enableport3",
"enableport4",
"enableport5",
"nrdeviceport1",
"nrdeviceport2",
"nrdeviceport3",
"nrdeviceport4",
"nrdeviceport5"
];


// Widgets list of radio buttons in GUI
//Should be same as html id attribute

var GwidgetlistRadio = [
"hubpower",
"i2senable",
"i2senablehid",
"downstreamBCsettingport1",
"downstreamBCsettingport2",
"downstreamBCsettingport3",
"downstreamBCsettingport4"
];


// Widgets list of Drop Down in GUI
//Should be same as html id attribute

var GwidgetlistDropDown = [
"PHYBOOST",
"SQUELCH",
"PHYBOOSTdownstreamsecondaryport",
"SQUELCHdownstreamsecondaryport",
"secondaryportHsRiseFall",
"upstreamHsRiseFall",
"PHYBOOSTdownstreamport1",
"SQUELCHdownstreamport1",
"downstreamport1HsRiseFall",
"PHYBOOSTdownstreamport2",
"SQUELCHdownstreamport2",
"downstreamport2HsRiseFall",
"PHYBOOSTdownstreamport3",
"SQUELCHdownstreamport3",
"downstreamport3HsRiseFall",
"PHYBOOSTdownstreamport4",
"SQUELCHdownstreamport4",
"downstreamport4HsRiseFall",
"PHYBOOSTdownstreamport5",
"SQUELCHdownstreamport5",
"downstreamport5HsRiseFall",
"flexport"
];


// Lookup for phyboost dropdown value selection
var DropDownPHYBOOST = [
"Nominal 17.78 mA",
"5% below nominal",
"10% above nominal",
"5% above nominal",
"20% above nominal",
"15% above nominal",
"30% above nominal",
"25% above nominal"
];

// Lookup for squelch dropdown value selection
var DropDownSQUELCH = [
"Nominal 100mV",
"12.5mV below nominal",
"25mV below nominal",
"37.5mV below nominal",
"50mV below nominal",
"62.5mV below nominal",
"25mV above nominal",
"12.5mV above nominal"
];

// Lookup for High Speed rise/fall adjust selection
var DropDownHSRiseFall =[
"Default",
"+18%",
"-18%",
"-12%"
];

// Lookup for Flexport selection
var DropDownflexport = [
"Select FlexPort",
"1",
"2",
"3",
"4"
];

var NCMStringMap = [
"hce1_vid",
"hce1_pid"
];
	
var HCEStringMap = {
"hce1_vid": "hce_vid",
"hce1_pid": "hce_pid",
};
//Mapping Hex widgets to the meaningful elaborations to print while in error
var Mapping = {

"vid": "Primary Hub Vendor ID",
"pid": "Primary Hub Product ID",
"did": "Primary Hub Device ID",
"usbvcd": "Primary Hub USB2.0 Specification number",
"languageid": "Primary Hub Language ID",
"manufacturer": "Primary Hub Manufacturer",
"manufacturerlen" :"Primary Hub Manufacturer String Length",
"product" : "Primary Hub Product",
"productlen" : "Primary Hub Product String Length",
"serial": "Primary Hub SerialNumber",
"seriallen" : "Primary Hub SerialNumber String Length",
"usb2uuid":"Primary Hub Universal unique ID",

"secondary_vid": "Secondary Hub Vendor ID",
"secondary_pid": "Secondary Hub Product ID",
"secondary_did": "Secondary Hub Device ID",
"secondary_usbvcd": "Secondary Hub USB2.0 Specification number",
"secondary_languageid": "Secondary Hub Language ID",
"secondary_manufacturer": "Secondary Hub Manufacturer",
"secondary_manufacturerlen" :"Secondary Hub Manufacturer String Length",
"secondary_product" : "Secondary Hub Product",
"secondary_productlen" : "Secondary Hub Product String Length",
"secondary_serial": "Secondary Hub SerialNumber",
"secondary_seriallen" : "Secondary Hub SerialNumber String Length",
"secondary_usb2uuid":"Secondary Hub Universal unique ID",


"enableport1":"Port1 Enable/Disable State",
"enableport2":"Port2 Enable/Disable State",
"enableport3":"Port3 Enable/Disable State",
"enableport4":"Port4 Enable/Disable State",
"enableport5":"Port5 Enable/Disable State",

"port1mapping":"Port1 Logical mapping",
"port2mapping":"Port2 Logical mapping",
"port3mapping":"Port3 Logical mapping",
"port4mapping":"Port4 Logical mapping",
"port5mapping":"Port5 Logical mapping",
"port6mapping":"Port6 Logical mapping",
"port7mapping":"Port7 Logical mapping",

"nrdeviceport1":"Port1 Non-removable State",
"nrdeviceport2":"Port2 Non-removable State",
"nrdeviceport3":"Port3 Non-removable State",
"nrdeviceport4":"Port4 Non-removable State",
"nrdeviceport5":"Port5 Non-removable State",
"nrdeviceport6":"Port6 Non-removable State",
"nrdeviceport7":"Port7 Non-removable State",


"downstreamBCsettingport1":"Port1 Battery charging State",
"downstreamBCsettingport2":"Port2 Battery charging State",
"downstreamBCsettingport3":"Port3 Battery charging State",
"downstreamBCsettingport4":"Port4 Battery charging State",

"swapport1dpdm":"Port1:Swap D+/D-",
"swapport2dpdm":"Port2:Swap D+/D-",
"swapport3dpdm":"Port3:Swap D+/D-",
"swapport4dpdm":"Port4:Swap D+/D-",
"swapport5dpdm":"Port5:Swap D+/D-",
"swapupstreamdpdm":"Upstream Port:Swap D+/D-",
"swapsecondaryportdpdm":"Secondary Port:Swap D+/D-",

"PHYBOOSTdownstreamport1":"Port1:PHYBOOST",
"PHYBOOSTdownstreamport2":"Port2:PHYBOOST",
"PHYBOOSTdownstreamport3":"Port3:PHYBOOST",
"PHYBOOSTdownstreamport4":"Port4:PHYBOOST",
"PHYBOOSTdownstreamport5":"Port5:PHYBOOST",
"PHYBOOST":"Upstream Port:PHYBOOST",
"PHYBOOSTdownstreamsecondaryport":"Secondary Port:PHYBOOST",

"SQUELCHdownstreamport1":"Port1:Varisense",
"SQUELCHdownstreamport2":"Port2:Varisense",
"SQUELCHdownstreamport3":"Port3:Varisense",
"SQUELCHdownstreamport4":"Port4:Varisense",
"SQUELCHdownstreamport5":"Port5:Varisense",
"SQUELCH":"Upstream Port:Varisense",
"SQUELCHdownstreamsecondaryport":"Secondary Port:Varisense",

"upstreamHsRiseFall":"Upstream High Speed rise/fall adjust",
"secondaryportHsRiseFall":"Secondary port High Speed rise/fall adjust",
"downstreamport1HsRiseFall":"Port1:High Speed rise/fall adjust",
"downstreamport2HsRiseFall":"Port2:High Speed rise/fall adjust",
"downstreamport3HsRiseFall":"Port3:High Speed rise/fall adjust",
"downstreamport4HsRiseFall":"Port4:High Speed rise/fall adjust",
"downstreamport5HsRiseFall":"Port5:High Speed rise/fall adjust",

"flexport": "Flex Port",
"flexconnect":"Flexconnect",
"hceenable":"Hub Feature Controller State",
"hce_vid": "Hub Feature Controller Vendor ID",
"hce_pid": "Hub Feature Controller Product ID",
"hce_did": "Hub Feature Controller Device ID",
"hce_languageid": "Hub Feature Controller Language ID",
"hce_manufacturer":"Hub Feature Controller Manufacturer",
"hce_product":"Hub Feature Controller Product",
"hce_serial":"Hub Feature Controller Serial",

"hce1_vid" : "NCM/IAP and IAP/EAP Class Device 1 Vendor ID",
"hce1_pid" : "NCM/IAP and IAP/EAP Class Device 1 Product ID",
"hce1_did" : "NCM/IAP and IAP/EAP Class Device 1 Device ID",
"hce1_languageid" : "NCM/IAP and IAP/EAP Class Device 1 Language ID",
"hce1_manufacturer" : "NCM/IAP and IAP/EAP Class Device 1 Manufacturer",
"hce1_manufacturerlen" : "NCM/IAP and IAP/EAP Class Device 1 Manufacturer String Length",
"hce1_product" : "NCM/IAP Class Device 1 Product",
"hce1_string5" : "NCM/IAP and IAP/EAP Class Device 1 Serial Number",
"hce1_productlen" : "NCM/IAP Class Device 1 Product String Length",
"hce1_macaddr" : "NCM/IAP Class Device 1 MAC address",
"hce1_eapproduct" : "IAP/EAP Class Device 1 Product String",
"hce1_eapinterface" : "IAP/EAP Class Device 1 Interface String",


"hce2_vid" : "NCM/IAP and IAP/EAP Class Device 2 Vendor ID",
"hce2_pid" : "NCM/IAP and IAP/EAP Class Device 2 Product ID",
"hce2_did" : "NCM/IAP and IAP/EAP Class Device 2 Device ID",
"hce2_languageid" : "NCM/IAP and IAP/EAP Class Device 2 Language ID",
"hce2_manufacturer" : "NCM/IAP and IAP/EAP Class Device 2 Manufacturer",
"hce2_manufacturerlen" : "NCM/IAP and IAP/EAP Class Device 2 Manufacturer String Length",
"hce2_product" : "NCM/IAP Class Device 2 Product",
"hce2_productlen" : "NCM/IAP Class Device 2 Product String Length",
"hce2_string5" : "NCM/IAP and IAP/EAP Class Device 2 Serial Number",
"hce2_macaddr" : "NCM/IAP Class Device 2 MAC address",
"hce2_eapproduct" : "IAP/EAP Class Device 2 Product String",
"hce2_eapinterface" : "IAP/EAP Class Device 2 Interface String",


"i2senable":"I2S Feature Select",
"i2senablehid":"HID Feature Select",
"power_ontime":"Power-on time",
"cdcenable":"CDC State",
"hubpower":"Hub Power",
"maxpowerself":"Hub MaxPower(Self)",
"hubcmaxpowerself":"Hub Circuit MaxCurrent (Self)",
"maxpowerbus":"Hub MaxPower (Bus)",
"hubcmaxpowerbus":"Hub Circuit MaxCurrent (Bus)",
"hsdisable":"Hub Full Speed Mode",
"lpmenable":"LPM State",
"xdataentry":"Direct Register Access",
"xdataprogram":"ini File"
};


//Lookup for Port id to port BC Seetings group id
var portenable_bcmap = { 
downstreamBCsettingport1:"enableport1", 
downstreamBCsettingport2:"enableport2",
downstreamBCsettingport3:"enableport3",
downstreamBCsettingport4:"enableport4" 
};

//Lookup for Port id for 5port SKUs

var portenableidlist5 =[
"enableport1",
"enableport2",
"enableport3",
"enableport4",
"enableport5"
];


//Lookup for Port id for 3port SKUs
var portenableidlist3 =[
"enableport1",
"enableport2"
];

//Lookup for Port id for 4port SKUs
var portenableidlist4 =[
"enableport1",
"enableport2",
"enableport3",
"enableport4"
];



(function ($) {
    disable_nav_fields = function () {
		
        $("#Apply").attr('disabled', true);
		$("#Preview").attr('disabled', true);
		$("#Refresh").attr('disabled', true);
		
    };
})(jQuery);

(function ($) {
    enable_nav_fields = function () {
        $("#Apply").attr('disabled', false);
		$("#Preview").attr('disabled', false);
		$("#Refresh").attr('disabled', false);
		
    };
})(jQuery);


(function ($) {
    get_hub_list = function () {
    	
    	//Close previous all hub instances
		MchpUsbCloseAllHubs();
		
		//Call to clear previously acquired widget Map
		clearWidgetMap();
		setConfigMode(false, "NULL");
		reset_fields();
		set_changed_fields_border_default();
		
		
        // Populate the List of Hubs
		var i = 0;
		var statusMsg  = "Fetching the hub list...";
		update_status_message(statusMsg);
		var data = "";
		data = getHubList();
		$("#devicelistdropdown").empty();

		
		if (data) {
			
			hub_list = data.split("###");
			hubCount = hub_list.length;
			
			for (var k = (hub_list.length - 1); k >= 0; k--) {
				
				if (hub_list[k]) {
					update_status_message(hub_list[k]);
					$("#devicelistdropdown").append("<li> <a tabindex=\"-1\" href=\"javascript:void(0)\" align=\"left\">" + hub_list[k] + "</a> </li>");
				}
			}

		
		
		$("#selectedhubinput").val(hub_list[(hub_list.length - 2)]);
		$('.selecthub1').find('[data-bind="SelectHublabel"]').text(hub_list[(hub_list.length - 2)]).children('.dropdown-toggle').dropdown('toggle');

		var btnValue = $("#selectedhubinput").val();
		var colonIndex = btnValue.indexOf(":");
		gb_HUB_ID = "" + btnValue.charAt(colonIndex + 1);
			
		gb_hubsFound = true;
			
		} else {
			
			
			if (gb_enableFlex) {
				
				var status_msg = "Flex connect has been enabled for the Upstream port. \n Connect the hub with the Downstream port for the device to be enumerated.";
				alert(status_msg);
				update_status_message(status_msg);
				gb_enableFlex	= false;
			}
			
			if (gb_disableFlex) {
				
				var status_msg = "Flex connect has been disabled for the Upstream port. \n Connect the hub with the Upstream port for the device to be enumerated.";
				alert(status_msg);
				update_status_message(status_msg);
				gb_disableFlex	= false;
				
			}
			
			if (gb_enable_swapupstreamdpdm) {
				
				var status_msg = "The D+/D- of the upstream port have been swapped.";
				alert(status_msg);
				update_status_message(status_msg);
				gb_enable_swapupstreamdpdm	= false;
			}
			
			gb_hubsFound = false;
			reset_fields();
			disable_fields();
				
			window.alert("No hubs found");
			update_status_message("No hubs found");
			
			$("#selectedhubinput").val("Selected Hub Details");
			$('.selecthub1')
			.find('[data-bind="SelectHublabel"]').text('Select USB Hub')
			.children('.dropdown-toggle').dropdown('toggle');
			
		}
    };
})(jQuery);

(function ($) {
	
    update_status_message = function (mesg) {
        var currentdate = new Date(); 
        currentdate+''; 
        var datetime = currentdate.toLocaleString();
        $("#DSStatusMessage").append( datetime +":"+ mesg + "\n");
        
        $("#DSStatusMessage").animate({
            scrollTop:$("#DSStatusMessage")[0].scrollHeight - $("#DSStatusMessage").height()
            },200,function(){
          })
          
       };
        
})(jQuery);

(function ($) {
    update_dra_status_message = function (mesg) {
        $("#DRStatusMessage").append(mesg + "\n");
        $("#DRStatusMessage").animate({
            scrollTop:$("#DRStatusMessage")[0].scrollHeight - $("#DRStatusMessage").height()
            },400,function(){
          })
        };
})(jQuery);

(function ($) {
    select_hub_set_widgets = function () {
    	
        
		$("body").css("cursor", "wait");
		
		var isFlexsku = false;
		var isNonFlexsku = false;

		var selectindex = 0;
		
		
		if(flagforINIread) {
			
			if((gb_HUB_ID == 0)) {
				
				selectindex =hubCount-1;
				
				for (selectindex; selectindex >= 0; selectindex--) {
					
					if(hub_list[selectindex]) {
						
						var selop = hub_list[selectindex];
						
						var colonIndex = selop.indexOf(":");
						incval = "" + selop.charAt(colonIndex + 1);	
						
					gb_skuName = set_selected_device(incval);
						
					var temp = gb_skuName.substring(0,5);
						
						
					if(temp == "USB49" &&  gb_product=="NonFlex") {
							
						isNonFlexsku = true;
							
						gb_HUB_ID = incval;
							
								$('.selecthub1').find('[data-bind="SelectHublabel"]').text(selop)
									.children('.dropdown-toggle').dropdown('toggle');
							
								$("#selectedhubinput").val(selop);
							
								break;
							
					} else if (temp == "USB47" &&  gb_product=="Flex") {
						
						isFlexsku = true;
							
						gb_HUB_ID = incval;
							
						$('.selecthub1').find('[data-bind="SelectHublabel"]').text(selop)
							.children('.dropdown-toggle').dropdown('toggle');
					
						$("#selectedhubinput").val(selop);
					
						break;
					}
				close_device(gb_HUB_ID);
					
						}
					}
				}	 
			} else {
				
				gb_skuName = set_selected_device(gb_HUB_ID);
				
			}
			
		if (gb_skuName == "") {

            reset_fields();
			disable_fields();
			
			$("body").css("cursor", "default");
			errorCode = getMchpUsbLastError(gb_HUB_ID);
			alert(errorMap[Dec2Hex(errorCode)] + " Check Help for troubleshooting.");
			update_status_message(errorMap[Dec2Hex(errorCode)] + " Check Help for troubleshooting.");			
			return;
		}

		var statusMsg = "The hub may go offline for a while. Please wait while the hub configuration is read and auto identification part number is available.";
        update_status_message(statusMsg);
		update_status_message("The skuName for the hub of Index: " + gb_HUB_ID + " is " + gb_skuName + ".");

		var temp = gb_skuName.substring(0,6);
		
		if (temp == "USB491" && gb_product == "NonFlex" ) {
			
			$("#secondaryHubDiv").hide();
			$("#NCMdiv").show();
			$("#copyNCM").show();
			$("#copyNcmSection").show();
			$('#primarytitle').text("Hub Identification");
			$("#SecondaryPort").hide();
			
		} else if(temp == "USB492" && gb_product == "NonFlex" ) {
			
			$("#NCMdiv").hide();
			$("#copyNCM").hide();
			$("#copyNcmSection").hide();
			$("#secondaryHubDiv").show();
			$("#SecondaryPort").show();
			$('#primarytitle').text("Primary Hub");
			
		} else if(temp == "USB471" && gb_product == "Flex"){
			
			$("#copyNCM").hide();
			$("#copyNcmSection").hide();
			
		}else{
			
			reset_fields();
			disable_fields();				
			var status_msg = "";
			
			if(gb_product == "NonFlex"){
							
				status_msg ="Unable to connect to USB49xx family MCHP hub";					
			}
			else{
			
				status_msg ="Unable to connect to USB471x family MCHP hub";	
								
			}
			
			update_status_message(status_msg);	
			alert(status_msg);
			$("body").css("cursor", "default");
			return;
		
		}
	
		if ((gb_skuName === "NOT MICROCHIP") || (gb_skuName === "NOT IMPLEMENTED"))
		{
			statusMsg = "Hub is not a Microchip Hub.Please select a Microchip hub\n";
			update_status_message (statusMsg);			
			console.log(statusMsg);
			alert(statusMsg);
						
			reset_fields();
			disable_fields();	
			
		} else {
			
			enable_fields();
			
			$("#partnumber").val(gb_skuName);
			
			statusMsg = "The selected hub part number is "+ gb_skuName;
			update_status_message (statusMsg);
			

			// Filling the Device Management Fields
			var info = get_otp_info(gb_HUB_ID);
			
			if (info) {
				
				var otp_info = info.split("###");
				var otpSize = otp_info[0];
				var ConfigBlockCnt = otp_info[1];
				var ConfigRemainCnt = otp_info[2];
				var ProgrammedByteCnt = otp_info[3];			
			
				// TODO SETTING DEFAULT VALUES FOR LIVE UPDATE MOVE TO SOOME OTHER PLACE AND MAKE IT A FUNCTION
				
				//Updating Device Management field
				
				var count = parseInt(ConfigBlockCnt,10) ;

				if (count >= 16){
					
					var string = "16+";
					$("#ProgrammedConfigCount").val(string);
					$("#Restore").attr('disabled', true);
				}
				else{
					
					$("#ProgrammedConfigCount").val(count);
				}
			
				$("#RemainingConfigCount").val(ConfigRemainCnt);
				
				var OTPsize = parseInt(otpSize,10);
				var ProgrammedByte = parseInt(ProgrammedByteCnt, 10);					
				var percentage = (ProgrammedByte /OTPsize) * 100;
				
									
				$("#configMemprogressbar").css('width',percentage+ "%");
				$("#configMemprogressbar").css('color', 'black');
				
				if (percentage < 50){
					
					$("#configMemprogressbar").css({'background-image': 'none','background-color': 'green'});
					$("#configMemprogressbar").attr('aria-valuenow', 45);
					
				} else if (percentage < 75){
					
					$("#configMemprogressbar").css({'background-image': 'none','background-color': 'orange'});
					
				} else if (percentage > 75){
					
					$("#configMemprogressbar").css({'background-image': 'none','background-color': 'red'});
				}
				
				percenttrim = parseFloat(percentage).toFixed(2);
				$("#configMemprogressbar").html("<p align=\"center\">"+ percenttrim + "%" +"<p>");
			
			} else {
				
				statusMsg = "OTP information could not be retrieved.";
				window.alert(statusMsg);
				update_status_message(statusMsg);
				
				reset_fields();
			    disable_fields();
				return;
			}
			
			var firmware_config = get_firmware_config_location(gb_HUB_ID);
			var firmware_config_array = firmware_config.split("::");
			var firmware_loc = firmware_config_array[0];
			var config_loc = firmware_config_array[1];
			
			$("#FirmwareLocation").val(firmware_loc);
			$("#ConfigLocation").val(config_loc);
			
			if(firmware_loc === "ROM")	// ROM does not support EAP Strings
			{
				$('#hce1EAP_Div').hide();
				$('#hce2EAP_Div').hide();
				NCM_EAPlabel.innerText = "NCM/IAP Class Device";
				NCM_EAPlabel1.innerText = "NCM/IAP Class Device 1";
				NCM_EAPlabel2.innerText = "NCM/IAP Class Device 2";
			}
			else
			{
				$('#hce1EAP_Div').show();
				$('#hce2EAP_Div').show();
				NCM_EAPlabel.innerText = "NCM/IAP and IAP/EAP Class Device";
				NCM_EAPlabel1.innerText = "NCM/IAP and IAP/EAP Class Device 1";
				NCM_EAPlabel2.innerText = "NCM/IAP and IAP/EAP Class Device 2";
			}
			
			// Updating the Role switch wvalue field based on the SKU Value
			
			if(gb_skuName== "USB4925" || gb_skuName== "USB4927"){
				
				$("#fcwValue").val("0051");
				
				
			}else if (gb_skuName== "USB4916" || gb_skuName== "USB4914" || gb_skuName == "USB4912"){
				
				$("#fcwValue").val("0011");
				
				
			}else if (gb_skuName== "USB4715" || gb_skuName == "USB4712"){
				
				$("#fcwValue").val("0031");
				
			}
	
			statusMsg = "Reading Hub Configuration ....";
			update_status_message (statusMsg);
			
																																		
			var portcount =  parseInt(gb_skuName.substring(6,7))- parseInt(gb_skuName.substring(5,6));
			
			// TODO MAKE THE STANDARD PORT BC NOT EDITABLE
			
			//By default show all ports and respective configurstion fields
			//later based on sku - show/hide
			// Basic Features tab
			$("#BCport2fieldset").show();
			$("#BCport3fieldset").show();
			$("#BCport4fieldset").show();
			$("#BCport5fieldset").show();
						
			$('#enableport2').attr("disabled",false);
			$('#enableport3').attr("disabled",false);
			
			$('#nrdeviceport2').attr("disabled", false);	
			$('#nrdeviceport3').attr("disabled", false);

			$("#BCdownstreamport2").show();
			$("#BCdownstreamport3").show();
			
			//Advanced features Tab
			$("#ad_port2fieldset").show();
			$("#ad_port3fieldset").show();
			$("#ad_port4fieldset").show();
			$("#ad_port5fieldset").show();
					
			$("#port2advance").find('input, button').attr('disabled',false);
			$("#port3advance").find('input, button').attr('disabled',false);

			$("#DCPport2group").show();
			$("#DCPport3group").show();
			$("#DCPport4group").show();
			
			$("#port2rsoption").show();
			$("#port3rsoption").show();
			$("#port4rsoption").show();
			
				
			if (portcount == 4 ) {
				$("#BCport5fieldset").hide();
				$("#ad_port5fieldset").hide();
				
				//Advanced features - Flexconnect. 
				// Show all 4 ports
				$('#ConfigFlex2').show();
				$('#ConfigFlex3').show();
				$('#ConfigFlex4').show();	
			} else if (portcount == 3) { //USB4914, USB4925 - 2 port + 1 standard port
				$("#BCport4fieldset").hide();
				$("#ad_port4fieldset").hide();
				$("#BCport5fieldset").hide();
				$("#ad_port5fieldset").hide();
								
				$("#port3advance").find('input, button').attr('disabled','disabled');
				
				//Standard port - should not allow to enable/disable port/NR
				$('#enableport3').attr("disabled",true);
				$('#nrdeviceport3').attr("disabled", true);	
				
				//Battery charging is not supported for standard ports.
				$("#BCdownstreamport3").hide();
				
				//hide the ports in DCP and role switch
				$("#DCPport4group").hide();
				$("#DCPport3group").hide();
				$("#port4rsoption").hide();
				$("#port3rsoption").hide();
			} else if(portcount == 5) {
				//Already all ports are shown above
				$('#enableport5').attr("disabled",true);
			}
			else if(portcount == 1) //USB4912, USB4712
			{
				if(gb_skuName == "USB4912")
				{
					$("#BCport3fieldset").hide();
					$("#BCport4fieldset").hide();
					$("#BCport5fieldset").hide();
					
					$("#ad_port3fieldset").hide();
					$("#ad_port4fieldset").hide();
					$("#ad_port5fieldset").hide();
					
					$("#port2advance").find('input, button').attr('disabled','disabled');
					
					//Standard port - should not allow to enable/disable port/NR
					$('#enableport2').attr("disabled",true);
					$('#nrdeviceport2').attr("disabled", true);	
										
					//Battery charging is not supported for standard ports.
					$("#BCdownstreamport2").hide();
					
					//hide the ports in DCP and role switch
					$("#DCPport2group").hide();
					$("#DCPport3group").hide();
					$("#DCPport4group").hide();
					
					$("#port2rsoption").hide();
					$("#port3rsoption").hide();
					$("#port4rsoption").hide();
				}
				else if(gb_skuName == "USB4712")
				{
					$("#BCport2fieldset").hide();
					$("#BCport3fieldset").hide();
					$("#BCport4fieldset").hide();
					$("#BCport5fieldset").hide();
					
					$("#ad_port2fieldset").hide();
					$("#ad_port3fieldset").hide();
					$("#ad_port4fieldset").hide();
					$("#ad_port5fieldset").hide();
					
					//Advanced features - Flexconnect. 
					// Show port 1 only and hide remaining
					$('#ConfigFlex2').hide();
					$('#ConfigFlex3').hide();
					$('#ConfigFlex4').hide();
					
					//hide the ports in DCP and role switch
					$("#DCPport2group").hide();
					$("#DCPport3group").hide();
					$("#DCPport4group").hide();
					
					$("#port2rsoption").hide();
					$("#port3rsoption").hide();
					$("#port4rsoption").hide();
				}
			}
			
																									
			// Updating GwidgetlistHex
			$.each(GwidgetlistHex, function( index, value ) {
				
				var widgetid = "#" + value;
				var widgetValue = getWidgetValue(gb_HUB_ID, value);
				
				
				if (widgetValue) {
					
					widgetValue = parseInt(widgetValue,10);
					var hexstring;
					
					if (value == "usbvcd" || value == "secondary_usbvcd" ) 
					{
						var dot = ".";
						var hexvalue = (widgetValue.toString(16));
						var position = 1;
						var hexstring = [hexvalue.slice(0, position), dot, hexvalue.slice(position)].join('');
						
					} else {
						
						hexstring = widgetValue.toString(16); //"0x" +  (decvalue.toString(16) );					 		
					}
					
					$(widgetid).val(hexstring);
				}
			});
			

			
			// Updating GwidgetlistString
			$.each(GwidgetlistString, function( index, value ) {
				
				var widgetid = "#" + value;
				var widgetValue = getWidgetValue(gb_HUB_ID, value);
				
				if((widgetValue === "")) {
					
					$(widgetid).val("");
					$(widgetid).attr('placeholder', stringnullvalue);
					
				} else {
					
					$(widgetid).val(widgetValue);
				}
			});

           
			// TODO FIND HOW POWER ON TIME SHD BE UPDATED
			// Updating GwidgetlistInt
			$.each(GwidgetlistInt, function( index, value ) {
				
			  var widgetid = "#" + value;
			  var widgetValue = getWidgetValue(gb_HUB_ID, value);									
			   var decVal;
			   
			   if ((value == "hubcmaxpowerbus") || (value == "hubcmaxpowerself")) {
					
					decVal = widgetValue & 0xff;
					decVal = parseInt(decVal,10);
					
				}else{
				
					decVal = widgetValue & 0xff;
					decVal = parseInt(decVal,10);
					decVal = decVal * 2;
					
				}
				
				$(widgetid).val(decVal);
			});
			
          
			// Updating GwidgetlistCheckbox
			$.each(GwidgetlistCheckbox, function( index,value ) {				
				
				var widgetid = "#" + value;
				
				var widgetValue = getWidgetValue(gb_HUB_ID, value);
				
				
				if ( widgetValue == checkbox_checked_value ){
					
					$(widgetid).prop('checked',true);  
											
				} else {
					
					$(widgetid).prop('checked',false);
				}
				
				if(value== "flexconnect" && widgetValue == checkbox_unchecked_value){
					
					//hide the flexport dropdown					
					$("#flexportULbutton").attr('disabled', true);
				}
								
				
				$(widgetid).trigger("change"); 
				set_changed_fields_border_default();
				
				//Dont Change the code flow
				
				if(value=="enableport5" || value=="nrdeviceport5" ) { 
				
					if(gb_skuName=="USB4912" )
					{
						widgetid = widgetid.substring(0, widgetid.length - 1);
						widgetid = widgetid +"2";
						
						if ( widgetValue == checkbox_checked_value ){
					
							 $(widgetid).prop('checked',true);  
											
				        } else {
					
							$(widgetid).prop('checked',false);
						}
						
						$(widgetid).trigger("change"); 
						set_changed_fields_border_default();	
					}
					if(gb_skuName=="USB4914" || gb_skuName=="USB4925" ){
						
						
						widgetid = widgetid.substring(0, widgetid.length - 1);
						widgetid = widgetid +"3";
						
						if ( widgetValue == checkbox_checked_value ){
					
							 $(widgetid).prop('checked',true);  
											
				        } else {
					
							$(widgetid).prop('checked',false);
						}
						
						$(widgetid).trigger("change"); 
						set_changed_fields_border_default();											
						
				     }
				 }
			});
			
						
			//setting the advanced port setting to not editable if port is disabled
			$.each(portenableidlist5, function( index, value ) {				
				
				widgetid = "#" + value;
				
				portnum = widgetid.substring(widgetid.length - 1);
				
				targetid = "#port" + portnum +"advance" ;
				
				if( ! ($(widgetid).is(':checked'))){
					
					$(targetid).find('input, button').attr('disabled','disabled');				
					
				}
			});
						

			// Updating the radio widgets

			$.each(GwidgetlistRadio, function( index, value ) {
									
				var groupname = value +"group";
				var widgetValue = getWidgetValue(gb_HUB_ID, value);
						
				var nameofcontrol = "input[name=" + groupname + "][value=" + widgetValue + "]";
				$(nameofcontrol).prop("checked", true);
				
				if ( value === "hubpower")
				{
					var widgetid = "#hubpowergroup";
					// If there are corresponding fieldsets - enable them 
					$(widgetid).trigger("change");
					 
					if (widgetValue == "0") { 
						
						// Bus power, So disabling the Self power fields
						$('#selfpowerfieldset').hide();
						$('#buspowerfieldset').show();
						
					} else if (widgetValue == "1") { 
						
						// Self power,so disabling the bus power fields
						$('#buspowerfieldset').hide();
						$('#selfpowerfieldset').show();
					}
					
					set_changed_fields_border_default();
				}
			});
			
			
			// Updating GwidgetlistDropDown
			$.each(GwidgetlistDropDown, function( index, value ) {
				
				
				var widgetValue = getWidgetValue(gb_HUB_ID, value);
				
				var widgetValue = parseInt(widgetValue,10);
				
				var nameofcontrol = "." + value + "1";
				var nameofcontrol1 = "[data-bind=\"" + value + "label\"]";
											
				if ( value == "PHYBOOST" || value=="PHYBOOSTdownstreamport1" || value=="PHYBOOSTdownstreamsecondaryport" 
					 || value=="PHYBOOSTdownstreamport2" || value=="PHYBOOSTdownstreamport3"
					 || value=="PHYBOOSTdownstreamport4" || value == "PHYBOOSTdownstreamport5"){
													 
							selText = DropDownPHYBOOST[widgetValue];
				}
				else if ( value == "SQUELCH" || value=="SQUELCHdownstreamport1" || value=="SQUELCHdownstreamsecondaryport" 
					 || value=="SQUELCHdownstreamport2" || value=="SQUELCHdownstreamport3"
					 || value=="SQUELCHdownstreamport4" || value == "SQUELCHdownstreamport5"){
					  
					   selText = DropDownSQUELCH[widgetValue];	
										
				}
				else if (value == "upstreamHsRiseFall" || value=="downstreamport1HsRiseFall" || value=="secondaryportHsRiseFall" 
					|| value=="downstreamport2HsRiseFall" || value =="downstreamport3HsRiseFall"
					|| value=="downstreamport4HsRiseFall" || value == "downstreamport5HsRiseFall"){
						
					  
					selText = DropDownHSRiseFall[widgetValue];
				
				}else if (value == "flexport" ){
					
					selText = DropDownflexport[widgetValue];
				}
			
			
				// Update fields based on obtained value
				$(nameofcontrol)
			   .find(nameofcontrol1).text(selText)
				.children('.dropdown-toggle').dropdown('toggle');
			
			});
			
			
			// Updating Config mode
			
			$("#ConfigMode").empty();
			
			var configModeVal =  MchpUsbConfigMode(gb_HUB_ID);
		
			
			$("#ConfigMode").val(configModeVal);
			
			var Mode = configModeVal;
			
			//Show or hide CDC based on SKU and Config Mode
			//4715-2,4,5
			//4916-3,5
			//4927-3,5
			
			if(gb_skuName == "USB4715" || gb_skuName == "USB4712"){
				
				if(Mode==2 || Mode== 4 || Mode==5 ){					
						
					$("#CDC_Div").show();										
					
				}
				
			}
			if(gb_skuName == "USB4916"){
				
				if(Mode ==3 || Mode == 5 ){
											
					$("#CDC_Div").show();	
															
				}
				
			}
			
			if(gb_skuName == "USB4927"){
				
				if(Mode ==3 || Mode == 5 ){
						
						$("#CDC_Div").show();	
																
				}				
			}
			
			HIDOption();
								
			statusMsg = "Reading Hub Configuration successful.";
			update_status_message (statusMsg);
								
		} 
				
		$("body").css("cursor", "default");
		
		
	};
        
})(jQuery);
var reloop = false;
(function ($) {
	
    get_hub_list_set_hub_index_zero = function () {
		
		get_hub_list();
		
		if (gb_hubsFound) {
			
			var rethubid = INIFileExists();
			var HUB_ID = 0;
			var singlehub = true;
			
			if(rethubid == false) {
				HUB_ID = 0;
			} else {
				HUB_ID = gethubfamilyIndex("4");  //sandia family type - 4
				singlehub = returnstatus();
			}
			var conform;
			if(HUB_ID == -1 && singlehub == false) {
				gb_HUB_ID = "0"
				select_hub_set_widgets();
			} else if(singlehub == false && HUB_ID != -1 ) {
						
				var rev = hub_list.reverse();
				
				conform = confirm("Selected hub is "+rev[HUB_ID+1]+". Do you want to proceed with selected hub index ?.");
				if(!conform) {
					reloop = true;
					$("#collapseDeviceSelection").show();
					$("#over").show();
					$("#SelectUSBHUBLabel").hide();
					$("#sfield").show();
					$("#close").show();
					$('#nav').hide();
					document.getElementById("over").setAttribute("class","w3-modal-new");
				} else {
					$("#over").show();
					$("#SelectUSBHUBLabel").show();
					$("#sfield").hide();
					$("#close").hide();
					$('#nav').show();
					document.getElementById("over").setAttribute("class","form-group");
					gb_HUB_ID = HUB_ID.toString();
					select_hub_set_widgets();
					$('.selecthub1').find('[data-bind="SelectHublabel"]').text(rev[HUB_ID+1])
											.children('.dropdown-toggle').dropdown('toggle');
									
					$("#selectedhubinput").val(rev[HUB_ID+1]);
				}
			
			} else if(singlehub == true){
				$("#over").show();
				$("#SelectUSBHUBLabel").show();
				$("#sfield").hide();
				$("#close").hide();
				
				gb_HUB_ID = HUB_ID.toString();
				select_hub_set_widgets();
				var rev = hub_list.reverse();
				
				$('.selecthub1').find('[data-bind="SelectHublabel"]').text(rev[HUB_ID+1])
										.children('.dropdown-toggle').dropdown('toggle');
								
				$("#selectedhubinput").val(rev[HUB_ID+1]);
			}
		}
	};
})(jQuery);


(function ($) {
    checkChangedWidget = function () {
    	
    	
    	var error_msg = "";
    	var hce_stringmodified=0;
		var hce1_stringmodified=0;
		var hce2_stringmodified=0;
		var primary_stringmodified=0;
		var secondary_stringmodified=0;
		var uuid_stringmodified=0;
		var secondary_uuid_stringmodified=0;
		
	    var hcemanuStringLength = 0;
		var manuStringLength = 0;
	    var SecStringLength = 0;
		
		var PrimaryDefaultlen = 126;
		var SecondaryDefaultlen = 126;
		var HCEDefaultlen = 126;
		var EAPDefaultLen = 111;
		
		var hce1macmodified=0;
	    var hce2macmodified=0; 
		var EapStrAlert = false; //Alert for EAP1
		var EapStrAlert1 = false; //Alert for EAP2
		var EapStrLengthVerify = false;
		
		var temp = gb_skuName.substring(0,6);
		
		if (temp == "USB491"){			
			gb_skuType=1;			
		}
			
		else if(temp == "USB492"){
			gb_skuType=2;
		} 
			 
		else if (temp == "USB471"){
			gb_skuType=3;
		}
    	
    	
    	// Find out currently how many ports are enabled
		var bEnable1 = $('#enableport1').is(':checked');
		var bEnable2 = $('#enableport2').is(':checked');
		var bEnable3 = $('#enableport3').is(':checked');
		var bEnable4 = $('#enableport4').is(':checked');
		var bEnable5 = $('#enableport5').is(':checked');
		
		var bTotal = bEnable1+bEnable2+bEnable3+bEnable4 + bEnable5;
		
		if((gb_skuName == "USB4912") || (gb_skuName == "USB4712")) {
			bTotal = bEnable1+bEnable2; 
		} else if ((gb_skuName == "USB4914") || (gb_skuName == "USB4925")) {
			bTotal = bEnable1+bEnable2+bEnable3; 
		} else if((gb_skuName == "USB4916") || (gb_skuName == "USB4927") || (gb_skuName == "USB4715")) {
			bTotal = bEnable1+bEnable2+bEnable3+bEnable4 + bEnable5;
		}
		
		var hceStatus = $('#hceenable').is(':checked')?1:0;
    	
    	
		// Check the hceenable and portenable validity
		if (hceStatus == 0 && bTotal==false) {
				
			var option = confirm("Hub controller is disabled.After programming all the ports will be disabled. do you want to continue?");
			if(!option) {
				enable_nav_fields();
				update_status_message("Programming of the device was terminated by the user.");
				return -1;
			}
		}
		
		//NCM1 - 146 bytes
		var fexist = INIFileExists();
		
		if(fexist == true) {
			var len = readStringfromINI();
		
			if (len) {
					
				var Defaultlen = len.split("###");
				PrimaryDefaultlen = Defaultlen[0];
				SecondaryDefaultlen = Defaultlen[1];
				HCEDefaultlen = Defaultlen[2];
				
			}
		}
	//String length constraint check
	$.each(GwidgetlistString, function( index, widgetName) {
			
		var widgetid = "#" + widgetName;
		var oldval = getWidgetValue(gb_HUB_ID, widgetName);	
				
		var newval = $(widgetid).val();
		
		
		if (newval != oldval){
			
			
			if (widgetName === "hce_manufacturer" || widgetName == "hce_product" || widgetName == "hce_serial")
			{
				var stringvalue = $(widgetid).val();
				
				// Check the widget length also
				if (stringvalue  == "")
				{
					// do nothing null string
				} else {
					hcemanuStringLength = ($(widgetid).val().length);
				}
				//Checking the string length constraint
				
				if ((hcemanuStringLength > HCEDefaultlen))
				{
					error_msg = error_msg+ "String Descriptor of Hub Feature Controller can have a max length of"+ " "+ HCEDefaultlen+ " "+ "unicode characters only\n";
					
				}
			}
				
			//Validating the NCM1 and NCM2 String descriptor 
			if(gb_skuType==1){
				
			
				/*if (widgetName === "hce1_manufacturer" || widgetName === "hce1_product" || widgetName == "hce1_string5")
				{
					var stringvalue = $(widgetid).val();
					
					// Check the widget length also
					if (stringvalue  == stringnullvalue)
					{
						// do nothing null string
					} else {
						hce1prodStringLength = hce1prodStringLength + ($(widgetid).val().length);
					}
				
					
					//Checking the string length constraint
					
					if ((hce1prodStringLength > HCEDefaultlen) && hce1StringFlag)
					{
						error_msg = error_msg+ "String Descriptor of NCM device 1 can have a max length of"+ HCEDefaultlen+ "unicode characters only\n";
						hce1StringFlag = false;
						
					}
				}
				
				if (widgetName === "hce2_manufacturer" || widgetName === "hce2_product" || widgetName == "hce2_string5")
				{
					var stringvalue = $(widgetid).val();

					// Check the widget length also
					if (stringvalue  == stringnullvalue)
					{
						// do nothing null string
					} else {
						hce2prodStringLength = hce2prodStringLength + ($(widgetid).val().length);
					}
					
					//Checking the string length constraint
				
					if ((hce2prodStringLength > HCEDefaultlen) && hce2StringFlag)
					{
						error_msg = error_msg+ "String Descriptor of NCM device 2 can have a max length of"+ HCEDefaultlen + "unicode characters only\n";
						hce2StringFlag = false;
						
					}
				}*/
				
				// Start of EAP1 Strings Alert
				if ((widgetName === "hce1_product"))
				{
					var stringvalue= $(widgetid).val();
					var stringvalue1 = $('#hce1_eapproduct').val();
								
					// Check the widget length also
					if ((stringvalue  === "") && (stringvalue1 === ""))
					{
					}
					else if((stringvalue  != "") && (stringvalue1 != ""))
					{
					}
					else
					{
						if(EapStrAlert === false)
						{
							var option = confirm("Disabling will NCM/IAP 1 Product will also disable IAP/EAP 1 Product. Do you want to continue?\n");
							if(option === false)
							{
								error_msg = error_msg + "Disabling will NCM/IAP 1 Product will also disable IAP/EAP 1 Product. Operation Terminated by user";
								update_status_message("Disabling will NCM/IAP 1 Product will also disable IAP/EAP 1 Product. Operation Terminated by user");
							}
							EapStrAlert = true;
						}
					}
				}
				if ((widgetName === "hce1_eapproduct"))
				{
					var stringvalue= $(widgetid).val();
					var stringvalue1 = $('#hce1_product').val();
								
					// Check the widget length also
					if ((stringvalue  === "") && (stringvalue1 === ""))
					{
					}
					else if((stringvalue  != "") && (stringvalue1 != ""))
					{
					}
					else
					{
						if(EapStrAlert === false)
						{
							var option = confirm("Disabling will IAP/EAP 1 Product will also disable NCM/IAP 1 Product. Do you want to continue?\n");
							if(option === false)
							{
								error_msg = error_msg + "Disabling will IAP/EAP 1 Product will also disable NCM/IAP 1 Product. Operation Terminated by user";
								update_status_message("Disabling will IAP/EAP 1 Product will also disable NCM/IAP 1 Product. Operation Terminated by user");
							}
							EapStrAlert = true;
						}
					}
				}
				// End of EAP1 Strings alert
				
				// Start of EAP2 Strings alert
				if ((widgetName === "hce2_product"))
				{
					var stringvalue= $(widgetid).val();
					var stringvalue1 = $('#hce2_eapproduct').val();
								
					// Check the widget length also
					if ((stringvalue  === "") && (stringvalue1 === ""))
					{
					}
					else if((stringvalue  != "") && (stringvalue1 != ""))
					{
					}
					else
					{
						if(EapStrAlert1 === false)
						{
							var option = confirm("Disabling will NCM/IAP 2 Product will also disable IAP/EAP 2 Product. Do you want to continue?\n");
							if(option === false)
							{
								error_msg = error_msg + "Disabling will NCM/IAP 2 Product will also disable IAP/EAP 2 Product. Operation Terminated by user";
								update_status_message("Disabling will NCM/IAP 2 Product will also disable IAP/EAP 2 Product. Operation Terminated by user");
							}
							EapStrAlert1 = true;
						}
					}
				}
				if ((widgetName === "hce2_eapproduct"))
				{
					var stringvalue= $(widgetid).val();
					var stringvalue1 = $('#hce2_product').val();
								
					// Check the widget length also
					if ((stringvalue  === "") && (stringvalue1 === ""))
					{
					}
					else if((stringvalue  != "") && (stringvalue1 != ""))
					{
					}
					else
					{
						if(EapStrAlert1 === false)
						{
							var option = confirm("Disabling will IAP/EAP 2 Product will also disable NCM/IAP 2 Product. Do you want to continue?\n");
							if(option === false)
							{
								error_msg = error_msg + "Disabling will IAP/EAP 2 Product will also disable NCM/IAP 2 Product. Operation Terminated by user" ;
								update_status_message("Disabling will IAP/EAP 2 Product will also disable NCM/IAP 2 Product. Operation Terminated by user");
							}
							EapStrAlert1 = true;
						}
					}
				}
				// End of EAP2 Strings Alert
				
				// Check for EAP Strings Length
				if((widgetName === "hce1_eapproduct") || (widgetName === "hce2_eapproduct") || (widgetName === "hce1_eapinterface") || (widgetName === "hce1_eapinterface"))
				{
					if(EapStrLengthVerify === false)
					{
						var Eap1ProductLen = ($('#hce1_eapproduct').val().length);
						var Eap1InterfaceLen = ($('#hce1_eapinterface').val().length);
						var Eap2ProductLen = ($('#hce2_eapproduct').val().length);
						var Eap2InterfaceLen = ($('#hce2_eapinterface').val().length);
						
						if((Eap1ProductLen + Eap1InterfaceLen + Eap2ProductLen +  Eap2InterfaceLen) > EAPDefaultLen)
						{
							error_msg = error_msg + "String Descriptor of IAP/EAP Class device Strings can have a max length of"+ " "+ EAPDefaultLen+ " "+ "unicode characters only." ;
							update_status_message("Error : String Descriptor of Hub Feature Controller can have a max length of"+ EAPDefaultLen+ "unicode characters only.");
							EapStrLengthVerify = true;
						}
					}
				}
				// End of EAP string length check
			
				if(widgetName === "hce1_macaddr" || widgetName === "hce2_macaddr"){
					var newval = "";
					if(widgetName === "hce1_macaddr")
					{
						newval = $("#hce1_macaddr").val();
					}
					else
					{
						newval = $("#hce2_macaddr").val();
					}
				
					var MacValue = newval.split(":");
	
					var maclength = MacValue.length;
					
										
					if(maclength < 6 || maclength > 6)
					{
						error_msg = error_msg + "The Given MAC Address is not valid.Mac Address should be for Example = 00:80:0F:10:20:01";
					}
					MacValue[0] = parseInt(MacValue[0],16);
					if((MacValue[0] & 0x01) === 0x01)
					{
						error_msg = error_msg + "MAC Address should not be a Multicast or Broadcast address";
					}
					
					var regex = /^([0-9a-fA-F]{2}[:-]){5}([0-9A-F]{2})$/;
				  
					var isMacOKAddr = regex.test(newval);
					
					if(!isMacOKAddr)
					{
						error_msg = error_msg +"The Given MAC Address is not a valid Mac Address";
					}
						
				}
				
			}
				
			//Validate the Maunfactuerer String
			if (widgetName === "manufacturer" || widgetName == "product" || widgetName == "serial") {
			
				var stringvalue = $(widgetid).val();
			
				// Check the widget length also
				if (stringvalue  == "")
				{
					// do nothing null string
				} else {
					manuStringLength = ($(widgetid).val().length);
				}
				//Checking the string length constraint
				
				if ((manuStringLength > PrimaryDefaultlen))
				{
					error_msg = error_msg+ "String Descriptor of Primary Hub can have a max length of"+ " "+ PrimaryDefaultlen + " "+ "unicode characters only\n";
					
				}
			}
			
			if (widgetName === "usb2uuid")
			{
				var uuidVal = $("#usb2uuid").val();
				var isValid = /^[0-9a-fA-F]{1,32}$/i.test(uuidVal);
                if (!isValid) {
									
					error_msg = error_msg + "UUID value entered is invalid. UUID must be a 16 bytes of hexadecimal number.\n";
				} 
			}

			//Validating the String Descriptor of Secondary Hub
			if(gb_skuType==2){
				
				if (widgetName === "secondary_manufacturer" || widgetName == "secondary_product" || widgetName == "secondary_serial") {
			
				var stringvalue = $(widgetid).val();
			
				// Check the widget length also
				if (stringvalue  == "")
				{
					// do nothing null string
				} else {
					SecStringLength = ($(widgetid).val().length);
				}
				//Checking the string length constraint
				
				if ((manuStringLength > SecondaryDefaultlen))
				{
					error_msg = error_msg+ "String Descriptor of Secondary Hub can have a max length of"+ " "+ SecondaryDefaultlen+ " "+ "unicode characters only\n";
					
				}
			}
			
			
			if (widgetName === "secondary_usb2uuid")
			{
				var uuidVal = $("#secondary_usb2uuid").val();
				var isValid = /^[0-9a-fA-F]{1,32}$/i.test(uuidVal);

				if (!isValid) {
									
					error_msg = error_msg + "Secondary Hub UUID value entered is invalid. UUID must be a 16 bytes of hexadecimal number.\n";
				}
			
			}
		}
	}
		   
});	
		 
	  
	    // Checking the validity of Hex fields against null,zero and valid hex digits	
		$.each(GwidgetlistHex, function( index, widgetName ) {
			
			var widgetid = "#" + widgetName;
			var oldval;
			var newval;
			var isValid;
			
			newval = $(widgetid).val();
			
			if(newval==""){
					
					error_msg = error_msg +  "The value of \"" + Mapping[widgetName] + "\" cannot be null.\n";
					
			}else{
									
				if(widgetName === "usbvcd" || widgetName === "secondary_usbvcd") {
					
					var iusbvcd = parseInt(getWidgetValue(gb_HUB_ID, widgetName), 10);
					var dot = ".";
					var xusbvcd = (iusbvcd.toString(16));
					
					var xusbvcd = [xusbvcd.slice(0,1), dot, xusbvcd.slice(1)].join('');
					oldval = xusbvcd;
					newval = $(widgetid).val();				
				
					isValid = /^2\.?[0-9]{0,2}$/i.test(newval);
					
					
					if (!isValid) {
						
						error_msg = error_msg +  "The value entered for \"" + Mapping[widgetName] + "\" is not valid.\n"
						
					}
				
				} else {
				
					oldval = parseInt(getWidgetValue(gb_HUB_ID, widgetName), 10);					
					isValid = /^[0-9A-Fa-f]{1,4}$/i.test($(widgetid).val());
					newval = parseInt($(widgetid).val(), 16);
									
					if (!isValid) {					
							
						error_msg = error_msg + "The value entered for \"" + Mapping[widgetName] + "\" must be a 4 digit hexadecimal value and it cannot be Zero.\n";
									
					}
				}
			}
		
		});
		
		
		
		// Checking int fields			
		$.each(GwidgetlistInt, function(index, widgetName) {
					
			
			widgetid = "#" + widgetName;
			
			var newval = $(widgetid).val();
			
			if ((widgetName == "maxpowerself") || (widgetName == "hubcmaxpowerself")) {
				
					if ((newval > 100) || (newval < 0)) {
						
						error_msg = error_msg + "USB2.0 max power(self) or USB2.0 hub circuit max power(self) cannot be more than 100mA or negative.\n";
					}
			}

			if (widgetName == "maxpowerbus") {
					
				if ((newval > 500) || (newval < 0)) {
					
					error_msg = error_msg +"USB2.0 max power(bus) cannot be more than 500mA or negative.\n";
				}
			}
				
			if (widgetName == "hubcmaxpowerbus") {
				
				if ((newval > 255) || (newval < 0)) {
					
					error_msg = error_msg + "USB2.0 hub circuit max power(bus) cannot be more than 255mA or negative.\n";
					
				}
			}
			if((widgetName == "maxpowerself") || (widgetName == "maxpowerbus") || (widgetName == "power_ontime"))
			{
				var newdecvalue = parseInt(newval,10);
				newdecvalue = newdecvalue & 0xff;
					
				if ((newdecvalue & 0x01))
				{
					error_msg = error_msg + "\"Hub MaxPower(Self)\" and \"Hub MaxPower(Bus)\" fields can have even numbers only";
					return;
				}
			}
			if (widgetName == "power_ontime") {
					
				if ((newval > 510) || (newval < 0)) {
					
					error_msg = error_msg +"Power-On Time cannot be more than 510ms or negative.\n";
				}
			}
		});			
			
			
			//Check flexconnect condition
				
		  if($('#flexconnect').is(':checked')){
				
			   var nameofcontrol = ".flexport1";
			   var nameofcontrol1 = "[data-bind=\"flexportlabel\"]";
			   var selText = $(nameofcontrol).find(nameofcontrol1).text();
					
				var portenableid = "#enableport" + selText;
					
				if (! ($(portenableid).is(':checked'))) {
					
					 error_msg = error_msg + "Downstream port " + selText + " is disabled. FlexConnect cannot be done. \n Enable Downstream port "+ selText+" and try again.\n";
				}			
		  }
		
			
			if (($("#Regoperationgroup").find(':checked').val()) && ($("#Regaddress").val()) && ($("#Regvalue").val())) {
				
				var Regaddress = $("#Regaddress").val();
				var Regaddress = Regaddress.replace(/\s+/g, "");
				var isValidAddr = /^[0-9A-Fa-f]{8}$/i.test(Regaddress);
				
				var RegValue = $("#Regvalue").val();
				var RegValue = RegValue.replace(/\s+/g, "");
				var isValidVal = /^[0-9A-Fa-f]+$/i.test(RegValue);
				
				
				if (!isValidAddr) {
					
					error_msg = error_msg + "The Register Address entered under the Direct Register Access must be a 8 digit hexadecimal number.\n";
					
				}
				
				if (!isValidVal) {
					
					error_msg = error_msg + "The Register value entered under the Direct Register Access is not a valid hexadecimal number.\n";
					
				}
				
			}	
				

    	  if(error_msg!= "") {
    	  	
    	  		alert(error_msg);
				enable_nav_fields();
    	  		return false;
    	  }
    	  
    	  return true;
    	
    };
})(jQuery);

(function ($) {
	
    set_changed_widget_list = function () {
		
	
		if(false == checkChangedWidget()){
			
			return;
		}
	
		
		var tempsku = gb_skuName.substring(0,6);
		
				
		//Array to save the widgets and their values which were changed.
		var deltaobj = [];		
		var widgetsToDisplay = [];
		var modifiedWidgets = [];
			    
		var enableMapping = false;
		var stringToSet = "";
		
		var vid_pidModified = false;
		
		// Find out currently how many ports are enabled
		var bEnable1 = $('#enableport1').is(':checked');
		var bEnable2 = $('#enableport2').is(':checked');
		var bEnable3 = $('#enableport3').is(':checked');
		var bEnable4 = $('#enableport4').is(':checked');
		var bEnable5 = $('#enableport5').is(':checked');
		
		//To program it to defaults when a port is disabled.
		if (bEnable1 == false &&  getWidgetValue(gb_HUB_ID, "enableport1" ) == "1" ) {
			
			var nrport1 = getWidgetValue(gb_HUB_ID, "nrdeviceport1");
			var dpdmSwap1 = getWidgetValue(gb_HUB_ID, "swapport1dpdm");
			var phyboost1 = getWidgetValue(gb_HUB_ID, "PHYBOOSTdownstreamport1");
			var varisense1 = getWidgetValue(gb_HUB_ID, "SQUELCHdownstreamport1");
			var hsrisefall1 = getWidgetValue(gb_HUB_ID, "downstreamport1HsRiseFall");
			
			
			if (dpdmSwap1 != 0) {
				deltaobj.push("swapport1dpdm", 0);
			}
			
			if (phyboost1 != 0) {
				deltaobj.push("PHYBOOSTdownstreamport1", 0);
			}
			
			if (varisense1 != 0) {
				deltaobj.push("SQUELCHdownstreamport1", 0);
			}
			if(hsrisefall1 !=0)
			{
				deltaobj.push("downstreamport1HsRiseFall", 0);
			}
		}

		if (bEnable2 == false &&  getWidgetValue(gb_HUB_ID, "enableport2" ) == "1" ) {
			
			var nrport2 = getWidgetValue(gb_HUB_ID, "nrdeviceport2");
			var dpdmSwap2 = getWidgetValue(gb_HUB_ID, "swapport2dpdm");
			var phyboost2 = getWidgetValue(gb_HUB_ID, "PHYBOOSTdownstreamport2");
			var varisense2 = getWidgetValue(gb_HUB_ID, "SQUELCHdownstreamport2");
			var hsrisefall2 = getWidgetValue(gb_HUB_ID, "downstreamport2HsRiseFall");
			
			
			if (dpdmSwap2 != 0) {
				deltaobj.push("swapport2dpdm", 0);
			}
			
			if (phyboost2 != 0) {
				deltaobj.push("PHYBOOSTdownstreamport2", 0);
			}
			
			if (varisense2 != 0) {
				deltaobj.push("SQUELCHdownstreamport2", 0);
			}
			if(hsrisefall2 !=0)
			{
				deltaobj.push("downstreamport2HsRiseFall", 0);
			}
		}

		if (bEnable3 == false &&  getWidgetValue(gb_HUB_ID, "enableport3" ) == "1" ) {
			
			var nrport3 = getWidgetValue(gb_HUB_ID, "nrdeviceport3");
			var dpdmSwap3 = getWidgetValue(gb_HUB_ID, "swapport3dpdm");
			var phyboost3 = getWidgetValue(gb_HUB_ID, "PHYBOOSTdownstreamport3");
			var varisense3 = getWidgetValue(gb_HUB_ID, "SQUELCHdownstreamport3");
			var hsrisefall3 = getWidgetValue(gb_HUB_ID, "downstreamport3HsRiseFall");
			
			
			if (dpdmSwap3 != 0) {
				deltaobj.push("swapport3dpdm", 0);
			}
			
			if (phyboost3 != 0) {
				deltaobj.push("PHYBOOSTdownstreamport3", 0);
			}
			
			if (varisense3 != 0) {
				deltaobj.push("SQUELCHdownstreamport3", 0);
			}
			if(hsrisefall3 !=0)
			{
				deltaobj.push("downstreamport3HsRiseFall", 0);
			}
		}

		if (bEnable4 == false  &&  getWidgetValue(gb_HUB_ID, "enableport4" ) == "1" ) {
			
			var nrport4 = getWidgetValue(gb_HUB_ID, "nrdeviceport4");
			var dpdmSwap4 = getWidgetValue(gb_HUB_ID, "swapport4dpdm");
			var phyboost4 = getWidgetValue(gb_HUB_ID, "PHYBOOSTdownstreamport4");
			var varisense4 = getWidgetValue(gb_HUB_ID, "SQUELCHdownstreamport4");
			var hsrisefall4 = getWidgetValue(gb_HUB_ID, "downstreamport4HsRiseFall");
			
			
			if (dpdmSwap4 != 0) {
				deltaobj.push("swapport4dpdm", 0);
			}
			
			if (phyboost4 != 0) {
				deltaobj.push("PHYBOOSTdownstreamport4", 0);
			}
			
			if (varisense4 != 0) {
				deltaobj.push("SQUELCHdownstreamport4", 0);
			}
			if(hsrisefall4 !=0)
			{
				deltaobj.push("downstreamport4HsRiseFall", 0);
			}
		}
		
		if (bEnable5 == false  &&  getWidgetValue(gb_HUB_ID, "enableport5" ) == "1" ) {
			
			var nrport5 = getWidgetValue(gb_HUB_ID, "nrdeviceport5");
			var dpdmSwap5 = getWidgetValue(gb_HUB_ID, "swapport5dpdm");
			var phyboost5 = getWidgetValue(gb_HUB_ID, "PHYBOOSTdownstreamport5");
			var varisense5 = getWidgetValue(gb_HUB_ID, "SQUELCHdownstreamport5");
			var hsrisefall5 = getWidgetValue(gb_HUB_ID, "downstreamport5HsRiseFall");
			
			
			if (dpdmSwap5 != 0) {
				deltaobj.push("swapport5dpdm", 0);
			}
			
			if (phyboost5 != 0) {
				deltaobj.push("PHYBOOSTdownstreamport5", 0);
			}
			
			if (varisense5 != 0) {
				deltaobj.push("SQUELCHdownstreamport5", 0);
			}
			if(hsrisefall5 !=0)
			{
				deltaobj.push("downstreamport5HsRiseFall", 0);
			}
		}
		
		
		$.each(GwidgetlistString, function( index, widgetName) {
			
			var widgetid = "#" + widgetName;
			var oldval = getWidgetValue(gb_HUB_ID, widgetName);
			
			var newval = $(widgetid).val();
			
			if (newval != oldval){

				if (jQuery.isEmptyObject(newval)) {
					
					newval = "";
				}
				
			   deltaobj.push(widgetName, newval);
			   modifiedWidgets.push(widgetName);
			  								
			}
		}); 
		

		
		//Hex Descriptors
		$.each(GwidgetlistHex, function( index, widgetName ) {
			
			
			var widgetid = "#" + widgetName;
			var oldval;
			var newval;
			var isValid;
			
			if(widgetName === "usbvcd" || widgetName === "secondary_usbvcd") {
				
				//Backend Values are in Int
				//UI values are in HEX
				
				var oldval  = parseInt(getWidgetValue(gb_HUB_ID, widgetName), 10);	
				oldval = oldval.toString(16);
				var strnewval = $(widgetid).val();
				strnewval = strnewval.replace('.', '');
				newval = parseInt(strnewval,16);
                newval = newval.toString(16);				
					
			} else {
				
				var ioldval = parseInt(getWidgetValue(gb_HUB_ID, widgetName), 10);
				var stroldval = ioldval.toString(16);
			    oldval = "0x" + stroldval			
				var strxnewval = $(widgetid).val();
				var inewval = parseInt(strxnewval,16);
				strxnewval =  inewval.toString(16);
				newval = "0x" +  strxnewval; 
				
			}
			
			
			
			if (oldval != newval) {
				
				//Check for language ID DO WE NEED to DO this
				
				if ((widgetName =="languageid" || widgetName== "secondary_languageid" || widgetName== "hce_languageid"
				      || widgetName== "hce1_languageid" || widgetName== "hce2_languageid")) {
						
					if (newval == "0x0") {
						
						alert("Language ID cannot be zero. Setting it to default value (0x409)");
						newval = parseInt("0x409", 16);
					}
				}
				
				// Adding the VID of USB2.0 and HCE to Protouch2.ini, if they are modified.
				
				if ((widgetName == "vid") || (widgetName == "secondary_vid") || (widgetName == "hce_vid") 
				     || (widgetName == "hce1_vid") || (widgetName == "hce2_vid") ) {
					
						var xval = $(widgetid).val();
						var strxval = "0x" + xval;
						updateINI(strxval);
												
						//if pid of USB2.0 or Hub controller is modified, then increase the time out.
						vid_pidModified = true;
				}

				//if vid of hub or Hub controller is modified, then increase the time out.
				if ((widgetName == "pid") || (widgetName == "secondary_pid") || (widgetName == "hce_pid") 
				     || (widgetName == "hce1_pid") || (widgetName == "hce2_pid") ) {
					
						vid_pidModified = true;
				}

				deltaobj.push(widgetName,newval);			
				modifiedWidgets.push(widgetName);
					
			}
			
		});
		
        
		//Int Descriptors
		$.each(GwidgetlistInt, function(index, widgetName) {
			
			var widgetid = "#" + widgetName;
			var oldval = getWidgetValue(gb_HUB_ID, widgetName);
			var strxnewval;
			
			if((widgetName == "hubcmaxpowerself") || (widgetName == "hubcmaxpowerbus")) {
				
				oldval = parseInt(oldval,10);
				
			} else {
				
				oldval = parseInt(oldval,10) * 2;
			}
			
			var newval = parseInt($(widgetid).val(),10);
			
			if (!(oldval == newval)) {
	
			    if ((widgetName == "hubcmaxpowerself") || (widgetName == "hubcmaxpowerbus")) {
			    	
					strxnewval = newval.toString(16);
					
				} else {
					
					newdecvalue = newval/2;
					strxnewval = newdecvalue.toString(16);
					
				}
				
				deltaobj.push(widgetName, strxnewval);
				modifiedWidgets.push(widgetName);
			}
		});
		
		
		//Radio buttons
		
		$.each(GwidgetlistRadio, function(index, widgetName) {
			
			var widgetgroupname = '#' + widgetName +"group";
			var oldval = getWidgetValue(gb_HUB_ID, widgetName);
			var newval = $(widgetgroupname).find(':checked').val();
			
			
			if (oldval != newval) {
				
				if(widgetName==	"i2senable" && newval == "0"){
					
					deltaobj.push("i2senablehid", "0");
					modifiedWidgets.push("i2senablehid");					
					
				}
					
				deltaobj.push(widgetName, newval);
				modifiedWidgets.push(widgetName);
			}
			
		});



		var sendportnrdetails = false;
		
		//Checkbox
		$.each(GwidgetlistCheckbox, function(index, widgetName) {
			
			var widgetid = "#" + widgetName;
			var newval = checkbox_unchecked_value;
			var finWidgetName = widgetName ;
			
			if($(widgetid).is(':checked')){
				
				newval = checkbox_checked_value;
			}
			
			if(gb_skuName== "USB4914" || gb_skuName== "USB4925"){
				    	
		    	if(widgetName== "enableport3" ){
		    		
		    		finWidgetName = "enableport5";
		    	}
		    	if(widgetName== "nrdeviceport3"){
		    		
		    		finWidgetName = "enableport5";
		    	}
			}
			if(gb_skuName== "USB4912")
			{
				if(widgetName == "enableport2")
				{
					finWidgetName= "enableport5";
				}
				if(widgetName== "nrdeviceport2"){
		    		
		    		finWidgetName = "nrdeviceport5";
		    	}
			}
			
			var oldval = getWidgetValue(gb_HUB_ID, finWidgetName);	

						
			if (oldval != newval) {
			
				
				if(widgetName== "enableport1" || widgetName== "enableport2" || widgetName== "enableport3" || widgetName== "enableport4" || widgetName== "enableport5" ){
				
				    sendportnrdetails = true;
				
			   }
			   if(widgetName == "lpmenable") {
				   
				   alert("The change in LPM Enable will cause change in the USB bcdUSB");
				   deltaobj.push("lpmenable", newval); 
			   
			   }
			   
			   finWidgetName = widgetName;
			   
			   if(widgetName == "flexconnect") { 
			   	
			   		if ($('#flexconnect').is(':checked')) {
			   			
			   		alert("Enabling Flexconnect will swap Downstream port  with Upstream port. Please make required changes in hub for further processing after successful programming");
			   		
			   		gb_enableFlex = true;
			   		
			   		}
			   		else{
			   			
			   			alert("Disabling Flexconnect will swap Downstream port with Upstream port. Please make required changes in hub for further processing after successful programming");
			   			
			   			gb_disableFlex = true;
			   		
			   		}
					
				} 
				if (widgetName == "swapupstreamdpdm") {
					
					if ($('#swapupstreamdpdm').is(':checked')) {
						
						alert("Programming Upstream swap will swap D+ and D- lines of Upstream port. Please make the required changes in hub for further processing after successful programming");
			        }
			        
			        gb_enable_swapupstreamdpdm = true;
			   }
			   
			   if(widgetName != "flexconnect"){
			   	
			   	 	deltaobj.push(finWidgetName, newval); 
			   	 			   				   	
			   	
			   }else{
			   	
			   	     if(!$('#flexconnect').is(':checked')){
			   	 		
			   	 		deltaobj.push("flexport", "0");
			   	 		
			   	 	}	
			   	
			   }
			   		   
			   modifiedWidgets.push(widgetName);		   
			   
			}
			
		});
		
		var nr1val = $('#nrdeviceport1').is(':checked') ? "1" : "0";
		var nr2val = $('#nrdeviceport2').is(':checked') ? "1" : "0";
		var nr3val = $('#nrdeviceport3').is(':checked') ? "1" : "0";
		var nr4val = $('#nrdeviceport4').is(':checked') ? "1" : "0";
		var nr5val = $('#nrdeviceport5').is(':checked') ? "1" : "0";
		
		
		if(sendportnrdetails==true){
						
			//Send NR and port mapping details if port is modified since the standard port has NR enabled by default
			
			if( tempsku=="USB491" || tempsku=="USB492"){
				
				var totalenabledports = 0;
			
				//send port mapping details
				
				if(gb_skuName== "USB4916" || gb_skuName== "USB4927"){
					
				
					$.each(portenableidlist5, function(index, widgetName) {
						
						
						var widgetid = "#" + widgetName;
						var portno = index+1;
						var mappingname = "port" + portno + "mapping";
						
						if ($(widgetid).is(':checked')) {
							
							totalenabledports++;
							deltaobj.push(mappingname, totalenabledports);					
						}
						else{
							
							deltaobj.push(mappingname,0);
						
						}
					});
				}
				
				if(gb_skuName== "USB4914" || gb_skuName==  "USB4925"){
				
				
					$.each(portenableidlist3, function(index, widgetName) {
						
						
						var widgetid = "#" + widgetName;
						var portno = index+1;
						var mappingname = "port" + portno + "mapping";
						
						if ($(widgetid).is(':checked')) {
							
							totalenabledports++;
							deltaobj.push(mappingname, totalenabledports);					
						}
						else{
							
							deltaobj.push(mappingname,0);
						
						}
					});
					
					if ($("#enableport3").is(':checked')) {
							
							totalenabledports++;
							deltaobj.push("port5mapping", totalenabledports);					
						}
						else{
							
							deltaobj.push("port5mapping",0);
						
						}					
					
				}		
				if(gb_skuName== "USB4912")
				{
					var widgetid = "#enableport1";
					var mappingname = "port1mapping";
					
					if ($(widgetid).is(':checked')) {
						
						totalenabledports++;
						deltaobj.push(mappingname, totalenabledports);					
					}
					else{
						
						deltaobj.push(mappingname,0);
					}
					
					if ($("#enableport2").is(':checked')) {
						totalenabledports++;
						deltaobj.push("port5mapping", totalenabledports);					
					}
					else{
						deltaobj.push("port5mapping",0);
					}		
				}
				
				//send UDC0,MHDC mapping details for 491X
				
				if(tempsku=="USB491"){
					
					
					deltaobj.push("port6mapping", totalenabledports+2);
					deltaobj.push("port7mapping", totalenabledports+1);
					
					//Send NR for Port 6 , Port 7
					deltaobj.push("nrdeviceport6","1" );
					modifiedWidgets.push("nrdeviceport6");
					deltaobj.push("nrdeviceport7","1" );
					modifiedWidgets.push("nrdeviceport7");
					
				}	

				// TODO NOT SENDING THE MAPPING OR NR FOR UDC here in 492X
				// TODO HANDLE THE CONDITION IF UDC IS DISBALED. DONT SEND THE MAPPING FOR UDC MHDC BLANKLY THEN
				
				//send NR details for port1-port7				
				
				if($('#enableport1').is(':checked')) {
					if (nr1val==  getWidgetValue(gb_HUB_ID, "nrdeviceport1")) {
					
						deltaobj.push("nrdeviceport1",nr1val );
						modifiedWidgets.push("nrdeviceport1");
					}
				} else {
					deltaobj.push("nrdeviceport1","0" );
					modifiedWidgets.push("nrdeviceport1");
				}
				
				if($('#enableport2').is(':checked')) {
					if (nr2val==  getWidgetValue(gb_HUB_ID, "nrdeviceport2")) {
					
						deltaobj.push("nrdeviceport2",nr2val );
						modifiedWidgets.push("nrdeviceport2");
					}
				} else {
					deltaobj.push("nrdeviceport2","0" );
					modifiedWidgets.push("nrdeviceport2");
				}
				
				if($('#enableport3').is(':checked')) {
					if (nr3val==  getWidgetValue(gb_HUB_ID, "nrdeviceport3")) {
					
						deltaobj.push("nrdeviceport3",nr3val );
						modifiedWidgets.push("nrdeviceport3");
					}
				} else {
					deltaobj.push("nrdeviceport3","0" );
					modifiedWidgets.push("nrdeviceport3");
				}
				
				if (nr3val==  getWidgetValue(gb_HUB_ID, "nrdeviceport5")  && (gb_skuName== "USB4914" || gb_skuName== "USB4925")) {
					
					deltaobj.push("nrdeviceport5","1" );
					modifiedWidgets.push("nrdeviceport3");
					
				}
				
				if($('#enableport4').is(':checked')) {
					if (nr4val==  getWidgetValue(gb_HUB_ID, "nrdeviceport4")) {
					
						deltaobj.push("nrdeviceport4",nr4val );
						modifiedWidgets.push("nrdeviceport4");
					}
				} else {
					deltaobj.push("nrdeviceport4","0" );
					modifiedWidgets.push("nrdeviceport4");
				}
				
				if (nr5val==  getWidgetValue(gb_HUB_ID, "nrdeviceport5") && (gb_skuName== "USB4916" || gb_skuName== "USB4927") ) {
					
					deltaobj.push("nrdeviceport5",nr5val );
					modifiedWidgets.push("nrdeviceport5");
					
				}				
				
			}else{
				
				// Send port mapping if port is modifed and NR incase if any port NR is enabled	

				var totalenabledports = 0;
	
				
				$.each(portenableidlist4, function(index, widgetName) {
					
					var widgetid = "#" + widgetName;
					var portno = index+1;
					var mappingname = "port" + portno + "mapping";
					
					
					if ($(widgetid).is(':checked')) {
						
						totalenabledports++;
						deltaobj.push(mappingname, totalenabledports);					
					}
					else{
						
						deltaobj.push(mappingname,0);
					
					}
				});
				
							
				
				// TODO NOT SENDING THE MAPPING OR NR FOR UDC here in 4715
				
				if( nr1val=="1" || nr2val=="1" || nr3val=="1" || nr4val=="1" ){
					
					if (nr1val==  getWidgetValue(gb_HUB_ID, "nrdeviceport1")) {
					
						deltaobj.push("nrdeviceport1",nr1val );
						modifiedWidgets.push("nrdeviceport1");
					
					}
				
					if (nr2val==  getWidgetValue(gb_HUB_ID, "nrdeviceport2")) {
						
						deltaobj.push("nrdeviceport2",nr2val );
						modifiedWidgets.push("nrdeviceport2");
						
					}
					
					if (nr3val==  getWidgetValue(gb_HUB_ID, "nrdeviceport3")) {
						
						deltaobj.push("nrdeviceport3",nr3val );
						modifiedWidgets.push("nrdeviceport3");
						
					}
					
					if (nr4val==  getWidgetValue(gb_HUB_ID, "nrdeviceport4") ) {
						
						deltaobj.push("nrdeviceport4",nr4val );
						modifiedWidgets.push("nrdeviceport4");
						
						
					}
					
					deltaobj.push("nrdeviceport5","1" );
					modifiedWidgets.push("nrdeviceport5");					
					
				}				
				
			}			
			
		}
						
	
		//DropDown
		$.each(GwidgetlistDropDown, function(index, widgetName) {
			
			var nameofClass = "." + widgetName + "1";
			var nameofSpan = "[data-bind=\"" + widgetName + "label\"]";
			var selText = $(nameofClass).find(nameofSpan).text();
			var nVal;
			
			if (widgetName === "PHYBOOST" || widgetName === "PHYBOOSTdownstreamport1" || widgetName == "PHYBOOSTdownstreamsecondaryport" ||
				widgetName === "PHYBOOSTdownstreamport2" || widgetName === "PHYBOOSTdownstreamport3" ||
				widgetName === "PHYBOOSTdownstreamport4" || widgetName === "PHYBOOSTdownstreamport5") {
					
				nVal = DropDownPHYBOOST.indexOf(selText);
				
			}
			if (widgetName === "SQUELCH" || widgetName === "SQUELCHdownstreamport1" || widgetName == "SQUELCHdownstreamsecondaryport" || 
				widgetName === "SQUELCHdownstreamport2" || widgetName === "SQUELCHdownstreamport3" ||
				widgetName === "SQUELCHdownstreamport4" || widgetName === "SQUELCHdownstreamport5")  {
					
				  nVal = DropDownSQUELCH.indexOf(selText);
		
			}
			
			if(widgetName === "upstreamHsRiseFall" || widgetName === "downstreamport1HsRiseFall" || widgetName == "secondaryportHsRiseFall" ||
				widgetName === "downstreamport2HsRiseFall" || widgetName === "downstreamport3HsRiseFall" ||
				widgetName === "downstreamport4HsRiseFall" || widgetName === "downstreamport5HsRiseFall") {
					
				
				nVal = DropDownHSRiseFall.indexOf(selText);
			}
			
			if(widgetName === "flexport"){
				
				gb_enableport = true;
				nVal = DropDownflexport.indexOf(selText);
				
			}
			
			var oldVal = getWidgetValue(gb_HUB_ID, widgetName);

			if (oldVal != nVal){
					
					deltaobj.push(widgetName, nVal);
					modifiedWidgets.push(widgetName);
			}
			
		});
	
		if(gb_enableFlex == true && gb_enableport == false) {
			error_msg = error_msg + "Flexconnect cannot be done without Flex Port.Please select Flex Port.";
			return;
		}
		var wKey;
		var wVal;
		var flag = 0;
		
		if (deltaobj.length != 0) {
			
			for (var i = deltaobj.length-2; i >= 0; i = i - 2) {
				
				wKey = deltaobj[i];
				wVal = deltaobj[i+1];
					
				stringToSet = wKey + ",,," + wVal + ";;;" + stringToSet;
				flag++;
				
			}
		}


		// TODO  Find the scope of stringToSet
		if (gb_iniFile) {
			
			gb_iniFile_fullPath = getFullPathINI();
			
			modifiedWidgets.push("xdataprogram");
			stringToSet = "xdataprogram,,," + gb_iniFile_fullPath + ";;;" + stringToSet;
			flag++;
		}
		
		
		if (($("#Regoperationgroup").find(':checked').val()) && ($("#Regaddress").val()) && ($("#Regvalue").val())) {
			
			gb_more = true;
			
			var regOptionChosen = $("#Regoperationgroup").find(':checked').val();
		
			if(regOptionChosen == 0){
				
				Regop = "XMODE_WRITE_BYTE";
			}
			else if(regOptionChosen == 1){
				
				Regop = "XMODE_SET_BITS";
			}
			else if(regOptionChosen == 2){
				
				Regop = "XMODE_CLEAR_BITS"
			}
			
			var Regaddress = $("#Regaddress").val();
		    var Regaddress = Regaddress.replace(/\s+/g, "");
				
			var RegValue = $("#Regvalue").val();
			var RegValue = RegValue.replace(/\s+/g, "");
			
			if(gb_RegString!=""){
					
				gb_RegString = Regop + "+" + Regaddress + "+" + RegValue + "+" + gb_RegString;				
					
			}else{
			
				gb_RegString = Regop + "+" + Regaddress + "+" + RegValue;
			
			}
			
		}
			
		
		if(gb_more == true) 
		{
			
			//Use one more variable to store values even if preview changes is clicked
			if(directRegString == "") 
			{
				directRegString = directRegString + gb_RegString;
			}
			else if((directRegString != "") && (gb_RegString != ""))
			{
				directRegString = directRegString + "+" + gb_RegString;
			}
			
			stringToSet = "xdataentry,,," + directRegString + ";;;" + stringToSet;
			modifiedWidgets.push("xdataentry");
			//gb_more = false;
			flag++;
		}
			
		if (gb_showPreview) {
						
			gb_showPreview = false;
			disable_nav_fields();
			
			if (flag != 0) {
				
				var fileSize = previewSetWidgetValue(gb_HUB_ID, stringToSet);
				
				//Get Current OTP information
				var info = get_otp_info(gb_HUB_ID);	
	
				
				if (info) {
					
					var otp_info = info.split("###");
					var otpSize = otp_info[0];

					var previewPercentage = ((fileSize / otpSize) * 100);
					
					$("#PreviewConfigMem").css('width',(previewPercentage).toFixed(2) + "%");
					$("#PreviewConfigMem").css('color', 'black');
					$("#PreviewConfigMem").css({'background-image': 'none','background-color': 'yellow'});
					$("#PreviewConfigMem").html("<p align=\"center\">"+ (previewPercentage).toFixed(2) + "%" +"<p>");
						
					$("#bytesProgrammed").val(fileSize);
					$('#previewChangesField').show();
					
				}
				
				update_status_message("No of bytes to be programmed: " + fileSize + ". Percentage of OTP memory to be used: " + previewPercentage.toFixed(2));
				enable_nav_fields();
				
			} else {
				enable_nav_fields();
				alert("No Changes detected.Preview cannot be shown.");
				
			}
			
		} else {
			
			if (flag == 0)
			{
				enable_nav_fields();
				var mesg = "Device configuration will not be changed ; No changes detected";
				alert(mesg);				
				update_status_message(mesg);
	
			} else {
				
				// TODO Change the DisplayChange variable showing	
					
					var displayChange = "";
					
					for (var i = 0; i < modifiedWidgets.length; i++) {
						
						var tempdisplay = Mapping[modifiedWidgets[i]];
						
						if(gb_skuType == 1 || gb_skuType == 3  ){
			   	
					   		if(tempdisplay.indexOf("Primary ") !== -1){
					   			
					   			tempdisplay = tempdisplay.replace("Primary ", "");
					   			
					   		}
			   				   	
			   			}
						
						
						if(i%4 == 0)
						{
							if (displayChange) {
								
								displayChange = "\n" + tempdisplay + ", " + displayChange;
								
							} else {
								
								displayChange = tempdisplay;
							}
							
						} else {
							
							if (displayChange) {
								
								displayChange = tempdisplay + ", " + displayChange;
							}
						}

					}
					
					var option = confirm("The following device settings will be changed ; Previously created JSON and Configuration files will be removed ; Do you want to continue?\n" + displayChange);
				
					if (option) {
											
						$('#mainprogressbar').show();
									
			 			setMainProgresswidth(60);
						
						window.setTimeout(function() {
						
						update_status_message("JSON and cfg files will be overwritten; and hub will be programmed with the following.\n " + displayChange);
						var status_msg = "Programming in progress...Please wait";
						update_status_message(status_msg);
						
						$("body").css("cursor", "wait");
						
						var result = setWidgetValue(gb_HUB_ID, stringToSet); // True is an input to JSON generator
						
						setMainProgresswidth(80);
						
															

						if (result) {
						
							//TODO error handling
							
							var mesg = "Hub is successfully programmed";
							update_status_message(mesg);
							
							
							window.setTimeout(function() {
							
						    var checksum= CalculateChecksum(true);
							setMainProgresswidth(80);
							
							mesg = "Configuration File 'bConfig.cfg' created with Checksum: 0x" + checksum ;
							update_status_message(mesg);
							
							cancelFlag = false;
							stringToSet = "";
							
							//Disable apply and preview buttons before making a java call
							
							set_changed_fields_border_default();

							var mesg = "Waiting for device reset to finish.....";
							update_status_message(mesg);
										

							if (vid_pidModified) {
								
								update_status_message("Vendor ID/Product ID of USB2.0/Hub controller has been modified...");

								
								window.setTimeout(function() {
									
									setMainProgresswidth(100);
								
									var mesg = "Refreshing Hub List....";
									update_status_message(mesg);						
										
									close_device(gb_HUB_ID);
									refresh();
									get_hub_list_set_hub_index_zero();								
									 
									  MainProghide();
									
									enable_nav_fields();									
									$("body").css("cursor", "default");
									
								
								}, 1500);
																					
								
							 } else {
							 	
								
									var mesg = "Refreshing Hub List....";
									update_status_message(mesg);
									
									setMainProgresswidth(100);
									
									window.setTimeout(function() {					
									
										close_device(gb_HUB_ID);
										refresh();
										get_hub_list_set_hub_index_zero();
										enable_nav_fields();																			
									 
										 MainProghide();									 							
										$("body").css("cursor", "default");
								
								}, 300);														
										 									  
							 }
							 
							 }, 200);	
											
						document.getElementById("DirectRegisterAccessForm").reset();
						
						}
						else {
							
													
							errorCode = getMchpUsbLastError(gb_HUB_ID);
							alert(errorMap[Dec2Hex(errorCode)]);
							update_status_message(errorMap[Dec2Hex(errorCode)] + "errorCode: " + errorCode);
							$("body").css("cursor", "default");	
							MainProghide();	
							gb_enable_swapupstreamdpdm = false;	
							gb_enableFlex = false;	
							gb_disableFlex	= false;
							enable_nav_fields();							
							
						}
						
						}, 100);
						directRegString = "";
						gb_more = false;
						gb_iniFile = "";
						
					} else {
						
						update_status_message("Programming of the device was terminated by the user.");
						gb_enable_swapupstreamdpdm = false;
						gb_enableFlex = false;
						gb_disableFlex	= false;
						enable_nav_fields();
					}
				}

			}
			
			//Required clean up action
			gb_RegString = "";
		}
		
		$("body").css("cursor", "default");
	
 })(jQuery);

(function ($) {
    set_dropdown_selected_option = function () {
        
        // Ordering is important - dont change code
        // Click of any field in  any drop down menu
        $(document).on('click', '.dropdown li a', function (event) {
            // this code is for making the current selection appear with caret
           
            var $target = $(event.currentTarget);

            $target.closest('.btn-group')
            .find('[data-bind]').text($target.text())
            .end()
            .children('.dropdown-toggle').dropdown('toggle');
            var selop = $(this).text();
            console.log("Selected Option - All dropdowns:" + selop);
        });

        // Click of Any hub in Select HUB drop down menu
        $(document).on('click', '.dropdown-selecthub li a', function (event) {
        	
			$("#over").show();
			$("#SelectUSBHUBLabel").show();
			$("#sfield").hide();
			$("#close").hide();
			$('#nav').show();
			document.getElementById("over").setAttribute("class","form-group");
			var selop = $(this).text();
			$("#selectedhubinput").val(selop);
			var btnValue = $("#selectedhubinput").val();
			var colonIndex = btnValue.indexOf(":");
			var currentHubSelected = btnValue.charAt(colonIndex + 1);

			if (currentHubSelected == gb_HUB_ID) {
				
				if(reloop == false ) {
					setTimeout(function() {
						
						get_hub_list_set_hub_index_zero();
						
					}, 200);
				} else {
					select_hub_set_widgets();
				}
			} else {
				
				setTimeout(function() {
					close_device(gb_HUB_ID);
					refresh();
					gb_HUB_ID = "" + currentHubSelected;
					select_hub_set_widgets();
					
				}, 200);
			}
			return false;
        });


    };
})(jQuery);




	function setSPIConfiguration(boolValue){
			var SpiconfigState = SPISetConfig(gb_HUB_ID, boolValue);
			if (!SpiconfigState) {

				$("#spisendtranfer").removeAttr('disabled', false);
				$("#spireceivetranfer").removeAttr('disabled', false);
			}
			gb_setSPIConfig_status = boolValue;
			setSPIConfigurationStatus(gb_setSPIConfig_status);
	}



	function setSPIConfigStatus_false()
	{
		
		if (gb_setSPIConfig_status) {
			setSPIConfiguration(false);
		}
			
	}

function setMainProgresswidth(width) {
	$('#mainprogressbar .progress-bar').css('width', width + '%').attr('aria-valuenow', width);	
}

function MainProghide() {
	
	$('#mainprogressbar .progress-bar').css('width', 0 + '%').attr('aria-valuenow', 0);	
	$('#mainprogressbar').hide();
}


function setI2CProgresswidth(width){
				
	$('#I2Cprogressbar .progress-bar').css('width', width + '%').attr('aria-valuenow', width);	
						

}

function setSPIProgresswidth(width){
				
	$('#SPIprogressbar .progress-bar').css('width', width + '%').attr('aria-valuenow', width);	
						

}

function I2CProghide() {
	
	$('#I2Cprogressbar .progress-bar').css('width', 0 + '%').attr('aria-valuenow', 0);	
	$('#I2Cprogressbar').hide();
}


function setSPIProgresswidth (width){
				
	$('#SPIprogressbar .progress-bar').css('width', width + '%').attr('aria-valuenow', width);	
						
}
		
function collapseallfields(){
		
			$('.panel-collapse').each(function () {
				
				if ($(this).hasClass('in')) {
				$(this).collapse('toggle');
			}
		});					
}

// Close Device function
function closeCurrentDevice() {
	
	setSPIConfigStatus_false();
	close_device(gb_HUB_ID);
}


$("#gpiostateclear").click(function(){
	
    $("#gpiopiostate").val('');
});

$("#xdataaddressclear").click(function(){
	
    $("#xdataaddress").val('');
});	

$("#RegisterLengthclear").click(function(){
	
    $("#RegisterLength").val('');
});
$("#xdatavalueclear").click(function(){
	
    $("#xdatavalue").val('');
});






