/*! jQuery v1.10.2 | (c) 2005, 2013 jQuery Foundation, Inc. | jquery.org/license
 */
//Variables to know which page has been selected: USB2.0 or USB3.1 Gen2
var portsAvailable = 0;
var hubCount;
var incval;
var hub_list;
var hceenablemanu = false;
var hceenableprod = false;
var gb_HUB_ID = "0";
var hceenableser = false;
var enablealertmanu = false;
var enablealertprod = false;
var enablealertser = false;
var newstringToSet = "";
var stringToSet = "";
var HUB_FAMILY_INDEX = "6";
var gb_enableport = false;
var gb_hubsFound = false;
var gb_Apply = false;


var USB7202_PortMap = ["0", "1", "3", "2", "4", "0", "5", "6"];
var USB725x_PortMap = ["0", "1", "4", "2", "0", "3", "5", "6"];
var USB7256_PortMap = ["0", "1", "5", "2", "3", "4", "6", "7"];
var USB7206_PortMap = ["0", "1", "2", "3", "4", "5", "6", "7"];

// Port type widgets
var GwidgetlistPortType = [ 
"port1type", 
"port2type", 
"port3type", 
"port4type",
"port5type", 
"port6type" 
];

// Port type widgets
var GwidgetlistPortMapping = [ 
"port1mapping",
"port2mapping",
"port3mapping",
"port4mapping",
"port5mapping",
"port6mapping",
"usb3port1mapping",
"usb3port2mapping",
"usb3port3mapping",
"usb3port4mapping",
"usb3port5mapping",
"usb3port6mapping",
];
// Widget ID of hex fields in the GUI
var GwidgetlistHex = [ 
"vid",
"pid",
"did",
"usbvcd",
"languageid",
"hce_vid",
"hce_pid", 
"hce_did", 
"hce_languageid", 
"hce1_vid", 
"hce1_pid",
"hce1_did", 
"hce1_languageid", 
"hce2_vid", 
"hce2_pid", 
"hce2_did",
"hce2_languageid",
// USB3 related
"usb3vid",
"usb3pid", 
"usb3did", 
"usb3vcd", 
"usb3languageid",
];

// Mapping widgets to the meaningful elaborations to print while in error
var Mapping = {
	// Hex
	"vid" : "USB2.0 Vendor ID",
	"pid" : "USB2.0 Product ID",
	"did" : "USB2.0 Device ID",
	"usbvcd" : "USB2.0 Version",
	"languageid" : "USB2.0 Language ID",
	"manufacturer" : "USB2.0 Manufacturer",
	"manufacturerlen" : "USB2.0 Manufacturer Length",
	"product" : "USB2.0 Product",
	"productlen" : "USB2.0 Product Length",
	"serial" : "USB2.0 Serial",
	"seriallen" : "USB2.0 Serial Length",
	
	"usb3vid" : "USB3.1 Gen2 Vendor ID",
	"usb3pid" : "USB3.1 Gen2 Product ID",
	"usb3did" : "USB3.1 Gen2 Device ID",
	"usb3vcd" : "USB3.1 Gen2 Version",
	"usb3languageid" : "USB3.1 Gen2 Language ID",
	"usb3manufacturer" : "USB3.1 Gen2 Manufacturer",
	"usb3product" : "USB3.1 Gen2 Product",
	"usb3serial" : "USB3.1 Gen2 Serial",
	"usb3uuid" : "Universal unique ID",
	
	"numberofports" : "Number of Enabled USB2.0 ports",
	"usb3numberofports" : "Number of Enabled USB3.1 Gen2 ports",
		
	"pstimeout" : "USB3 Port Split Link TimeOut",
	

	// "flexport" : "USB2 Flex Port",
	// "flexconnect" : "USB2 Flexconnect",
	// "usb3flexport" : "USB3.1 Gen2 Hub Flex Port",
	// "usb3flexconnect" : "USB3.1 Gen2 Hub Flexconnect",

	"hceenable" : "Hub Feature Controller State",
	"hce_vid" : "HFC Vendor ID",
	"hce_pid" : "HFC Product ID",
	"hce_did" : "HFC Device ID",
	"hce_languageid" : "HFC Language ID",
	"hce_manufacturer" : "HFC Manufacturer",
	"hce_manufacturerlen" : "HFC Manufacturer Length",
	"hce_product" : "HFC Product",
	"hce_productlen" : "HFC Product Length",
	"hce_serial" : "HFC Serial",
	"hce_seriallen" : "HFC Serial Length",

	"hce1_vid" : "NCM/IAP and IAP/EAP Class Device 1 Vendor ID",
	"hce1_pid" : "NCM/IAP and IAP/EAP Class Device 1 Product ID",
	"hce1_did" : "NCM/IAP and IAP/EAP Class Device 1 Device ID",
	"hce1_languageid" : "NCM/IAP and IAP/EAP Class Device 1 Language ID",
	"hce1_manufacturer" : "NCM/IAP and IAP/EAP Class Device 1 Manufacturer",
	"hce1_manufacturerlen" : "NCM/IAP and IAP/EAP Class Device 1 Manufacturer String Length",
	"hce1_product" : "NCM/IAP Class Device 1 Product",
	"hce1_string5" : "NCM/IAP and IAP/EAP Class Device 1 Serial Number",
	"hce1_productlen" : "NCM/IAP Class Device 1 Product String Length",
	"hce1_macaddr" : "NCM/IAP Class Device 1 MAC address",
	"hce1_eapproduct" : "IAP/EAP Class Device 1 Product String",
	"hce1_eapinterface" : "IAP/EAP Class Device 1 Interface String",
	

	"hce2_vid" : "NCM/IAP and IAP/EAP Class Device 2 Vendor ID",
	"hce2_pid" : "NCM/IAP and IAP/EAP Class Device 2 Product ID",
	"hce2_did" : "NCM/IAP and IAP/EAP Class Device 2 Device ID",
	"hce2_languageid" : "NCM/IAP and IAP/EAP Class Device 2 Language ID",
	"hce2_manufacturer" : "NCM/IAP and IAP/EAP Class Device 2 Manufacturer",
	"hce2_manufacturerlen" : "NCM/IAP and IAP/EAP Class Device 2 Manufacturer String Length",
	"hce2_product" : "NCM/IAP Class Device 2 Product",
	"hce2_productlen" : "NCM/IAP Class Device 2 Product String Length",
	"hce2_string5" : "NCM/IAP and IAP/EAP Class Device 2 Serial Number",
	"hce2_macaddr" : "NCM/IAP Class Device 2 MAC address",
	"hce2_eapproduct" : "IAP/EAP Class Device 2 Product String",
	"hce2_eapinterface" : "IAP/EAP Class Device 2 Interface String",

	"i2senable" : "I2S Feature Select",
	"i2senablehid" : "HID Feature Select",
	"power_ontime" : "Power-on time",
	"cdcenable":"CDC State",
	"hubpower" : "Hub Power",
	"maxpowerself" : "USB2.0 Hub Max Power(Self)",
	"hubcmaxpowerself" : "Hub Circuit Max Power (Self)",
	"maxpowerbus" : "USB2.0 Hub Max Power (Bus)",
	"hubcmaxpowerbus" : "Hub Circuit Max Power (Bus)",
	"hub3maxpowerselfbus" : "USB3.1 Gen2 Max Power",
	"hsdisable" : "Hub Full Speed Mode",
	"lpmenable" : "LPM State",
	"xdataentry" : "Direct Register Access",
	"xdataprogram" : "ini File",
	
	"minihost_vidpidrule" : "MiniHost VID PID Rule",
	"minihost_vidpidmaskrule" : "MiniHost VID PID Mask Rule",
	"minihost_deviceclassrule" : "Minihost Device Class Rule",
	
	"pdport1" : "Port 1 Power delivery",
	"pdport3" : "Port 2 Power delivery",
	"pdupstream" : "Upstram Port Power delivery",
	"enableport1" : "USB2.0 Port1 Enable/Disable State",
	"enableport2" : "USB2.0 Port2 Enable/Disable State",
	"enableport3" : "USB2.0 Port3 Enable/Disable State",
	"enableport4" : "USB2.0 Port4 Enable/Disable State",
	"enableport5" : "USB2.0 Port5 Enable/Disable State",
	"enableport6" : "USB2.0 Port6 Enable/Disable State",
	
	"port1mapping" : "USB2.0 Port1 Logical mapping",
	"port2mapping" : "USB2.0 Port2 Logical mapping",
	"port3mapping" : "USB2.0 Port3 Logical mapping",
	"port4mapping" : "USB2.0 Port4 Logical mapping",
	"port5mapping" : "USB2.0 Port5 Logical mapping",
	"port6mapping" : "USB2.0 Port6 Logical mapping",
	"port7mapping" : "USB2.0 Port7 Logical mapping",

	"nrdeviceport1" : "USB2.0 Port1 Non-removable State",
	"nrdeviceport2" : "USB2.0 Port2 Non-removable State",
	"nrdeviceport3" : "USB2.0 Port3 Non-removable State",
	"nrdeviceport4" : "USB2.0 Port4 Non-removable State",
	"nrdeviceport5" : "USB2.0 Port5 Non-removable State",
	"nrdeviceport6" : "USB2.0 Port6 Non-removable State",

	"usb3enableport1" : "USB3.1 Gen2 Port1 Enable/Disable State",
	"usb3enableport2" : "USB3.1 Gen2 Port2 Enable/Disable State",
	"usb3enableport3" : "USB3.1 Gen2 Port3 Enable/Disable State",
	"usb3enableport4" : "USB3.1 Gen2 Port4 Enable/Disable State",
	"usb3enableport5" : "USB3.1 Gen2 Port5 Enable/Disable State",

	"usb3port1mapping" : "USB3.1 Gen2 Port1 Logical mapping",
	"usb3port2mapping" : "USB3.1 Gen2 Port2 Logical mapping",
	"usb3port3mapping" : "USB3.1 Gen2 Port3 Logical mapping",
	"usb3port4mapping" : "USB3.1 Gen2 Port4 Logical mapping",
	"usb3port5mapping" : "USB3.1 Gen2 Port5 Logical mapping",

	"usb3nrdeviceport1" : "USB3.1 Gen2 Port1 Non-removable State",
	"usb3nrdeviceport2" : "USB3.1 Gen2 Port2 Non-removable State",
	"usb3nrdeviceport3" : "USB3.1 Gen2 Port3 Non-removable State",
	"usb3nrdeviceport4" : "USB3.1 Gen2 Port4 Non-removable State",
	"usb3nrdeviceport5" : "USB3.1 Gen2 Port5 Non-removable State",
	"usb3nrdevice"	    : "USB3.1 Gen2 Non-removable value",

	"downstreamBCsettingport1" : "Port1 Battery charging State",
	"downstreamBCsettingport2" : "Port2 Battery charging State",
	"downstreamBCsettingport3" : "Port3 Battery charging State",
	"downstreamBCsettingport4" : "Port4 Battery charging State",
	"downstreamBCsettingport5" : "Port5 Battery charging State",
	"downstreamBCsettingport6" : "Port6 Battery charging State",

	"swapport1dpdm" : "Port1:Swap D+/D-",
	"swapport2dpdm" : "Port2:Swap D+/D-",
	"swapport3dpdm" : "Port3:Swap D+/D-",
	"swapport4dpdm" : "Port4:Swap D+/D-",
	"swapport5dpdm" : "Port5:Swap D+/D-",
	"swapport6dpdm" : "Port6:Swap D+/D-",
	"swapupstreamdpdm" : "Upstream Port:Swap D+/D-",

	"PHYBOOSTdownstreamport1" : "Port1:PHYBOOST",
	"PHYBOOSTdownstreamport2" : "Port2:PHYBOOST",
	"PHYBOOSTdownstreamport3" : "Port3:PHYBOOST",
	"PHYBOOSTdownstreamport4" : "Port4:PHYBOOST",
	"PHYBOOSTdownstreamport5" : "Port5:PHYBOOST",
	"PHYBOOSTdownstreamport6" : "Port6:PHYBOOST",
	"PHYBOOST" : "Upstream Port:PHYBOOST",

	"SQUELCHdownstreamport1" : "Port1:Varisense",
	"SQUELCHdownstreamport2" : "Port2:Varisense",
	"SQUELCHdownstreamport3" : "Port3:Varisense",
	"SQUELCHdownstreamport4" : "Port4:Varisense",
	"SQUELCHdownstreamport5" : "Port5:Varisense",
	"SQUELCHdownstreamport6" : "Port6:Varisense",
	"SQUELCH" : "Upstream Port:Varisense",

	"upstreamHsRiseFall" : "Upstream High Speed rise/fall adjust",
	"downstreamport1HsRiseFall" : "Port1:High Speed rise/fall adjust",
	"downstreamport2HsRiseFall" : "Port2:High Speed rise/fall adjust",
	"downstreamport3HsRiseFall" : "Port3:High Speed rise/fall adjust",
	"downstreamport4HsRiseFall" : "Port4:High Speed rise/fall adjust",
	"downstreamport5HsRiseFall" : "Port5:High Speed rise/fall adjust",
	"downstreamport6HsRiseFall" : "Port6:High Speed rise/fall adjust",
	"port3splitting" : "Port 3 Port Splitting",
	"port4splitting" : "Port 4 Port Splitting",
	"port5splitting" : "Port 5 Port Splitting"
};

var USB7202_Mapping = {
	"enableport1" : "USB2.0 Port1 Enable/Disable State",
	"enableport2" : "USB2.0 Port3 Enable/Disable State",
	"enableport3" : "USB2.0 Port2 Enable/Disable State",
	"enableport4" : "USB2.0 Port4 Enable/Disable State",
	"enableport5" : "USB2.0 Port5 Enable/Disable State",
	"enableport6" : "USB2.0 Port6 Enable/Disable State",
	
	"port1mapping" : "USB2.0 Port1 Logical mapping",
	"port2mapping" : "USB2.0 Port3 Logical mapping",
	"port3mapping" : "USB2.0 Port2 Logical mapping",
	"port4mapping" : "USB2.0 Port4 Logical mapping",
	"port5mapping" : "USB2.0 Port5 Logical mapping",
	"port6mapping" : "USB2.0 Port6 Logical mapping",
	"port7mapping" : "USB2.0 Port7 Logical mapping",

	"nrdeviceport1" : "USB2.0 Port1 Non-removable State",
	"nrdeviceport2" : "USB2.0 Port3 Non-removable State",
	"nrdeviceport3" : "USB2.0 Port2 Non-removable State",
	"nrdeviceport4" : "USB2.0 Port4 Non-removable State",
	"nrdeviceport5" : "USB2.0 Port5 Non-removable State",
	"nrdeviceport6" : "USB2.0 Port6 Non-removable State",

	"usb3enableport1" : "USB3.1 Gen2 Port1 Enable/Disable State",
	"usb3enableport2" : "USB3.1 Gen2 Port3 Enable/Disable State",
	"usb3enableport3" : "USB3.1 Gen2 Port2 Enable/Disable State",
	"usb3enableport4" : "USB3.1 Gen2 Port4 Enable/Disable State",
	"usb3enableport5" : "USB3.1 Gen2 Port5 Enable/Disable State",

	"usb3port1mapping" : "USB3.1 Gen2 Port1 Logical mapping",
	"usb3port2mapping" : "USB3.1 Gen2 Port3 Logical mapping",
	"usb3port3mapping" : "USB3.1 Gen2 Port2 Logical mapping",
	"usb3port4mapping" : "USB3.1 Gen2 Port4 Logical mapping",
	"usb3port5mapping" : "USB3.1 Gen2 Port5 Logical mapping",

	"usb3nrdeviceport1" : "USB3.1 Gen2 Port1 Non-removable State",
	"usb3nrdeviceport2" : "USB3.1 Gen2 Port3 Non-removable State",
	"usb3nrdeviceport3" : "USB3.1 Gen2 Port2 Non-removable State",
	"usb3nrdeviceport4" : "USB3.1 Gen2 Port4 Non-removable State",
	"usb3nrdeviceport5" : "USB3.1 Gen2 Port5 Non-removable State",
	"usb3nrdevice"	    : "USB3.1 Gen2 Non-removable value",

	"downstreamBCsettingport1" : "Port1 Battery charging State",
	"downstreamBCsettingport2" : "Port3 Battery charging State",
	"downstreamBCsettingport3" : "Port2 Battery charging State",
	"downstreamBCsettingport4" : "Port4 Battery charging State",
	"downstreamBCsettingport5" : "Port5 Battery charging State",
	"downstreamBCsettingport6" : "Port6 Battery charging State",

	"swapport1dpdm" : "Port1:Swap D+/D-",
	"swapport2dpdm" : "Port3:Swap D+/D-",
	"swapport3dpdm" : "Port2:Swap D+/D-",
	"swapport4dpdm" : "Port4:Swap D+/D-",
	"swapport5dpdm" : "Port5:Swap D+/D-",
	"swapport6dpdm" : "Port6:Swap D+/D-",
	"swapupstreamdpdm" : "Upstream Port:Swap D+/D-",

	"PHYBOOSTdownstreamport1" : "Port1:PHYBOOST",
	"PHYBOOSTdownstreamport2" : "Port3:PHYBOOST",
	"PHYBOOSTdownstreamport3" : "Port2:PHYBOOST",
	"PHYBOOSTdownstreamport4" : "Port4:PHYBOOST",
	"PHYBOOSTdownstreamport5" : "Port5:PHYBOOST",
	"PHYBOOSTdownstreamport6" : "Port6:PHYBOOST",
	"PHYBOOST" : "Upstream Port:PHYBOOST",

	"SQUELCHdownstreamport1" : "Port1:Varisense",
	"SQUELCHdownstreamport2" : "Port3:Varisense",
	"SQUELCHdownstreamport3" : "Port2:Varisense",
	"SQUELCHdownstreamport4" : "Port4:Varisense",
	"SQUELCHdownstreamport5" : "Port5:Varisense",
	"SQUELCHdownstreamport6" : "Port6:Varisense",
	"SQUELCH" : "Upstream Port:Varisense",

	"upstreamHsRiseFall" : "Upstream High Speed rise/fall adjust",
	"downstreamport1HsRiseFall" : "Port1:High Speed rise/fall adjust",
	"downstreamport2HsRiseFall" : "Port3:High Speed rise/fall adjust",
	"downstreamport3HsRiseFall" : "Port2:High Speed rise/fall adjust",
	"downstreamport4HsRiseFall" : "Port4:High Speed rise/fall adjust",
	"downstreamport5HsRiseFall" : "Port5:High Speed rise/fall adjust",
	"downstreamport6HsRiseFall" : "Port6:High Speed rise/fall adjust",
	
	"port3splitting" : "Port 3 Port Splitting",
	"port4splitting" : "Port 4 Port Splitting",
	"port5splitting" : "Port 5 Port Splitting"
};
var USB725x_Mapping = {
	"enableport1" : "USB2.0 Port1 Enable/Disable State",
	"enableport2" : "USB2.0 Port4 Enable/Disable State",
	"enableport3" : "USB2.0 Port2 Enable/Disable State",
	"enableport5" : "USB2.0 Port3 Enable/Disable State",
	
	"port1mapping" : "USB2.0 Port1 Logical mapping",
	"port2mapping" : "USB2.0 Port4 Logical mapping",
	"port3mapping" : "USB2.0 Port2 Logical mapping",
	"port5mapping" : "USB2.0 Port3 Logical mapping",

	"nrdeviceport1" : "USB2.0 Port1 Non-removable State",
	"nrdeviceport2" : "USB2.0 Port4 Non-removable State",
	"nrdeviceport3" : "USB2.0 Port2 Non-removable State",
	"nrdeviceport5" : "USB2.0 Port3 Non-removable State",

	"usb3enableport1" : "USB3.1 Gen2 Port1 Enable/Disable State",
	"usb3enableport2" : "USB3.1 Gen2 Port4 Enable/Disable State",
	"usb3enableport3" : "USB3.1 Gen2 Port2 Enable/Disable State",
	"usb3enableport5" : "USB3.1 Gen2 Port3 Enable/Disable State",

	"usb3port1mapping" : "USB3.1 Gen2 Port1 Logical mapping",
	"usb3port2mapping" : "USB3.1 Gen2 Port4 Logical mapping",
	"usb3port3mapping" : "USB3.1 Gen2 Port2 Logical mapping",
	"usb3port5mapping" : "USB3.1 Gen2 Port3 Logical mapping",

	"usb3nrdeviceport1" : "USB3.1 Gen2 Port1 Non-removable State",
	"usb3nrdeviceport2" : "USB3.1 Gen2 Port4 Non-removable State",
	"usb3nrdeviceport3" : "USB3.1 Gen2 Port2 Non-removable State",
	"usb3nrdeviceport5" : "USB3.1 Gen2 Port3 Non-removable State",
	"usb3nrdevice"	    : "USB3.1 Gen2 Non-removable value",

	"downstreamBCsettingport1" : "Port1 Battery charging State",
	"downstreamBCsettingport2" : "Port4 Battery charging State",
	"downstreamBCsettingport3" : "Port2 Battery charging State",
	"downstreamBCsettingport5" : "Port3 Battery charging State",

	"swapport1dpdm" : "Port1:Swap D+/D-",
	"swapport2dpdm" : "Port4:Swap D+/D-",
	"swapport3dpdm" : "Port2:Swap D+/D-",
	"swapport5dpdm" : "Port3:Swap D+/D-",
	"swapupstreamdpdm" : "Upstream Port:Swap D+/D-",

	"PHYBOOSTdownstreamport1" : "Port1:PHYBOOST",
	"PHYBOOSTdownstreamport2" : "Port4:PHYBOOST",
	"PHYBOOSTdownstreamport3" : "Port2:PHYBOOST",
	"PHYBOOSTdownstreamport5" : "Port3:PHYBOOST",
	"PHYBOOST" : "Upstream Port:PHYBOOST",

	"SQUELCHdownstreamport1" : "Port1:Varisense",
	"SQUELCHdownstreamport2" : "Port4:Varisense",
	"SQUELCHdownstreamport3" : "Port2:Varisense",
	"SQUELCHdownstreamport5" : "Port3:Varisense",
	"SQUELCH" : "Upstream Port:Varisense",

	"upstreamHsRiseFall" : "Upstream High Speed rise/fall adjust",
	"downstreamport1HsRiseFall" : "Port1:High Speed rise/fall adjust",
	"downstreamport2HsRiseFall" : "Port4:High Speed rise/fall adjust",
	"downstreamport3HsRiseFall" : "Port2:High Speed rise/fall adjust",
	"downstreamport5HsRiseFall" : "Port3:High Speed rise/fall adjust",
	
	"port5splitting" : "Port 3 Port Splitting",
};
var USB7256_Mapping = {
	"enableport1" : "USB2.0 Port1 Enable/Disable State",
	"enableport2" : "USB2.0 Port5 Enable/Disable State",
	"enableport3" : "USB2.0 Port2 Enable/Disable State",
	"enableport4" : "USB2.0 Port3 Enable/Disable State",
	"enableport5" : "USB2.0 Port4 Enable/Disable State",
	"enableport6" : "USB2.0 Port6 Enable/Disable State",
	
	"port1mapping" : "USB2.0 Port1 Logical mapping",
	"port2mapping" : "USB2.0 Port5 Logical mapping",
	"port3mapping" : "USB2.0 Port2 Logical mapping",
	"port4mapping" : "USB2.0 Port3 Logical mapping",
	"port5mapping" : "USB2.0 Port4 Logical mapping",
	"port6mapping" : "USB2.0 Port6 Logical mapping",

	"nrdeviceport1" : "USB2.0 Port1 Non-removable State",
	"nrdeviceport2" : "USB2.0 Port5 Non-removable State",
	"nrdeviceport3" : "USB2.0 Port2 Non-removable State",
	"nrdeviceport4" : "USB2.0 Port3 Non-removable State",
	"nrdeviceport5" : "USB2.0 Port4 Non-removable State",
	"nrdeviceport6" : "USB2.0 Port6 Non-removable State",

	"usb3enableport1" : "USB3.1 Gen2 Port1 Enable/Disable State",
	"usb3enableport2" : "USB3.1 Gen2 Port5 Enable/Disable State",
	"usb3enableport3" : "USB3.1 Gen2 Port2 Enable/Disable State",
	"usb3enableport4" : "USB3.1 Gen2 Port3 Enable/Disable State",
	"usb3enableport5" : "USB3.1 Gen2 Port4 Enable/Disable State",

	"usb3port1mapping" : "USB3.1 Gen2 Port1 Logical mapping",
	"usb3port2mapping" : "USB3.1 Gen2 Port5 Logical mapping",
	"usb3port3mapping" : "USB3.1 Gen2 Port2 Logical mapping",
	"usb3port4mapping" : "USB3.1 Gen2 Port3 Logical mapping",
	"usb3port5mapping" : "USB3.1 Gen2 Port4 Logical mapping",

	"usb3nrdeviceport1" : "USB3.1 Gen2 Port1 Non-removable State",
	"usb3nrdeviceport2" : "USB3.1 Gen2 Port5 Non-removable State",
	"usb3nrdeviceport3" : "USB3.1 Gen2 Port2 Non-removable State",
	"usb3nrdeviceport4" : "USB3.1 Gen2 Port3 Non-removable State",
	"usb3nrdeviceport5" : "USB3.1 Gen2 Port4 Non-removable State",
	"usb3nrdevice"	    : "USB3.1 Gen2 Non-removable value",

	"downstreamBCsettingport1" : "Port1 Battery charging State",
	"downstreamBCsettingport2" : "Port5 Battery charging State",
	"downstreamBCsettingport3" : "Port2 Battery charging State",
	"downstreamBCsettingport4" : "Port3 Battery charging State",
	"downstreamBCsettingport5" : "Port4 Battery charging State",
	"downstreamBCsettingport6" : "Port6 Battery charging State",

	"swapport1dpdm" : "Port1:Swap D+/D-",
	"swapport2dpdm" : "Port5:Swap D+/D-",
	"swapport3dpdm" : "Port2:Swap D+/D-",
	"swapport4dpdm" : "Port3:Swap D+/D-",
	"swapport5dpdm" : "Port4:Swap D+/D-",
	"swapport6dpdm" : "Port6:Swap D+/D-",
	"swapupstreamdpdm" : "Upstream Port:Swap D+/D-",

	"PHYBOOSTdownstreamport1" : "Port1:PHYBOOST",
	"PHYBOOSTdownstreamport2" : "Port5:PHYBOOST",
	"PHYBOOSTdownstreamport3" : "Port2:PHYBOOST",
	"PHYBOOSTdownstreamport4" : "Port3:PHYBOOST",
	"PHYBOOSTdownstreamport5" : "Port4:PHYBOOST",
	"PHYBOOSTdownstreamport6" : "Port6:PHYBOOST",
	"PHYBOOST" : "Upstream Port:PHYBOOST",

	"SQUELCHdownstreamport1" : "Port1:Varisense",
	"SQUELCHdownstreamport2" : "Port5:Varisense",
	"SQUELCHdownstreamport3" : "Port2:Varisense",
	"SQUELCHdownstreamport4" : "Port3:Varisense",
	"SQUELCHdownstreamport5" : "Port4:Varisense",
	"SQUELCHdownstreamport6" : "Port6:Varisense",
	"SQUELCH" : "Upstream Port:Varisense",

	"upstreamHsRiseFall" : "Upstream High Speed rise/fall adjust",
	"downstreamport1HsRiseFall" : "Port1:High Speed rise/fall adjust",
	"downstreamport2HsRiseFall" : "Port5:High Speed rise/fall adjust",
	"downstreamport3HsRiseFall" : "Port2:High Speed rise/fall adjust",
	"downstreamport4HsRiseFall" : "Port3:High Speed rise/fall adjust",
	"downstreamport5HsRiseFall" : "Port4:High Speed rise/fall adjust",
	"downstreamport6HsRiseFall" : "Port6:High Speed rise/fall adjust",
	
	"port3splitting" : "Port 2 Port Splitting",
	"port4splitting" : "Port 3 Port Splitting",
	"port5splitting" : "Port 4 Port Splitting",
};

// Widget ID of string fields in the GUI
var GwidgetlistString = [ 
"manufacturer", 
"product", 
"serial",
"hce_manufacturer", 
"hce_product", 
"hce_serial", 
"hce1_manufacturer",
"hce1_product", 
"hce1_eapproduct",
"hce1_eapinterface",
"hce1_string5", 
"hce2_manufacturer", 
"hce2_product",
"hce2_eapproduct",
"hce2_eapinterface",
"hce2_string5", 
"hce1_macaddr", 
"hce2_macaddr",
// USB3 related
"usb3manufacturer", 
"usb3product", 
"usb3serial", 
"usb3uuid"
];

// Widget ID of decimal fields in the GUI
var GwidgetlistInt = [ 
"maxpowerself", 
"hubcmaxpowerself", 
"maxpowerbus",
"hubcmaxpowerbus",  
"hub3maxpowerselfbus" ,
"power_ontime"
];

// Widgets that are checkboxes in GUI
var GwidgetlistCheckbox = [
// "flexconnect", 
// "usb3flexconnect", 
"hsdisable",
"hceenable", 
"cdcenable",
"lpmenable", 
"swapupstreamdpdm", 
"swapport1dpdm", 
"swapport2dpdm",
"swapport3dpdm", 
"swapport4dpdm", 
"swapport5dpdm", 
"swapport6dpdm",
"enableport1", 
"enableport2", 
"enableport3", 
"enableport4",
"enableport5", 
"enableport6", 
"nrdeviceport1", 
"nrdeviceport2",
"nrdeviceport3", 
"nrdeviceport4", 
"nrdeviceport5", 
"nrdeviceport6",
"usb3enableport1", 
"usb3enableport2", 
"usb3enableport3",
"usb3enableport4", 
"usb3enableport5", 
"usb3nrdeviceport5",
"usb3nrdeviceport4", 
"usb3nrdeviceport3", 
"usb3nrdeviceport2",
"usb3nrdeviceport1",
"pdport1",
"pdport3",
"pdupstream"
];

// Widgets that are radio buttons in GUI
var GwidgetlistRadio = [ 
"hubpower", 
"downstreamBCsettingport1", 
"downstreamBCsettingport2",
"downstreamBCsettingport3", 
"downstreamBCsettingport4",
"downstreamBCsettingport5", 
"downstreamBCsettingport6",
"port5splitting", 
"port4splitting", 
"port3splitting", 
"pstimeout",
"i2senable",
"i2senablehid"
];

// Widgets that are Drop Down in GUI
var GwidgetlistDropDown = [ 
"PHYBOOST", 
"SQUELCH", 
"upstreamHsRiseFall",
"PHYBOOSTdownstreamport1", 
"SQUELCHdownstreamport1",
"downstreamport1HsRiseFall", 
"PHYBOOSTdownstreamport2",
"SQUELCHdownstreamport2", 
"downstreamport2HsRiseFall",
"PHYBOOSTdownstreamport3", 
"SQUELCHdownstreamport3",
"downstreamport3HsRiseFall",
"PHYBOOSTdownstreamport4",
"SQUELCHdownstreamport4", 
"downstreamport4HsRiseFall",
"PHYBOOSTdownstreamport5", 
"SQUELCHdownstreamport5",
"downstreamport5HsRiseFall", 
"PHYBOOSTdownstreamport6",
"SQUELCHdownstreamport6", 
"downstreamport6HsRiseFall"
//"flexport"
];

// Lookup for phyboost dropdown value selection
var DropDownPHYBOOST = [ 
"Nominal 17.78 mA", 
"5% below nominal",
"10% above nominal", 
"5% above nominal", 
"20% above nominal",
"15% above nominal", 
"30% above nominal", 
"25% above nominal",
];

// Lookup for squelch dropdown value selection
var DropDownSQUELCH = [ 
"Nominal 100mV", 
"12.5mV below nominal",
"25mV below nominal", 
"37.5mV below nominal", 
"50mV below nominal",
"62.5mV below nominal", 
"25mV above nominal", 
"12.5mV above nominal"
];

// Lookup for High Speed rise/fall adjust selection
var DropDownHSRiseFall = [ 
"Default", 
"+18%", 
"-18%", 
"-12%" 
];

//Lookup for Dynamic Port mapping
var DropDownPortMapping = [ 
"Disable", 
"Map to Port1", 
"Map to Port2", 
"Map to Port3",
"Map to Port4",
"Map to Port5",
"Map to Port6",
"Map to Port7"
];

var DynamicPortMappingReadVal = [ 
"Disabled", 
"Mapped to Port1", 
"Mapped to Port2", 
"Mapped to Port3",
"Mapped to Port4",
"Mapped to Port5",
"Mapped to Port6",
"Mapped to Port7"
];

// Lookup for Flexport selection
var DropDownflexport = [ "", "1", "2", "3", "4", "5", "6" ];
var DropDownusb3flexport = [ "", "1", "3","4","5" ];

var minihostconnectFunction = {
"USB 1.1 DFP" : "0",
"Connect to the USB2 hub in USB 1.1 Mode" : "2",
"Connect in USB2 Mode" : "3",
"Connect in USB 3 Gen 1 Mode" : "4",
"Connect in USB 3 Gen 2 Mode" : "5",
"Unlimited Connection" : "7"
};

var deviceclass = {
	"Device" : "00",
	"Audio" : "01",
	"Communications and CDC Control" : "02",
	"HID – Human Interface Device" : "03",
	"Physical" : "05",
	"Still Imaging" : "06",
	"Printer" : "07",
	"Mass Storage" : "08",
	"Hub" : "09",
	"CDC-Data":"0A",
	"Smart Card":"0B",
	"Content Security":"0D",
	"Video" : "0E",
	"Personal Healthcare" : "0F",
	"Audio/Video Devices" : "10",
	"Billboard Device" : "11",
	"USB Type-C Bridge Device" : "12",
	"Diagnostic Device" : "DC",
	"Wireless Controller" : "E0",
    	"Miscellaneous" : "EF",
	"Application Specific" : "FE",
    	"Vendor Specific" : "FF"
};

// Set these flags if they are modified by user
var nr1UserModified = false;
var nr2UserModified = false;
var nr3UserModified = false;
var nr4UserModified = false;
var nr5UserModified = false;
var nr6UserModified = false;
var nr7UserModified = false;

// Set these flags if they are modified by user
var usb3nr1UserModified = false;
var usb3nr2UserModified = false;
var usb3nr3UserModified = false;
var usb3nr4UserModified = false;
var usb3nr5UserModified = false;
var usb3nr6UserModified = false;
var usb3nr7UserModified = false;

// values returned if a value is 1 from the backend
var checkbox_checked_value = "1";
var checkbox_unchecked_value = "0";

var stringnullvalue = "NULL STRING - NOT PROGRAMMED YET";

var enableApplyButton = false;
var enableFlex = false;
var disableFlex = false;
var enable_swapupstreamdpdm = false;
var enable_lpm = false;

var CurrentflexLiveValue = -1;
var vid_pidModified = false;
var errorCode;
var CurrenthubProgrammed = "";
var percentage = 0;

// Set this variable when Non-removable parameter of a hub is modified
var nrModified = false;
var nr1Modified = false;
var nr2Modified = false;
var nr3Modified = false;
var nr4Modified = false;
var nr5Modified = false;
var nr6Modified = false;
var nr7Modified = false;

var usb3nrModified = false;
var usb3nr1Modified = false;
var usb3nr2Modified = false;
var usb3nr3Modified = false;
var usb3nr4Modified = false;
var usb3nr5Modified = false;
var usb3nr6Modified = false;
var usb3nr7Modified = false;

// Set these flags if they are modified by user
var nr1UserModified = false;
var nr2UserModified = false;
var nr3UserModified = false;
var nr4UserModified = false;
var nr5UserModified = false;
var nr6UserModified = false;
var nr7UserModified = false;

// set this variable when enable port widget is pushed
var enableprt1 = false;
var enableprt2 = false;
var enableprt3 = false;
var enableprt4 = false;

// flags for INI file programming
var iniFile = "";
var iniFile_fullPath;

// Flag to send the parameter "numberofports"
var numberofportState = false;
var usb3numberofportState = false;

var currentProgrammingCount = 0;

(function($) {
	enable_all_fields = function() {
		$("#Apply").attr('disabled', true);
		$("#Preview").attr('disabled', true);
		$("#Factory").attr('disabled', true);
		$("#flexApply").attr('disabled', true);
		$("#XdataApply").attr('disabled', true);
		$("#MemdumpBtn").attr('disabled', true);
		$("#devicedescriptortab").attr('disabled', false);
		$("#stringdescriptortab").attr('disabled', false);
		$("#USB3devicedescriptortab").attr('disabled', false);
		$("#USB3stringdescriptortab").attr('disabled', false);
		$("#USB3otherdescriptortab").attr('disabled', true);
		$("#upstreamtab").attr('disabled', false);
		$("#downstreamtab").attr('disabled', false);
		$("#Bdownstreamtab").attr('disabled', false);
		$("#USB3_Bdownstreamtab").attr('disabled', false);
		$("#uchtab").attr('disabled', false);
		$("#advancedtab").attr('disabled', false);

		$('#BPORT1fieldset').attr('disabled', 'disabled');
		$('#BPORT2fieldset').attr('disabled', 'disabled');
		$('#BPORT3fieldset').attr('disabled', 'disabled');
		$('#BPORT4fieldset').attr('disabled', 'disabled');
		$('#BPORT5fieldset').attr('disabled', 'disabled');

		$('#PORT1fieldset').attr('disabled', 'disabled');
		$('#PORT2fieldset').attr('disabled', 'disabled');
		$('#PORT3fieldset').attr('disabled', 'disabled');
		$('#PORT4fieldset').attr('disabled', 'disabled');
		$('#PORT5fieldset').attr('disabled', 'disabled');

	};
})(jQuery);

(function($) {
	enable_all_fields_debugging = function() {
		// For Testing only
		// Basic Downstream FieldSet - USB 2.0
		$('#BPORT1fieldset').removeAttr('disabled');
		$('#BPORT2fieldset').removeAttr('disabled');
		$('#BPORT3fieldset').removeAttr('disabled');
		$('#BPORT4fieldset').removeAttr('disabled');
		$('#BPORT5fieldset').removeAttr('disabled');

		// Show USB configuration items
		$('#BdownstreamUSBport1').show();
		$('#BdownstreamUSBport2').show();
		$('#BdownstreamUSBport3').show();
		$('#BdownstreamUSBport4').show();
		$('#BdownstreamUSBport5').show();
		$('#BdownstreamUSBport6').show();

		// Advanced Downstream FieldSet - USB 2.0
		$('#PORT1fieldset').removeAttr('disabled');
		$('#PORT2fieldset').removeAttr('disabled');
		$('#PORT3fieldset').removeAttr('disabled');
		$('#PORT4fieldset').removeAttr('disabled');
		$('#PORT5fieldset').removeAttr('disabled');
		$('#downstreamport1Fieldset').removeAttr('disabled');
		$('#downstreamport2Fieldset').removeAttr('disabled');
		$('#downstreamport3Fieldset').removeAttr('disabled');
		$('#downstreamport4Fieldset').removeAttr('disabled');
		$('#usb2nr1div').removeAttr('disabled');
		$('#usb2nr2div').removeAttr('disabled');
		$('#usb2nr3div').removeAttr('disabled');
		$('#usb2nr4div').removeAttr('disabled');
		$('#usb2nr5div').removeAttr('disabled');
		// Show USB configuration items
		$('#downstreamUSBport1').show();
		$('#downstreamUSBport2').show();
		$('#downstreamUSBport3').show();
		$('#downstreamUSBport4').show();
		$('#downstreamUSBport5').show();

		$('#upstreamUSB').show();

	};
})(jQuery);

(function($) {
	disable_nav_fields = function() {
		$("#Apply").attr('disabled', true);
		$("#Preview").attr('disabled', true);
		$("#Refresh").attr('disabled', true);

	};
})(jQuery);

(function($) {
	enable_nav_fields = function() {
		$("#Apply").attr('disabled', false);
		$("#Preview").attr('disabled', false);
		$("#Refresh").attr('disabled', false);

	};
})(jQuery);

(function($) {
	get_hub_list = function() {
		// Close previous all hub instances
		MchpUsbCloseAllHubs();
		// Call to clear previously acquired widget Map
		clearWidgetMap();
		setConfigMode(false, "NULL");
		enable_all_fields();
		enable_all_fields_debugging();
		reset_fields();
		set_changed_fields_border_default();
		// Populate the List of Hubs
		var test2 = "Fetching the hub list...";
		update_status_message(test2);
		var data = "";
		data = getHubList();
		$("#devicelistdropdown").empty();

		if (data) 
		{
			enable_fields();
			hub_list = data.split("###");

			hubCount = hub_list.length;
			for (var k = (hub_list.length - 1); k >= 0; k--) 
			{
				if (hub_list[k]) 
				{
					update_status_message(hub_list[k]);
					$("#devicelistdropdown").append(
							"<li> <a tabindex=\"-1\" href=\"javascript:void(0)\" align=\"left\">"
									+ hub_list[k] + "</a> </li>");
				}
			}

			$("#selectedhubinput").val(hub_list[(hub_list.length - 2)]);
			$('.selecthub1').find('[data-bind="SelectHublabel"]').text(
					hub_list[(hub_list.length - 2)]).children(
					'.dropdown-toggle').dropdown('toggle');

			var btnValue = $("#selectedhubinput").val();
			var colonIndex = btnValue.indexOf(":");
			gb_HUB_ID = "" + btnValue.charAt(colonIndex + 1);
			gb_hubsFound = true;

		} 
		else 
		{
			enableApplyButton = false;
			if (enableFlex) {
				alert("Flex connect has been enabled for the Upstream port. \n Connect the hub with the Downstream port1 for the device to be enumerated.");
				update_status_message("Flex connect has been enabled for the Upstream port. \n Connect the hub with the Downstream port1 for the device to be enumerated.");
			}

			if (disableFlex) {
				alert("Flex connect has been disabled for the Upstream port. \n Connect the hub with the Upstream port for the device to be enumerated.");
				update_status_message("Flex connect has been disabled for the Upstream port. \n Connect the hub with the Upstream port for the device to be enumerated.");
			}

			if (enable_swapupstreamdpdm) {
				alert("The D+/D- of the upstream port have been swapped.");
				update_status_message("The D+/D- of the upstream port have been swapped.");
			}

			gb_hubsFound = false;
			reset_fields();
			disable_fields();
			$("#progID").hide();
			window.alert("No hubs found");
			update_status_message("No hubs found");
			$("#selectedhubinput").val("Selected Hub Details");
			$('.selecthub1')
			.find('[data-bind="SelectHublabel"]').text('Select USB Hub')
			.children('.dropdown-toggle').dropdown('toggle');
		}
	};
})(jQuery);

(function($) {
	update_status_message = function(mesg) 
	{
		var currentdate = new Date();
		currentdate + '';
		var datetime = currentdate.toLocaleString();
		$("#DSStatusMessage").append(datetime + ":" + mesg + "\n");
		$("#DSStatusMessage").animate(
				{
					scrollTop : $("#DSStatusMessage")[0].scrollHeight
							- $("#DSStatusMessage").height()
				}, 400, function() {
				});
	};
})(jQuery);


(function ($) {
    update_dra_status_message = function (mesg) {
        $("#DRStatusMessage").append(mesg + "\n");
        $("#DRStatusMessage").animate({
            scrollTop:$("#DRStatusMessage")[0].scrollHeight - $("#DRStatusMessage").height()
            },400,function(){
          })
        };
})(jQuery);

(function($) { set_selected_hub_get_widgets = function() 
	{
		enable_all_fields();
		enable_all_fields_debugging();
		$("body").css("cursor", "wait");

		var isTeton = false;
		var isValcanpopulate = true;
		var selectindex = 0;

		if (flagforINIread) 
		{
			if ((gb_HUB_ID == 0)) 
			{
				selectindex = hubCount - 1;

				for (selectindex; selectindex >= 0; selectindex--) 
				{
					if (hub_list[selectindex]) 
					{
						var selop = hub_list[selectindex];
						var colonIndex = selop.indexOf(":");
						incval = "" + selop.charAt(colonIndex + 1);

						gb_skuName = set_selected_device(incval);

						var temp = gb_skuName.substring(0, 5);

						if (temp == "USB72") {

							isTeton = true;

							gb_HUB_ID = incval;

							$('.selecthub1').find(
									'[data-bind="SelectHublabel"]').text(selop)
									.children('.dropdown-toggle').dropdown(
											'toggle');

							$("#selectedhubinput").val(selop);

							break;
						}
						close_device(gb_HUB_ID);

					}
				}
			}
		} 
		else 
		{
			gb_skuName = set_selected_device(gb_HUB_ID);
		}

		if (gb_skuName == "") 
		{
			gb_skuName = "not identified";
			errorCode = getMchpUsbLastError(gb_HUB_ID);
			update_status_message(errorMap[Dec2Hex(errorCode)]
					+ " Check Help for troubleshooting.");
		}

		var mesg1 = "The hub may go offline for a while. Please wait while the hub configuration is read and auto identification part number is available.";
		update_status_message(mesg1);
		mesg1 = "";
		update_status_message("The gb_skuName for the hub of Index: " + gb_HUB_ID
				+ " is " + gb_skuName + ".");

		if (gb_skuName) 
		{
			enable_fields();
			$("#partnumber").val(gb_skuName);

			/*
			 * Get the last digit of the SKU Name. It decides the number of
			 * downstream ports that are currently available.
			 */

			var temp = gb_skuName.substring(0, 5);

			if (temp == "USB72") 
			{
				isTeton = true;
				$("#Apply").attr('disabled', false);
				$("#Preview").attr('disabled', false);
				$("#Factory").attr('disabled', false);
				$("#flexApply").attr('disabled', false);
				$("#XdataApply").attr('disabled', false);
				$("#MemdumpBtn").attr('disabled', false);
			}

			if (!isTeton) 
			{
				reset_fields();
				disable_fields();
				update_status_message("Unable to connect to USB72XX family MCHP hub");
				alert("Unable to connect to USB72XX family MCHP hub");
				$("body").css("cursor", "default");
				// $('#ajaxBusy').hide();
				return;
			}

			if ((gb_skuName === "NOT MICROCHIP") || (gb_skuName === "NOT IMPLEMENTED")) 
			{
				statusMsg = "Hub is not a Microchip Hub.Please select a Microchip hub\n";
				update_status_message(statusMsg);
				console.log(statusMsg);
				alert(statusMsg);

				reset_fields();
				disable_fields();
			} 
			else 
			{		
				update_status_message("The selected hub part number is "
						+ gb_skuName);
						
				// show/hide ports based on SKU
				if (gb_skuName === "USB7202") 
				{
					custom_dos_portorder(gb_skuName);
					//hide ports based on SKU for Dynamic port mapping. 
					//USB3 					
					//DCP
					$('#DCPport4group').show();
					$('#DCPport5group').hide();
					$('#DCPport6group').hide();
					//End of DCP
			
					$('#BPORT4fieldset').show();
					$('#BPORT5fieldset').hide();
					$('#BPORT6fieldset').hide();
					
					// Hide port 2 usb 3
					$('#BasicPort2Usb3').hide();
					
					//Hide USB3 Port for port 4
					$('#usb3port4mappingdiv').hide();
					
					// Hide port splitting
					$('#port3Split').hide();
					$('#port4Split').hide();
					$('#port5Split').hide();

					// Hide port5 and 6 in advancedtab
					$('#ad_port4fieldset').show();
					$('#ad_port5fieldset').hide();
					$('#ad_port6fieldset').hide();

					// Show NCM related feilds
					$('#NCMdiv').show();

					// // Show flexconnect
					// $('#otpflex').show();
					
					//Show/hide Flexport
					// $('#flxprt5').hide();
					// $('#flxprt6').hide();
					
					//Role switch
					$('#port5rsoption').hide();
					$('#port6rsoption').hide();
					
					
					//Power delivery
					$('#disablepdupstream').hide();
					$('#disablepdport1').hide();
					$('#disablepdport3').hide();
					
					//Flex, BC, Mini-host and MHB will not be available in USB725X SKU. Sec - Hub and Other features DOS
					$('#RoleSwitchDemo').show();
					$('#minihostfeature').show();
					$('#DynamicPortMappingdiv').show();
					$('#DynamicDCPDemoDiv').show();
					
					$('#BCPort1').show();
					$('#BCPort2').show();
					$('#BCPort3').show();
					$('#BCPort4').show();
					$('#BCPort5').show();
					$('#BCPort6').show();
					
					$('#usb3port1div').show();
					$('#usb3port2div').hide();
					$('#usb3port3div').show();
					$('#usb3port4div').show();
					$('#usb3port5div').show();
					
					$('#usb2port1div').show();
					$('#usb2port2div').show();
					$('#usb2port3div').show();
					$('#usb2port4div').show();
					$('#usb2port5div').show();
					$('#usb2port6div').show();
				} 
				if ((gb_skuName === "USB7250") || (gb_skuName === "USB7251") || (gb_skuName === "USB7252")) 
				{
					custom_dos_portorder(gb_skuName);
					
					//DCP Demo
					$('#DCPport4group').hide();
					$('#DCPport6group').hide();
					$('#DCPport5group').show();
					
					$('#BPORT4fieldset').hide();
					$('#BPORT6fieldset').hide();
					$('#BPORT5fieldset').show();
					
					// Hide port 2 usb 3
					$('#BasicPort2Usb3').hide();

					// Show port splitting only for port 5 and hide others
					$('#port3Split').hide();
					$('#port4Split').hide();
					$('#port5Split').show();

					// Hide port5 and 6 in advancedtab
					$('#ad_port4fieldset').hide();
					$('#ad_port6fieldset').hide();
					$('#ad_port5fieldset').show();
					
					//Show/hide Flexport
					// $('#flxprt5').hide();
					// $('#flxprt6').hide();
					
					//Role switch
					$('#port5rsoption').hide();
					$('#port6rsoption').hide();
					
					//Flex, BC, Mini-host and MHB will not be available in USB725X SKU. Sec - Hub and Other features DOS
					$('#RoleSwitchDemo').hide();
					$('#minihostfeature').hide();
					$('#DynamicPortMappingdiv').hide();
					$('#DynamicDCPDemoDiv').hide();
					
					$('#BCPort1').hide();
					$('#BCPort2').hide();
					$('#BCPort3').hide();
					$('#BCPort4').hide();
					$('#BCPort5').hide();
					$('#BCPort6').hide();
					
					$('#usb3port1div').hide();
					$('#usb3port2div').hide();
					$('#usb3port3div').hide();
					$('#usb3port4div').hide();
					$('#usb3port5div').hide();
					
					$('#usb2port1div').hide();
					$('#usb2port2div').hide();
					$('#usb2port3div').hide();
					$('#usb2port4div').hide();
					$('#usb2port5div').hide();
					$('#usb2port6div').hide();

					if (gb_skuName === "USB7250") {
						// Show NCM related feilds
						$('#NCMdiv').show();
						//Power delivery
						$('#disablepdupstream').show();
						$('#disablepdport1').show();
						$('#disablepdport3').show();
					} else {
						// Hide NCM related feilds
						$('#NCMdiv').hide();
						if(gb_skuName === "USB7251")
						{
							//Power delivery
							$('#disablepdupstream').show();
							$('#disablepdport1').hide();
							$('#disablepdport3').show();
						}
						if(gb_skuName === "USB7252")
						{
							//Power delivery
							$('#disablepdupstream').show();
							$('#disablepdport1').hide();
							$('#disablepdport3').hide();
						}
					}
				} 

				if (gb_skuName === "USB7216" || gb_skuName === "USB7206" || gb_skuName === "USB7256") 
				{
					custom_dos_portorder(gb_skuName);
					
					$('#DCPport4group').show();
					$('#DCPport5group').show();
					$('#DCPport6group').show();
					
					$('#BPORT4fieldset').show();
					$('#BPORT5fieldset').show();
					$('#BPORT6fieldset').show();
					
					if(gb_skuName === "USB7216" || gb_skuName === "USB7256")
					{
						// Hide port 2 usb 3
						$('#BasicPort2Usb3').hide();	
					}else if(gb_skuName === "USB7206")
					{
						// show port 2 usb 3
						$('#BasicPort2Usb3').show();
					}

					// Hide port splitting
					$('#port3Split').show();
					$('#port4Split').show();
					$('#port5Split').show();

					// Hide port5 and 6 in advancedtab
					$('#ad_port4fieldset').show();
					$('#ad_port5fieldset').show();
					$('#ad_port6fieldset').show();
					
					//Hide USB3 Port for port 4
					$('#usb3port4mappingdiv').show();
					
					$('#minihostfeature').hide();
					
					//$('#RoleSwitchDemo').hide();
				
					//Flex, BC, Mini-host and MHB will not be available in USB725X SKU. Sec - Hub and Other features DOS
					if(gb_skuName === "USB7206")
					{
						$('#DynamicPortMappingdiv').show();
						$('#DynamicDCPDemoDiv').show();
						$('#BCPort1').show();
						$('#BCPort2').show();
						$('#BCPort3').show();
						$('#BCPort4').show();
						$('#BCPort5').show();
						$('#BCPort6').show();
						$('#usb3port1div').show();
						$('#usb3port2div').show();
						$('#usb3port3div').show();
						$('#usb3port4div').show();
						$('#usb3port5div').show();
						
						$('#usb2port1div').show();
						$('#usb2port2div').show();
						$('#usb2port3div').show();
						$('#usb2port4div').show();
						$('#usb2port5div').show();
						$('#usb2port6div').show();		

						$('#RoleSwitchDemo').show();
					} else if(gb_skuName === "USB7216") {
						$('#DynamicPortMappingdiv').show();
						$('#DynamicDCPDemoDiv').show();
						$('#BCPort1').show();
						$('#BCPort2').show();
						$('#BCPort3').show();
						$('#BCPort4').show();
						$('#BCPort5').show();
						$('#BCPort6').show();
						$('#usb3port1div').show();
						$('#usb3port2div').show();
						$('#usb3port3div').show();
						$('#usb3port4div').show();
						$('#usb3port5div').show();
						
						$('#usb2port1div').show();
						$('#usb2port2div').show();
						$('#usb2port3div').show();
						$('#usb2port4div').show();
						$('#usb2port5div').show();
						$('#usb2port6div').show();		
						
						$('#RoleSwitchDemo').show();
					} 
					else {
						$('#DynamicPortMappingdiv').hide();
						$('#DynamicDCPDemoDiv').hide();
						$('#BCPort1').hide();
						$('#BCPort2').hide();
						$('#BCPort3').hide();
						$('#BCPort4').hide();
						$('#BCPort5').hide();
						$('#BCPort6').hide();
						$('#usb3port1div').hide();
						$('#usb3port2div').hide();
						$('#usb3port3div').hide();
						$('#usb3port4div').hide();
						$('#usb3port5div').hide();
						
						$('#usb2port1div').hide();
						$('#usb2port2div').hide();
						$('#usb2port3div').hide();
						$('#usb2port4div').hide();
						$('#usb2port5div').hide();
						$('#usb2port6div').hide();	
							
						$('#RoleSwitchDemo').hide();
					}
					
					//Show/hide Flexport
					// $('#flxprt5').show();
					// $('#flxprt6').show();
					
					//Role switch
					$('#port5rsoption').show();
					$('#port6rsoption').show();

					// Hide NCM related feilds
					$('#NCMdiv').hide();
					
					//Power delivery
					if(gb_skuName === "USB7256")
					{
						$('#disablepdupstream').show();
						$('#disablepdport1').hide();
						$('#disablepdport3').hide();
					}
					else if(gb_skuName === "USB7216")
					{
						$('#disablepdupstream').hide();
						$('#disablepdport1').hide();
						$('#disablepdport3').hide();
					}
					else if(gb_skuName === "USB7206")
					{
						$('#disablepdupstream').hide();
						$('#disablepdport1').hide();
						$('#disablepdport3').hide();
					}
				}
				////Read Current Rule cont 
				var minireg = "BFCF99f4";
				var newval = registerOperation(gb_HUB_ID, minireg, "1", true, "", "");
				gb_vidpidrulecnt = newval.toString(16);
				gb_vidpidrulecnt = parseInt(gb_vidpidrulecnt, 16);
				gblivevidpidrulecnt = gb_vidpidrulecnt;
				
				minireg = "BFCF99f8";
				newval = registerOperation(gb_HUB_ID, minireg, "1", true, "", "");
				gb_vidpidmaskrulecnt = newval.toString(16);
				gb_vidpidmaskrulecnt = parseInt(gb_vidpidmaskrulecnt, 16);
				gblivevidpidmaskrulecnt = gb_vidpidmaskrulecnt;
				
				minireg = "BFCF99FC";
				newval = registerOperation(gb_HUB_ID, minireg, "1", true, "", "");
				gb_deviceclassrulecnt = newval.toString(16);
				gb_deviceclassrulecnt = parseInt(gb_deviceclassrulecnt, 16);
				gblivedeviceclassrulecnt = gb_deviceclassrulecnt;
				enableApplyButton = true;

				// OTP Information
				var info = get_otp_info(gb_HUB_ID);
				if (info) 
				{
					var otp_info = info.split("###");
					var otpSize = otp_info[0];
					var ConfigBlockCnt = otp_info[1];
					var ConfigRemainCnt = otp_info[2];
					var ProgrammedByteCnt = otp_info[3];

					// Configured block count
					$("#ProgrammedConfigCount").val(ConfigBlockCnt);
					var count = parseInt(ConfigBlockCnt, 10);
					currentProgrammingCount = count;
					if (count >= 16) 
					{
						var string = "16+";
						$("#ProgrammedConfigCount").val(string);
						$("#Restore").attr('disabled', true);
					}

					// Configured remaining count
					$("#RemainingConfigCount").val(ConfigRemainCnt);

					// OTP size
					var OTP = parseInt(otpSize, 10);
					var PBC = parseInt(ProgrammedByteCnt, 10);

					percentage = (PBC / OTP) * 100;

					$("#configMemprogressbar").css('width', percentage + "%");
					$("#configMemprogressbar").css('color', 'black');
					if (percentage < 50) 
					{
						$("#configMemprogressbar").css({
							'background-image' : 'none',
							'background-color' : 'green'
						});
						$("#configMemprogressbar").attr('aria-valuenow', 45);
					} 
					else if (percentage < 75) 
					{
						$("#configMemprogressbar").css({
							'background-image' : 'none',
							'background-color' : 'orange'
						});
					} 
					else if (percentage > 75) 
					{
						$("#configMemprogressbar").css({
							'background-image' : 'none',
							'background-color' : 'red'
						});
					}
					percenttrim = parseFloat(percentage).toFixed(2);
					$("#configMemprogressbar").html(
							"<p align=\"center\">" + percenttrim + "%" + "<p>");

				} 
				else 
				{
					window.alert("OTP information could not be retrieved.");
					update_status_message("OTP information could not be retrieved.");
				}

				// Updating firmware and config location in the UI
				var firmware_config = get_firmware_config_location(gb_HUB_ID);
				var firmware_config_array = firmware_config.split("::");
				var firmware_loc = firmware_config_array[0];
				var config_loc = firmware_config_array[1];

				$("#FirmwareLocation").val(firmware_loc);
				$("#ConfigLocation").val(config_loc);
				
				$("#fcwValue").val("0020");
				$("#flexconnectTooltip").show();
				$("#RoleSwitchportButton").attr('disabled', true);
				$(".RoleSwitchport1").find("[data-bind=\"" + "RoleSwitchportlabel\"]").text("").children('.dropdown-toggle').dropdown('toggle');
				$("#MHBTooltip").hide();
						
				
				// Updating the rest of the widgets.
				update_status_message("Reading Hub Configuration ....");

				// Updating GwidgetlistHex Starts
				$.each(GwidgetlistHex, function(index, value) 
				{
					var widgetid = "#" + value;
					var widgetValue = getWidgetValue(gb_HUB_ID, value);
					
					if (widgetValue) 
					{
						widgetValue = parseInt(widgetValue, 10);
						var hexstring = "";

						if (value == "usbvcd" || value == "usb3vcd") {
							var dot = ".";
							var hexvalue = (widgetValue.toString(16));
							var position = 1;
							hexstring = [ hexvalue.slice(0, position), dot,
									hexvalue.slice(position) ].join('');
						} 
						else 
						{
							hexstring = widgetValue.toString(16); 
						}
						$(widgetid).val(hexstring);
					}
					else
					{
						//Hex value cannot be null. assumming get_widget value got failed
						isValcanpopulate = false;
						return false;
					}
				});
				if(isValcanpopulate === false)
				{
					reset_fields();
					disable_fields();
					update_status_message("Failed to get widget values");
					alert("Failed to get widget values");
					$("body").css("cursor", "default");
					return false;
				}
				else
				{
					isValcanpopulate = true;
				}
				// Updating GwidgetlistHex Ends

				// Updating GwidgetlistString Starts
				$.each(GwidgetlistString, function(index, value) 
				{
					var widgetid = "#" + value;
					var widgetValue = getWidgetValue(gb_HUB_ID, value);
					if ((widgetValue === "")) 
					{
						$(widgetid).val("");
						$(widgetid).attr('placeholder', stringnullvalue);
					} 
					else 
					{
						$(widgetid).val(widgetValue);
					}
				});
				// Updating GwidgetlistString Ends

				// Updating GwidgetlistInt Starts
				$.each(GwidgetlistInt, function(index, value) 
				{
					var widgetid = "#" + value;
					var widgetValue = getWidgetValue(gb_HUB_ID, value);

					if (widgetValue === "") 
					{
						$(widgetid).val("");
					} 
					else 
					{
						var decVal;
						if (value == "hub3maxpowerselfbus") 
						{
							decVal = widgetValue & 0xff;
							decVal = parseInt(decVal, 10);
							decVal = decVal * 8;
						} 
						else if ((value == "hubcmaxpowerbus")
								|| (value == "hubcmaxpowerself")) 
						{
							decVal = widgetValue & 0xff;
							decVal = parseInt(decVal, 10);
						} 
						else 
						{
							decVal = widgetValue & 0xff;
							decVal = parseInt(decVal, 10);
							decVal = decVal * 2;
						}
						$(widgetid).val(decVal);
					}
				});
				// Updating GwidgetlistInt Ends

				// Updating GwidgetlistCheckbox Starts
				$.each(GwidgetlistCheckbox, function(index, value) 
				{
					var widgetid = "#" + value;
					var widgetValue = getWidgetValue(gb_HUB_ID, value);

					if (widgetValue === checkbox_checked_value) 
					{
						$(widgetid).prop('checked', true);
					} 
					else 
					{
						$(widgetid).prop('checked', false);
					}

					// if (value == "flexconnect"
							// && widgetValue == checkbox_unchecked_value) 
					// {
						// // hide the flexport dropdown
						// $("#flexportULbutton").attr('disabled', true);
					// }
					// if (value == "usb3flexconnect"
							// && widgetValue == checkbox_unchecked_value) 
					// {
						// // hide the flexport dropdown
						// $("#usb3flexportULbutton").attr('disabled', true);
					// }

					$(widgetid).trigger("change");
					set_changed_fields_border_default();
				});
				// Updating GwidgetlistCheckbox Ends
				
				// Updating GwidgetlistRadio Starts
				$.each(GwidgetlistRadio,function(index, value) 
				{
					var groupname = value + "group";
					var widgetValue = getWidgetValue(gb_HUB_ID, value);
					if(widgetValue === "")
					{
					}
					else
					{
						var nameofcontrol = "input[name=" + groupname + "][value=" + widgetValue + "]";
						$(nameofcontrol).prop("checked", true);
					}
					
					if(value === "port3splitting" || value === "port4splitting" || value === "port5splitting")
					{
						var widgetid = "#" + value + "group";
						$(widgetid).trigger("change");
					}
					if (value === "hubpower") 
					{
						var widgetid = "#hubpowergroup";
						// If there are corresponding fieldsets
						// - enable them
						$(widgetid).trigger("change");
						if (widgetValue == "0") { // Bus power
							// Disable the fields

							$('#selfpowerfieldset').hide();
							$('#buspowerfieldset').show();
						} else if (widgetValue == "1") { // Self
															// power
							// Disable the fields
							$('#buspowerfieldset').hide();
							$('#selfpowerfieldset').show();
						}
						set_changed_fields_border_default();
					}
					if (value === "i2senable") 
					{
						if(widgetValue == "0")
						{
							document.getElementById("speakermeute").disabled=true;
							document.getElementById("bothms").disabled=true;
							document.getElementById("bothms1").disabled=true;
						}
						else if(widgetValue == "1") {
							document.getElementById("speakermeute").disabled=false;
							document.getElementById("bothms").disabled=true;
							document.getElementById("bothms1").disabled=true;
						} else if(widgetValue == "2") {
							document.getElementById("speakermeute").disabled=true;
							document.getElementById("bothms").disabled=false;
							document.getElementById("bothms1").disabled=true;
							
						} else if(widgetValue == "3") {
							document.getElementById("speakermeute").disabled=false;
							document.getElementById("bothms").disabled=false;
							document.getElementById("bothms1").disabled=false;
						}
					}
					if ((value === "downstreamBCsettingport1")
							|| (value === "downstreamBCsettingport2")
							|| (value === "downstreamBCsettingport3")
							|| (value === "downstreamBCsettingport4")
							|| (value === "downstreamBCsettingport5")
							|| (value === "downstreamBCsettingport6")) 
					{
						var BCfeild = "";
						var BCFeildLabel = "";
						if ((widgetValue != 0)
								&& (widgetValue != 1)
								&& (widgetValue != 2)) {
							BCfeild = "#" + value + "radio4";
							BCFeildLabel = value
									+ "radio4label";
							$(BCfeild).show();
							$(BCfeild).prop("checked", true);
							var BCDesStr = "";
							document
									.getElementById(BCFeildLabel).value = widgetValue;
							BCDesStr = Determine_BCDescription(widgetValue);
							// Decode the value to display
							// description
							// dynamically
							document
									.getElementById(BCFeildLabel).innerHTML = BCDesStr;

						} 
						else 
						{

							$(BCfeild).hide();
						}

					}
				});
				// Updating GwidgetlistRadio Ends
				
				// Updating GwidgetlistPortType Starts
				$.each(GwidgetlistPortType, function(index, value) 
				{
					var widgetValue = getWidgetValue(gb_HUB_ID, value);
					var portid = value + "label";
					var portnumber = document.getElementById(portid).innerHTML;
					document.getElementById(portid).innerHTML = portnumber + widgetValue;
				});
				// Updating GwidgetlistPortType Ends
				
				//Updating minihost rules configured Starts
				var widgetValue = getWidgetValue(gb_HUB_ID, "minihost");
				if(widgetValue == "1")
				{
					$('#minihostmousehover').hide();
					$('#minihostfeature :input').attr('disabled', false);
					var widgetValue = getWidgetValue(gb_HUB_ID, "minihostrulesconfigured");
					if(widgetValue == "") //Dont Show if no rules are programmed
					{
						$('#minihostrulesconfigured').hide();
					}
					else
					{
						$('#minihostrulesconfigured').show();
						document.getElementById("minihostrulesconfiguredarea").value = widgetValue;
					}
				}
				else if(widgetValue == "0")
				{
					$('#minihostmousehover').show();
					$('#collapse_minihost').hide();
					$('#minihostfeature :input').attr('disabled', true);
				}
				//Updating minihost rules configured Ends
				
				
				// Updating GwidgetlistDropDown Starts
				$.each(GwidgetlistDropDown, function(index, value) 
				{
					var widgetValue = getWidgetValue(gb_HUB_ID, value);
					widgetValue = parseInt(widgetValue, 10);

					var nameofcontrol = "." + value + "1";
					var nameofcontrol1 = "[data-bind=\"" + value + "label\"]";

					if (value == "PHYBOOST"
							|| value == "PHYBOOSTdownstreamport1"
							|| value == "PHYBOOSTdownstreamport2"
							|| value == "PHYBOOSTdownstreamport3"
							|| value == "PHYBOOSTdownstreamport4"
							|| value == "PHYBOOSTdownstreamport5"
							|| value == "PHYBOOSTdownstreamport6") 
					{

						selText = DropDownPHYBOOST[widgetValue];
					} 
					else if (value == "SQUELCH"
							|| value == "SQUELCHdownstreamport1"
							|| value == "SQUELCHdownstreamport2"
							|| value == "SQUELCHdownstreamport3"
							|| value == "SQUELCHdownstreamport4"
							|| value == "SQUELCHdownstreamport5"
							|| value == "SQUELCHdownstreamport6") 
					{

						selText = DropDownSQUELCH[widgetValue];

					} else if (value == "upstreamHsRiseFall"
							|| value == "downstreamport1HsRiseFall"
							|| value == "downstreamport2HsRiseFall"
							|| value == "downstreamport3HsRiseFall"
							|| value == "downstreamport4HsRiseFall"
							|| value == "downstreamport5HsRiseFall"
							|| value == "downstreamport6HsRiseFall") 
					{

						selText = DropDownHSRiseFall[widgetValue];
					} 
					// else if (value == "flexport") 
					// {
						// selText = DropDownflexport[widgetValue];
					// } 
					// Update fields based on obtained value
					$(nameofcontrol).find(nameofcontrol1).text(selText)
							.children('.dropdown-toggle').dropdown('toggle');
				});
				// Updating GwidgetlistDropDown Ends
				
				var selText;
				// Updating GwidgetlistPortMapping Starts
				$.each(GwidgetlistPortMapping, function(index, value) 
				{
					var widgetValue = getWidgetValue(gb_HUB_ID, value);
					document.getElementById(value).style.fontSize = "small";
					if(widgetValue == "0")
					{
						document.getElementById(value).innerHTML = "Disabled";
					}
					else
					{
						document.getElementById(value).innerHTML = "Mapped to Port" + widgetValue;
					}
					//Populate dropdown also
					selText = DropDownPortMapping[widgetValue];
					value = "select" + value;
					var nameofcontrol = "." + value + "1";
					var nameofcontrol1 = "[data-bind=\"" + value + "label\"]";
					$(nameofcontrol).find(nameofcontrol1).text(selText)
							.children('.dropdown-toggle').dropdown('toggle');
					
				});
				// Updating GwidgetlistPortType Ends

				$("#ConfigMode").empty();
				var configModeVal = MchpUsbConfigMode(gb_HUB_ID);

				$("#ConfigMode").val(configModeVal);

				var Mode = configModeVal;
				
				if((gb_skuName == "USB7202") || (gb_skuName == "USB7250") || (gb_skuName == "USB7251") || ((gb_skuName == "USB7252")))
				{
					if(Mode=="3"){					
						$("#CDC_Div").show();										
					}
					else
					{
						$("#CDC_Div").hide();
					}
				}
				else{
					$("#CDC_Div").hide();		
				}

				update_status_message("Reading Hub Configuration successful.");

			}

			$("body").css("cursor", "default");
		} 
		else 
		{
			reset_fields();
			disable_fields();
			$("#progID").hide();
			$("body").css("cursor", "default");
			enableApplyButton = false;
			errorCode = getMchpUsbLastError(gb_HUB_ID);
			alert(errorMap[Dec2Hex(errorCode)]
					+ " Check Help for troubleshooting.");
			update_status_message(errorMap[Dec2Hex(errorCode)]
					+ " Check Help for troubleshooting.");
		}
	};
})(jQuery);

var reloop = false;
(function($) {
	get_hub_list_set_hub_index_zero = function () {
		get_hub_list();
		if (gb_hubsFound) {
			
			var rethubid = INIFileExists();
			var HUB_ID = 0;
			var singlehub = true;
			
			if(rethubid == false) {
				HUB_ID = 0;
			} else {
				HUB_ID = gethubfamilyIndex("6");  //Adaro family type - 6
				singlehub = returnstatus();	
			}
			var conform;
			if(HUB_ID == -1 && singlehub == false) {
				
				gb_HUB_ID = "0"
				set_selected_hub_get_widgets();
			} else if(singlehub == false && HUB_ID != -1 ) {
				
				var rev = hub_list.reverse();
				
				conform = confirm("Selected hub is "+rev[HUB_ID+1]+". Do you want to proceed with selected hub index ?.");
				if(!conform) {
					reloop = true;
					$("#collapseDeviceSelection").show();
					$("#over").show();
					$("#SelectUSBHUBLabel").hide();
					$('.nav-tabs a[href="#PT_basic"]').tab('show');
					$("#sfield").show();
					$("#close").show();
					$('#nav').hide();
					document.getElementById("over").setAttribute("class","w3-modal-new");
				} else {
					$("#over").show();
					$("#SelectUSBHUBLabel").show();
					$("#sfield").hide();
					$("#close").hide();
					$('#nav').show();
					document.getElementById("over").setAttribute("class","form-group");
					gb_HUB_ID = HUB_ID.toString();
					set_selected_hub_get_widgets();
					$('.selecthub1').find('[data-bind="SelectHublabel"]').text(rev[HUB_ID+1])
											.children('.dropdown-toggle').dropdown('toggle');
									
					$("#selectedhubinput").val(rev[HUB_ID+1]);
				}
			
			} else if(singlehub == true){
				$("#over").show();
				$("#SelectUSBHUBLabel").show();
				$("#sfield").hide();
				$("#close").hide();
				
				gb_HUB_ID = HUB_ID.toString();
				set_selected_hub_get_widgets();
				var rev = hub_list.reverse();
				
				$('.selecthub1').find('[data-bind="SelectHublabel"]').text(rev[HUB_ID+1])
										.children('.dropdown-toggle').dropdown('toggle');
								
				$("#selectedhubinput").val(rev[HUB_ID+1]);
			}
		}
	};
})(jQuery);

(function($) {
	checkChangedWidget = function() 
	{
		var USB3StrSupportedChar = 141;
		var usb3strerror = false;
		var USB3CurrentTotalLen = 0;
		var error_msg = "";

		var hcemanuStringLength = 0;
		var manuStringLength = 0;

		// TODO - Calculate maximum length and add check accordigly
		var usb2Defaultlen = 126;
		var usb3Defaultlen = 126;
		var HCEDefaultlen = 126;
		
		var EAPDefaultLen = 111;

		var EapStrAlert = false; //Alert for EAP1
		var EapStrAlert1 = false; //Alert for EAP2
		var EapStrLengthVerify = false;

		var temp = gb_skuName.substring(0, 6);

		var bUSB2PortEnable = [ 0, 0, 0, 0, 0, 0, 0 ];
		// Find out currently how many ports are enabled
		bUSB2PortEnable[1] = $('#enableport1').is(':checked');
		bUSB2PortEnable[2] = $('#enableport2').is(':checked');
		bUSB2PortEnable[3] = $('#enableport3').is(':checked');
		bUSB2PortEnable[4] = $('#enableport4').is(':checked');
		bUSB2PortEnable[5] = $('#enableport5').is(':checked');
		bUSB2PortEnable[6] = $('#enableport6').is(':checked');

		var bTotal = false;
		
		if(gb_skuName === "USB7202")
		{
			bTotal = bUSB2PortEnable[1] + bUSB2PortEnable[2]
					+ bUSB2PortEnable[3] + bUSB2PortEnable[4];		
		}
		if(gb_skuName === "USB7206")
		{
			bTotal = bUSB2PortEnable[1] + bUSB2PortEnable[2]
					+ bUSB2PortEnable[3] + bUSB2PortEnable[4] + bUSB2PortEnable[5] + bUSB2PortEnable[6];
		}
		var hceStatus = $('#hceenable').is(':checked') ? 1 : 0;

		// Check the hceenable and portenable validity
		if (hceStatus == 0 && bTotal == false) 
		{
			var option = confirm("Hub controller is disabled.After programming all the ports will be disabled. do you want to continue?");
			if(!option) {
				enable_nav_fields();
				update_status_message("Programming of the device was terminated by the user.");
				return false;
			}
		}

		/*if (bTotal == false) 
		{
			error_msg = error_msg
					+ "Disabling all downstream ports is not allowed.\n";
		}*/

		// //String length constraint check
		$.each(GwidgetlistString,function(index, widgetName) 
		{
			var widgetid = "#" + widgetName;
			var oldval = getWidgetValue(gb_HUB_ID, widgetName);

			var newval = $(widgetid).val();

			if (newval != oldval) 
			{
				if (widgetName === "hce_manufacturer"
						|| widgetName == "hce_product"
						|| widgetName == "hce_serial") 
				{
					var stringvalue = $(widgetid).val();

					// Check the widget length also
					if (stringvalue == "") 
					{
						// do nothing null string
					} 
					else 
					{
						hcemanuStringLength = ($(widgetid)
								.val().length);
					}
					// Checking the string length constraint

					if ((hcemanuStringLength > HCEDefaultlen)) 
					{
						error_msg = error_msg
								+ "String Descriptor of Hub Feature Controller can have a max length of"
								+ " " + HCEDefaultlen + " "
								+ "unicode characters only\n";
					}
				}

				// Validating the NCM1 and NCM2 String
				// descriptor
				if (widgetName === "hce1_macaddr" || widgetName === "hce2_macaddr") 
				{
					var newval = "";
					if(widgetName === "hce1_macaddr")
					{
						newval = $("#hce1_macaddr").val();
					}
					else
					{
						newval = $("#hce2_macaddr").val();
					}
				
					var MacValue = newval.split(":");
	
					var maclength = MacValue.length;
					
										
					if(maclength < 6 || maclength > 6)
					{
						error_msg = error_msg + "The Given MAC Address is not valid.Mac Address should be for Example = 00:80:0F:10:20:01";
					}
					MacValue[0] = parseInt(MacValue[0],16);
					if((MacValue[0] & 0x01) === 0x01)
					{
						error_msg = error_msg + "MAC Address should not be a Multicast or Broadcast address";
					}
					
					var regex = /^([0-9a-fA-F]{2}[:-]){5}([0-9A-F]{2})$/;
				  
					var isMacOKAddr = regex.test(newval);
					
					if(!isMacOKAddr)
					{
						error_msg = error_msg +"The Given MAC Address is not a valid Mac Address";
					}

				}

				// Validate the Maunfactuerer String
				if (widgetName === "manufacturer"
						|| widgetName == "product"
						|| widgetName == "serial") 
				{

					var stringvalue = $(widgetid).val();

					// Check the widget length also
					if (stringvalue == "") 
					{
						// do nothing null string
					} 
					else 
					{
						manuStringLength = ($(widgetid).val().length);
					}
					// Checking the string length constraint
					if ((manuStringLength > usb2Defaultlen)) 
					{
						error_msg = error_msg
								+ "String Descriptor of USB2 Hub can have a max length of"
								+ " " + usb2Defaultlen + " "
								+ "unicode characters only\n";
					}
				}

				if (widgetName === "usb3uuid") 
				{
					var uuidVal = $("#usb3uuid").val();
					var isValid = /^[0-9a-fA-F]{1,32}$/i
							.test(uuidVal);
					if (!isValid) {

						error_msg = error_msg
								+ "UUID value entered is invalid. UUID must be a 16 bytes of hexadecimal number.\n";
					}
				}

				// Validating the String Descriptor of USb3 Hub
				if (widgetName === "usb3manufacturer"
						|| widgetName == "usb3product"
						|| widgetName == "usb3serial") 
				{
					if(false === usb3strerror)
					{
						var stringvalue = $(widgetid).val();
						
						// Check the widget length also
						if (stringvalue == "") 
						{
							// do nothing null string
						} 
						else 
						{
							usb3StringLength = ($(widgetid).val().length);
							USB3CurrentTotalLen += usb3StringLength;
						}
						//Calculate maximum supported Char
						if((usb3StringLength & 0x03) === 0x03)
						{
							//Do Nothing
						}
						else{
							// USB3 start addr - BFD2_E500 (512 Bytes), End addr - BFD2_E700
							// USB3 string start addr - BFD2_E5E0
							// Total chars = (BFD2_E700 - BFD2_E5E0) = 0x120 (288) --> (288 -6)/2 = 141
							// String descriptors must start at a QWORD boundary.
							// String length multiple of 3 does not require additional Bytes
							// Example:
							// String Length		Calculated			QWORD Address		Difference in Bytes
							// 1					E5E4				E5E8				4
							// 2					E5E6				E5E8				2
							// 3					E5E8				E5E8				0
							// 4					E5EA				E5F0				6
							// 5					E5EC				E5F0				4
							// 6					E5EE				E5F0				2
							// 7					E5F0				E5F0				0
							// Cycle ( 6, 4, 2, 0) repeats ...
							// String len that does not have diffrence in bytes - 3 (0011), 7 (0111), 11 (1011), 15 (1111), 
							// 19 (0001 0011), 23 (0001 0111), 27 (0001 1011), 31 (0001 1111), 35 (0010 0011) ...
							// How below equation is obtained?
							// 6 = 6 - ((0x04 & 0x03) * 2) --> 6 - (0 * 2)
							// 4 = 6 - ((0x05 & 0x03) * 2) --> 6 - (1 * 2)
							// 2 = 6 - ((0x06 & 0x03) * 2) --> 6 - (2 * 2)
							// 0 = 6 - ((0x07 & 0x03) * 2) --> 6 - (3 * 2)
							
							var TempVal = usb3StringLength & 0x03;
							var Temp1Val = (6 - (TempVal * 2));
							USB3StrSupportedChar = USB3StrSupportedChar - (Temp1Val /2); // 2 Bytes = 1 char
						}
					
						if(USB3CurrentTotalLen > USB3StrSupportedChar)
						{
							error_msg = error_msg
										+ "USB3.1 Gen2 Sting descriptors is greater than Maximum supported" + USB3StrSupportedChar + "characters\n";
						}
						usb3strerror = true;
					}
				}
				// Start of EAP1 Strings Alert
				if ((widgetName === "hce1_product"))
				{
					var stringvalue= $(widgetid).val();
					var stringvalue1 = $('#hce1_eapproduct').val();
								
					// Check the widget length also
					if ((stringvalue  === "") && (stringvalue1 === ""))
					{
					}
					else if((stringvalue  != "") && (stringvalue1 != ""))
					{
					}
					else
					{
						if(EapStrAlert === false)
						{
							var option = confirm("Disabling will NCM/IAP 1 Product will also disable IAP/EAP 1 Product. Do you want to continue?\n");
							if(option === false)
							{
								error_msg = error_msg + "Disabling will NCM/IAP 1 Product will also disable IAP/EAP 1 Product. Operation Terminated by user";
								update_status_message("Disabling will NCM/IAP 1 Product will also disable IAP/EAP 1 Product. Operation Terminated by user");
							}
							EapStrAlert = true;
						}
					}
				}
				if ((widgetName === "hce1_eapproduct"))
				{
					var stringvalue= $(widgetid).val();
					var stringvalue1 = $('#hce1_product').val();
								
					// Check the widget length also
					if ((stringvalue  === "") && (stringvalue1 === ""))
					{
					}
					else if((stringvalue  != "") && (stringvalue1 != ""))
					{
					}
					else
					{
						if(EapStrAlert === false)
						{
							var option = confirm("Disabling will IAP/EAP 1 Product will also disable NCM/IAP 1 Product. Do you want to continue?\n");
							if(option === false)
							{
								error_msg = error_msg + "Disabling will IAP/EAP 1 Product will also disable NCM/IAP 1 Product. Operation Terminated by user";
								update_status_message("Disabling will IAP/EAP 1 Product will also disable NCM/IAP 1 Product. Operation Terminated by user");
							}
							EapStrAlert = true;
						}
					}
				}
				// End of EAP1 Strings alert
				
				// Start of EAP2 Strings alert
				if ((widgetName === "hce2_product"))
				{
					var stringvalue= $(widgetid).val();
					var stringvalue1 = $('#hce2_eapproduct').val();
								
					// Check the widget length also
					if ((stringvalue  === "") && (stringvalue1 === ""))
					{
					}
					else if((stringvalue  != "") && (stringvalue1 != ""))
					{
					}
					else
					{
						if(EapStrAlert1 === false)
						{
							var option = confirm("Disabling will NCM/IAP 2 Product will also disable IAP/EAP 2 Product. Do you want to continue?\n");
							if(option === false)
							{
								error_msg = error_msg + "Disabling will NCM/IAP 2 Product will also disable IAP/EAP 2 Product. Operation Terminated by user";
								update_status_message("Disabling will NCM/IAP 2 Product will also disable IAP/EAP 2 Product. Operation Terminated by user");
							}
							EapStrAlert1 = true;
						}
					}
				}
				if ((widgetName === "hce2_eapproduct"))
				{
					var stringvalue= $(widgetid).val();
					var stringvalue1 = $('#hce2_product').val();
								
					// Check the widget length also
					if ((stringvalue  === "") && (stringvalue1 === ""))
					{
					}
					else if((stringvalue  != "") && (stringvalue1 != ""))
					{
					}
					else
					{
						if(EapStrAlert1 === false)
						{
							var option = confirm("Disabling will IAP/EAP 2 Product will also disable NCM/IAP 2 Product. Do you want to continue?\n");
							if(option === false)
							{
								error_msg = error_msg + "Disabling will IAP/EAP 2 Product will also disable NCM/IAP 2 Product. Operation Terminated by user" ;
								update_status_message("Disabling will IAP/EAP 2 Product will also disable NCM/IAP 2 Product. Operation Terminated by user");
							}
							EapStrAlert1 = true;
						}
					}
				}
				// End of EAP2 Strings Alert
				
				// Check for EAP Strings Length
				if((widgetName === "hce1_eapproduct") || (widgetName === "hce2_eapproduct") || (widgetName === "hce1_eapinterface") || (widgetName === "hce1_eapinterface"))
				{
					if(EapStrLengthVerify === false)
					{
						var Eap1ProductLen = ($('#hce1_eapproduct').val().length);
						var Eap1InterfaceLen = ($('#hce1_eapinterface').val().length);
						var Eap2ProductLen = ($('#hce2_eapproduct').val().length);
						var Eap2InterfaceLen = ($('#hce2_eapinterface').val().length);
						
						if((Eap1ProductLen + Eap1InterfaceLen + Eap2ProductLen +  Eap2InterfaceLen) > EAPDefaultLen)
						{
							error_msg = error_msg + "String Descriptor of IAP/EAP Class device Strings can have a max length of"+ " "+ EAPDefaultLen+ " "+ "unicode characters only." ;
							update_status_message("Error : String Descriptor of Hub Feature Controller can have a max length of"+ EAPDefaultLen+ "unicode characters only.");
							EapStrLengthVerify = true;
						}
					}
				}
				// End of EAP string length check
			}
		});

		// Checking the validity of Hex fields against null,zero and valid hex
		// digits
		$.each(GwidgetlistHex, function(index, widgetName) 
		{
			var widgetid = "#" + widgetName;
			var oldval;
			var newval;
			var isValid;

			newval = $(widgetid).val();

			if (newval == "") 
			{
				error_msg = error_msg + "The value of \""
						+ Mapping[widgetName]
						+ "\" cannot be null.\n";
			} 
			else 
			{
				if (widgetName === "usbvcd"
						|| widgetName === "usb3vcd") 
				{

					var iusbvcd = parseInt(getWidgetValue(
							gb_HUB_ID, widgetName), 10);
					var dot = ".";
					var xusbvcd = (iusbvcd.toString(16));

					var xusbvcd = [ xusbvcd.slice(0, 1), dot,
							xusbvcd.slice(1) ].join('');
					oldval = xusbvcd;
					newval = $(widgetid).val();

					if (widgetName === "usbvcd") {
						isValid = /^2\.?[0-9]{0,2}$/i
								.test(newval);
					}
					if (widgetName === "usb3vcd") {
						isValid = /^3\.?[0-9]{0,2}$/i
								.test(newval);
					}

					if (!isValid) {

						error_msg = error_msg
								+ "The value entered for \""
								+ Mapping[widgetName]
								+ "\" is not valid.\n";

					}

				} 
				else if ((widgetName === "vid")
						|| (widgetName === "usb3vid")) 
				{
					var usb3VID = $("#usb3vid").val();
					var usb2VID = $("#vid").val();
					if (usb3VID == usb2VID) {
						// do nothing
					} else {
						update_status_message("Mismatch in VID of USB2.0 and USB3.1 Gen2. Please make sure their VID is the same.");
						error_msg = "Mismatch in VID of USB2.0 and USB3.1 Gen2. Please make sure their VID is the same.";
					}
				} 
				else 
				{
					oldval = parseInt(getWidgetValue(gb_HUB_ID, widgetName), 10);
					isValid = /^[0-9A-Fa-f]{1,4}$/i.test($(widgetid).val());
					newval = parseInt($(widgetid).val(), 16);

					if (!isValid) 
					{
						error_msg = error_msg
								+ "The value entered for \""
								+ Mapping[widgetName]
								+ "\" must be a 4 digit hexadecimal value and it cannot be Zero.\n";
					}
				}
			}

		});

		// Checking int fields
		$.each(GwidgetlistInt,function(index, widgetName) 
		{
			widgetid = "#" + widgetName;
			var newval = $(widgetid).val();

			if ((widgetName == "maxpowerself")
					|| (widgetName == "hubcmaxpowerself")) 
			{
				if ((newval > 100) || (newval < 0)) 
				{
					error_msg = error_msg
							+ "USB2.0 max power(self) or USB2.0 hub circuit max power(self) cannot be more than 100mA or negative.\n";
				}
			}

			if (widgetName == "maxpowerbus") 
			{
				if ((newval > 500) || (newval < 0)) {
					error_msg = error_msg
							+ "USB2.0 max power(bus) cannot be more than 500mA or negative.\n";
				}
			}

			if (widgetName == "hubcmaxpowerbus") 
			{
				if ((newval > 255) || (newval < 0)) 
				{
					error_msg = error_msg
							+ "USB2.0 hub circuit max power(bus) cannot be more than 255mA or negative.\n";
				}
			}
			if ((widgetName == "maxpowerself")
					|| (widgetName == "maxpowerbus")
					|| (widgetName == "power_ontime")) 
			{
				var newdecvalue = parseInt(newval, 10);
				newdecvalue = newdecvalue & 0xff;

				if ((newdecvalue & 0x01)) 
				{
					error_msg = error_msg
							+ "\"Hub MaxPower(Self)\" and \"Hub MaxPower(Bus)\" fields can have even numbers only";
					return;
				}
			}
			if (widgetName == "power_ontime") 
			{
				if ((newval > 510) || (newval < 0)) 
				{
					error_msg = error_msg
							+ "Power-On Time cannot be more than 510ms or negative.\n";
				}
			}
		});

		// Check flexconnect condition

		// if ($('#flexconnect').is(':checked')) 
		// {
			// var nameofcontrol = ".flexport1";
			// var nameofcontrol1 = "[data-bind=\"flexportlabel\"]";
			// var selText = $(nameofcontrol).find(nameofcontrol1).text();

			// var portenableid = "#enableport" + selText;

			// if (!($(portenableid).is(':checked'))) 
			// {
				// error_msg = error_msg
						// + "Downstream port "
						// + selText
						// + " is disabled. FlexConnect cannot be done. \n Enable Downstream port "
						// + selText + " and try again.\n";
			// }
		// }
		// if ($('#usb3flexconnect').is(':checked')) 
		// {
			// var nameofcontrol = ".flexport1";
			// var nameofcontrol1 = "[data-bind=\"flexportlabel\"]";
			// var selText = $(nameofcontrol).find(nameofcontrol1).text();

			// var portenableid = "#usb3enableport" + selText;

			// if (!($(portenableid).is(':checked'))) 
			// {
				// error_msg = error_msg
						// + "Downstream port "
						// + selText
						// + " is disabled. FlexConnect cannot be done. \n Enable Downstream port "
						// + selText + " and try again.\n";
			// }
		// }

		if (($("#Regoperationgroup").find(':checked').val())
				&& ($("#Regaddress").val()) && ($("#Regvalue").val())) 
		{
			var Regaddress = $("#Regaddress").val();
			var Regaddress = Regaddress.replace(/\s+/g, "");
			var isValidAddr = /^[0-9A-Fa-f]{8}$/i.test(Regaddress);

			var RegValue = $("#Regvalue").val();
			var RegValue = RegValue.replace(/\s+/g, "");
			var isValidVal = /^[0-9A-Fa-f]+$/i.test(RegValue);

			if (!isValidAddr) {
				error_msg = error_msg
						+ "The Register Address entered under the Direct Register Access must be a 8 digit hexadecimal number.\n";
			}

			if (!isValidVal) {
				error_msg = error_msg
						+ "The Register value entered under the Direct Register Access is not a valid hexadecimal number.\n";
			}

		}
		if(gb_minihostruletype === "01") //Rule type:vid pid
		{
			vidpid_idx = 0, vidpid_vid = 0, vidpid_pid =0 ,vidpid_ruleid = 0;
			if(gb_vidpidrulecnt >= 20)
			{
				error_msg = error_msg + "Maximum there can be only 20 rules for VID PID Rule type";
			}
			else if($('#minihostoverwrite').is(':checked') && (gb_existingruleidx == 0))
			{
				error_msg = error_msg + "Select Existing Mini Host Rule Index to be overwritten";
			}
			else
			{
				if($('#minihostoverwrite').is(':checked'))
				{
					vidpid_idx = gb_existingruleidx;
				}
				else
				{
					gb_vidpidrulecnt = gb_vidpidrulecnt + 1;
					vidpid_idx = gb_vidpidrulecnt;
				}
				vidpid_vid = document.getElementById("vidpidrule_vid").value;
				vidpid_pid = document.getElementById("vidpidrule_pid").value;
				vidpid_ruleid = document.getElementById("vidpidrule_ruleid").value;
				if(vidpid_vid == "" || vidpid_pid == "" || vidpid_ruleid== "" || vidpid_conn=="")
				{
					error_msg = error_msg + "Please fill all fields for Mini Host selected Rule type";
				}
			}
		}
		if(gb_minihostruletype === "11")
		{
			vidpidmask_idx = 0, vidpidmask_vid = 0, vidpidmask_pid =0 ,vidpidmask_vidpidmsk =0, vidpidmask_ruleid = 0;
			if(gb_vidpidmaskrulecnt >= 10)
			{
				error_msg = error_msg + "Maximum there can be only 10 rules for VID PID Mask Rule type";
			}
			if($('#minihostoverwrite').is(':checked') && (gb_existingruleidx == 0))
			{
				error_msg = error_msg + "Select Existing Mini Host Rule Index to be overwritten";
			}
			else
			{
				if($('#minihostoverwrite').is(':checked'))
				{
					vidpidmask_idx = gb_existingruleidx;
				}
				else
				{
					gb_vidpidmaskrulecnt = gb_vidpidmaskrulecnt + 1;
					vidpidmask_idx = gb_vidpidmaskrulecnt;
				}
				vidpidmask_vid = document.getElementById("vidpidmaskrule_vid").value;
				vidpidmask_pid = document.getElementById("vidpidmaskrule_pid").value;
				vidpidmask_vidpidmsk = document.getElementById("vidpidmaskrule_vidpidmask").value;
				vidpidmask_ruleid = document.getElementById("vidpidmaskrule_ruleid").value;
				if(vidpidmask_vid == "" || vidpidmask_pid == "" || vidpidmask_vidpidmsk== "" || vidpidmask_ruleid=="" || vidpidmask_conn=="")
				{
					error_msg = error_msg + "Please fill all fields for Mini Host selected Rule type";
				}
			}
		}
		if(gb_minihostruletype === "10")
		{
			deviceclass_idx = 0,deviceclass_ruleid = 0;
			if(gb_deviceclassrulecnt >= 5)
			{
				error_msg = error_msg +  "Maximum there can be only 5 rules for Device Class Rule type";
			}
			if($('#minihostoverwrite').is(':checked') && (gb_existingruleidx == 0))
			{
				error_msg = error_msg + "Select Existing Mini Host Rule Index to be overwritten";
			}
			else
			{
				if($('#minihostoverwrite').is(':checked'))
				{
					deviceclass_idx = gb_existingruleidx;
				}
				else
				{
					gb_deviceclassrulecnt = gb_deviceclassrulecnt + 1;
					deviceclass_idx = gb_deviceclassrulecnt;
				}
				deviceclass_ruleid = document.getElementById("deviceclassrule_ruleid").value;
				if(deviceclass_class == "" || deviceclass_conn == "" || deviceclass_ruleid == "" )
				{
					error_msg = error_msg + "Please fill all fields for Mini Host selected Rule type";
				}
			}
		}
		if (error_msg != "") 
		{
			alert(error_msg);
			enable_nav_fields();
			return false;
		}

		return true;
	};
})(jQuery);

(function($) {
	set_changed_widget_list = function() 
	{
		// To do
		if (false == checkChangedWidget()) {

			return;
		}

		var tempsku = gb_skuName.substring(0, 6);
		// Array to save the widgets and their values which were changed.
		var deltaobj = [];
		var widgetsToDisplay = [];
		var modifiedWidgets = [];

		var enableMapping = false;
		var stringToSet = "";

		var vid_pidModified = false;
		var sentinel = true;
		var mismatchCheck = 0;

		// List of widgets to display on the alert

		// language id constraint
		var stringmodified = 0;
		var udc_stringmodified = 0;
		var langid = $("#languageid").val();
		var udc_langid = $("#hce_languageid").val();

		var usb3langid = $("#usb3languageid").val();
		var usb3stringmodified = 0;
		var usb3StringLength = 0;
		var usb3StringFlag = true;
		var currentvalue = "NONE";

		// Check length of strings constraint
		var usb2StringLength = 0;
		var hceStringLength = 0;

		// Alert flags for string lengths
		var usb2StringFlag = true;
		var hceStringFlag = true;

		// flag for alert message
		var errorFlag = false;

		var abUSB2PortEnable = [ 0, 0, 0, 0, 0, 0, 0 ];
		var abUSB3PortEnable = [ 0, 0, 0, 0, 0, 0, 0 ];

		// Find out currently how many USB2.0 ports are enabled
		abUSB2PortEnable[1] = ($('#enableport1').is(':checked')) ? 1 : 0;
		abUSB2PortEnable[2] = ($('#enableport2').is(':checked')) ? 1 : 0;
		abUSB2PortEnable[3] = ($('#enableport3').is(':checked')) ? 1 : 0;
		abUSB2PortEnable[4] = ($('#enableport4').is(':checked')) ? 1 : 0;
		abUSB2PortEnable[5] = ($('#enableport5').is(':checked')) ? 1 : 0;
		abUSB2PortEnable[6] = ($('#enableport6').is(':checked')) ? 1 : 0;

		// Find out USB3.0 ports are enabled?
		abUSB3PortEnable[1] = ($('#usb3enableport1').is(':checked')) ? 1 : 0;
		abUSB3PortEnable[2] = ($('#usb3enableport2').is(':checked')) ? 1 : 0;
		abUSB3PortEnable[3] = ($('#usb3enableport3').is(':checked')) ? 1 : 0;
		abUSB3PortEnable[4] = ($('#usb3enableport4').is(':checked')) ? 1 : 0;
		abUSB3PortEnable[5] = ($('#usb3enableport5').is(':checked')) ? 1 : 0;
		abUSB3PortEnable[6] = ($('#usb3enableport6').is(':checked')) ? 1 : 0;

		// To program it to defaults when a port is disabled.
		var enableportwidget;
		var usb3enableportwidget;
		var nrwidget;
		var usb3nrwidget;
		var usb3nrwidgetchanged = false;
		var swapwidget;
		var phyboostwidget;
		var varisensewidget;
		var hsrisefallwidget;
		var nrport;
		var dpdmSwap;
		var phyboost;
		var hsrisefall;
		var varisense;
		var NRModified = [ false, false, false, false, false, false, false ];
		var USB3NRModified = [ false, false, false, false, false, false ];

		var NROldVal = [ 0, 0, 0, 0, 0, 0, 0 ];
		var USB3NROldVal = [ 0, 0, 0, 0, 0, 0, 0 ];

		var SwapModified = [ false, false, false, false, false, false, false ];
		var PhyBoostModified = [ false, false, false, false, false, false, false ];
		var VarisenseModified = [ false, false, false, false, false, false, false ];
		var RiseFallModified = [ false, false, false, false, false, false, false ];
		var enableportOldVal = [ 0, 0, 0, 0, 0, 0, 0 ];
		var usb3enableportOldVal = [ 0, 0, 0, 0, 0, 0, 0 ];
		var usb3portmapping = [ 0, 0, 0, 0, 0, 0, 0, 0 ];
		var usb2portmapping = [ 0, 0, 0, 0, 0, 0, 0, 0 ];

		var NoofUSB2Port, NoofUSB3Port, USB2PhysicalPortMax;

		if (gb_skuName === "USB7202") 
		{
			NoofUSB2Port = 4;
			NoofUSB3Port = 2;
			USB2PhysicalPortMax = 4;
		}
		if (gb_skuName === "USB7250" || gb_skuName === "USB7251"
				|| gb_skuName === "USB7252") 
		{
			NoofUSB2Port = 4;
			NoofUSB3Port = 3;
			USB2PhysicalPortMax = 5;
		}
		if (gb_skuName === "USB7216" || gb_skuName === "USB7206" || gb_skuName === "USB7256") 
		{
			NoofUSB2Port = 6;
			if(gb_skuName === "USB7216" || gb_skuName === "USB7256")
			{
				NoofUSB3Port = 4;
			}else if(gb_skuName === "USB7206")
			{
				NoofUSB3Port = 5;
			}
			USB2PhysicalPortMax = 6;
		}

		// USB2 Non Removable
		var abnrcurrentval = [ 0, 0, 0, 0, 0, 0, 0 ];
		abnrcurrentval[1] = $('#nrdeviceport1').is(':checked') ? "1" : "0";
		abnrcurrentval[2] = $('#nrdeviceport2').is(':checked') ? "1" : "0";
		abnrcurrentval[3] = $('#nrdeviceport3').is(':checked') ? "1" : "0";
		abnrcurrentval[4] = $('#nrdeviceport4').is(':checked') ? "1" : "0";
		abnrcurrentval[5] = $('#nrdeviceport5').is(':checked') ? "1" : "0";
		abnrcurrentval[6] = $('#nrdeviceport6').is(':checked') ? "1" : "0";

		// USB3 Non Removable
		var abusb3nrcurrentval = [ 0, 0, 0, 0, 0, 0 ];
		abusb3nrcurrentval[1] = $('#usb3nrdeviceport1').is(':checked') ? "1" : "0";
		abusb3nrcurrentval[2] = $('#usb3nrdeviceport2').is(':checked') ? "1" : "0";
		abusb3nrcurrentval[3] = $('#usb3nrdeviceport3').is(':checked') ? "1" : "0";
		abusb3nrcurrentval[4] = $('#usb3nrdeviceport4').is(':checked') ? "1" : "0";
		abusb3nrcurrentval[5] = $('#usb3nrdeviceport5').is(':checked') ? "1" : "0";

		// USB2 Swap port
		var abPortSwapcurrentval = [ 0, 0, 0, 0, 0, 0, 0 ];
		abPortSwapcurrentval[1] = $('#swapport1dpdm').is(':checked') ? "1" : "0";
		abPortSwapcurrentval[2] = $('#swapport2dpdm').is(':checked') ? "1" : "0";
		abPortSwapcurrentval[3] = $('#swapport3dpdm').is(':checked') ? "1" : "0";
		abPortSwapcurrentval[4] = $('#swapport4dpdm').is(':checked') ? "1" : "0";
		abPortSwapcurrentval[5] = $('#swapport5dpdm').is(':checked') ? "1" : "0";
		abPortSwapcurrentval[6] = $('#swapport6dpdm').is(':checked') ? "1" : "0";

		// PhyBoost
		var selText;
		var abPhyboostcurrentval = [ 0, 0, 0, 0, 0, 0, 0 ];
		selText = $(".PHYBOOSTdownstreamport11").find("[data-bind=\"PHYBOOSTdownstreamport1label\"]").text();
		abPhyboostcurrentval[1] = DropDownPHYBOOST.indexOf(selText);
		selText = $(".PHYBOOSTdownstreamport21").find("[data-bind=\"PHYBOOSTdownstreamport2label\"]").text();
		abPhyboostcurrentval[2] = DropDownPHYBOOST.indexOf(selText);
		selText = $(".PHYBOOSTdownstreamport31").find("[data-bind=\"PHYBOOSTdownstreamport3label\"]").text();
		abPhyboostcurrentval[3] = DropDownPHYBOOST.indexOf(selText);
		selText = $(".PHYBOOSTdownstreamport41").find("[data-bind=\"PHYBOOSTdownstreamport4label\"]").text();
		abPhyboostcurrentval[4] = DropDownPHYBOOST.indexOf(selText);
		selText = $(".PHYBOOSTdownstreamport51").find("[data-bind=\"PHYBOOSTdownstreamport5label\"]").text();
		abPhyboostcurrentval[5] = DropDownPHYBOOST.indexOf(selText);
		selText = $(".PHYBOOSTdownstreamport61").find("[data-bind=\"PHYBOOSTdownstreamport6label\"]").text();
		abPhyboostcurrentval[6] = DropDownPHYBOOST.indexOf(selText);

		// Varisense
		var abSQUELCHcurrentval = [ 0, 0, 0, 0, 0, 0, 0 ];
		selText = $(".SQUELCHdownstreamport11").find("[data-bind=\"SQUELCHdownstreamport1label\"]").text();
		abSQUELCHcurrentval[1] = DropDownSQUELCH.indexOf(selText);
		selText = $(".SQUELCHdownstreamport21").find("[data-bind=\"SQUELCHdownstreamport2label\"]").text();
		abSQUELCHcurrentval[2] = DropDownSQUELCH.indexOf(selText);
		selText = $(".SQUELCHdownstreamport31").find("[data-bind=\"SQUELCHdownstreamport3label\"]").text();
		abSQUELCHcurrentval[3] = DropDownSQUELCH.indexOf(selText);
		selText = $(".SQUELCHdownstreamport41").find("[data-bind=\"SQUELCHdownstreamport4label\"]").text();
		abSQUELCHcurrentval[4] = DropDownSQUELCH.indexOf(selText);
		selText = $(".SQUELCHdownstreamport51").find("[data-bind=\"SQUELCHdownstreamport5label\"]").text();
		abSQUELCHcurrentval[5] = DropDownSQUELCH.indexOf(selText);
		selText = $(".SQUELCHdownstreamport61").find("[data-bind=\"SQUELCHdownstreamport6label\"]").text();
		abSQUELCHcurrentval[6] = DropDownSQUELCH.indexOf(selText);

		// HS RiseFall
		var abHSRiseFallcurrentval = [ 0, 0, 0, 0, 0, 0, 0 ];
		selText = $(".downstreamport1HsRiseFall1").find("[data-bind=\"downstreamport1HsRiseFalllabel\"]").text();
		abHSRiseFallcurrentval[1] = DropDownHSRiseFall.indexOf(selText);
		selText = $(".downstreamport2HsRiseFall1").find("[data-bind=\"downstreamport2HsRiseFalllabel\"]").text();
		abHSRiseFallcurrentval[2] = DropDownHSRiseFall.indexOf(selText);
		selText = $(".downstreamport3HsRiseFall1").find("[data-bind=\"downstreamport3HsRiseFalllabel\"]").text();
		abHSRiseFallcurrentval[3] = DropDownHSRiseFall.indexOf(selText);
		selText = $(".downstreamport4HsRiseFall1").find("[data-bind=\"downstreamport4HsRiseFalllabel\"]").text();
		abHSRiseFallcurrentval[4] = DropDownHSRiseFall.indexOf(selText);
		selText = $(".downstreamport5HsRiseFall1").find("[data-bind=\"downstreamport5HsRiseFalllabel\"]").text();
		abHSRiseFallcurrentval[5] = DropDownHSRiseFall.indexOf(selText);
		selText = $(".downstreamport6HsRiseFall1").find("[data-bind=\"downstreamport6HsRiseFalllabel\"]").text();
		abHSRiseFallcurrentval[6] = DropDownHSRiseFall.indexOf(selText);

		// Phy, varisense,hsrisefall all are usb2 based feilds. so checking for
		// maximum physical port
		for (var port = 1; port <= 7; port++) 
		{
			enableportwidget = "enableport" + port.toString();
			enableportOldVal[port] = getWidgetValue(gb_HUB_ID, enableportwidget);
			if (port <= 5) 
			{
				usb3enableportwidget = "usb3enableport" + port.toString();
				usb3enableportOldVal[port] = getWidgetValue(gb_HUB_ID,usb3enableportwidget);
			}
			if (port <= USB2PhysicalPortMax) 
			{
				if (abUSB2PortEnable[port] == 0)
				{
					if (abUSB3PortEnable[port] == true) 
					{
						var widgetgroupname;
						var portsplitval = 0;
						if((gb_skuName === "USB7216" || gb_skuName === "USB7206" || gb_skuName === "USB7256"))
						{
							if(port === 3)
							{
								widgetgroupname = '#' + "port3splitting" + "group";
								portsplitval = $(widgetgroupname).find(':checked').val();
							}
							if(port === 4)
							{
								widgetgroupname = '#' + "port4splitting" + "group";
								portsplitval = $(widgetgroupname).find(':checked').val();
							}
							if(port === 5)
							{
								widgetgroupname = '#' + "port5splitting" + "group";
								portsplitval = $(widgetgroupname).find(':checked').val();
							}
						}
						else if((gb_skuName === "USB7250") || (gb_skuName === "USB7251") || (gb_skuName === "USB7252"))
						{
							if(port === 5)
							{
								widgetgroupname = '#' + "port5splitting" + "group";
								portsplitval = $(widgetgroupname).find(':checked').val();
								
							}
						}
						
						if(portsplitval == 0)
						{
							var Customer_Port = 0;
							if(gb_skuName === "USB7202")
							{
								Customer_Port = USB7202_PortMap[port] ;
							}
							else if(gb_skuName === "USB7250" || gb_skuName === "USB7251" || gb_skuName === "USB7252")
							{
								Customer_Port = USB725x_PortMap[port];
							}
							else if(gb_skuName === "USB7216" || gb_skuName === "USB7256")
							{
								Customer_Port = USB7256_PortMap[port];
							}
							else if(gb_skuName === "USB7206")
							{
								Customer_Port = USB7206_PortMap[port];
							}
							alert("USB2.0 port of Port"
									+ Customer_Port
									+ "cannot be disabled, when USB3.1 Gen2 port is still in enabled state");
							enable_nav_fields();
							return;
						}
					}
				}
				if ((abUSB2PortEnable[port] == 0)
						&& (enableportOldVal[port] == 1)) 
				{
					// Non -removable
					nrwidget = "nrdeviceport" + port.toString();
					nrport = getWidgetValue(gb_HUB_ID, nrwidget);
					NROldVal[port] = nrport;
					// If port is disabled, force nr to 0
					if ((nrport != 0)) 
					{
						NRModified[port] = true;
						deltaobj.push(nrwidget, 0);
					} 
					else if ((NROldVal[port] == 0)
							|| (abnrcurrentval[port] != 0)) 
					{
						// do nothing. if current val of nr is 1 but port is
						// disabled
					}

					// Port Swap
					swapwidget = "swapport" + port.toString() + "dpdm";
					dpdmSwap = getWidgetValue(gb_HUB_ID, swapwidget);
					if ((dpdmSwap != 0)) 
					{
						SwapModified[port] = true;
						deltaobj.push(swapwidget, 0);
					} 
					else if ((dpdmSwap == 0)
							|| (abPortSwapcurrentval[port] != 0)) 
					{
						// do nothing. if current val of nr is 1 but port is
						// disabled
					}
					// Phyboost
					phyboostwidget = "PHYBOOSTdownstreamport" + port.toString();
					phyboost = getWidgetValue(gb_HUB_ID, phyboostwidget);

					if (phyboost != 0) {
						PhyBoostModified[port] = true;
						deltaobj.push(phyboostwidget, 0);
					} 
					else if ((phyboost == 0)
							|| (abPhyboostcurrentval[port] != 0)) 
					{
						// do nothing. if current val of phyboost is not 0 but
						// port is disabled
					}

					// Varisense
					varisensewidget = "SQUELCHdownstreamport" + port.toString();
					varisense = getWidgetValue(gb_HUB_ID, varisensewidget);
					if (varisense != 0) {
						VarisenseModified[port] = true;
						deltaobj.push(varisensewidget, 0);
					} 
					else if ((varisense == 0)
							|| (abSQUELCHcurrentval[port] != 0)) 
					{
						// do nothing. if current val of squelch is not 0 but
						// port is disabled
					}

					// risefall
					hsrisefallwidget = "downstreamport" + port.toString()
							+ "HsRiseFall";
					hsrisefall = getWidgetValue(gb_HUB_ID, hsrisefallwidget);
					if (hsrisefall != 0) 
					{
						RiseFallModified[port] = true;
						deltaobj.push(hsrisefall, 0);
					} 
					else if ((hsrisefall == 0)
							|| (abHSRiseFallcurrentval[port] != 0)) 
					{
						// do nothing. if current val of hsrisefall is not 0 but
						// port is disabled
					}

				} 
				else 
				{
					nrwidget = "nrdeviceport" + port.toString();
					if (abnrcurrentval[port] != getWidgetValue(gb_HUB_ID,nrwidget)) 
					{
						if (NRModified[port] == true) 
						{
							// do nothing. since nr port for this port is forced
							// to 0 in above steps
						} 
						else 
						{
							deltaobj.push(nrwidget, abnrcurrentval[port]);
							modifiedWidgets.push(nrwidget);
						}
					}
					
					swapwidget = "swapport" + port.toString() + "dpdm";
					if (abPortSwapcurrentval[port] != getWidgetValue(gb_HUB_ID,swapwidget)) 
					{
						if (SwapModified[port] == true) 
						{
							// do nothing. since swap port for this port is
							// forced to 0 in above steps
						} 
						else 
						{
							deltaobj.push(swapwidget, abPortSwapcurrentval[port]);
							modifiedWidgets.push(swapwidget);
						}
					}
					
					
					phyboostwidget = "PHYBOOSTdownstreamport" + port.toString();
					if (abPhyboostcurrentval[port] != getWidgetValue(gb_HUB_ID,phyboostwidget)) 
					{
						if (PhyBoostModified[port] == true) 
						{
							// do nothing. since swap port for this port is
							// forced to 0 in above steps
						} 
						else 
						{
							deltaobj.push(phyboostwidget,
									abPhyboostcurrentval[port]);
							modifiedWidgets.push(phyboostwidget);
						}
					}
					
					
					varisensewidget = "SQUELCHdownstreamport" + port.toString();
					if (abSQUELCHcurrentval[port] != getWidgetValue(gb_HUB_ID,varisensewidget)) 
					{
						if (VarisenseModified[port] == true) 
						{
							// do nothing. since swap port for this port is
							// forced to 0 in above steps
						} 
						else 
						{
							deltaobj.push(varisensewidget,
									abSQUELCHcurrentval[port]);
							modifiedWidgets.push(varisensewidget);
						}
					}
					
					
					hsrisefallwidget = "downstreamport" + port.toString() + "HsRiseFall";
					if (abHSRiseFallcurrentval[port] != getWidgetValue(gb_HUB_ID, hsrisefallwidget)) 
					{
						if (RiseFallModified[port] == true) 
						{
							// do nothing. since swap port for this port is
							// forced to 0 in above steps
						} 
						else 
						{
							deltaobj.push(hsrisefallwidget,
									abHSRiseFallcurrentval[port]);
							modifiedWidgets.push(hsrisefallwidget);
						}
					}
				}
				if(port <=5 ) //USB3 port can be maximum at port5
				{
					if ((abUSB3PortEnable[port] == 0) && (usb3enableportOldVal[port] == 1)) 
					{
						usb3nrwidget = "usb3nrdeviceport" + port.toString();
						USB3NROldVal[port] = getWidgetValue(gb_HUB_ID, usb3nrwidget);
						// If port is disabled, force nr to 0
						if ((USB3NROldVal[port] != 0) || (abusb3nrcurrentval[port] != 0)) 
						{
							usb3nrwidgetchanged = true;
							USB3NRModified[port] = true;
							deltaobj.push(usb3nrwidget, 0);
						}
					} 
					else 
					{
						usb3nrwidget = "usb3nrdeviceport" + port.toString();
						if (abusb3nrcurrentval[port] != getWidgetValue(gb_HUB_ID, usb3nrwidget)) 
						{
							if (USB3NRModified[port] == true) 
							{
								// do nothing. since nr port for this port is forced
								// to 0 in above steps
							} 
							else 
							{
								usb3nrwidgetchanged = true;
								deltaobj.push(usb3nrwidget, abusb3nrcurrentval[port]);
								modifiedWidgets.push(usb3nrwidget);
							}
						}
					}
				}

			}
		}
		// Do remapping if there is a change in port state
		if ((abUSB2PortEnable[1] != enableportOldVal[1])
				|| (abUSB2PortEnable[2] != enableportOldVal[2])
				|| (abUSB2PortEnable[3] != enableportOldVal[3])
				|| (abUSB2PortEnable[4] != enableportOldVal[4])
				|| (abUSB2PortEnable[5] != enableportOldVal[5])
				|| (abUSB2PortEnable[6] != enableportOldVal[6])
				|| (abUSB3PortEnable[1] != usb3enableportOldVal[1])
				|| (abUSB3PortEnable[2] != usb3enableportOldVal[2])
				|| (abUSB3PortEnable[3] != usb3enableportOldVal[3])
				|| (abUSB3PortEnable[4] != usb3enableportOldVal[4])
				|| (abUSB3PortEnable[5] != usb3enableportOldVal[5])) 
		{

			// Use Fw logic to do port remapping
			var byUSB2PortDis = 0;
			var byUSB3PortDis = 0;

			var BIT = [ 0x00000001, 0x00000002, 0x00000004, 0x00000008,
					0x00000010, 0x00000020, 0x00000040, 0x00000080 ];
			var HUB_PORT_BIT = [0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80];
			var HUB_PORT_6 = 0x40;
			var HUB_PORT_5 = 0x20;
			var HUB_PORT_4 = 0x10;
			var HUB_PORT_3 = 0x08;
			var HUB_PORT_2 = 0x04;
			var HUB_PORT_1 = 0x02;

			// Disabled ports are calculated based on customer docs (i.e - Tool display)
			if (gb_skuName == "USB7202") 
			{
				byUSB2PortDis = (BIT[5] | BIT[7]); //4 DFP
				byUSB3PortDis = (BIT[3] | BIT[4] | BIT[5] | BIT[6] | BIT[7]); // Only first 2 ports has 3.0
			}
			if (gb_skuName === "USB7250" || gb_skuName === "USB7251"
					|| gb_skuName === "USB7252") 
			{
				byUSB2PortDis = (BIT[5] | BIT[7]); //4 DFP
				byUSB3PortDis = (BIT[4] | BIT[5] | BIT[6] | BIT[7]); // First 3 ports has 3.0
			}
			if (gb_skuName === "USB7216" || gb_skuName === "USB7206" || gb_skuName === "USB7256") 
			{
				byUSB2PortDis = (BIT[7]); //6 DFP
				
				if(gb_skuName === "USB7216" || gb_skuName === "USB7256")
				{
					byUSB3PortDis = (BIT[5] | BIT[6] | BIT[7]); // First 4 ports has 3.0
				}
				else if(gb_skuName === "USB7206")
				{
					byUSB3PortDis = (BIT[6] | BIT[7]); // First 5 ports has 3.0
				}
			}
			// Based on current user disabled ports, update byUSB2PortDis and
			// byUSB3PortDis
			// var ports used in for loop is as per DOS (i.e - Continuous div in UI)
			for (var ports = 1; ports <= USB2PhysicalPortMax; ports++) 
			{
				if (abUSB2PortEnable[ports] == 0) // disable
				{
					if (gb_skuName == "USB7202") 
					{
						if (((ports == 5) || (ports == 7))) 
						{
							// do nothing
						} 
						else 
						{
							if(ports == 2)
							{
								byUSB2PortDis |= BIT[3];
							}
							else if(ports == 3)
							{
								byUSB2PortDis |= BIT[2];
							}
							else
							{
								byUSB2PortDis |= BIT[ports];
							}
						}
					}
					if (gb_skuName == "USB7250" || gb_skuName == "USB7251"
							|| gb_skuName == "USB7252") 
					{
						if ((ports == 4) || (ports == 7)) 
						{
							// do nothing
						} 
						else 
						{
							if(ports == 2)
							{
								byUSB2PortDis |= BIT[4];
							}
							else if(ports == 3)
							{
								byUSB2PortDis |= BIT[2];
							}
							else if(ports == 5)
							{
								byUSB2PortDis |= BIT[3];
							}
							else
							{
								byUSB2PortDis |= BIT[ports];
							}
						}
					}
					if (gb_skuName === "USB7216" || gb_skuName === "USB7206" || gb_skuName === "USB7256") 
					{
						if (ports == 7) 
						{
							// do nothing
						} 
						else 
						{
							if(gb_skuName === "USB7216" || gb_skuName === "USB7256")
							{
								if(ports == 2)
								{
									byUSB2PortDis |= BIT[5];
								}
								else if(ports == 3)
								{
									byUSB2PortDis |= BIT[2];
								}
								else if(ports == 4)
								{
									byUSB2PortDis |= BIT[3];
								}
								else if(ports == 5)
								{
									byUSB2PortDis |= BIT[4];
								}
								else
								{
									byUSB2PortDis |= BIT[ports];
								}
							}
							else if(gb_skuName === "USB7206")
							{
								byUSB2PortDis |= BIT[ports];
							}
						}
					}
				}
				if (abUSB3PortEnable[ports] == 0) // usb3 disable
				{
					if ((gb_skuName == "USB7202")) 
					{
						if ( (ports ==2) || (ports == 4)
							|| (ports == 5) || (ports == 6)
							|| (ports === 7)) 
						{
							// do nothing
						} 
						else 
						{
							if(ports == 3)
							{
								byUSB3PortDis |= BIT[2];
							}
							else
							{
								byUSB3PortDis |= BIT[ports];
							}
						}
					}
					if (gb_skuName == "USB7250" || gb_skuName == "USB7251"
							|| gb_skuName == "USB7252") 
					{
						if ((ports == 2) || (ports == 4)
							|| (ports == 6) || (ports === 7)) 
						{
							// do nothing
						} 
						else 
						{
							if(ports == 3)
							{
								byUSB3PortDis |= BIT[2];
							}
							else if(ports == 5)
							{
								byUSB3PortDis |= BIT[3];
							}
							else
							{
								byUSB3PortDis |= BIT[ports];
							}
						}
					}
					if (gb_skuName === "USB7216" || gb_skuName === "USB7206" || gb_skuName === "USB7256")
					{
						if (gb_skuName === "USB7216" || gb_skuName === "USB7256")
						{
							if ((ports == 2) || (ports == 6)
									|| (ports === 7)) 
							{
								// do nothing
							} else 
							{
								if(ports == 3)
								{
									byUSB3PortDis |= BIT[2];
								}
								else if(ports == 4)
								{
									byUSB3PortDis |= BIT[3];
								}
								else if(ports == 5)
								{
									byUSB3PortDis |= BIT[4];
								}
								else
								{
									byUSB3PortDis |= BIT[ports];
								}
							}
						}
						if (gb_skuName === "USB7206")
						{
							if ((ports == 6)
									|| (ports === 7)) 
							{
								// do nothing
							} else 
							{
								byUSB3PortDis |= BIT[ports];
							}
						}
					}
				}
			}
			var byUSB2PortDisnew = byUSB2PortDis.toString(16);
			var byUSB3PortDisnew = byUSB3PortDis.toString(16);

			var byUSB3PortDishex = parseInt(byUSB3PortDisnew, 16);
			var byUSB2PortDishex = parseInt(byUSB2PortDisnew, 16);

			var byLogicalPort = 1, byusb3LogicalPort = 1;
			var USB3EnableVal = 0xFF - byUSB3PortDishex;
			var USB2EnableVal = 0xFF - byUSB2PortDishex;
				
			var USB3USB2SameEnabledPorts = USB2EnableVal & USB3EnableVal ;
			var USB3UnMappedPorts = 0;
			var USB2UnMappedPorts =0;
			if(USB3USB2SameEnabledPorts > USB3EnableVal)
			{
				USB3UnMappedPorts = USB3USB2SameEnabledPorts - USB3EnableVal;
			}
			else
			{
				USB3UnMappedPorts = USB3EnableVal - USB3USB2SameEnabledPorts;
			}
			if(USB3USB2SameEnabledPorts > USB2EnableVal)
			{
				USB2UnMappedPorts = USB3USB2SameEnabledPorts - USB2EnableVal;
			}
			else
			{
				USB2UnMappedPorts = USB2EnableVal - USB3USB2SameEnabledPorts;
			}
				
			usb2portmapping[1] = (USB3USB2SameEnabledPorts & 0x02) ? byLogicalPort++ : 0x00;
			usb3portmapping[1] = (USB3USB2SameEnabledPorts & 0x02) ? byusb3LogicalPort++ : 0x00;
			
			usb2portmapping[2] = (USB3USB2SameEnabledPorts & 0x04) ? byLogicalPort++ : 0x00;
			usb3portmapping[2] = (USB3USB2SameEnabledPorts & 0x04) ? byusb3LogicalPort++ : 0x00;
			
			usb2portmapping[3] = (USB3USB2SameEnabledPorts & 0x08) ? byLogicalPort++ : 0x00;
			usb3portmapping[3] = (USB3USB2SameEnabledPorts & 0x08) ? byusb3LogicalPort++ : 0x00;
			
			usb2portmapping[4] = (USB3USB2SameEnabledPorts & 0x10) ? byLogicalPort++ : 0x00;
			usb3portmapping[4] = (USB3USB2SameEnabledPorts & 0x10) ? byusb3LogicalPort++ : 0x00;
			
			usb2portmapping[5] = (USB3USB2SameEnabledPorts & 0x20) ? byLogicalPort++ : 0x00;
			usb3portmapping[5] = (USB3USB2SameEnabledPorts & 0x20) ? byusb3LogicalPort++ : 0x00;
			
			usb2portmapping[6] = (USB3USB2SameEnabledPorts & 0x40) ? byLogicalPort++ : 0x00;
			usb3portmapping[6] = (USB3USB2SameEnabledPorts & 0x40) ? byusb3LogicalPort++ : 0x00;

			for(var i= 1; i<=6; i++)
			{
				if(usb3portmapping[i] === 0)
				{
					usb3portmapping[i] = (USB3UnMappedPorts & HUB_PORT_BIT[i]) ? byusb3LogicalPort++ : 0x00;
				}
				if(usb2portmapping[i] === 0)
				{
					usb2portmapping[i] = (USB2UnMappedPorts & HUB_PORT_BIT[i]) ? byLogicalPort++ : 0x00;
				}
			}
		
			var hcestate = $('#hceenable').is(':checked');
			if (hcestate === true) 
			{
				usb2portmapping[7] = byLogicalPort;
			}
			
			if(gb_skuName == "USB7202")
			{
				// DOS port 2 is customer Doc port 3 and DOS port 3 is customer Doc port 2
				// So swap the value here
				var temp2 = usb2portmapping[2];
				var temp3 = usb2portmapping[3];
				usb2portmapping[2] = temp3;
				usb2portmapping[3] = temp2;
				
				temp2 = usb3portmapping[2];
				temp3 = usb3portmapping[3];
				
				usb3portmapping[2] = temp3;
				usb3portmapping[3] = temp2;
			}
			if (gb_skuName == "USB7250" || gb_skuName == "USB7251"
							|| gb_skuName == "USB7252")
			{
				// So swap the value here
				var temp2 = usb2portmapping[2];
				var temp3 = usb2portmapping[3];
				var temp4 = usb2portmapping[4];
				
				usb2portmapping[2] = temp4
				usb2portmapping[3] = temp2;
				usb2portmapping[4] = 0x00;
				usb2portmapping[5] = temp3;
				
				temp2 = usb3portmapping[2];
				temp3 = usb3portmapping[3];
				temp4 = usb3portmapping[4];
				
				usb3portmapping[2] = temp4
				usb3portmapping[3] = temp2;
				usb3portmapping[4] = 0x00;
				usb3portmapping[5] = temp3;
			} 
			if(gb_skuName === "USB7216" || gb_skuName === "USB7256")
			{
				var temp2 = usb2portmapping[2];
				var temp3 = usb2portmapping[3];
				var temp4 = usb2portmapping[4];
				var temp5 = usb2portmapping[5];
				
				usb2portmapping[2] = temp5;
				usb2portmapping[3] = temp2;
				usb2portmapping[4] = temp3;
				usb2portmapping[5] = temp4;
				
				temp2 = usb3portmapping[2];
				temp3 = usb3portmapping[3];
				temp4 = usb3portmapping[4];
				temp5 = usb3portmapping[5];
				
				usb3portmapping[2] = temp5;
				usb3portmapping[3] = temp2;
				usb3portmapping[4] = temp3;
				usb3portmapping[5] = temp4;
			}
			var portmapping, usb3portmappingwid;
			var usb2portmappingOldVal = [ 0, 0, 0, 0, 0, 0, 0 ];
			// send widget and values to backend. Maximum teton ports is 7, so
			// checking for 7 since we required for UDC also
			for (var ports = 1; ports <= 7; ports++) 
			{
				portmapping = "port" + ports.toString() + "mapping";

				deltaobj.push(portmapping, usb2portmapping[ports]);
				if((abUSB2PortEnable[ports] != enableportOldVal[ports]))
				{
					if(ports == 7)
					{
						//UI does not have div for port 7
					}
					else
					{
						modifiedWidgets.push(portmapping);
					}
				}
			}
			for (var ports = 1; ports <= USB2PhysicalPortMax; ports++) 
			{
				enableportwidget = "enableport" + ports.toString();
				usb3enableportwidget = "usb3enableport" + ports.toString();
				deltaobj.push(enableportwidget, abUSB2PortEnable[ports]);
				if((abUSB2PortEnable[ports] != enableportOldVal[ports]))
				{
					modifiedWidgets.push(enableportwidget);
				}
				usb3portmappingwid = "usb3port" + ports.toString() + "mapping";

				if(ports <=5) //usb3 is present maximum at port5
				{
					deltaobj.push(usb3enableportwidget,abUSB3PortEnable[ports]);
					deltaobj.push(usb3portmappingwid,usb3portmapping[ports]);
			
					if(abUSB3PortEnable[ports] != usb3enableportOldVal[ports])
					{
						modifiedWidgets.push(usb3enableportwidget);
						modifiedWidgets.push(usb3portmappingwid);
					}
				}	
			}
			deltaobj.push("usb3numberofports", (byusb3LogicalPort - 1));
			//modifiedWidgets.push("usb3numberofports");

		} 
		else 
		{
			var usb3mapping = 1;
			// Port mapping of USB3 is necessary to update USB3 NR
			usb3portmapping[1] = (abUSB3PortEnable[1] == 1) ? usb3mapping++ : 0x00;
			usb3portmapping[2] = (abUSB3PortEnable[2] == 1) ? usb3mapping++ : 0x00;
			usb3portmapping[3] = (abUSB3PortEnable[3] == 1) ? usb3mapping++ : 0x00;
			usb3portmapping[4] = (abUSB3PortEnable[4] == 1) ? usb3mapping++ : 0x00;
			usb3portmapping[5] = (abUSB3PortEnable[5] == 1) ? usb3mapping++ : 0x00;
		}
		if ((usb3nrwidgetchanged === true) || (abUSB3PortEnable[1] != usb3enableportOldVal[1])
				|| (abUSB3PortEnable[2] != usb3enableportOldVal[2])
				|| (abUSB3PortEnable[3] != usb3enableportOldVal[3])
				|| (abUSB3PortEnable[5] != usb3enableportOldVal[5]))  
		{
			var usb3nrdev = 0;
			usb3nrdev |= (abusb3nrcurrentval[1] == 1) ? (1 << usb3portmapping[1]) : 0x00;
			usb3nrdev |= (abusb3nrcurrentval[2] == 1) ? (1 << usb3portmapping[2]) : 0x00;
			usb3nrdev |= (abusb3nrcurrentval[3] == 1) ? (1 << usb3portmapping[3]) : 0x00;
			usb3nrdev |= (abusb3nrcurrentval[4] == 1) ? (1 << usb3portmapping[4]) : 0x00;
			usb3nrdev |= (abusb3nrcurrentval[5] == 1) ? (1 << usb3portmapping[5]) : 0x00;
			usb3nrdev = usb3nrdev.toString(16);
			deltaobj.push("usb3nrdevice", usb3nrdev);
			//modifiedWidgets.push("usb3nrdevice");
		}

		// setwidget GwidgetlistHex starts
		$.each(GwidgetlistHex,function(index, widgetName) 
		{
			var widgetid = "#" + widgetName;
			var oldval;
			var newval;
			var isValid;

			if (widgetName === "usbvcd"
					|| widgetName === "usb3vcd") 
			{
				// Backend Values are in Int
				// UI values are in HEX
				var oldval = parseInt(getWidgetValue(gb_HUB_ID, widgetName), 10);
				oldval = oldval.toString(16);
				var strnewval = $(widgetid).val();
				strnewval = strnewval.replace('.', '');
				newval = parseInt(strnewval, 16);
				newval = newval.toString(16);

			} 
			else 
			{

				var ioldval = parseInt(getWidgetValue(gb_HUB_ID, widgetName), 10);
				var stroldval = ioldval.toString(16);
				oldval = "0x" + stroldval
				var strxnewval = $(widgetid).val();
				var inewval = parseInt(strxnewval, 16);
				strxnewval = inewval.toString(16);
				newval = "0x" + strxnewval;
			}
			if (oldval != newval) 
			{
				// Check for language ID DO WE NEED to DO this
				if ((widgetName == "languageid"
						|| widgetName == "usb3languageid"
						|| widgetName == "hce_languageid"
						|| widgetName == "hce1_languageid" || widgetName == "hce2_languageid")) 
				{
					if (newval == "0x0") 
					{
						alert("Language ID cannot be zero. Setting it to default value (0x409)");
						newval = parseInt("0x409", 16);
					}
				}

				// Adding the VID of USB2.0 and HCE to
				// Protouch2.ini, if they are modified.
				if ((widgetName == "vid")
						|| (widgetName == "usb3vid")
						|| (widgetName == "hce_vid")
						|| (widgetName == "hce1_vid")
						|| (widgetName == "hce2_vid")) 
				{

					var xval = $(widgetid).val();
					var strxval = "0x" + xval;
					updateINI(strxval);
					// if pid of USB2.0 or Hub controller is
					// modified, then increase the time out.
					vid_pidModified = true;
				}

				// if vid of hub or Hub controller is modified,
				// then increase the time out.
				if ((widgetName == "pid")
						|| (widgetName == "usb3pid")
						|| (widgetName == "hce_pid")
						|| (widgetName == "hce1_pid")
						|| (widgetName == "hce2_pid")) 
				{

					vid_pidModified = true;
				}

				deltaobj.push(widgetName, newval);
				modifiedWidgets.push(widgetName);

			}

		});
		// setwidget GwidgetlistHex ends

		// setwidget GwidgetlistInt starts
		$.each(GwidgetlistInt,function(index, widgetName) 
		{
			var widgetid = "#" + widgetName;
			var oldval = getWidgetValue(gb_HUB_ID, widgetName);
			var strxnewval;

			if (widgetName == "hub3maxpowerselfbus") 
			{
				oldval = parseInt(oldval, 10) * 8;
			} else if ((widgetName == "hubcmaxpowerself")
					|| (widgetName == "hubcmaxpowerbus")) 
			{
				oldval = parseInt(oldval, 10);
			} 
			else 
			{
				oldval = parseInt(oldval, 10) * 2;
			}

			var that = $(widgetid), parent = that.closest('fieldset');
			var checkdisabled = $(parent).prop("disabled");

			var newval = $(widgetid).val();
			var newdecvalue = parseInt(newval, 10);
			newdecvalue = newdecvalue & 0xff;
			if ((widgetName == "hub3maxpowerselfbus")
					|| (widgetName == "maxpowerself")
					|| (widgetName == "maxpowerbus")) 
			{
				if ((newdecvalue & 0x01) && !checkdisabled) 
				{
					currentvalue = "ODDNUM";
					return;
				}
			}

			if ((oldval == newval) || isNaN(newval)) 
			{
				// do nothing - no change in value
			} 
			else if (checkdisabled) 
			{
				// Change detected but field is disabled - So do
				// nothing
			} 
			else 
			{
				if ((widgetName == "maxpowerself")
						|| (widgetName == "hubcmaxpowerself")) 
				{
					if ((newval > 100) || (newval < 0)) 
					{
						alert("USB2.0 max power(self) or USB2.0 hub circuit max power(self) cannot be more than 100mA or negative.");
						update_status_message("USB2.0 max power(self) or USB2.0 hub circuit max power(self) cannot be more than 100mA or negative.");
						errorFlag = true;
						return;
					}
				}

				if (widgetName == "maxpowerbus") 
				{
					if ((newval > 500) || (newval < 0)) {
						alert("USB2.0 max power(bus) cannot be more than 500mA or negative.");
						update_status_message("USB2.0 max power(bus) cannot be more than 500mA or negative.");
						errorFlag = true;
						return;
					}
				}

				if (widgetName == "hubcmaxpowerbus") 
				{
					if ((newval > 255) || (newval < 0)) {
						alert("USB2.0 hub circuit max power(bus) cannot be more than 255mA or negative.");
						update_status_message("USB2.0 hub circuit max power(bus) cannot be more than 255mA or negative.");
						errorFlag = true;
						return;
					}
				}

				if (widgetName == "hub3maxpowerselfbus") 
				{
					if ((newval > 900) || (newval < 0)) {
						alert("USB3.1 Gen2 hub max power cannot be more than 900mA or negative.");
						update_status_message("USB3.1 Gen2 hub max power cannot be more than 900mA or negative.");
						errorFlag = true;
						return;
					}
				}
				var hexval;
				if (widgetName == "hub3maxpowerselfbus") 
				{
					var newdecvalue = parseInt(newval, 10);
					var reminder = newdecvalue % 8;
					if (reminder != 0) 
					{
						alert("Hub Max Power 3.1 Gen2 field can have multiples of 8 only");
						var mesg = "Error : Hub Max Power 3.1 Gen2 field can have multiples of 8 only";
						update_status_message(mesg);
						errorFlag = true;
						return;
					}
					newdecvalue = newdecvalue / 8;
					var temp = Math.floor(newdecvalue);
					hexval = temp.toString(16);
				} 
				else if ((widgetName == "hubcmaxpowerbus")
						|| (widgetName == "hubcmaxpowerself")) 
				{
					newdecvalue = parseInt(newval, 10);
					hexval = newdecvalue.toString(16);
				} 
				else 
				{
					newdecvalue = parseInt(newval, 10);
					newdecvalue = newdecvalue / 2;
					hexval = newdecvalue.toString(16);
				}
				deltaobj.push(widgetName, hexval);
				modifiedWidgets.push(widgetName);
			}
		});
		if (currentvalue == "ODDNUM") 
		{
			$("#progID").hide();
			alert("\"Hub MaxPower(Self)\", \"Hub Circuit MaxPower(Self)\", \"HubMaxPower(Bus)\" and \"Hub Circuit MaxPower(Bus)\" fields can have even numbers only");
			var mesg = "Error : \"Hub MaxPower(Self)\", \"Hub Circuit MaxPower(Self)\", \"Hub MaxPower(Bus)\" and \"Hub Circuit MaxPower(Bus)\" fields can have even numbers only";
			update_status_message(mesg);
			currentvalue = "NONE";
			errorFlag = true;
			return;
		}
		// setwidget GwidgetlistInt ends

		// setwidget GwidgetlistRadio Start
		$.each(GwidgetlistRadio, function(index, widgetName) 
		{
			var widgetgroupname = '#' + widgetName + "group";
			var oldval = getWidgetValue(gb_HUB_ID, widgetName);
			var newval = $(widgetgroupname).find(':checked').val();
			var that = $(widgetgroupname), parent = that.closest('fieldset');
			var checkdisabled = $(parent).prop("disabled");

			if (widgetName === "downstreamBCsettingport1"
					|| widgetName === "downstreamBCsettingport2"
					|| widgetName === "downstreamBCsettingport3"
					|| widgetName === "downstreamBCsettingport4"
					|| widgetName === "downstreamBCsettingport5"
					|| widgetName === "downstreamBCsettingport6")					
			{

				if (oldval != 0 && oldval != 1 && oldval != 2) // Default
																// values will
																// be 0,1,2
				{
					oldval = "3";
				}

			}
			if ((oldval === newval) || jQuery.isEmptyObject(newval)) 
			{

				// do nothing
				// If Port splitting is already enabled and only GPIO needs to
				// be updated
			} 
			else if (checkdisabled) 
			{
				// Change detected but field is disabled - So do nothing
				console.log("change detected but field disabled: widget:"
						+ widgetgroupname + " new value:" + newval);
			} 
			else 
			{
				deltaobj.push(widgetName, newval);
				modifiedWidgets.push(widgetName);

				// TBD
				/*if (widgetName == "pstimeout") 
				{
					if (portSplittimeoutinclude) {
						deltaobj.push(widgetName, newval);
						modifiedWidgets.push(widgetName);
						portSplittimeoutinclude = false;
					}
				}*/
			}

		});
		// setwidget GwidgetlistRadio ends

		// setwidget GwidgetlistCheckbox starts
		$.each(GwidgetlistCheckbox,function(index, widgetName) 
		{
			var widgetid = "#" + widgetName;
			var oldval = getWidgetValue(gb_HUB_ID, widgetName);
			var newval = checkbox_unchecked_value;
			var that = $(widgetid), parent = that
					.closest('fieldset');
			var checkdisabled = $(parent).prop("disabled");
			if ($(widgetid).is(':checked')) 
			{
				newval = checkbox_checked_value;
			}
			// Enabled - check the previous value and determine
			// delta
			if (oldval == newval) 
			{
				// do nothing - no change in value
			} 
			else 
			{
				if (widgetName == "lpmenable") 
				{
					alert("The change in LPM Enable will cause change in the USB bcdUSB");
					deltaobj.push("lpmenable", newval);
				}
				// if (widgetName == "flexconnect") 
				// {
					// if ($('#flexconnect').is(':checked')) 
					// {
						// alert("Enabling Flexconnect will swap Downstream port  with Upstream port. Please make required changes in hub for further processing after successful programming");
						// gb_enableFlex = true;
					// } 
					// else 
					// {
						// alert("Disabling Flexconnect will swap Downstream port with Upstream port. Please make required changes in hub for further processing after successful programming");
						// gb_disableFlex = true;
					// }
				// }
				if (widgetName == "swapupstreamdpdm") 
				{
					if ($('#swapupstreamdpdm').is(':checked')) 
					{
						alert("Programming Upstream swap will swap D+ and D- lines of Upstream port. Please make the required changes in hub for further processing after successful programming");
					}
					gb_enable_swapupstreamdpdm = true;
				}
				//if (widgetName != "flexconnect" && widgetName != "usb3flexconnect") 
				//{
					if ((widgetName === "nrdeviceport1")
							|| (widgetName === "nrdeviceport2")
							|| (widgetName === "nrdeviceport3")
							|| (widgetName === "nrdeviceport4")
							|| (widgetName === "nrdeviceport5")
							|| (widgetName === "nrdeviceport6")
							|| (widgetName === "usb3nrdeviceport1")
							|| (widgetName === "usb3nrdeviceport2")
							|| (widgetName === "usb3nrdeviceport3")
							|| (widgetName === "usb3nrdeviceport4")
							|| (widgetName === "usb3nrdeviceport5")
							|| (widgetName === "swapport1dpdm")
							|| (widgetName === "swapport2dpdm")
							|| (widgetName === "swapport3dpdm")
							|| (widgetName === "swapport4dpdm")
							|| (widgetName === "swapport5dpdm")
							|| (widgetName === "swapport6dpdm")
							|| (widgetName === "enableport1")
							|| (widgetName === "enableport2")
							|| (widgetName === "enableport3")
							|| (widgetName === "enableport4")
							|| (widgetName === "enableport5")
							|| (widgetName === "enableport6")
							|| (widgetName === "usb3enableport1")
							|| (widgetName === "usb3enableport2")
							|| (widgetName === "usb3enableport3")
							|| (widgetName === "usb3enableport4")
							|| (widgetName === "usb3enableport5")) 
					{
						// do nothing. since value of these
						// checkboxes may be forced to 0 based
						// on state of port
						// handled down
					} 
					else 
					{
						deltaobj.push(widgetName, newval);
						modifiedWidgets.push(widgetName);
					}
				//}
				// else 
				// {
					// var nameofcontrol = "." + "flexport" + "1";
					// var nameofcontrol1 = "[data-bind=\"" + "flexport"+ "label\"]";
					// var selText = $(nameofcontrol).find(nameofcontrol1).text();
					// var flxport = DropDownflexport.indexOf(selText);
					// if((gb_skuName == "USB7250" || gb_skuName == "USB7251" || gb_skuName == "USB7252") && (flxportName == "4"))
					// {
						// flxport = "5"; //Port 4 is not available
					// }
					// if(widgetName === "flexconnect")
					// {
						// modifiedWidgets.push(widgetName);
						// deltaobj.push(widgetName,newval);
							
						// if ((!$('#flexconnect').is(':checked'))) 
						// {
							// modifiedWidgets.push("flexport");
							// deltaobj.push("flexport","0");
						// }
						// else //checked
						// {
							// deltaobj.push("flexport", flxport);
							// modifiedWidgets.push("flexport");
						// }
						
					// }	
					// if(widgetName == "usb3flexconnect")
					// {
						// modifiedWidgets.push(widgetName);
						// deltaobj.push(widgetName,newval);
							
						// if ((!$('#usb3flexconnect').is(':checked'))) 
						// {
							// modifiedWidgets.push("usb3flexport");
							// deltaobj.push("usb3flexport","0");
						// }
						// else
						// {
							// deltaobj.push("usb3flexport", flxport); //push usb3flexport also
							// modifiedWidgets.push("usb3flexport");
						// }
					// }
				// }

			}
		});
		// setwidget GwidgetlistCheckbox ends
		
		// setwidget GwidgetlistString starts
		$.each(GwidgetlistString, function(index, widgetName) 
		{
			var widgetid = "#" + widgetName;
			var oldval = getWidgetValue(gb_HUB_ID, widgetName);
			var newval = $(widgetid).val();

			if (newval != oldval) 
			{
				if (jQuery.isEmptyObject(newval)) {

					newval = "";
				}
				deltaobj.push(widgetName, newval);
				modifiedWidgets.push(widgetName);
			}
		});
		// setwidget GwidgetlistString ends

		// setwidget GwidgetlistDropDown starts
		$.each(GwidgetlistDropDown, function(index2, value1) 
		{
			if (value1 === "PHYBOOSTdownstreamport1"
					|| value1 === "PHYBOOSTdownstreamport2"
					|| value1 === "PHYBOOSTdownstreamport3"
					|| value1 === "PHYBOOSTdownstreamport4"
					|| value1 === "PHYBOOSTdownstreamport5"
					|| value1 === "PHYBOOSTdownstreamport6"
					|| value1 === "SQUELCHdownstreamport1"
					|| value1 === "SQUELCHdownstreamport2"
					|| value1 === "SQUELCHdownstreamport3"
					|| value1 === "SQUELCHdownstreamport4"
					|| value1 === "SQUELCHdownstreamport5"
					|| value1 === "SQUELCHdownstreamport6"
					|| value1 === "downstreamport1HsRiseFall"
					|| value1 === "downstreamport2HsRiseFall"
					|| value1 === "downstreamport3HsRiseFall"
					|| value1 === "downstreamport4HsRiseFall"
					|| value1 === "downstreamport5HsRiseFall"
					|| value1 === "downstreamport6HsRiseFall")
					//|| value1 === "flexport") 
			{
				// do nothing
			} 
			else 
			{
				var nameofcontrol = "." + value1 + "1";
				var nameofcontrol1 = "[data-bind=\"" + value1 + "label\"]";
				var selText = $(nameofcontrol).find(nameofcontrol1).text();
				var newindexofdropdownlist;
				var that = $(nameofcontrol), parent = that.closest('fieldset');
				var checkdisabled = $(parent).prop("disabled");

				if (value1 === "PHYBOOST") 
				{
					newindexofdropdownlist = DropDownPHYBOOST.indexOf(selText);
				}
				if (value1 === "SQUELCH") 
				{
					newindexofdropdownlist = DropDownSQUELCH.indexOf(selText);
				}
				if (value1 === "upstreamHsRiseFall") 
				{
					newindexofdropdownlist = DropDownHSRiseFall.indexOf(selText);
				}
				// if (value1 === "flexport") 
				// {
					// gb_enableport = true;
					// newindexofdropdownlist = DropDownflexport.indexOf(selText);
					// if((gb_skuName == "USB7250" || gb_skuName == "USB7251" || gb_skuName == "USB7252") && (newindexofdropdownlist == "4"))
					// {
						// newindexofdropdownlist = "5"; //Port 4 is not available
					// }
					// if(($("#usb3flexconnect").is(':checked')) && ($("#flexconnect").is(':checked')))
					// {
						// deltaobj.push("usb3flexport", newindexofdropdownlist); //push usb3flexport also
						// modifiedWidgets.push("usb3flexport");
					// }
					// if(($("#usb3flexconnect").is(':checked')) && (!($("#flexconnect").is(':checked'))))
					// {
						// value1 = "usb3flexport";
					// }
				// }
				var oldval = getWidgetValue(gb_HUB_ID, value1);

				// TODO - Dropdown forced values
				if (newindexofdropdownlist != oldval) 
				{
					deltaobj.push(value1, newindexofdropdownlist);
					modifiedWidgets.push(value1);
				}
			}
		});
		var stringToSet = "";
		var wKey;
		var wVal;
		var flag = 0;
		if (deltaobj.length != 0) 
		{
			for (var i = deltaobj.length; i >= 0; i = i - 2) 
			{
				wKey = deltaobj[i];
				wVal = deltaobj[i + 1];
				if ((typeof wKey === 'undefined')
						|| (typeof wVal === 'undefined')) 
				{
					// Do nothing
				} 
				else 
				{
					stringToSet = wKey + ",,," + wVal + ";;;" + stringToSet;
					flag++;
				}
			}
		}
		if (iniFile) 
		{
			iniFile_fullPath = getFullPathINI();
			modifiedWidgets.push("xdataprogram");
			stringToSet = "xdataprogram,,," + iniFile_fullPath + ";;;"
					+ stringToSet;
			flag++;
		}

		if (($("#Regoperationgroup").find(':checked').val())
				&& ($("#Regaddress").val()) && ($("#Regvalue").val())) 
		{
			gb_more = true;
			var regOptionChosen = $("#Regoperationgroup").find(':checked').val();
			if (regOptionChosen == 0) 
			{
				Regop = "XMODE_WRITE_BYTE";
			} 
			else if (regOptionChosen == 1) 
			{
				Regop = "XMODE_SET_BITS";
			} 
			else if (regOptionChosen == 2) 
			{
				Regop = "XMODE_CLEAR_BITS"
			}

			var Regaddress = $("#Regaddress").val();
			var Regaddress = Regaddress.replace(/\s+/g, "");

			var RegValue = $("#Regvalue").val();
			var RegValue = RegValue.replace(/\s+/g, "");

			if (gb_RegString != "") 
			{
				gb_RegString = Regop + "+" + Regaddress + "+" + RegValue + "+" + gb_RegString;
			} 
			else 
			{
				gb_RegString = Regop + "+" + Regaddress + "+" + RegValue;
			}
		}
		if((gb_minihostruletype === "01") && (vidpid_vid != "") && (vidpid_pid != "") && (vidpid_conn != "") && (vidpid_ruleid != ""))
		{
			if(gb_vidpidString != "")
			{
				gb_vidpidString = vidpid_idx + "+" + vidpid_vid + "+" + vidpid_pid + "+" + vidpid_conn + "+"+ vidpid_ruleid + "+" + gb_vidpidString;
			}
			else
			{
				gb_vidpidString = vidpid_idx + "+" + vidpid_vid + "+" + vidpid_pid + "+" + vidpid_conn + "+"+ vidpid_ruleid;
			}
			gb_newvidpidrule = true;
		}
		if((gb_minihostruletype === "11") && (vidpidmask_vid != "") && (vidpidmask_pid != "") && (vidpidmask_vidpidmsk != "") && (vidpidmask_ruleid != "") && (vidpidmask_conn != ""))
		{
			if(gb_vidpidmaskString != "")
			{
				gb_vidpidmaskString = vidpidmask_idx + "+" + vidpidmask_vid + "+" + vidpidmask_pid + "+" + vidpidmask_vidpidmsk + "+" + vidpidmask_conn + "+"+ vidpidmask_ruleid + "+" + gb_vidpidmaskString;
			}
			else
			{
				gb_vidpidmaskString = vidpidmask_idx + "+" + vidpidmask_vid + "+" + vidpidmask_pid + "+" + vidpidmask_vidpidmsk + "+" + vidpidmask_conn + "+"+ vidpidmask_ruleid;
			}
			gb_newvipidmaskrule = true;
		}
		if((gb_minihostruletype === "10") && (deviceclass_class != "") && (deviceclass_conn != "") && (deviceclass_ruleid != ""))
		{
			if(gb_deviceclassString != "")
			{
				gb_deviceclassString = deviceclass_idx + "+"  +  deviceclass_class + "+" + deviceclass_conn + "+" + deviceclass_ruleid + "+" + gb_deviceclassString;
			}
			else
			{
				gb_deviceclassString = deviceclass_idx + "+"  +  deviceclass_class + "+" + deviceclass_conn + "+" + deviceclass_ruleid;
			}
			gb_newdeviceclassrule = true;
		}
		if (gb_more == true) 
		{
			// Use one more variable to store values even if preview changes is
			// clicked
			if (directRegString == "") 
			{
				directRegString = directRegString + gb_RegString;
			} 
			else if ((directRegString != "") && (gb_RegString != "")) 
			{
				directRegString = directRegString + "+" + gb_RegString;
			}
			stringToSet = "xdataentry,,," + directRegString + ";;;" + stringToSet;
			modifiedWidgets.push("xdataentry");
			flag++;
		}

		if ((cancelFlag) && (flag == 0)) 
		{
			stringToSet = newstringToSet;
			modifiedWidgets.push("xdataentry");
			flag++;
		}
		if(gb_newvidpidrule == true)
		{
			// Use one more variable to store values even if preview changes is
			// clicked
			if(vidpidrulevalues == "")
			{
				vidpidrulevalues = vidpidrulevalues + gb_vidpidString;
			}
			else if((vidpidrulevalues != "") && (gb_vidpidString != ""))
			{
				vidpidrulevalues = vidpidrulevalues + "+" + gb_vidpidString;
			}
			stringToSet = "minihost_vidpidrule,,," + gb_vidpidrulecnt + "+" + vidpidrulevalues + ";;;" + stringToSet;
			modifiedWidgets.push("minihost_vidpidrule");
			flag++;
		}
		if(gb_newvipidmaskrule == true)
		{
			// Use one more variable to store values even if preview changes is
			// clicked
			if(vidpidmaskrulevalues == "")
			{
				vidpidmaskrulevalues = vidpidmaskrulevalues + gb_vidpidmaskString;
			}
			else if((vidpidmaskrulevalues != "") && (gb_vidpidmaskString != ""))
			{
				vidpidmaskrulevalues = vidpidmaskrulevalues + "+" + gb_vidpidmaskString;
			}
			stringToSet = "minihost_vidpidmaskrule,,," + gb_vidpidmaskrulecnt + "+" + vidpidmaskrulevalues + ";;;" + stringToSet;
			modifiedWidgets.push("minihost_vidpidmaskrule");
			flag++;
		}
		if(gb_newdeviceclassrule == true)
		{
			// Use one more variable to store values even if preview changes is
			// clicked
			if(deviceclassrulevalues == "")
			{
				deviceclassrulevalues = deviceclassrulevalues + gb_deviceclassString;
			}
			else if((deviceclassrulevalues != "") && (gb_deviceclassString != ""))
			{
				deviceclassrulevalues = deviceclassrulevalues + "+" + gb_deviceclassString;
			}
			stringToSet = "minihost_deviceclassrule,,," + gb_deviceclassrulecnt + "+" + deviceclassrulevalues + ";;;" + stringToSet;
			modifiedWidgets.push("minihost_deviceclassrule");
			flag++;
		}
		
		// dont call service if no change
		if (gb_showPreview) 
		{
			gb_showPreview = false;
			if (flag != 0) 
			{
				var fileSize = previewSetWidgetValue(gb_HUB_ID, stringToSet);
				// Get Current OTP information
				var info = get_otp_info(gb_HUB_ID);
				if (info) 
				{
					var otp_info = info.split("###");
					var otpSize = otp_info[0];
					
					var previewPercentage = ((fileSize / otpSize) * 100)
							+ percentage;

					$("#progressbarPreview3").css('width',
							(previewPercentage).toFixed(2) + "%");
					$("#progressbarPreview3").css('color', 'black');
					$("#progressbarPreview3").css({
						'background-image' : 'none',
						'background-color' : 'yellow'
					});
					$("#progressbarPreview3").html(
							"<p align=\"center\">"
									+ (previewPercentage).toFixed(2) + "%"
									+ "<p>");

					$("#bytesProgrammed").val(fileSize);
					$('#previewChangesField').show();
				}
				update_status_message("No of bytes to be programmed: "
						+ fileSize + ". Percentage of OTP memory to be used: "
						+ previewPercentage.toFixed(2));
						
				enable_nav_fields();
					
				gb_vidpidString ="";
				gb_vidpidmaskString ="";
				gb_deviceclassString ="";
				gb_minihostruletype ="";
			} 
			else 
			{
				alert("No Changes detected. Cannot show preview.");
				enable_nav_fields();
			}
		} 
		else 
		{
			if (flag == 0 && errorFlag == false) 
			{
				enable_nav_fields();
				var mesg = "Device configuration will not be changed ; No changes detected";
				alert(mesg);				
				update_status_message(mesg);

			} 
			else 
			{
				if (errorFlag === false) 
				{
					if ((langid == "0") && (stringmodified == 1)) 
					{
						// print to the user that string is modified but
						// language id is not - so english is set as default
						var mesg = "String Descriptors are changed;But languageid is not - So setting language to US English(0x0409). Please change if language is not English";
						update_status_message(mesg);
						var widgetlang = "languageid";
						var englishus = "0x0409";
						stringToSet = widgetlang + ",,," + englishus + ";;;"
								+ stringToSet;
						modifiedWidgets.push(widgetlang);
					}
					// Check udc_langid
					if ((udc_langid == "0") && (udc_stringmodified == 1)) 
					{
						// print to the user that string is modified but
						// language id is not - so english is set as default
						var mesg = "UCH String Descriptors are changed;But languageid is not - So setting language to US English(0x0409). Please change if language is not English";
						update_status_message(mesg);
						var widgetlang = "hce_languageid";
						var englishus = "0x0409";
						stringToSet = widgetlang + ",,," + englishus + ";;;"
								+ stringToSet;
						modifiedWidgets.push(widgetlang);
					}

					if ((usb3langid == "0") && (usb3stringmodified == 1)) 
					{
						// print to the user that string is modified but
						// language id is not - so english is set as default
						var mesg = "String Descriptors are changed;But languageid is not - So setting language to US English(0x0409). Please change if language is not English";
						update_status_message(mesg);
						var widgetlang = "usb3languageid";
						var englishus = "0x0409";
						stringToSet = widgetlang + ",,," + englishus + ";;;"
								+ stringToSet;
						modifiedWidgets.push(widgetlang);
					}

					var displayChange = "";
					for (var i = 0; i < modifiedWidgets.length; i++) 
					{
						if (i % 4 == 0) 
						{
							if (displayChange) 
							{
								if(typeof Mapping[modifiedWidgets[i]] === 'undefined')
								{
									if(gb_skuName === "USB7202")
									{
										displayChange = "\n"
										+ USB7202_Mapping[modifiedWidgets[i]] + ", "
										+ displayChange;
									}
									else if(gb_skuName === "USB7250" || gb_skuName === "USB7251" || gb_skuName === "USB7252")
									{
										displayChange = "\n"
										+ USB725x_Mapping[modifiedWidgets[i]] + ", "
										+ displayChange;
									}
									else if(gb_skuName === "USB7216" || gb_skuName === "USB7256")
									{
										displayChange = "\n"
										+ USB7256_Mapping[modifiedWidgets[i]] + ", "
										+ displayChange;
									}
									else if(gb_skuName === "USB7206")
									{
										displayChange = "\n"
										+ Mapping[modifiedWidgets[i]] + ", "
										+ displayChange;
									}
								}
								else
								{
									displayChange = "\n"
										+ Mapping[modifiedWidgets[i]] + ", "
										+ displayChange;
								}
							} 
							else 
							{
								if(typeof Mapping[modifiedWidgets[i]] === 'undefined')
								{
									if(gb_skuName === "USB7202")
									{
										displayChange = USB7202_Mapping[modifiedWidgets[i]];
									}
									else if(gb_skuName === "USB7250" || gb_skuName === "USB7251" || gb_skuName === "USB7252")
									{
										displayChange = USB725x_Mapping[modifiedWidgets[i]];
									}
									else if(gb_skuName === "USB7216" || gb_skuName === "USB7256")
									{
										displayChange = USB7256_Mapping[modifiedWidgets[i]];
									}
									else if(gb_skuName === "USB7206")
									{
										displayChange = Mapping[modifiedWidgets[i]];
									}
								}
								else
								{
									displayChange = Mapping[modifiedWidgets[i]];
								}
							}
						} 
						else 
						{
							if (displayChange) 
							{
								if(typeof Mapping[modifiedWidgets[i]] === 'undefined')
								{
									if(gb_skuName === "USB7202")
									{
										displayChange = USB7202_Mapping[modifiedWidgets[i]] + ", " + displayChange;
									}
									else if(gb_skuName === "USB7250" || gb_skuName === "USB7251" || gb_skuName === "USB7252")
									{
										displayChange = USB725x_Mapping[modifiedWidgets[i]] + ", " + displayChange;
									}
									else if(gb_skuName === "USB7216" || gb_skuName === "USB7256")
									{
										displayChange = USB7256_Mapping[modifiedWidgets[i]] + ", " + displayChange;
									}
									else if(gb_skuName === "USB7206")
									{
										displayChange = Mapping[modifiedWidgets[i]] + ", " + displayChange;
									}
								}
								else
								{
									displayChange = Mapping[modifiedWidgets[i]] + ", " + displayChange;
								}
							}
						}
					}
					
					nr1Modified = false;
					nr2Modified = false;
					nr3Modified = false;
					nr4Modified = false;

					enableprt1 = false;
					enableprt2 = false;
					enableprt3 = false;
					enableprt4 = false;
					var option = confirm("The following device settings will be changed ; Previously created JSON and Configuration files will be removed ; Do you want to continue?\n"
							+ displayChange);

					if (option) {
						
						gb_Apply = true;
						$('#mainprogressbar').show();
									
			 			setMainProgresswidth(60);
						
						window.setTimeout(function() {
						window.scrollTo(0,document.body.scrollHeight);
						
						update_status_message("JSON and cfg files will be overwritten; and hub will be programmed with the following.\n " + displayChange);
						var status_msg = "Programming in progress...Please wait";
						update_status_message(status_msg);
						
						$("body").css("cursor", "wait");
						
						var result = setWidgetValue(gb_HUB_ID, stringToSet); // True is an input to JSON generator
						
						setMainProgresswidth(80);
						
													

						if (result) {
						
							//TODO error handling
							
							var mesg = "Hub is successfully programmed";
							update_status_message(mesg);
							
							
							window.setTimeout(function() {
							
						    var checksum= CalculateChecksum(true);
							setMainProgresswidth(80);
							
							mesg = "Configuration File 'bConfig.cfg' created with Checksum: 0x" + checksum ;
							update_status_message(mesg);
							
							cancelFlag = false;
							stringToSet = "";
							
							//Disable apply and preview buttons before making a java call
							
							set_changed_fields_border_default();

							var mesg = "Waiting for device reset to finish.....";
							update_status_message(mesg);
										

							if (vid_pidModified) {
								
								update_status_message("Vendor ID/Product ID of USB2.0/Hub controller has been modified...");

								
								window.setTimeout(function() {
									
									setMainProgresswidth(100);
								
									var mesg = "Refreshing Hub List....";
									update_status_message(mesg);						
										
									close_device(gb_HUB_ID);
									refresh();
									get_hub_list_set_hub_index_zero();								
									 
									  MainProghide();
									
									enable_nav_fields();									
									$("body").css("cursor", "default");
									
								
								}, 1500);
																					
								
							 } else {
							 	
								
									var mesg = "Refreshing Hub List....";
									update_status_message(mesg);
									
									setMainProgresswidth(100);
									
									window.setTimeout(function() {					
									
										close_device(gb_HUB_ID);
										refresh();
										get_hub_list_set_hub_index_zero();
										enable_nav_fields();																			
									 
										 MainProghide();									 							
										$("body").css("cursor", "default");
								
								}, 300);														
										 									  
							 }
							 
							 }, 200);	
											
							document.getElementById("DirectRegisterAccessForm").reset();
							//Reset minihost
							$("#vidpidmaskrule").hide();
							$("#vidpidrule").hide();
							$("#deviceclassrule").hide();
							$('#addminihostrule').hide();
							$('#minihostoverwriteexistingrule').hide();
							var nameofcontrol = ".minihostruletype";
							var nameofcontrol1 = "[data-bind=\"" + "minihostruletype" + "label\"]";
							$(nameofcontrol).find(nameofcontrol1).text("Select Rule Type")
							.children('.dropdown-toggle').dropdown('toggle');
							var nameofcontrol = ".minihostexistingrule";
							var nameofcontrol1 = "[data-bind=\"" + "minihostexistingrule" + "label\"]";
							$(nameofcontrol).find(nameofcontrol1).text("Select Rule Index")
							.children('.dropdown-toggle').dropdown('toggle');
							$('#minihostruleindex').hide();
							Reset_miniHostDiv();
							Reset_miniHostVariables();
							Reset_innerHTML();	
						
						}
						else {
							
													
							errorCode = getMchpUsbLastError(gb_HUB_ID);
							alert(errorMap[Dec2Hex(errorCode)]);
							update_status_message(errorMap[Dec2Hex(errorCode)] + "errorCode: " + errorCode);
							$("body").css("cursor", "default");	
							MainProghide();	
							gb_enable_swapupstreamdpdm = false;	
							gb_enableFlex = false;	
							gb_disableFlex	= false;
							gb_Apply = false;
							enable_nav_fields();

							Reset_innerHTML();		
							//Reset minihost
							$("#vidpidmaskrule").hide();
							$("#vidpidrule").hide();
							$("#deviceclassrule").hide();
							$('#addminihostrule').hide();
							$('#minihostoverwriteexistingrule').hide();
							var nameofcontrol = ".minihostruletype";
							var nameofcontrol1 = "[data-bind=\"" + "minihostruletype" + "label\"]";
							$(nameofcontrol).find(nameofcontrol1).text("Select Rule Type")
							.children('.dropdown-toggle').dropdown('toggle');
							var nameofcontrol = ".minihostexistingrule";
							var nameofcontrol1 = "[data-bind=\"" + "minihostexistingrule" + "label\"]";
							$(nameofcontrol).find(nameofcontrol1).text("Select Rule Index")
							.children('.dropdown-toggle').dropdown('toggle');
							$('#minihostruleindex').hide();
							Reset_miniHostDiv();
							Reset_miniHostVariables();						
						}
						
						}, 100);
						directRegString = "";
						gb_more = false;
						gb_iniFile = "";
						
					} else {
						
						update_status_message("Programming of the device was terminated by the user.");
						gb_enable_swapupstreamdpdm = false;
						gb_enableFlex = false;
						gb_disableFlex	= false;
						gb_Apply = false;
						enable_nav_fields();
						Reset_innerHTML();
					}
				} 
				else 
				{
				}
			}
			// Required clean up action
			iniFile = "";
			RegString = "";
			numberofportState = false;
			errorFlag = false;
			enable_swapupstreamdpdm = false;
			enable_lpm = false;
		}
		$("body").css("cursor", "default");
		$("#progID").hide();
	}
})(jQuery);

(function($) 
{
	set_dropdown_selected_option = function() 
	{

		// Ordering is important - dont change code
		// Click of any field in any drop down menu
		$(document).on('click','.dropdown li a',
				function(event) 
		{
			// this code is for making the current selection appear with
			// caret
			var $target = $(event.currentTarget);

			$target.closest('.btn-group').find('[data-bind]').text(
					$target.text()).end().children('.dropdown-toggle')
					.dropdown('toggle');
			var selop = $(this).text();
			console.log("Selected Option - All dropdowns:" + selop);
		});

		// Click of Any hub in Select HUB drop down menu
		$(document).on('click','.dropdown-selecthub li a',
				function(event) 
		{
			$("#over").show();
			$("#SelectUSBHUBLabel").show();
			$("#sfield").hide();
			$("#close").hide();
			$('#nav').show();
			document.getElementById("over").setAttribute("class",
					"form-group");
			var selop = $(this).text();

			$("#selectedhubinput").val(selop);
			var btnValue = $("#selectedhubinput").val();
			var colonIndex = btnValue.indexOf(":");
			var currentHubSelected = btnValue.charAt(colonIndex + 1);

			if (currentHubSelected == gb_HUB_ID) 
			{
				Reset_innerHTML();
				if (reloop == false) 
				{
					setTimeout(function() 
					{
						get_hub_list_set_hub_index_zero();
					}, 200);
				} 
				else 
				{
					set_selected_hub_get_widgets();
				}
			} 
			else 
			{
				Reset_innerHTML();
				setTimeout(function() 
				{
					close_device(gb_HUB_ID);
					refresh();
					gb_HUB_ID = "" + currentHubSelected;

					set_selected_hub_get_widgets();
					// $("#progID").hide();
				}, 200);
			}
			return false;
		});

		// Click of Any sku in Force product drop down menu
		$(document).on('click', '.dropdown-forceproduct li a', function(event) 
		{
			var selop = $(this).text();
			// console.log("Selected Option:" + selop + "hubid:" + GHubId);
			// call the service
			var data = force_part_number(gb_HUB_ID);
			// console.log("Sending request:force_part_number:" + url);
			if (data) {
				var obj = data;
			} else {
				window.alert("force_part_number:Failed");
			}
			return false;
		});

		// Phase 2
		// Click of Any sku in Select product drop down menu for offline
		// configuration
		$(document).on('click', '.dropdown-selectproduct li a', function()
		{
			$('.selectproduct1').text(this.innerHTML);
			var selop = $(this).text();
			console.log("SelectProduct: Selected Option:" + selop);
		});
	};
})(jQuery);

function setSPIConfiguration(boolValue) 
{
	var SpiconfigState = SPISetConfig(gb_HUB_ID, boolValue);
	if (!SpiconfigState) 
	{
		$("#spisendtranfer").removeAttr('disabled', false);
		$("#spireceivetranfer").removeAttr('disabled', false);
	}
	gb_setSPIConfig_status = boolValue;
	setSPIConfigurationStatus(gb_setSPIConfig_status);
}

function setSPIConfigStatus_false() 
{
	if (gb_setSPIConfig_status) 
	{
		setSPIConfiguration(false);
	}

}
function setMainProgresswidth(width) 
{
	$('#mainprogressbar .progress-bar').css('width', width + '%').attr(
			'aria-valuenow', width);
}

function MainProghide() 
{

	$('#mainprogressbar .progress-bar').css('width', 0 + '%').attr(
			'aria-valuenow', 0);
	$('#mainprogressbar').hide();
}
function setI2CProgresswidth(width){
				
	$('#I2Cprogressbar .progress-bar').css('width', width + '%').attr('aria-valuenow', width);	
						

}
function I2CProghide() {
	
	$('#I2Cprogressbar .progress-bar').css('width', 0 + '%').attr('aria-valuenow', 0);	
	$('#I2Cprogressbar').hide();
}
function setSPIProgresswidth(width){
				
	$('#SPIprogressbar .progress-bar').css('width', width + '%').attr('aria-valuenow', width);	
						

}

// Close Device function
function closeCurrentDevice() {
	
	setSPIConfigStatus_false();
	close_device(gb_HUB_ID);
}
$("#gpiostateclear").click(function(){
	
    $("#gpiopiostate").val('');
});

$("#xdataaddressclear").click(function(){
	
    $("#xdataaddress").val('');
});	

$("#RegisterLengthclear").click(function(){
	
    $("#RegisterLength").val('');
});
$("#xdatavalueclear").click(function(){
	
    $("#xdatavalue").val('');
});

function collapseallfields() 
{
	$('.panel-collapse').each(function() 
	{
		if ($(this).hasClass('in')) {
			$(this).collapse('toggle');
		}
	});
}

function Determine_BCDescription(BCValue) 
{
	// Remove 0x from value
	BCValue.replace("0x", "");
	// Convert string to hex
	var iBCValue = parseInt(BCValue, 16);
	var BCDesc = "";
	if (iBCValue & 0x01) 
	{
		BCDesc += "BC Enabled with ";
	} 
	else 
	{
		BCDesc += "BC Disabled with "
	}
	if (iBCValue & 0x20) // BC Mode
	{
		BCDesc = "1.2 DCP, ";
	}
	if (((iBCValue & 0x06) >> 1) == 0x03) 
	{
		BCDesc += "Omega 2.5A Mode ";
	} 
	else if (((iBCValue & 0x06) >> 1) == 0x02) 
	{
		BCDesc += "Omega 2A Mode ";
	} 
	else if (((iBCValue & 0x06) >> 1) == 0x01) 
	{
		BCDesc += "Omega 1A Mode ";
	} 
	else 
	{
		BCDesc += "Omega Mode Disabled ";
	}
	if (iBCValue & 0x10) // chine mode
	{
		BCDesc += "and China Mode Enabled ";
	}
	if (iBCValue & 0x08) {
		BCDesc += "and SAMSUNG Mode Enabled";
	}
	return BCDesc;
}
function Reset_minihostvidpidRules()
{
	document.getElementById("vidpidrule_vid").value="";
	document.getElementById("vidpidrule_pid").value="";
	document.getElementById("vidpidrule_ruleid").value ="";
	var nameofcontrol = ".setvidpidruleconnectiontype";
	var nameofcontrol1 = "[data-bind=\"" + "setvidpidruleconnectiontype" + "label\"]";
	$(nameofcontrol).find(nameofcontrol1).text("Select connection type")
	.children('.dropdown-toggle').dropdown('toggle');
}	
function Reset_minihostvidpidmaskRules()
{
	document.getElementById("vidpidmaskrule_vid").value="";
	document.getElementById("vidpidmaskrule_pid").value="";
	document.getElementById("vidpidmaskrule_vidpidmask").value ="";
	document.getElementById("vidpidmaskrule_ruleid").value ="";
	var nameofcontrol = ".setvidpidmaskruleconnectiontype";
	var nameofcontrol1 = "[data-bind=\"" + "setvidpidmaskruleconnectiontype" + "label\"]";
	$(nameofcontrol).find(nameofcontrol1).text("Select connection type")
	.children('.dropdown-toggle').dropdown('toggle');
}
function Reset_deviceclassRules()
{
	document.getElementById("deviceclassrule_ruleid").value ="";
	var nameofcontrol = ".setdeviceclassruleconnectiontype";
	var nameofcontrol1 = "[data-bind=\"" + "setdeviceclassruleconnectiontype" + "label\"]";
	$(nameofcontrol).find(nameofcontrol1).text("Select connection type")
	.children('.dropdown-toggle').dropdown('toggle');
	nameofcontrol = ".setdeviceclasstype";
	nameofcontrol1 = "[data-bind=\"" + "setdeviceclasstype" + "label\"]";
	$(nameofcontrol).find(nameofcontrol1).text("Select Device Class")
	.children('.dropdown-toggle').dropdown('toggle');
}
function Reset_miniHostVariables()
{
	gb_minihostruletype = "";
	gb_connectiontype;
	gb_vidpidrulecnt =0;
	gblivevidpidrulecnt = 0;
	gb_vidpidmaskrulecnt =0;
	gblivevidpidmaskrulecnt =0;
	gb_deviceclassrulecnt =0;
	gblivedeviceclassrulecnt;
	gb_existingruleidx=0;
	gb_vidpidString="";
	gb_vidpidmaskString ="";
	gb_deviceclassString ="";
	gb_newvidpidrule = false;
	gb_newvipidmaskrule = false;
	gb_newdeviceclassrule = false;
	vidpidrulevalues ="";
	vidpidmaskrulevalues ="";
	deviceclassrulevalues="";
	vidpid_idx = 0, vidpid_vid = 0, vidpid_pid =0 ,vidpid_ruleid = 0;
	vidpidmask_idx = 0, vidpidmask_vid = 0, vidpidmask_pid =0 ,vidpidmask_vidpidmsk =0, vidpidmask_ruleid = 0;
	deviceclass_idx = 0,deviceclass_ruleid = 0;
}
function Reset_miniHostDiv()
{
	Reset_deviceclassRules();
	Reset_minihostvidpidmaskRules();
	Reset_minihostvidpidRules();	
	var nameofcontrol = ".minihostruletype";
	var nameofcontrol1 = "[data-bind=\"" + "minihostruletype" + "label\"]";
	$(nameofcontrol).find(nameofcontrol1).text("Select Rule Type")
	.children('.dropdown-toggle').dropdown('toggle');
	$('#minihostoverwriteexistingrule').hide();
	$("#minihostoverwrite").prop("checked", false);
	$('#minihostruleindex').hide();
}
function Reset_innerHTML()
{
	if(gb_Apply)
	{
		document.getElementById('port1typelabel').innerHTML = "Port 1 ";
		document.getElementById('port2typelabel').innerHTML = "Port 2 ";
		document.getElementById('port3typelabel').innerHTML = "Port 3 ";
		document.getElementById('port4typelabel').innerHTML = "Port 4 ";
		document.getElementById('port5typelabel').innerHTML = "Port 5 ";
		document.getElementById('port6typelabel').innerHTML = "Port 6 ";
	}
	
	document.getElementById('viderr').innerText  = "";
	document.getElementById('piderr').innerText  = "";
	document.getElementById('diderr').innerText  = "";
	document.getElementById('usbvcderr').innerText  = "";
	document.getElementById('languageiderr').innerText  = "";
	
	document.getElementById('usb3viderr').innerText  = "";
	document.getElementById('usb3piderr').innerText  = "";
	document.getElementById('usb3diderr').innerText  = "";
	document.getElementById('usb3vcderr').innerText  = "";
	document.getElementById('usb3languageiderr').innerText  = "";
	document.getElementById('usb3uuiderr').innerText  = "";
	
	document.getElementById('hce_viderr').innerText  = "";
	document.getElementById('hce_piderr').innerText  = "";
	document.getElementById('hce_diderr').innerText  = "";
	document.getElementById('hce_languageiderr').innerText  = "";
	
	document.getElementById('minihostvidpiderr').innerText  = "";
	document.getElementById('minihostvidpidmaskerr').innerText  = "";
	document.getElementById('minihostdeviceclasserr').innerText  = "";
	
	document.getElementById('Regaddresserr').innerText  = "";
	document.getElementById('Regvalueerr').innerText  = "";
	document.getElementById('xdataaddresserr').innerText  = "";
	document.getElementById('xdatavalueerr').innerText  = "";
	document.getElementById('fcwValueerr').innerText  = "";
}
function custom_dos_portorder(skuname)
{
	PortMap_default(); // For USB7206, ports are in correct order
	if(skuname === "USB7202")
	{
		//Change Order of Div based on Customer DOS
		$("#BPORT3fieldset").insertAfter("#BPORT1fieldset");
		$("#BPORT2fieldset").insertAfter("#BPORT3fieldset");
		$("#BPORT4fieldset").insertAfter("#BPORT2fieldset");
		
		//Advanced
		$("#ad_port3fieldset").insertAfter("#ad_port1fieldset");
		$("#ad_port2fieldset").insertAfter("#ad_port3fieldset");
		$("#ad_port4fieldset").insertAfter("#ad_port2fieldset");
		
		
		//Rename ports - Advanced
		ad_port3label.innerHTML = "Port 2";
		ad_port2label.innerHTML = "Port 3";
		ad_port4label.innerHTML = "Port 4";
		
		// Rename ports - Basic
		port3typelabel.innerText = "Port 2 ";
		port2typelabel.innerText = "Port 3 ";
		port4typelabel.innerText = "Port 4 ";

		usb2port3typelabel.innerText = "Enable Port 2";
		usb3port3typelabel.innerText = "Enable Port 2";
		
		usb2port2typelabel.innerText = "Enable Port 3";
		//usb3port2typelabel.innerText = "Enable Port 3"; //PP2 doe not have USB3
		
		usb2port4typelabel.innerText = "Enable Port 4";
		usb3port4typelabel.innerText = "Enable Port 4";
		
		
		//DCP Demo
		$("#DCPport3group").insertAfter("#DCPport1group");
		$("#DCPport2group").insertAfter("#DCPport3group");
		$("#DCPport4group").insertAfter("#DCPport2group");
		
		dcpport3sellabel.innerText = "Port 2";
		dcpport2sellabel.innerText = "Port 3";
		dcpport4sellabel.innerText = "Port 4";
		
		///////////////////////////////////////////////////////////////////////////////////
		Show_DynamicPortMapcell();
		var tbl = document.getElementById("dynamicportmappingusb3");
		var usb2tbl = document.getElementById("dynamicportmappingusb2");
		
		//Dynamic Port mapping - USB2 Columns
		$("#usb2port3dynamic").insertAfter("#usb2port1dynamic");
		$("#usb2port2dynamic").insertAfter("#usb2port3dynamic");
		$("#usb2port4dynamic").insertAfter("#usb2port2dynamic");
		
		$("#port3mapping").insertAfter("#port1mapping");
		$("#port2mapping").insertAfter("#port3mapping");
		$("#port4mapping").insertAfter("#port2mapping");
		
		$("#newusb2port3mapping").insertAfter("#newusb2port1mapping");
		$("#newusb2port2mapping").insertAfter("#newusb2port3mapping");
		$("#newusb2port4mapping").insertAfter("#newusb2port2mapping");
		
		//Dynamic Port mapping - USB3 Columns
		$("#usb3port3dynamic").insertAfter("#usb3port1dynamic");
		$("#usb3port2dynamic").insertAfter("#usb3port3dynamic");
		$("#usb3port4dynamic").insertAfter("#usb3port2dynamic");
		
		$("#usb3port3mapping").insertAfter("#usb3port1mapping");
		$("#usb3port2mapping").insertAfter("#usb3port3mapping");
		$("#usb3port4mapping").insertAfter("#usb3port2mapping");
		
		$("#newusb3port3mapping").insertAfter("#newusb3port1mapping");
		$("#newusb3port2mapping").insertAfter("#newusb3port3mapping");
		$("#newusb3port4mapping").insertAfter("#newusb3port2mapping");
		
		$("#selectusb3port4mapping").attr('disabled', true);
		$("#selectusb3port2mapping").attr('disabled', true);
					
		//USB2
		usb2tbl.rows[0].cells[1].innerHTML = "Port 2";
		usb2tbl.rows[0].cells[2].innerHTML = "Port 3";
		usb2tbl.rows[0].cells[3].innerHTML = "Port 4";
		
		tbl.rows[0].cells[1].innerHTML = "Port 2";
		tbl.rows[0].cells[2].innerHTML = "Port 3";
		tbl.rows[0].cells[3].innerHTML = "Port 4";
		
		//port 5
		usb2tbl.rows[0].cells[4].style.display = "none";
		usb2tbl.rows[1].cells[4].style.display = "none";
		usb2tbl.rows[2].cells[4].style.display = "none";
		//port 6
		usb2tbl.rows[0].cells[5].style.display = "none";
		usb2tbl.rows[1].cells[5].style.display = "none";
		usb2tbl.rows[2].cells[5].style.display = "none";
		
		//USB3 port 5
		tbl.rows[0].cells[4].style.display = "none";
		tbl.rows[1].cells[4].style.display = "none";
		tbl.rows[2].cells[4].style.display = "none";
		//port 6
		tbl.rows[0].cells[5].style.display = "none";
		tbl.rows[1].cells[5].style.display = "none";
		tbl.rows[2].cells[5].style.display = "none";
		
		//End of dynamic port map
	}
	else if ((skuname === "USB7250") || (skuname === "USB7251")
			|| (skuname === "USB7252")) 
	{
		//Change Order of Div based on Customer DOS
		$("#BPORT3fieldset").insertAfter("#BPORT1fieldset");
		$("#BPORT5fieldset").insertAfter("#BPORT3fieldset");
		$("#BPORT2fieldset").insertAfter("#BPORT5fieldset");
		
		//Advanced
		$("#ad_port3fieldset").insertAfter("#ad_port1fieldset");
		$("#ad_port5fieldset").insertAfter("#ad_port3fieldset");
		$("#ad_port2fieldset").insertAfter("#ad_port5fieldset");
		
		
		//Rename ports - Advanced
		ad_port3label.innerHTML = "Port 2";
		ad_port5label.innerHTML = "Port 3";
		ad_port2label.innerHTML = "Port 4";
		
		// Rename ports - Basic
		port3typelabel.innerText = "Port 2 ";
		port5typelabel.innerText = "Port 3 ";
		port2typelabel.innerText = "Port 4 ";

		usb2port3typelabel.innerText = "Enable Port 2";
		usb3port3typelabel.innerText = "Enable Port 2";
				
		usb2port5typelabel.innerText = "Enable Port 3";
		usb3port5typelabel.innerText = "Enable Port 3";
		
		usb2port2typelabel.innerText = "Enable Port 4";
		//usb3port2typelabel.innerText = "Enable Port 3"; //PP2 doe not have USB3
		
		//DCP Demo
		$("#DCPport3group").insertAfter("#DCPport1group");
		$("#DCPport5group").insertAfter("#DCPport3group");
		$("#DCPport2group").insertAfter("#DCPport5group");
		
		dcpport3sellabel.innerText = "Port 2";
		dcpport5sellabel.innerText = "Port 3";
		dcpport2sellabel.innerText = "Port 4";
		
		
		////////////////////////////////////////////////////////////////////////////////////////////////////////
		//USB3
		Show_DynamicPortMapcell();
		var tbl = document.getElementById("dynamicportmappingusb3");
		var usb2tbl = document.getElementById("dynamicportmappingusb2");
		
		$("#selectusb3port2mapping").attr('disabled', true);
				
		//Dynamic Port mapping - USB2 Columns
		$("#usb2port3dynamic").insertAfter("#usb2port1dynamic");
		$("#usb2port5dynamic").insertAfter("#usb2port3dynamic");
		$("#usb2port2dynamic").insertAfter("#usb2port5dynamic");
		
		$("#port3mapping").insertAfter("#port1mapping");
		$("#port5mapping").insertAfter("#port3mapping");
		$("#port2mapping").insertAfter("#port5mapping");
		
		$("#newusb2port3mapping").insertAfter("#newusb2port1mapping");
		$("#newusb2port5mapping").insertAfter("#newusb2port3mapping");
		$("#newusb2port2mapping").insertAfter("#newusb2port5mapping");
		
		//Dynamic Port mapping - USB3 Columns
		$("#usb3port3dynamic").insertAfter("#usb3port1dynamic");
		$("#usb3port5dynamic").insertAfter("#usb3port3dynamic");
		$("#usb3port2dynamic").insertAfter("#usb3port5dynamic");
		
		$("#usb3port3mapping").insertAfter("#usb3port1mapping");
		$("#usb3port5mapping").insertAfter("#usb3port3mapping");
		$("#usb3port2mapping").insertAfter("#usb3port5mapping");
		
		$("#newusb3port3mapping").insertAfter("#newusb3port1mapping");
		$("#newusb3port5mapping").insertAfter("#newusb3port3mapping");
		$("#newusb3port2mapping").insertAfter("#newusb3port5mapping");
		
		//USB2
		usb2tbl.rows[0].cells[1].innerHTML = "Port 2";
		usb2tbl.rows[0].cells[2].innerHTML = "Port 3";
		usb2tbl.rows[0].cells[3].innerHTML = "Port 4";
		
		tbl.rows[0].cells[1].innerHTML = "Port 2";
		tbl.rows[0].cells[2].innerHTML = "Port 3";
		tbl.rows[0].cells[3].innerHTML = "Port 4";
		
		//port 4
		usb2tbl.rows[0].cells[4].style.display = "none";
		usb2tbl.rows[1].cells[4].style.display = "none";
		usb2tbl.rows[2].cells[4].style.display = "none";
		//port 6
		usb2tbl.rows[0].cells[5].style.display = "none";
		usb2tbl.rows[1].cells[5].style.display = "none";
		usb2tbl.rows[2].cells[5].style.display = "none";
		
		//USB3 port 4
		tbl.rows[0].cells[4].style.display = "none";
		tbl.rows[1].cells[4].style.display = "none";
		tbl.rows[2].cells[4].style.display = "none";
		//port 6
		tbl.rows[0].cells[5].style.display = "none";
		tbl.rows[1].cells[5].style.display = "none";
		tbl.rows[2].cells[5].style.display = "none";

		//End of Dynamic port map
	}
	else if(skuname === "USB7216" || gb_skuName === "USB7256" || gb_skuName === "USB7206")
	{
		//Change Order of Div based on Customer DOS
		$("#BPORT3fieldset").insertAfter("#BPORT1fieldset");
		$("#BPORT4fieldset").insertAfter("#BPORT3fieldset");
		$("#BPORT5fieldset").insertAfter("#BPORT4fieldset");
		$("#BPORT2fieldset").insertAfter("#BPORT5fieldset");
		$("#BPORT6fieldset").insertAfter("#BPORT2fieldset");
		
		//Advanced
		$("#ad_port3fieldset").insertAfter("#ad_port1fieldset");
		$("#ad_port4fieldset").insertAfter("#ad_port3fieldset");
		$("#ad_port5fieldset").insertAfter("#ad_port4fieldset");
		$("#ad_port2fieldset").insertAfter("#ad_port5fieldset");
		$("#ad_port6fieldset").insertAfter("#ad_port2fieldset");
				
		//Rename ports - Advanced
		ad_port3label.innerHTML = "Port 2";
		ad_port4label.innerHTML = "Port 3";
		ad_port5label.innerHTML = "Port 4";
		ad_port2label.innerHTML = "Port 5";
		ad_port6label.innerHTML = "Port 6";
		
		// Rename ports - Basic
		port3typelabel.innerText = "Port 2 ";
		port4typelabel.innerText = "Port 3 ";
		port5typelabel.innerText = "Port 4 ";
		port2typelabel.innerText = "Port 5 ";
		port6typelabel.innerText = "Port 6 ";

		usb2port3typelabel.innerText = "Enable Port 2";
		usb3port3typelabel.innerText = "Enable Port 2";
				
		usb2port4typelabel.innerText = "Enable Port 3";
		usb3port4typelabel.innerText = "Enable Port 3";
		
		usb2port5typelabel.innerText = "Enable Port 4";
		usb3port5typelabel.innerText = "Enable Port 4";
		
		usb2port2typelabel.innerText = "Enable Port 5";
		
		usb2port6typelabel.innerText = "Enable Port 6";
		//usb3port6typelabel.innerText = "Enable Port 6"; //PP6 does not have USB3
		
		//DCP Demo
		$("#DCPport3group").insertAfter("#DCPport1group");
		$("#DCPport4group").insertAfter("#DCPport3group");
		$("#DCPport5group").insertAfter("#DCPport4group");
		$("#DCPport2group").insertAfter("#DCPport5group");
		$("#DCPport6group").insertAfter("#DCPport2group");
		
		dcpport3sellabel.innerText = "Port 2";
		dcpport4sellabel.innerText = "Port 3";
		dcpport5sellabel.innerText = "Port 4";
		dcpport2sellabel.innerText = "Port 5";
		dcpport6sellabel.innerText = "Port 6";
		
		///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		Show_DynamicPortMapcell();
		var tbl = document.getElementById("dynamicportmappingusb3");
		var usb2tbl = document.getElementById("dynamicportmappingusb2");
		
		//Dynamic Port mapping - USB2 Columns
		$("#usb2port3dynamic").insertAfter("#usb2port1dynamic");
		$("#usb2port4dynamic").insertAfter("#usb2port3dynamic");
		$("#usb2port5dynamic").insertAfter("#usb2port4dynamic");
		$("#usb2port2dynamic").insertAfter("#usb2port5dynamic");
		$("#usb2port6dynamic").insertAfter("#usb2port2dynamic");
		
		$("#port3mapping").insertAfter("#port1mapping");
		$("#port4mapping").insertAfter("#port3mapping");
		$("#port5mapping").insertAfter("#port4mapping");
		$("#port2mapping").insertAfter("#port5mapping");
		$("#port6mapping").insertAfter("#port2mapping");
		
		$("#newusb2port3mapping").insertAfter("#newusb2port1mapping");
		$("#newusb2port4mapping").insertAfter("#newusb2port3mapping");
		$("#newusb2port5mapping").insertAfter("#newusb2port4mapping");
		$("#newusb2port2mapping").insertAfter("#newusb2port5mapping");
		$("#newusb2port6mapping").insertAfter("#newusb2port2mapping");
		
		//Dynamic Port mapping - USB3 Columns
		$("#usb3port3dynamic").insertAfter("#usb3port1dynamic");
		$("#usb3port4dynamic").insertAfter("#usb3port3dynamic");
		$("#usb3port5dynamic").insertAfter("#usb3port4dynamic");
		$("#usb3port2dynamic").insertAfter("#usb3port5dynamic");
		$("#usb3port6dynamic").insertAfter("#usb3port2dynamic");
		
		$("#usb3port3mapping").insertAfter("#usb3port1mapping");
		$("#usb3port4mapping").insertAfter("#usb3port3mapping");
		$("#usb3port5mapping").insertAfter("#usb3port4mapping");
		$("#usb3port2mapping").insertAfter("#usb3port5mapping");
		$("#usb3port6mapping").insertAfter("#usb3port2mapping");
		
		$("#newusb3port3mapping").insertAfter("#newusb3port1mapping");
		$("#newusb3port4mapping").insertAfter("#newusb3port3mapping");
		$("#newusb3port5mapping").insertAfter("#newusb3port4mapping");
		$("#newusb3port2mapping").insertAfter("#newusb3port5mapping");
		$("#newusb3port6mapping").insertAfter("#newusb3port2mapping");
		
		//USB3
		tbl.rows[0].cells[1].innerHTML = "Port 2";
		tbl.rows[0].cells[2].innerHTML = "Port 3";
		tbl.rows[0].cells[3].innerHTML = "Port 4";
		tbl.rows[0].cells[4].innerHTML = "Port 5";
		tbl.rows[0].cells[5].innerHTML = "Port 6";

		
		//Enable Port 4
		$("#selectusb3port4mapping").attr('disabled', false);
		$("#selectusb3port6mapping").attr('disabled', true);
		if(skuname === "USB7216" || gb_skuName === "USB7256")
		{
			$("#selectusb3port2mapping").attr('disabled', true);
		}

		
		usb2tbl.rows[0].cells[1].innerHTML = "Port 2";
		usb2tbl.rows[0].cells[2].innerHTML = "Port 3";
		usb2tbl.rows[0].cells[3].innerHTML = "Port 4";
		usb2tbl.rows[0].cells[4].innerHTML = "Port 5";
		usb2tbl.rows[0].cells[5].innerHTML = "Port 6";
		

		//End of dynamic port map
	}
}
function Show_DynamicPortMapcell()
{
	$("#usb2port2dynamic").insertAfter("#usb2port1dynamic");
	$("#usb2port3dynamic").insertAfter("#usb2port2dynamic");
	$("#usb2port4dynamic").insertAfter("#usb2port3dynamic");
	$("#usb2port5dynamic").insertAfter("#usb2port4dynamic");
	$("#usb2port6dynamic").insertAfter("#usb2port5dynamic");
	
	$("#port2mapping").insertAfter("#port1mapping");
	$("#port3mapping").insertAfter("#port2mapping");
	$("#port4mapping").insertAfter("#port3mapping");
	$("#port5mapping").insertAfter("#port4mapping");
	$("#port6mapping").insertAfter("#port5mapping");
	
	$("#newusb2port2mapping").insertAfter("#newusb2port1mapping");
	$("#newusb2port3mapping").insertAfter("#newusb2port2mapping");
	$("#newusb2port4mapping").insertAfter("#newusb2port3mapping");
	$("#newusb2port5mapping").insertAfter("#newusb2port4mapping");
	$("#newusb2port6mapping").insertAfter("#newusb2port5mapping");
	
	//Dynamic Port mapping - USB3 Columns
	$("#usb3port2dynamic").insertAfter("#usb3port1dynamic");
	$("#usb3port3dynamic").insertAfter("#usb3port2dynamic");
	$("#usb3port4dynamic").insertAfter("#usb3port3dynamic");
	$("#usb3port5dynamic").insertAfter("#usb3port4dynamic");
	$("#usb3port6dynamic").insertAfter("#usb3port5dynamic");
	
	$("#usb3port2mapping").insertAfter("#usb3port1mapping");
	$("#usb3port3mapping").insertAfter("#usb3port2mapping");
	$("#usb3port4mapping").insertAfter("#usb3port3mapping");
	$("#usb3port5mapping").insertAfter("#usb3port4mapping");
	$("#usb3port6mapping").insertAfter("#usb3port5mapping");
	
	$("#newusb3port2mapping").insertAfter("#newusb3port1mapping");
	$("#newusb3port3mapping").insertAfter("#newusb3port2mapping");
	$("#newusb3port4mapping").insertAfter("#newusb3port3mapping");
	$("#newusb3port5mapping").insertAfter("#newusb3port4mapping");
	$("#newusb3port6mapping").insertAfter("#newusb3port5mapping");
		
	var tbl = document.getElementById("dynamicportmappingusb3");
	var usb2tbl = document.getElementById("dynamicportmappingusb2");
	
	tbl.rows[0].cells[0].style.display = "table-cell";
	tbl.rows[1].cells[0].style.display = "table-cell";
	tbl.rows[2].cells[0].style.display = "table-cell";
	
	tbl.rows[0].cells[1].style.display = "table-cell";
	tbl.rows[1].cells[1].style.display = "table-cell";
	tbl.rows[2].cells[1].style.display = "table-cell";
		
	tbl.rows[0].cells[2].style.display = "table-cell";
	tbl.rows[1].cells[2].style.display = "table-cell";
	tbl.rows[2].cells[2].style.display = "table-cell";
	
	tbl.rows[0].cells[3].style.display = "table-cell";
	tbl.rows[1].cells[3].style.display = "table-cell";
	tbl.rows[2].cells[3].style.display = "table-cell";
	
	//port 5
	tbl.rows[0].cells[4].style.display = "table-cell";
	tbl.rows[1].cells[4].style.display = "table-cell";
	tbl.rows[2].cells[4].style.display = "table-cell";

	//port 6
	tbl.rows[0].cells[5].style.display = "table-cell";
	tbl.rows[1].cells[5].style.display = "table-cell";
	tbl.rows[2].cells[5].style.display = "table-cell";
	
	//port 5
	usb2tbl.rows[0].cells[0].style.display = "table-cell";
	usb2tbl.rows[1].cells[0].style.display = "table-cell";
	usb2tbl.rows[2].cells[0].style.display = "table-cell";
	
	//port 2
	usb2tbl.rows[0].cells[1].style.display = "table-cell";
	usb2tbl.rows[1].cells[1].style.display = "table-cell";
	usb2tbl.rows[2].cells[1].style.display = "table-cell";
	
	//port 3
	usb2tbl.rows[0].cells[2].style.display = "table-cell";
	usb2tbl.rows[1].cells[2].style.display = "table-cell";
	usb2tbl.rows[2].cells[2].style.display = "table-cell";
	
	//port 4
	usb2tbl.rows[0].cells[3].style.display = "table-cell";
	usb2tbl.rows[1].cells[3].style.display = "table-cell";
	usb2tbl.rows[2].cells[3].style.display = "table-cell";
	
	//port 5
	usb2tbl.rows[0].cells[4].style.display = "table-cell";
	usb2tbl.rows[1].cells[4].style.display = "table-cell";
	usb2tbl.rows[2].cells[4].style.display = "table-cell";
	//port 6
	usb2tbl.rows[0].cells[5].style.display = "table-cell";
	usb2tbl.rows[1].cells[5].style.display = "table-cell";
	usb2tbl.rows[2].cells[5].style.display = "table-cell";
	
	usb2tbl.rows[0].cells[0].innerHTML = "Port 1";
	usb2tbl.rows[0].cells[1].innerHTML = "Port 2";
	usb2tbl.rows[0].cells[2].innerHTML = "Port 3";
	usb2tbl.rows[0].cells[3].innerHTML = "Port 4";
	usb2tbl.rows[0].cells[4].innerHTML = "Port 5";
	usb2tbl.rows[0].cells[5].innerHTML = "Port 6";
	
	tbl.rows[0].cells[0].innerHTML = "Port 1";
	tbl.rows[0].cells[1].innerHTML = "Port 2";
	tbl.rows[0].cells[2].innerHTML = "Port 3";
	tbl.rows[0].cells[3].innerHTML = "Port 4";
	tbl.rows[0].cells[4].innerHTML = "Port 5";
	tbl.rows[0].cells[5].innerHTML = "Port 6";
}
function PortMap_default()
{
	$("#usb3nrdeviceport1").prop("checked",false);
	$("#usb3nrdeviceport3").prop("checked",false);
	$("#usb3nrdeviceport4").prop("checked",false);
	$("#usb3nrdeviceport5").prop("checked",false);
	
	$("#nrdeviceport1").prop("checked",false);
	$("#nrdeviceport2").prop("checked",false);
	$("#nrdeviceport3").prop("checked",false);
	$("#nrdeviceport4").prop("checked",false);
	$("#nrdeviceport5").prop("checked",false);
	$("#nrdeviceport6").prop("checked",false);
	
	//Change Order of Div based on Customer DOS
	$("#BPORT2fieldset").insertAfter("#BPORT1fieldset");
	$("#BPORT3fieldset").insertAfter("#BPORT2fieldset");
	$("#BPORT4fieldset").insertAfter("#BPORT3fieldset");
	$("#BPORT5fieldset").insertAfter("#BPORT4fieldset");
	$("#BPORT6fieldset").insertAfter("#BPORT5fieldset");
	
	//Advanced
	$("#ad_port2fieldset").insertAfter("#ad_port1fieldset");
	$("#ad_port3fieldset").insertAfter("#ad_port2fieldset");
	$("#ad_port4fieldset").insertAfter("#ad_port3fieldset");
	$("#ad_port5fieldset").insertAfter("#ad_port4fieldset");
	$("#ad_port6fieldset").insertAfter("#ad_port5fieldset");
			
	//Rename ports - Advanced
	ad_port1label.innerHTML = "Port 1";
	ad_port2label.innerHTML = "Port 2";
	ad_port3label.innerHTML = "Port 3";
	ad_port4label.innerHTML = "Port 4";
	ad_port5label.innerHTML = "Port 5";
	ad_port6label.innerHTML = "Port 6";
	
	// Rename ports - Basic
	port1typelabel.innerText = "Port 1 ";
	port2typelabel.innerText = "Port 2 ";
	port3typelabel.innerText = "Port 3 ";
	port4typelabel.innerText = "Port 4 ";
	port5typelabel.innerText = "Port 5 ";
	port6typelabel.innerText = "Port 6 ";

	
	usb2port2typelabel.innerText = "Enable Port 2";
	usb3port2typelabel.innerText = "Enable Port 2"; 
	
	usb2port3typelabel.innerText = "Enable Port 3";
	usb3port3typelabel.innerText = "Enable Port 3";
			
	usb2port4typelabel.innerText = "Enable Port 4";
	usb3port4typelabel.innerText = "Enable Port 4";
	
	usb2port5typelabel.innerText = "Enable Port 5";
	usb3port5typelabel.innerText = "Enable Port 5";

	usb2port6typelabel.innerText = "Enable Port 6";
	//usb3port6typelabel.innerText = "Enable Port 6"; //PP6 does not have USB3
}